#if !defined( _AIP_CRYPTO )
#define _AIP_CRYPTO

#include <stdlib.h>
#include <openssl/blowfish.h>

typedef unsigned char byte;

#define IV_SIZE BF_BLOCK
#define KEY_SIZE 16

typedef struct {
  BF_KEY key_schedule;
  byte iv[ IV_SIZE ];
  int num;
} AIP_CRYPTO_CTX;

#ifdef __cpluspus
extern "C" {
#endif

#if defined( __KERNEL__ )

#define aip_crypto_init() /* nothing */
#define aip_crypto_random( buf, len ) get_random_bytes( buf, len )
#define aip_crypto_close() /* nothing */

#else

int aip_crypto_init( void );
int aip_crypto_random( void* buf, size_t len );
void aip_crypto_close( void );

#endif

void aip_crypto_setup( AIP_CRYPTO_CTX* ctx, byte key[ KEY_SIZE ] );
void aip_crypto_setup_iv( AIP_CRYPTO_CTX* ctx, byte iv[ IV_SIZE ] );
void aip_crypto_encrypt( AIP_CRYPTO_CTX* ctx, void* data, size_t len );
void aip_crypto_decrypt( AIP_CRYPTO_CTX* ctx, void* data, size_t len );

#ifdef __cplusplus
}
#endif

#endif
