#include "cAipComponent.h"
#include "czkThreadTrack.h"

#define REV_ID "@(#) $Id: StartThread.cpp,v 1.2 2001/04/18 17:36:27 alainc Exp $"
#include <zkrev.h>




//
// entry point to start a component in a thread
//

// StartThread is a "C" routine used to start a component thread 
// (hence the name)
//
// it simply calls the startup method of the specified component
//
// it is to be invoked by the "spawn" method of the czkThread class
// and thus, will executed in the context of new thread
//
// since the startup method of the specified component never returns, 
// the thread is borne.
//
void ZKPR_CALLBACK StartThread( void* arg)
{

  cAipComponent* component = (cAipComponent*) arg;

  //instantiate a ThreadTrack object for this component
  //it increments the "threadAlive" element of the component.
  //if the thread dies, the ThreadTrack object will go out of scope
  //and its destructor will decrement the "theadAlive" element.
  czkThreadTrack threadTracker(component);

  //invoke the startup method of the component
  component->startup();
}

