#ifndef _cDHNegotiatorResultHandler
#define _cDHNegotiatorResultHandler

#include "frEnt.h"
#include "cLinkManagerInfo.h"


// D-H exchange protocol version (not to confuse with lekv)
#define DHNEGO_DH_V1         1


typedef enum  
{ 
    DHNegoPass, 
    DHNegoFail 
}DHNegoResult;

typedef enum 
{
   initiatorFirstAuthenticated, 
   recipientFirstUnauthenticated,
   lastDhNegoType  // this last type MUST only be used as an indication of the 
}DHNegoType;       // amount of types in the enumeration

class cDHNegotiatorResultHandler {

private:
    DHNegoType         type;     // D-H negotiation type
    uint8_t            version;  // D-H negotiation protocol version
    uint16_t           port;     // D-H negotiation (incoming) port
    
public:
    cDHNegotiatorResultHandler() {};
    virtual ~cDHNegotiatorResultHandler() {};
    
    virtual void reportResult( FrEntIdExp & entity, 
                               DHNegoResult result, uint8_t lekv,
                               SymKey encrKey, SymKey decrKey,
                               ZKPRNetAddr * dhAddr) = 0;

    DHNegoType getType()    { return type; };
    uint8_t    getVersion() { return version; };
    uint16_t   getPort()    { return port; };

    void setType(DHNegoType typein)    { type = typein; };
    void setVersion(uint8_t versionin) { version = versionin; };
    void setPort(uint16_t portin)      { port = portin; };
};


#endif
