//
// cDHNegotiatorEventHandlerAccept class implementation
// 
// 

#include "czkSockAcceptor.h"
#include "cDHNegotiatorEventHandlerAccept.h"
#include "cDHNegotiator.h"

#define REV_ID "@(#) $Id: cDHNegotiatorEventHandlerAccept.cpp,v 1.2 2001/04/18 17:36:38 alainc Exp $"
#include <zkrev.h>




void cDHNegotiatorEventHandlerAccept::handleInput(czkSocket * sock, 
                                                  czkEventHandlerData *)
{
    const char * func = "cDHNegotiatorEventHandlerAccept::handleInput";
    const char * msg = NULL;
    
    ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, sock != NULL);

    try
    {
        try
        {
            ZKS_LOGDEBUG_0(ZKS_LOG_ANY_MASK, ZKS_DHNEGOTIATOR_MOD, " calling accept ");

            msg = "Handling connection request from peer";
            dh->accept(*(czkSockAcceptor *)sock, type);
        }
        catch (...)
        {
            CZKS::Rethrow(func, msg);
        }
    }
    catch (CZKS::Exception &e)
    {
        CZKS::LogException(e);
    }
}

void cDHNegotiatorEventHandlerAccept::handleException(czkSocket * sock, 
                                                      czkEventHandlerData *)
{
  DECL_FUNC("cDHNegotiatorEventHandlerAccept::handleException");
    
  ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, sock != NULL);

  try {
    try {
      ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, ZKS_DHNEGOTIATOR_MOD, 
	  	     " calling exception (accept) error %d", 
		     PR_GetError());

      dh->exception(*(czkSockAcceptor *)sock, type);
    }
    catch (...) {
      CZKS::Rethrow(func, "Failure.");
    }
  }
  catch (CZKS::Exception &e)
  {
    CZKS::LogException(e);
  }

  zksLogMesg(ZKS_DHNEGOTIATOR_MOD, 
	     "%s:  Handled socket exception.", func);
}
