//
// cDHNegotiatorEventHandlerRecv class implementation
// 
// 
#include "cDHNegotiatorEventHandlerRecv.h"
#include "cDHNegotiator.h"

#define REV_ID "@(#) $Id: cDHNegotiatorEventHandlerRecv.cpp,v 1.2 2001/04/18 17:36:38 alainc Exp $"
#include <zkrev.h>




void cDHNegotiatorEventHandlerRecv::handleInput(czkSocket * sock, 
                                                czkEventHandlerData * data)
{
    const char * func = "cDHNegotiatorEventHandlerRecv::handleInput";
    const char * msg = NULL;
    
    ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, dh != NULL);
    ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, sock != NULL);

    try
    {
        try
        {
            ZKS_LOGDEBUG_0(ZKS_LOG_ANY_MASK, ZKS_DHNEGOTIATOR_MOD, " calling recv ");

            msg = "Handling incoming message";
            dh->recv(*sock, *(cDHNegotiatorInfo *)data);
        }
        catch (...)
        {
            CZKS::Rethrow(func, msg);
        }
    }
    catch (CZKS::Exception &e)
    {
        CZKS::LogException(e);
    }
}

void cDHNegotiatorEventHandlerRecv::handleOutput(czkSocket * sock, 
                                                 czkEventHandlerData * data)
{
    const char * func = "cDHNegotiatorEventHandlerRecv::handleOutput";
    const char * msg = NULL;
    
    ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, dh != NULL);
    ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, sock != NULL);

    try
    {
        try
        {
            ZKS_LOGDEBUG_0(ZKS_LOG_ANY_MASK, ZKS_DHNEGOTIATOR_MOD, " calling connected ");

            msg = "Handling connection establishment to peer";
            dh->connected(*sock, *(cDHNegotiatorInfo *)data);
        }
        catch (...)
        {
            CZKS::Rethrow(func, msg);
        }
    }
    catch (CZKS::Exception &e)
    {
        CZKS::LogException(e);
    }
}

void cDHNegotiatorEventHandlerRecv::handleException(
  czkSocket            *sock, 
  czkEventHandlerData  *data)
{
  DECL_FUNC("cDHNegotiatorEventHandlerRecv::handleException");

  ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, dh != NULL);
  ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, sock != NULL);

  try {
    try {
      ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, ZKS_DHNEGOTIATOR_MOD, 
	  	     " calling exception (recv) error %d", 
		     PR_GetError());

      dh->exception(*sock, *(cDHNegotiatorInfo *)data);
    }
    catch (...) {
      CZKS::Rethrow(func, "Failure.");
    }
  }
  catch (CZKS::Exception &e)
  {
    CZKS::LogException(e);
  }

  zksLogMesg(ZKS_DHNEGOTIATOR_MOD, 
	     "%s:  Handled socket exception.", func);
}



int32_t cDHNegotiatorEventHandlerRecv::handleTimeout(czkEventHandlerData * data)
{
    const char * func = "cDHNegotiatorEventHandlerRecv::handleTimeout";
    const char * msg = NULL;

    ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, dh != NULL);
    
    try
    {
        try
        {
            ZKS_LOGDEBUG_0(ZKS_LOG_ANY_MASK, ZKS_DHNEGOTIATOR_MOD, " calling timeout ");

            msg = "Handling timeout";
            dh->timeout(*(cDHNegotiatorInfo *)data);
        }
        catch (...)
        {
            CZKS::Rethrow(func, msg);
        }
    }
    catch (CZKS::Exception &e)
    {
        CZKS::LogException(e);
    }

    // Never reschedule timeout
    return 0;
}
