//
// cDHNegotiatorKeyHandler class implementation
// 
// 
#include "cDHNegotiatorKeyHandler.h"
#include "cDHNegotiator.h"

#define REV_ID "@(#) $Id: cDHNegotiatorKeyHandler.cpp,v 1.2 2001/04/18 17:36:38 alainc Exp $"
#include <zkrev.h>




cDHNegotiatorKeyHandler::cDHNegotiatorKeyHandler(cDHNegotiator * dhin,
                                                 cDHNegotiatorInfo * nego)
{
    ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, dhin != NULL);
    ZKS_ASSERT(ZKS_DHNEGOTIATOR_MOD, nego != NULL);

    dh = dhin;
    negoInfo = nego;
}

void cDHNegotiatorKeyHandler::handleEvent(cKeyProviderCacheEntryData entryData)
{
    const char * func = "cDHNegotiatorKeyHandler::handleEvent";
    const char * msg = NULL;
    
    try
    {
        try
        {
            msg = "Handling key event";
            dh->handleKey(*negoInfo, entryData);
        }
        catch (...)
        {
            CZKS::Rethrow(func, msg);
        }
    }
    catch (CZKS::Exception &e)
    {
        CZKS::LogException(e);
    }
}
