#ifndef _aip_modules

#define _aip_modules

#include "aip-module-names.h"

#include "zksexception.h"
#include <stdexcept>

#include "aip-params.h"

#include "cAipKernelErr.h"
#include "cComponentManagerErr.h"
#include "cConfigProviderErr.h"
#include "cDHNegotiatorErr.h"
#include "cKeyProviderErr.h"
#include "cLinkMaintainerErr.h"
#include "cLinkManagerErr.h"
#include "cPktDispatcherErr.h"
#include "cPrivateKeysErr.h"
#include "cRouteCreatorErr.h"
#include "cStatsHarvestorErr.h"
#include "cStatsPackagerErr.h"

//uncomment this next #define line to magically yield a multi-threaded AIP 
//proceed at your own risk.
//NOTE that you also need to recompile libczksnspr with LOCKING defined
//#define AIPMULTITHREADED

//for KeyProvider Unit Test, set cache expiry time in minutes instead of hours
//#define KEYPROVIDERUNITTEST

//for LinkManager Unit Test, generate a report of the link table contents
//   whenever the link table update is performed
//#define LINKMANAGERUNITTEST

//this is a workaround until my compiler problem is fixed.

extern "C" {
size_t strnlen( const char *, size_t);
}

#endif
