#ifndef _AIPPARAMS
#define _AIPPARAMS

// Sections
#define UAIP_SECTION_NAME       "UAIP"

// General
#define AIP_ENTITY_NAME         "AIP_entityName"
//#define AIP_IP_ADDRESS          "AIP_IPAddress"
//#define AIP_IP_ADDRESS_DH       "AIP_IPAddressDH"
#define AIP_FREEDOM_PORT        "AIP_freedomPort"

#define AIP_RUNTIME_DIR         "AIP_RuntimeDir"
#define AIP_RUNTIME_DIR_DEF     "/freedom/var/run/"

#define AIP_LOG_DIR             "AIP_LogDir"
#define AIP_LOG_DIR_DEF         "/freedom/var/log/"

#define AIP_LOG_FILENAME        "AIP_LogFile"
#define AIP_LOG_FILENAME_DEF    "fruaipd"

#define AIP_LOG_FILEEXT         "AIP_LogFileExt"
#define AIP_LOG_FILEEXT_DEF    ".log"

#define AIP_PID_FILE           "AIP_PidFile"
#define AIP_PID_FILE_DEF       "/freedom/var/run/fruaipd.pid"

#define AIP_REFUSE_CONN_SIG     "AIP_RefuseConnSig"
#define AIP_REFUSE_CONN_SIG_DEF "SIGUSR1"

#define AIP_RELOAD_KEYS_SIG     "AIP_ReloadKeysSig"
#define AIP_RELOAD_KEYS_SIG_DEF "SIGUSR2"


// LinkMaintainer
#define KAP_SEND_TIMEOUT        "KAP_sendTimeout"
#define KAP_SEND_TIMEOUT_DEF    30
#define KAP_SEND_FIRSTDELTA     "KAP_sendFirstDelta"
#define KAP_SEND_FIRSTDELTA_DEF 3
#define KAP_RECV_TIMEOUT        "KAP_recvTimeout"
#define KAP_RECV_TIMEOUT_DEF    180


// netInfoProvider
#define NIP_POLL_INTERVAL          "NIP_PollInterval"
#define NIP_POLL_INTERVAL_DEF      30                     // In seconds
#define NIP_INIT_TIMEOUT           "NIP_InitTimeout"
#define NIP_INIT_TIMEOUT_DEF       600                    // In seconds
#define NIP_WATCHDOG_INTERVAL      "NIP_WatchdogInterval"
#define NIP_WATCHDOG_INTERVAL_DEF  300                    // In seconds
#define NIP_WATCHDOG_MAXRETRY      "NIP_WatchdogMaxRetry"
#define NIP_WATCHDOG_MAXRETRY_DEF  1


// KeyProvider
#define KP_CACHE_PRUNE_INTERVAL               "KP_cachePruneInterval"
#define KP_CACHE_PRUNE_INTERVAL_DEF           3600
#define KP_KEY_REQUEST_TIMEOUT                "KP_keyRequestTimeout"
#define KP_KEY_REQUEST_TIMEOUT_DEF            10
#define KP_KEY_REQUEST_MAXRETRY               "KP_keyRequestMaxRetry"
#define KP_KEY_REQUEST_MAXRETRY_DEF           5

// LinkManager
#define DH_VERSION_AIP                        "DH_versionAip"
#define DH_VERSION_AIP_DEF                    1
#define DH_PORT_AIP                           "DH_portAip"
#define DH_PORT_AIP_DEF                       1
#define DH_VERSION_CLIENT                     "DH_versionClient"
#define DH_VERSION_CLIENT_DEF                 1
#define DH_PORT_CLIENT                        "DH_portClient"
#define DH_PORT_CLIENT_DEF                    1
#define DH_LINK_EXPIRY_INTERVAL               "DH_linkExpiryInterval"
#define DH_LINK_EXPIRY_INTERVAL_DEF           3600

#define DH_RENEGO_INTERVAL                    "DH_renegoInterval"
#define DH_RENEGO_INTERVAL_DEF                3000
#define DH_RENEGO_INTERVAL_FIRST              "DH_renegoIntervalFirst"
#define DH_RENEGO_INTERVAL_FIRST_DEF          5
#define DH_RENEGO_INTERVAL_DELTA              "DH_renegoIntervalDelta"
#define DH_RENEGO_INTERVAL_DELTA_DEF          300
#define DH_RENEGO_EXP_BACKOFF_FACTOR          "DH_renegoExpBackoffFactor"
#define DH_RENEGO_EXP_BACKOFF_FACTOR_DEF      2
#define DH_RENEGO_INTERVAL_MAX                "DH_renegoIntervalMax"
#define DH_RENEGO_INTERVAL_MAX_DEF            18000

#define LM_NEIGHBOUR_RELOAD_INTERVAL          "LM_neighbourReloadInterval"
#define LM_NEIGHBOUR_RELOAD_INTERVAL_DEF      3600

// PrivateKeys
#define PK_CRYPT_DIRECTORY                    "PK_cryptDirectory"
#define PK_CRYPT_DIRECTORY_DEF                "/freedom/privkey/AIP/crypt"
#define PK_SIG_DIRECTORY                      "PK_sigDirectory"
#define PK_SIG_DIRECTORY_DEF                  "/freedom/privkey/AIP/sig"
#define PK_PASSPHRASE_PROMPT                  "PK_passphrasePrompt"
#define PK_PASSPHRASE_PROMPT_DEF              "Enter the passphrase"
#define PK_PASSPHRASE_FILE                    "PK_passphraseFile"

// RouteCreator
#define RC_MAX_ROUTES_ALLOWED                 "RC_maxRoutesAllowed"
#define RC_MAX_ROUTES_ALLOWED_DEF             5000
#define RC_MAX_ROUTE_EXPIRY_TIME              "RC_maxRouteExpiryTime"
#define RC_MAX_ROUTE_EXPIRY_TIME_DEF          18000
#define RC_ROUTE_ACK_TIME                     "RC_routeAckTime"
#define RC_ROUTE_ACK_TIME_DEF                 10
#define RC_WORMHOLE_IP_ADDRESS                "RC_wormholeIPAddress"
#define RC_AUTH_ROUTE_NET_ADDRESS_MASK_V1     "RC_authRouteNetAddressMaskV1"
#define RC_UNAUTH_ROUTE_NET_ADDRESS_MASK_V1   "RC_unauthRouteNetAddressMaskV1"
#define RC_AUTH_ROUTE_NET_ADDRESS_MASK_V2     "RC_authRouteNetAddressMaskV2"
#define RC_UNAUTH_ROUTE_NET_ADDRESS_MASK_V2   "RC_unauthRouteNetAddressMaskV2"

// Stats Packager
#define SP_STATS_PORT                        "SP_statsPort"
#define SP_STATS_PORT_DEF                     51120
#define SP_SEND_STATS_INTERVAL                "SP_sendStatsInterval"
#define SP_SEND_STATS_INTERVAL_DEF            3600
#define SP_MAX_NISS_REQUESTS_PER_PERIOD       "SP_maxNISSrequestPerPeriod"
#define SP_MAX_NISS_REQUESTS_PER_PERIOD_DEF   1
#define SP_NISS_STATS_HISTORY_RECORDS         "SP_NISSstatsHistoryRecords"
#define SP_NISS_STATS_HISTORY_RECORDS_DEF     5

// AIP Kernel
#define AK_KAIP_INTERFACE                     "AK_kaipInterface"
#define AK_KAIP_INTERFACE_DEF                 "kaip"
#define AK_NUM_KAIP_DEVICES                   "AK_nKaipDevices"
#define AK_NUM_KAIP_DEVICES_DEF               1              
#define AK_PROXY_IOCTL_FD                     "AK_proxyIoctlFd"
#define AK_PROXY_IOCTL_FD_DEF                 -1
#define AK_PROXY_NETLINK_FD                   "AK_proxyNetlinkFd"
#define AK_PROXY_NETLINK_FD_DEF               -1

// DH Negotiator
#define DH_SYM_ALG                            "DH_symAlg"
#define DH_SYM_ALG_DEF                        "BLOWFISH"
#define DH_CONNECTION_BACKLOG                 "DH_connectionBacklog"
#define DH_CONNECTION_BACKLOG_DEF             10
#define DH_EXCHANGE_TIMEOUT                   "DH_exchangeTimeout"
#define DH_EXCHANGE_TIMEOUT_DEF               5


// This array contains the list of params that should
// be recognized in the command line.

// ******* NOTE *******
// IF you want your params to be definable in the command line,
// list them here:
//
// KAP_SEND_TIMEOUT
// KAP_RECV_TIMEOUT
//


//#define PARAMSCOUNT (sizeof(_AIP_PARAMS) / sizeof(char *))



#endif
