#ifndef _cKeyProviderEventHandler

#define _cKeyProviderEventHandler

#include "aip-modules.h"

#include "czkEventHandlerData.h"
#include "cKeyProviderCacheEntryData.h"

//
// virtual class providing template for "concrete" inheritors. 
//
class cKeyProviderEventHandler {

private:

  czkEventHandlerData* data; // object-specific data to provide event context

  bool  dispose;   // if true, delete after invoking handleEvent

protected:
  //copy constructor (disabled)
  cKeyProviderEventHandler( const cKeyProviderEventHandler&) { assert(0); };

  //assignment operator (disabled)
  cKeyProviderEventHandler& operator=( const cKeyProviderEventHandler&) { assert(0); };

public:

  cKeyProviderEventHandler() { dispose = true; }

  virtual ~cKeyProviderEventHandler() {};

  void setDispose( bool disposein) { dispose = disposein; }

  bool getDispose() { return dispose; }

  // this method will get called when a Key is finally validated or invalidated
  virtual void handleEvent(cKeyProviderCacheEntryData entryData) 
           { assert(0); (void)entryData; };

  // call this method to set the object-specific data
  void setData( czkEventHandlerData* datain) { data = datain; };

  czkEventHandlerData* getData() { return data; }
};

#endif
