#ifndef _cKeyProviderEventHandlerDataIO

#define _cKeyProviderEventHandlerDataIO

#include "frKeyQry.h"

#include "aip-modules.h"
#include "czknspr.h"
#include "czkCoreLoop.h"

//
// this class provides the data for IO & timeout events
// 
class cKeyProviderEventHandlerDataIO : public czkEventHandlerData {

private:

  enum TimeoutType {PRUNECACHE, KEYREQUESTTIMEOUT};

  TimeoutType type;

  //copy constructor (disabled)
  cKeyProviderEventHandlerDataIO( const cKeyProviderEventHandlerDataIO&) { assert(0); };

  //assignment operator (disabled)
  cKeyProviderEventHandlerDataIO& operator=( const cKeyProviderEventHandlerDataIO&) { assert(0); };

public:
 
  czkCoreLoop* pCoreLoop;

  FrKeyQryQueryExp qry;       // copy of key query data
  int32_t nretry;             // counts number of retries for this request

  //constructor
  cKeyProviderEventHandlerDataIO() {};  

  //destructor
  virtual ~cKeyProviderEventHandlerDataIO() {};  
  
  void setPruneCache() { type = PRUNECACHE; }
  bool isPruneCache() { return (type == PRUNECACHE); }

  void setKeyRequestTimeout() { type = KEYREQUESTTIMEOUT; }
  bool isKeyRequestTimeout() { return (type == KEYREQUESTTIMEOUT); }


};

#endif
