#ifndef _cKeyProviderEventHandlerIO

#define _cKeyProviderEventHandlerIO

#include "aip-modules.h"
#include "czknspr.h"

#include "cKeyProviderCache.h"

enum TimeoutType {PRUNECACHE, KEYREQUESTTIMEOUT};

typedef struct TimeoutEventStruc TimeoutEvent;
struct TimeoutEventStruc {
  TimeoutType timeoutType;    // enumerates the types of timeout events
                              // that are handled
  FrKeyQryQueryExp qry;       // copy of key query data
  int32_t nretry;             // counts number of retries for this request
};
  
#include "czkEventHandler.h"
#include "cKeyProviderEventHandlerParent.h"

//
// this class will do all the I/O and Timeout event processing
// 
class cKeyProviderEventHandlerIO : public czkEventHandler {

private:

  cKeyProvider* pKeyProvider;  // pointer to KeyProvider object

  //copy constructor (disabled)
  cKeyProviderEventHandlerIO( const cKeyProviderEventHandlerIO& e) 
  : czkEventHandler(e) { assert(0); };

  //assignment operator (disabled)
  cKeyProviderEventHandlerIO& operator=( const cKeyProviderEventHandlerIO&) { assert(0); };

public:

  //constructor
  cKeyProviderEventHandlerIO();

  //destructor
  virtual ~cKeyProviderEventHandlerIO();

  void setKeyProvider( cKeyProvider* kp);

  void handleInput(czkSocket* socket, czkEventHandlerData* data);
  void handleOutput(czkSocket*, czkEventHandlerData*) { assert(0); };
  void handleException(czkSocket* socket, czkEventHandlerData* data);
  int32_t handleTimeout( czkEventHandlerData* data);
 
};

#endif
