#include "cKeyProviderEventHandlerNotify.h"

#define REV_ID "@(#) $Id: cKeyProviderEventHandlerNotify.cpp,v 1.2 2001/04/18 17:36:47 alainc Exp $"
#include <zkrev.h>




// initialize 
void cKeyProviderEventHandlerNotify::init()
{
  const char* func = "cKeyProviderEventHandlerNotify::init";

  status = 0;
  if (lock.open() != ZKPR_SUCCESS) {
     CZKS::Throw( ZKS_KEYPROVIDER_MOD, ZKS_KEYPROVIDER_OPENLOCK_ERR,
                  func, "unable to initialize");
  }

  if (condition.open( lock) != ZKPR_SUCCESS) {
     CZKS::Throw( ZKS_KEYPROVIDER_MOD, ZKS_KEYPROVIDER_OPENCOND_ERR,
                  func, "unable to initialize");
  }
  
}

// save the key data and signal the event
void cKeyProviderEventHandlerNotify::handleEvent(cKeyProviderCacheEntryData entryData)
{
  ZKS_LOGDEBUG_0(ZKS_LOG_ANY_MASK, ZKS_KEYPROVIDER_MOD, "in cKeyProviderEventHandlerNotify::handleEvent "); 
  lock.acquire();
  localData = entryData;
  status = 1;
  condition.broadcast();
  lock.release();
}
   
// wait for the event to be signalled (if it has not happened already)
// and return the saved data
cKeyProviderCacheEntryData cKeyProviderEventHandlerNotify::waitForEvent( 
                                ZKPRIntervalTime timeout)
{
  lock.acquire();
  if (status == 0) {
     condition.wait(timeout);
  }
  lock.release();
  return localData;
}

// close the locks.
void cKeyProviderEventHandlerNotify::cleanup()
{
  condition.close();
  lock.close();
}


