#ifndef _cKeyProviderEventHandlerNotify

#define _cKeyProviderEventHandlerNotify

#include "aip-modules.h"

#include "cKeyProviderEventHandler.h"
#include "czkLock.h"
#include "czkCondition.h"
#include "cKeyProviderCacheEntryData.h"

// 
// class to notify caller to key is available
//
class cKeyProviderEventHandlerNotify: public cKeyProviderEventHandler {

private:

  czkLock lock;              // lock guarding "condition"
  czkCondition condition;    // used to signal other threads
  int32_t status;            // is set to 1 when data is received
  cKeyProviderCacheEntryData localData;  //local copy of data to return to callee

  //copy constructor (disabled)
  cKeyProviderEventHandlerNotify( const cKeyProviderEventHandlerNotify& c) : cKeyProviderEventHandler( c) { assert(0); };

  //assignment operator (disabled)
  cKeyProviderEventHandlerNotify& operator=( const cKeyProviderEventHandlerNotify&) { assert(0); };

public:

  //constructor 
  cKeyProviderEventHandlerNotify() {};

  //destructor 
  virtual ~cKeyProviderEventHandlerNotify() {};

  // initialize 
  void init();

  // save the key data and signal the event
  void handleEvent(cKeyProviderCacheEntryData entryData);
   
  // wait for the event to be signalled (if it has happened already)
  // and return the saved data
  cKeyProviderCacheEntryData waitForEvent( ZKPRIntervalTime timeout);

  // close the locks.
  void cleanup();
};


#endif
