#ifndef _cKeyProviderEventHandlerParent

#define _cKeyProviderEventHandlerParent

#include "aip-modules.h"

#include "cKeyProviderCache.h"

//
// class to process parent key signature validation
//
class cKeyProviderEventHandlerParent: public cKeyProviderEventHandler {

private:
    FrKeyQryQueryExp qry; // a copy of the query to retrieve the child's KeyCache entry
    cKeyProviderCache* pKeyCache; // a pointer to the KeyCache object

    //copy constructor (disabled)
    cKeyProviderEventHandlerParent( const cKeyProviderEventHandlerParent& c) 
    : cKeyProviderEventHandler(c) { assert(0); };

    //assignment operator (disabled)
    cKeyProviderEventHandlerParent& operator=( const cKeyProviderEventHandlerParent&) { assert(0); };

public:

    //constructor
    cKeyProviderEventHandlerParent() {};

    //destructor
    virtual ~cKeyProviderEventHandlerParent() {};

    // call this method to set the query and KeyCache pointer
    void setKeyQry(FrKeyQryQueryExp qryin, cKeyProviderCache* pk);

    // provides the actual implemention of a key validation event
    // receives a copy of the newly-validated parent KeyCache entry
    // and uses this to validate the signature in the child's KeyCache entry
    void handleEvent(cKeyProviderCacheEntryData entryData);
};


#endif
