#define MAXKEYLEN 256
struct ltkey
{
  bool operator()(const char* s1, const char* s2) const
  {
    // NOTE that "strcmp" is safe here, dealing with only
    // our own defined component name strings 
    return strncmp(s1, s2, MAXKEYLEN) < 0;
  }
};
  
class cArgParser {

 private:

  int ac;
  char** av;
  
  // a map containing all the registered args 
  typedef  map <const char*, const char*, ltkey> ArgMap;
  ArgMap args;
  
 public:
 
  cArgParser( int acin, char** avin) { ac = acin; av = avin; }

  ~cArgParser() {};

  void registerName( char* key, char* val) { args[key] = val; }

  bool get(const char* key, char** val) 
  {
     bool rc = false;

     ArgMap::iterator i = args.find(key);
     if (i != args.end()) {
       rc = true;
       if (val) *val = const_cast<char *>(i->second);
     }        
     return rc;
  };

  void populate()
  {
     while (av++, --ac) 
     {
        if (strncmp(&av[0][0], "--", 2) == 0) {
          if (ac > 1) {
            if (strncmp(&av[1][0], "--", 2) != 0) {
	      registerName( av[0], av[1]);
              (av++, --ac);
	    }
            else {
	      registerName( av[0], NULL);
	    }
	  }
          else {
	     registerName( av[0], NULL);
	  }
	}
     }
  }
};
            
