#define REV_ID "@(#) $Id: linkMaintainer_UnitTest.cpp,v 1.2 2001/04/18 17:36:58 alainc Exp $"
#include <zkrev.h>
#include <stdio.h>
#include <iostream>
#include <fstream>

#include <zks.h>
#include <zksini.h>
#include <zkscmdline.h>
#include <zkspath.h>

#include <time.h>

#include "czkCoreLoop.h"
#include "aip-modules.h"
#include "cConfigProvider.h"
#include "cLinkManagerInfo.h"
#include "cLinkManager.h"
#include "cLinkMaintainer.h"
#include "cKeepAlivePkt.h"
//#include "cDHNegotiatorResultHandler.h"
#include "cPktDispatcher.h"
#include "cPktDispatcherPktHandler.h"

namespace {

  enum UnitTestCode {
    UT_PASS = 0,
    UT_FAIL = 1,
    UT_UNRESOLVED = 2,
    UT_NOTINUSE = 3,
    UT_UNSUPPORTED = 4,
    UT_UNTESTED = 5,
    UT_UNINITIATED = 6,
    UT_NORESULT = 7,
    UT_FATAL = 101,
    UT_INSPECT = 102
  };

};



unsigned long g_idHack = 1;
time_t startTime;
czkCoreLoop *coreloop = NULL;
int totalLinks = 0;

//////////////////////////////////////////////////////////
// Packet dispatcher stub

cPktDispatcher::cPktDispatcher()
{
}

cPktDispatcher::~cPktDispatcher()
{
}


PktDispatcherHandleId cPktDispatcher::registerHandler(FrPktType, cPktDispatcherPktHandler *)
{
    // I don't care about the packet type. This is just meant as a stub to send
    // keepalives to the LinkMaintainer. Also, in the context of this unit test,
    // the handler is always the LinkMaintainer.
    // this->ph = (cLinkMaintainer *) pComponentManager->get( ZKS_LINKMAINTAINER_MOD );
    return 1;
}

void cPktDispatcher::removeHandler( PktDispatcherHandleId handle )
{

}

bool cPktDispatcher::initializePrivateData( czkCoreLoop *pCoreloop )
{
    if( pCoreloop == NULL ) {
        coreloop = new czkCoreLoop();
    }
    else {
        coreloop = pCoreloop;
    }
    
    return true;
}

void cPktDispatcher::cleanupPrivateData()
{
}

bool cPktDispatcher::validateConfig()
{
    return true;
}

void cPktDispatcher::startup()
{
    signalReady();    
}

void cPktDispatcher::send(cLinkManagerInfo *pLinkInfo, uint8_t *, size_t)
{
    time_t now;
    time(&now);
    printf( "%i s: AIP sending a KAL over link %i\n", now - startTime, pLinkInfo->getLinkId() );
/*    ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK,  ZKS_LINKMANAGER_MOD, "cPktDispatcher::STUB -- I've been requested to"
      " send a KAL over link %i", pLinkInfo->getLinkId());*/
}

void cPktDispatcher::shutdown()
{

}



// handle incoming packets
void cPktDispatcher::cPktDispatcherEventHandler::handleInput(czkSocket *, czkEventHandlerData *)
{
}

// handle socket exception
void cPktDispatcher::cPktDispatcherEventHandler::handleException(czkSocket *, czkEventHandlerData *)
{
}

/*int32_t cPktDispatcher::cPktDispatcherEventHandler::handleTimeout(czkEventHandlerData *)
{
    return 0;
}

void cPktDispatcher::cPktDispatcherEventHandler::handleOutput(czkSocket *, czkEventHandlerData *)
{

}*/


void cPktDispatcher::cPktDispatcherEventHandler::setPktDispatcher(cPktDispatcher *)
{

}


//////////////////////////////////////////////////////////
// cLinkManagerInfo stub

/*void cLinkManagerInfo::setEncrKey(uint8_t alg)
{
    CZKS::Exception e;
    
    frCryptSymNew(e.zkError(), &encrKey);
    frCryptSymSetAlg(e.zkError(), encrKey, (FrCryptSymAlg)alg);
}

void cLinkManagerInfo::setAddr(ZKPRNetAddr * addrin)
{
    memcpy(&addr, addrin, sizeof(ZKPRNetAddr));
}

void cLinkManagerInfo::setLekv(uint8_t lekvin)
{
    version = lekvin;
}*/


cLinkManagerInfo::cLinkManagerInfo()
{
}

cLinkManagerInfo::~cLinkManagerInfo()
{
}


void cLinkManagerInfo::cancelExpiryTimer() {}
void cLinkManagerInfo::cancelRenegoTimer() {}
void cLinkManagerInfo::cancelTimers() {}

void cLinkManagerInfo::scheduleExpiryTimer(
      czkCoreLoop* coreloop, cLinkManager* pLinkManager, cLinkManagerEventHandler* eh)
{
    (void)coreloop; (void)pLinkManager; (void)eh;
}

void cLinkManagerInfo::scheduleRenegoTimer(
       czkCoreLoop* coreloop, cLinkManager* pLinkManager, cLinkManagerEventHandler* eh)
{
    (void)coreloop; (void)pLinkManager; (void)eh;
}

FrAci cAciBin::getAci()
{
    FrAci aci;
    return aci;
}     

void cAciBin::returnAci(FrAci aci)
{
}     



//////////////////////////////////////////////////////////
// cLinkManagerResultHandler stub

/*cLinkManagerResultHandler::cLinkManagerResultHandler()
{

}*/


/*cLinkManagerResultHandler::~cLinkManagerResultHandler()
{

}*/


//////////////////////////////////////////////////////////
// LinkManager stub


cLinkManager::cLinkManager()
{
}

cLinkManager::~cLinkManager()
{
}

void cLinkManager::reportLinkState( LinkState incomingState,
        cLinkManagerInfo* link)
{
    if( incomingState == linkDown )
    {
	// In the context of this unit test, reportLinkDown can
	// only be called if a link has expired in linkMaintainer
	time_t now;
	time(&now);
	printf( "%i s: Link %i has expired\n", now - startTime, link->getLinkId() );
        pLinkMaintainer->removeLink(link);
	if (--totalLinks <= 0 )
	    coreloop->abortEventLoop();
    }
}

// WARNING: This is a hack. I need a way to set the linkId
// in a cLinkManInfo class, but only cLinkManager is a friend
// of this class. So I take advantage of the fact that this
// method takes a LinkId as a parameter and use it to create
// a cLinkManInfo object and register it with the LinkMaintainer.
cLinkManagerInfo* cLinkManager::getLink(LinkId linkId)
{
    g_idHack = linkId;
    cLinkManagerInfo *pLinkManInfo = new cLinkManagerInfo();
    pLinkManInfo->linkId = *(new GenericId());
    return pLinkManInfo;
}

bool cLinkManager::initializePrivateData( czkCoreLoop *pCoreloop )
{
    if( pCoreloop == NULL ) {
        coreloop = new czkCoreLoop();
    }
    else {
        coreloop = pCoreloop;
    }

    pLinkMaintainer = 
     (cLinkMaintainer*)pComponentManager->get(ZKS_LINKMAINTAINER_MOD);
     
    assert(pLinkMaintainer);
    
    return true;
}

void cLinkManager::cleanupPrivateData()
{}

bool cLinkManager::validateConfig()
{
    return true;
}

void cLinkManager::startup()
{
/*    pPktDispatcher = (cPktDispatcher *)
        pComponentManager->get(ZKS_PACKETDISPATCHER_MOD);*/

    pLinkMaintainer = (cLinkMaintainer *)
        pComponentManager->get(ZKS_LINKMAINTAINER_MOD);

    signalReady();
}


void cLinkManager::shutdown()
{

}

GenericId::GenericId(id_type, name_type)
{
    
}

GenericId::GenericId()
{
    m_id = g_idHack;
}

GenericId::GenericId(const GenericId &)
{

}


GenericId & GenericId::operator=(const GenericId & aId)
{
  if( &aId != this ) {
    m_id   = aId.m_id;
    m_name = aId.m_name;
  }
  return *this;
}


// GenericIdBin::GenericIdBin(GenericId::id_type min = GenericId::MIN_ID, GenericId::id_type max = GenericId::MAX_ID)
GenericIdBin::GenericIdBin(GenericId::id_type, GenericId::id_type)
{
}

GenericIdBin::~GenericIdBin()
{

}

/*int32_t cLinkManagerEventHandler::handleTimeout(czkEventHandlerData *)
{
    return 0;
}

void cLinkManagerResultHandler::reportResult(
    FrEntIdExp, DhNegoResult, uint8_t, uint8_t, SymKey, 
    uint8_t, SymKey)
{
}
*/

//////////////////////////////////////////////////////////
// cKeepAlivePkt stub

/*cKeyProviderCacheEntryData::cKeyProviderCacheEntryData() { };

cKeyProviderCacheEntryData::~cKeyProviderCacheEntryData() { };*/

//////////////////////////////////////////////////////////
// cKeepAlivePkt stub

cKeepAlivePkt::cKeepAlivePkt()
{

}

cKeepAlivePkt::~cKeepAlivePkt()
{

}

void cKeepAlivePkt::create(uint32_t, uint8_t)
{

}


void cKeepAlivePkt::destroy()
{

}

void cKeepAlivePkt::getBuffer(uint8_t **, size_t *)
{

}




class cKeepAliveFaker : public czkEventHandler
{
    
private:
    
    char *name;
    int count;
    int *intervals;
    int size;
    cLinkMaintainer *plm;
    czkCoreLoop *pCoreLoop;
    bool repeat;
    cLinkManager *pLinkManager;
    int id;
    
public:
    
    cKeepAliveFaker( char *name, int *intervals, int size, cLinkMaintainer *plm,
		     czkCoreLoop *pCoreLoop, bool repeat, int id, cLinkManager *pLinkManager )
    {
        this->name = name;
        count = 0;
        this->id = id;
        this->intervals = intervals;
        this->size = size;
        this->plm = plm;
        this->pCoreLoop = pCoreLoop;
        this->repeat = repeat;
        this->pLinkManager = pLinkManager;
        pCoreLoop->scheduleTimer( this, NULL, intervals[count++] );
    }

    // I don't really do much cleanup for this unit test...

    int32_t handleTimeout(czkEventHandlerData*)
    {
	time_t now;
	time(&now);
	cLinkManagerInfo *pLinkManInfo = pLinkManager->getLink(id);
        printf( "%i s: %s sending keep alive\n", now - startTime, name );
        plm->handlePkt( pLinkManInfo, NULL, 0 );
        delete pLinkManInfo;

        // This is never called without count being at least 1
        if( count >= size && repeat )
        {
            printf( "%s looped\n", name );
            count = 0;
        }
                
        if( count < size )
            pCoreLoop->scheduleTimer( this, NULL, intervals[count++] );
        
        return 0;
    }

    void handleInput(czkSocket*, czkEventHandlerData*)
    {

    }

    void handleOutput(czkSocket*, czkEventHandlerData*)
    {
    
    }

    void handleException(czkSocket*, czkEventHandlerData*)
    {
    
    }
};



/////////////////////////////////////////////////////////////////////
// test routines






int main(int argc, char **argv)
{
    CZKS::Ini ini;
    CZKS::CmdLine cmdline;

	cout<<"1..1\n"; //one test in this suite
	cout.flush();

	try {

	  cLinkMaintainer *somePointer = NULL;
	  
	  time(&startTime);

	  cerr<<"This test will have the link maintainer register 2 ficticious\n";
	  cerr<< "links over which keep alives will arrive at the following\n" ;
	  cerr<< "intervals:\n" ;
	  cerr<< "    link1: 3s, 3s, 3s \n" ;
	  cerr<< "    link2: 2s, 2s, 3s, 5s, 9s \n" ;
	  cerr<< "\n" ;
	  cerr<< "The link maintainer will consider a link expired after 10 seconds.\n" ;
	  cerr<< "So link1 should expire after 3 + 3 + 3 + 10 = ~19 seconds\n" ;
	  cerr<< "and link2 after 2 + 2 + 3 + 5 + 9 + 10 = ~31 seconds\n" ;
	  cerr<< "\n" ;
	  cerr<< "This should be automated......\n" ;
	  cerr<< "\n" ;
	  cerr.flush();

	  /*  if( !::zksLogInit(Path(argv[0]).basename().c_str()) ||
		  !::zksLogTermInit() ) {
        return 1;
		}*/
	  
	  std::ifstream file("./linkMaintainer_UnitTest.conf");
	  file >> ini;
	  
	  if( !frCryptInit(0, 0) )
        return UT_UNINITIATED;
	  
	  coreloop = new czkCoreLoop();
	  
	  cAipComponentManager *pCmp = new cAipComponentManager();
	  cConfigProvider *pConfigProvider = new cConfigProvider( cmdline, ini );
	  cLinkManager *pLinkManager = new cLinkManager();
	  cLinkMaintainer *pLinkMaintainer = new cLinkMaintainer();
	  cPktDispatcher *pPktDispatcher = new cPktDispatcher();
	  

	  
	  pCmp->add( ZKS_CONFIGPROVIDER_MOD, pConfigProvider );
	  //    pConfigProvider->processIniStream(file);

	  //    pLinkManager->validateConfig();
	  pCmp->add( ZKS_LINKMANAGER_MOD, pLinkManager );
	  
	  //    pLinkMaintainer->validateConfig(/*pConfigProvider*/);
	  pCmp->add( ZKS_LINKMAINTAINER_MOD, pLinkMaintainer );
    
	  //    pPktDispatcher->validateConfig();
	  pCmp->add( ZKS_PACKETDISPATCHER_MOD, pPktDispatcher );
	  
	  pCmp->initComponent(pConfigProvider, coreloop);
	  pCmp->startComponent(ZKS_CONFIGPROVIDER_MOD, false);
	  
	  pCmp->validateAllConfig();
	  pCmp->initAllComponents(coreloop);
   


	  // TODO: if doThread is true (last parameter), then waitForReadySignal
	  // must be called after calling start component
	  /*    pCmp->startComponent( ZKS_CONFIGPROVIDER_MOD, false );
			pCmp->startComponent( ZKS_LINKMANAGER_MOD, false );
			pCmp->startComponent( ZKS_LINKMAINTAINER_MOD, false );
			pCmp->startComponent( ZKS_PACKETDISPATCHER_MOD, false );*/
	  
	  // We add a link
    
	  pLinkMaintainer->registerLink( pLinkManager->getLink(1) );
	  pLinkMaintainer->registerLink( pLinkManager->getLink(2) );
	  
	  int intervals1[] = { 3000, 3000, 3000 };
	  cKeepAliveFaker linkFaker1 = cKeepAliveFaker("faker 1", intervals1, 
												   sizeof(intervals1) / sizeof(int), 
												   pLinkMaintainer,
												   coreloop, false, 1, pLinkManager );
	  
	  int intervals2[] = { 2000, 2000, 3000, 5000, 9000 };
	  cKeepAliveFaker linkFaker2 = cKeepAliveFaker("faker 2", intervals2, 
												   sizeof(intervals2) / sizeof(int), 
												   pLinkMaintainer,
												   coreloop, false, 2, pLinkManager );
	  
	  totalLinks = 2;

	  // Wait for completion
	  int32_t status = coreloop->runEventLoop();

	}
	catch (...) {
	  cout<<"not ok\n";
	  cout.flush();
	  return UT_FAIL;
	}

	cout<<"ok\n";
	cout.flush();
	return UT_PASS;
}
