#include "cAciBin.h"

#define REV_ID "@(#) $Id: cAciBin.cpp,v 1.2 2001/04/18 17:37:02 alainc Exp $"
#include <zkrev.h>

//default constructor
//allocates full-range AciBin (used by wormhole)
cAciBin::cAciBin()
{
   CZKS::Exception e;

   aciBin = NULL;

   if (!zkACIContextNew(e.zkError(), &aciBin)) {
      CZKS::Throw(e);
   }
}

//constructor
//allocates half-range AciBin depending on entity comparison
cAciBin::cAciBin(FrEntIdExp e1, FrEntIdExp e2)
{
   CZKS::Exception e;

   if (!zkACIContextNewByEntity(e.zkError(), &aciBin, e1, e2)) {
      CZKS::Throw(e);
   }
}

//destructor
//free allocated aciBin context
cAciBin::~cAciBin()
{
   CZKS::Exception e;

   if (aciBin) {
      if (!zkACIContextFree(e.zkError(), &aciBin)) {
         CZKS::LogException(e);
      }
   }

}   

//get free aci from bin
FrAci cAciBin::getAci()
{
   CZKS::Exception e;
  
   FrAci aci;
   if (!zkACIGetAciOneRange(e.zkError(), aciBin, &aci))
   { 
      CZKS::Throw(e);
   }
   return aci;
}     

//return allocated aci to bin
void cAciBin::returnAci(FrAci aci)
{
   CZKS::Exception e;
  
   if (!zkACIReturnAci(e.zkError(), aciBin, aci))
   { 
      CZKS::Throw(e);
   }
}     
