#include "cLinkManagerEventHandler.h"
#include "cLinkManager.h"

#define REV_ID "@(#) $Id: cLinkManagerEventHandler.cpp,v 1.2 2001/04/18 17:37:02 alainc Exp $"
#include <zkrev.h>




int32_t cLinkManagerEventHandler::handleTimeout( czkEventHandlerData* userData)
{
  const char* func = " cLinkManagerEventHandler::handleTimeout";

  ZKS_ASSERT(ZKS_LINKMANAGER_MOD, userData);

  int32_t rc = 0;

  cLinkManagerEventHandlerDataTimeout* pTimeoutEvent = 
         (cLinkManagerEventHandlerDataTimeout*) userData;

  try {

    ZKS_LOGDEBUG_0(ZKS_LOG_ANY_MASK, ZKS_LINKMANAGER_MOD, " calling timeout ");
    rc = pTimeoutEvent->pLinkManager->timeout(pTimeoutEvent);

  }
  catch (CZKS::Exception& e) {

    CZKS::Push(e, func, "failure");
    CZKS::LogException(e);

  }
  catch (...) {

    CZKS::Rethrow(func,"failure");

  }

  return rc;
}
