#include "cLinkManagerResultHandler.h"
#include "cLinkManager.h"

#define REV_ID "@(#) $Id: cLinkManagerResultHandler.cpp,v 1.2 2001/04/18 17:37:02 alainc Exp $"
#include <zkrev.h>




// handle the result of a DH negotation
void cLinkManagerResultHandler::reportResult( FrEntIdExp& entity, 
                                              DHNegoResult result,
                                              uint8_t lekv, 
                                              SymKey encrKey, 
                                              SymKey decrKey,
                                              ZKPRNetAddr* dhaddr)
{
   const char* func = " cLinkManagerResultHandler::reportResult";

   ZKS_ASSERT(ZKS_LINKMANAGER_MOD, pLinkManager);

   try {
     pLinkManager->negoResult( entity, result, lekv, encrKey, 
                               decrKey, dhaddr);
   }
   catch (CZKS::Exception &e)
   {
      CZKS::Push(e, func, "failure");
      CZKS::LogException(e);
   }
   catch (...)
   {
      CZKS::Rethrow( func, "failure");
   }


}

void cLinkManagerResultHandler::setLinkManager( cLinkManager* p)
{

  ZKS_ASSERT(ZKS_LINKMANAGER_MOD, p);

  pLinkManager = p;

}


