#ifndef _cLinkManagerScopeLock

#define _cLinkManagerScopeLock

#include "czkScopeLock.h"

// Class to enable "safe" handling of a czkLock object.
// It will automatically release an acquired lock if the object is deleted
// (e.g. goes out of scope)
//

#ifdef AIPMULTITHREADED

class cLinkManagerScopeLock : public czkScopeLock {

 private:

 public:

  cLinkManagerScopeLock(czkLock* lockin): czkScopeLock(lockin) {};
  
  virtual ~cLinkManagerScopeLock() {};

};

#define INITLOCK(a,b)  cLinkManagerScopeLock a(b)
#define LOCK(a)        a.acquire()
#define UNLOCK(a)      a.release()

#else  //not aipmultithreaded

#define INITLOCK(a,b) 
#define LOCK(a)       
#define UNLOCK(a)      

#endif  //multithreaded

#endif


