#define REV_ID "@(#) $Id: cDHNegotiator_stub.cpp,v 1.2 2001/04/18 17:37:06 alainc Exp $"
#include <zkrev.h>
#include "cDHNegotiator.h"
#include "cDHNegotiatorEventHandler_stub.h"
#include "cDHNegotiatorResultHandler.h"
#include "czkEventHandler.h"

  // constructor
  cDHNegotiator::cDHNegotiator() {}

  // destructor
  cDHNegotiator::~cDHNegotiator() {}

  // validate configuration
  bool cDHNegotiator::validateConfig() { return true;}

  // initialize private data members
  bool cDHNegotiator::initializePrivateData(czkCoreLoop* coreloopin) 
     { coreloop = coreloopin; return true; }

void cDHNegotiator::cleanupPrivateData() 
{}
  // startup
  void cDHNegotiator::startup() {}

  void cDHNegotiator::shutdown() {}


  void cDHNegotiator::requestNegotiation( FrEntIdExp& entity, ZKPRNetAddr&,  
                           cDHNegotiatorResultHandler* rh, uint8_t) 
  {

    cDHNegotiatorEventHandler* eh = new cDHNegotiatorEventHandler;
    cDHNegotiatorEventHandlerData* ehd = new cDHNegotiatorEventHandlerData;
    ehd->rh = rh;
    ehd->entity = entity;

    czkIntervalTime ti;
    coreloop->scheduleTimer( eh, ehd, ti.getSeconds(1)); 
     
  }


  int32_t cDHNegotiatorEventHandler::handleTimeout( czkEventHandlerData* data)
  {
    const char *func = "cDHNegotiatorResultHandler::reportResult";

    CZKS::Exception e;
   
    cDHNegotiatorEventHandlerData* p = (cDHNegotiatorEventHandlerData*) data;

    SymKey encrKey;
    SymKey decrKey;
    ZKPRNetAddr dhaddr;

    if (rand() < 5.*RAND_MAX/10.) {
      if (!frCryptSymNew( e.zkError(), &encrKey)) {
          e.Rethrow(func, "fail");
      }
      if (!frCryptSymNew( e.zkError(), &decrKey)) {
          e.Rethrow(func, "fail");
      }

      p->rh->reportResult( p->entity, DHNegoPass, 0, encrKey, decrKey, &dhaddr);
    }
    else {
      p->rh->reportResult( p->entity, DHNegoFail, 0, encrKey, decrKey, &dhaddr);
    }
    delete p;
    return 0;
  }

  void cDHNegotiatorResultHandler::reportResult( 
                             FrEntIdExp&, 
                             DHNegoResult,
                             uint8_t, SymKey, 
                             SymKey, ZKPRNetAddr*) 
  {
  }


  void cDHNegotiator::registerHandler(cDHNegotiatorResultHandler *) {}
  void cDHNegotiator::removeHandler(cDHNegotiatorResultHandler *) {}

