#if !defined(_cNetInfoData)

#define _cNetInfoData

#include "czkSocket.h"

#include "InfoObj.h"
#include "czkTimerProxy.h"
#include "czkEventHandlerData.h"



/*
 *   Base class for NetInfo data types
 */

class cNetInfoProvider;

class cNetInfoData: public czkEventHandlerData 
{
 protected: 
  P_InfoObjMain      infoObj;         // NIDS info object
  uint8_t            infoObjCmd;      // Command token for NIDS
  cNetInfoProvider  *nip;             // "Parent" net info provider
  czkTimerProxy     *pollTimerProxy;  // Timeout handler proxy

 private:
  // Copy constructor (disabled)
  cNetInfoData(const cNetInfoData& e)
    {(void) e;  assert(0);}

  // Assignment operator (disabled)
  cNetInfoData& operator=(const cNetInfoData& e) 
    {(void) e; assert(0);}

 public:
  cNetInfoData():
    infoObj(NULL),
    nip(NULL),
    pollTimerProxy(NULL) {}

  virtual ~cNetInfoData() {}

  virtual void setInfoObj(P_InfoObjMain in) {infoObj = in;};
  virtual P_InfoObjMain getInfoObj() {return infoObj;}
  
  void setNip(cNetInfoProvider *nip) {this->nip = nip;}

  void setTimerProxy(czkTimerProxy &tpx) {pollTimerProxy = &tpx;};
  void killTimerProxy(void) {pollTimerProxy->cancelTimer(); pollTimerProxy = NULL;};

  virtual void init(void)
    {assert(0);}
  // Prompt NIDS for new data
  virtual void trigger(czkSocket &socket)
    {(void) socket; assert(0);}
  // Validate foreign data from local NIDS
  virtual void verify(uint8_t command, time_t timeStamp,
		      uint8_t *buffer, int32_t buflen)  
    {(void) command; (void) timeStamp; (void) buffer; (void) buflen; assert(0);}
  virtual void validate(bool isValid) // Roll back to older data if verification fails
    {(void) isValid; assert(0);}
};

#endif /* _cNetInfoData */
