#if !defined(_cNetInfoProviderEventHandler)

#define _cNetInfoProviderEventHandler

#include "aip-modules.h"

#include "czkEventHandlerData.h"

//
// virtual class providing template for "concrete" inheritors. 
//
class cNetInfoProviderEventHandler {

 private:

  czkEventHandlerData* data; // object-specific data to provide event context

  bool  dispose;   // if true, delete after invoking handleEvent

 private:
  //copy constructor (disabled)
  cNetInfoProviderEventHandler( const cNetInfoProviderEventHandler&) { assert(0); };

  //assignment operator (disabled)
  cNetInfoProviderEventHandler& operator=( const cNetInfoProviderEventHandler&) { assert(0); };

 public:

  cNetInfoProviderEventHandler() { dispose = true; }

  virtual ~cNetInfoProviderEventHandler() {};

  void setDispose( bool disposein) { dispose = disposein; }

  bool getDispose() { return dispose; }

  // Callback to handle event
  virtual void handleEvent(void) 
           { assert(0); };

  // call this method to set the object-specific data
  void setData( czkEventHandlerData* datain) { data = datain; };

  czkEventHandlerData* getData() { return data; }
};

#endif /* _cNetInfoProviderEventHandler */
