#if !defined(_cNetInfoSigData)

#define _cNetInfoSigData

#include "aip-modules.h"

#include "czkEventHandlerData.h"

// Class to pass packet data received from Netinfo daemon to key handler

class cNetInfoSigData: public czkEventHandlerData {
private:
  uint8_t  *m_buffer;
  size_t    m_bufsiz;

private:
  // Disable copy constructor & assignment operator
  cNetInfoSigData(cNetInfoSigData &)
    {assert(0);}

  cNetInfoSigData& operator=(cNetInfoSigData &)
    {assert(0);}

public:
  cNetInfoSigData():
    czkEventHandlerData(),
    m_buffer(NULL),
    m_bufsiz(0)
    {}

  cNetInfoSigData(
    const uint8_t *buffer,
    size_t         bufsiz):
    czkEventHandlerData()
    {
      m_buffer = new uint8_t[bufsiz];
      memcpy(m_buffer, buffer, bufsiz);
      m_bufsiz = bufsiz;
    }

  virtual ~cNetInfoSigData()
    {delete m_buffer;}

  const uint8_t *getBuf()
    {return m_buffer;}

  size_t getBufSiz()
    {return m_bufsiz;}
};

#endif /* _cNetInfoSigData */
