#include <strstream>

#include "czkIntervalTime.h"


#include "cNetInfoProvider.h"
#include "cNetInfoWatchdog.h"

#define REV_ID "@(#) $Id: cNetInfoWatchdog.cpp,v 1.2 2001/04/18 17:37:12 alainc Exp $"
#include <zkrev.h>



  
// Constructor
cNetInfoWatchdog::cNetInfoWatchdog():
  m_attempts(0),
  pNetInfoProvider(NULL),
  pollTimerProxy(NULL)
{
}


// Destructor
cNetInfoWatchdog::~cNetInfoWatchdog() {}



// Handle timeout events
int32_t cNetInfoWatchdog::handleTimeout(
  czkEventHandlerData* data)
{
  DECL_FUNC("cNetInfoWatchdog::handleTimeout");
  
  (void) data;

  int32_t reschedule = 1;

  if (pNetInfoProvider->isConnected()) {
    // Reset counter in case of recent success
    m_attempts = 0;
  }
  else {
    int maxRetry =
      pNetInfoProvider->getConfigProvider()->
      getOpt_int(UAIP_SECTION_NAME, NIP_WATCHDOG_MAXRETRY, NIP_WATCHDOG_MAXRETRY_DEF);

    if (++m_attempts > maxRetry) {
      // Throw exception
      CZKS::Throw(ZKS_NETINFOPROVIDER_MOD, ZKS_NETINFOPROVIDER_NIDSTIMEOUT_ERR,
		  func, "Couldn't connect to NIDS after %d attempt(s).", maxRetry);
    }
    else if (pNetInfoProvider->connectNids()) {
      m_attempts = 0;
    }
  }

  return reschedule;
}
