#if !defined(_cNetInfoWatchdog)

#define _cNetInfoWatchdog

#include "aip-modules.h"
#include "czknspr.h"

#include "czkEventHandler.h"

#include "cNetInfoProviderErr.h"


class cNetInfoProvider;


//
// This class periodically verifies NIDS connectivity
// 
class cNetInfoWatchdog: public czkEventHandler 
{
 private:
  int32_t           m_attempts;        // Number of failed NIDS connects
  cNetInfoProvider *pNetInfoProvider;  // Pointer to NetInfoProvider object
  czkTimerProxy    *pollTimerProxy;    // Timeout handler proxy

 private:
  // Copy constructor (disabled)
  cNetInfoWatchdog(const cNetInfoWatchdog& e):
    czkEventHandler(e)
    {(void) e; assert(0);}

  // Assignment operator (disabled)
  cNetInfoWatchdog& operator=(const cNetInfoWatchdog& e) 
    {(void) e; assert(0);}

  // IO methods (disabled)
  void handleInput     (czkSocket*, czkEventHandlerData*) {assert(0);}
  void handleOutput    (czkSocket*, czkEventHandlerData*) {assert(0);}
  void handleException (czkSocket*, czkEventHandlerData*) {assert(0);}


 public:
  // Constructor
  cNetInfoWatchdog();

  // Destructor
  virtual ~cNetInfoWatchdog();

  void setNetInfoProvider(cNetInfoProvider *nip) {this->pNetInfoProvider = nip;}
  void setTimerProxy     (czkTimerProxy &tpx) {pollTimerProxy = &tpx;};
  void killTimerProxy    () {pollTimerProxy->cancelTimer(); pollTimerProxy = NULL;};

  int32_t handleTimeout(czkEventHandlerData* data);
};

#endif /* _cNetInfoWatchdog */
