#define REV_ID "@(#) $Id: cKeyProvider_stub.cpp,v 1.2 2001/04/18 17:37:16 alainc Exp $"
#include <zkrev.h>
#include <strstream>

#include "aip-modules.h"
#include "cKeyProvider.h"

#include "cNetInfoProvider.h"


//constructor
cKeyProvider::cKeyProvider() {}
  
//destructor
cKeyProvider::~cKeyProvider() 
{
}

// validate configuration items
bool cKeyProvider::validateConfig() 
{ 

 //pConfigProvider->get("PruneKeyCacheTimeInterval", &prunetime);

  //pConfigProvider->get("KeyRequestTimeout", &keyRequestTimeoutVal);
   
  //pConfigProvider->getParameter("KEY_REQUEST_NRETRY", &maxretry);

  return true; 
}


int32_t cKeyProvider::getMaxRetry()
{
  // An arbitrary value
  return 10;
}


// initialize private data elements
bool  cKeyProvider::initializePrivateData(czkCoreLoop*) 
{
  return true;
}
void  cKeyProvider::cleanupPrivateData() 
{
}

// startup routine
void cKeyProvider::startup()
{
}

void cKeyProvider::shutdown()
{
}

// try to connect to the KQD
void cKeyProvider::connectKQD()
{
}

void cKeyProvider::sendQry(FrKeyQryQueryExp&)
{
}

// make a key request 
void cKeyProvider::makeKeyRequest( 
  char* entity, 
  FrEntIdType entity_type, 
  FrPubKeyType key_type, 
  uint32_t key_version, 
  cKeyProviderEventHandler* eventhandler,
  cKeyProviderCacheEntryData& entryData)
{
   FrKeyQryQueryExp pqry; /* key query */

   // build the key query 

   pqry.keyVersion = key_version;
   pqry.keyType = key_type;
   pqry.keyOwner.type = entity_type;

   memset(pqry.keyOwner.name, 0, sizeof( pqry.keyOwner.name));
   size_t n = strnlen(entity,sizeof(pqry.keyOwner.name)-1)+1;
   if (n > sizeof(pqry.keyOwner.name)) {
     n = sizeof(pqry.keyOwner.name);
   }
   strncpy(pqry.keyOwner.name,
           entity,
           n);

   // pass request to the "real" makeKeyRequest
   makeKeyRequest(pqry, eventhandler, entryData);
}

// cancel a key request (actually, simply removes the attached eventhandler)
void cKeyProvider::cancelKeyRequest( char* , 
                                     FrEntIdType , 
                                     FrPubKeyType , 
                                     uint32_t , 
			             cKeyProviderEventHandler*)
{
}


// make the key request
//
// NOTE that the default action is to delete the eventhandler object
// after it is invoked. To suppress this, call the eventhandler's
// "setDispose( false)" method (before calling this routine)
//
void cKeyProvider::makeKeyRequest ( 
  FrKeyQryQueryExp pqry,
  cKeyProviderEventHandler* eventhandler,
  cKeyProviderCacheEntryData& entryData)
{        
  DECL_FUNC("cKeyProvider::makeKeyRequest");
  CZKS::Exception e;

  try {
    entryData.setQry(pqry);
    entryData.setState(FRKEYQRY_ST_VALID);
   
#if 0
    // Key is bogus (uninitialized)
    FrCryptSig *pubKey = NULL;
    char sigFile[] = "./m.pub";

    if (!frCryptSigNewFromFile(e.zkError(), pubKey, sigFile)) {
      CZKS::Throw(e);
    }

    entryData.setPubKey(*pubKey);
#endif

    // Test provo netinfo
    cNetInfoProvider *pNip = static_cast<cNetInfoProvider *> 
      (pComponentManager->get(ZKS_NETINFOPROVIDER_MOD));

    pNip->getNextKQS().dump();
    
    if (eventhandler) {
      eventhandler->handleEvent(entryData);
      if (eventhandler->getDispose()) {
	delete eventhandler;
	eventhandler = NULL;
      }
    }
  }
  catch (...) {
    CZKS::Rethrow(func, "Key request failed.");
  }

  return;
}


// make a key request and return entry as is
void cKeyProvider::getKeyNoWait( char* , 
                                 FrEntIdType , 
                                 FrPubKeyType, 
                                 uint32_t ,
                                 cKeyProviderCacheEntryData&)
{
}

// make a key request and wait (at most "timeout" seconds) for response
void cKeyProvider::getKeyWait( char* , 
                               FrEntIdType, 
                               FrPubKeyType , 
                               uint32_t , 
                               ZKPRIntervalTime ,
                               cKeyProviderCacheEntryData&)
{
}

