#ifndef __CPKTDISPATCHERPKTHANDLER
#define __CPKTDISPATCHERPKTHANDLER

#include "cLinkManagerInfo.h"

// 
// cPktDispatcherPktHandler is a base class.  It should never be instantiated
// directly.
// 
class cPktDispatcherPktHandler
{
public:
    cPktDispatcherPktHandler() {};
    virtual ~cPktDispatcherPktHandler() {};
    
    // Pure virtual member used to handle packet reception.
    virtual void handlePkt
    (
        cLinkManagerInfo * link,    // reference to info of source link
        uint8_t          * pkt,     // reference to incoming packet
        size_t             pktSize  // packet size
    ) = 0;

private:
    // copy constructor (disabled)
    cPktDispatcherPktHandler(const cPktDispatcherPktHandler &) { assert(0); };

    // assignment operator (disabled)
    void operator=(const cPktDispatcherPktHandler &) { assert(0); };
};

# ifdef __cplusplus
extern "C" {
# endif

# ifdef __cplusplus
}
# endif

#endif /* __CPKTDISPATCHERPKTHANDLER */
