#ifndef _cPrivateKeysScopeLock

#define _cPrivateKeysScopeLock

#include "czkScopeLock.h"

// Class to enable "safe" handling of a czkLock object.
// It will automatically release an acquired lock if the object is deleted
// (e.g. goes out of scope)
//

#ifdef AIPMULTITHREADED

class cPrivateKeysScopeLock : public czkScopeLock {

 private:

 public:

  cPrivateKeysScopeLock(czkLock* lockin): czkScopeLock(lockin) {};
  
  virtual ~cPrivateKeysScopeLock() {};

};

#define INITLOCK(a,b)  cPrivateKeysScopeLock a(b)
#define LOCK(a)        a.acquire()
#define UNLOCK(a)      a.release()

#else  //not aipmultithreaded

#define INITLOCK(a,b) 
#define LOCK(a)       
#define UNLOCK(a)      

#endif  //multithreaded

#endif


