#ifndef _cFakeNetAddress

#define  _cFakeNetAddress

#include <string>

#include "aip-modules.h"
#include "zkrand.h"
#include "czkNetAddr.h"

class cFakeNetAddress {

 private:

  string      netAddrMask;
  uint32_t    nBits;
  uint32_t    maxAddr;
  uint32_t    nFree;
  uint32_t    nBytes;
  uint8_t*    netAddrBin;
  ZKPRNetAddr baseAddr;
  bool        validated;

 public:

  //constructor
  cFakeNetAddress();

  //destructor
  ~cFakeNetAddress();

  //parse & validate
  void parse(const char* netAddrMaskIn);

  //initialize
  void init();
  
  //cleanup
  void cleanup();

  //get fake address
  ZKPRNetAddr cFakeNetAddress::getFakeNetAddr();   

  //return fakeNetAddr
  void cFakeNetAddress::returnFakeNetAddr(ZKPRNetAddr addr);

  uint32_t getNFree() { return nFree; };

  bool isValidated() { return validated; }
};

#endif
