#ifndef _cRouteCreatorAciMap
#define _cRouteCreatorAciMap

#include <map>

#include "czkCoreLoop.h"
#include "aip-modules.h"
#include "frEnt.h"
#include "frPktFmt.h"
#include "czkIntervalTime.h"
#include "czkLock.h"
#include "cAipComponent.h"
#include "cAipComponentManager.h"
#include "cAipKernel.h"
#include "cPrivateKeys.h"
#include "cLinkManager.h"
#include "cLinkManagerInfo.h"
#include "cPktDispatcher.h"
#include "cPktDispatcherPktHandler.h"
#include "cKeyProviderEventHandler.h"
#include "cKeyProvider.h"
#include "cAciBin.h"

#include "cRouteCreatePkt.h"
#include "cRouteCreateAckPkt.h"
#include "cRouteDestroyPkt.h"
#include "cKeepAlivePkt.h"

#include "cRouteCreatorInfo.h"
#include "cRouteCreatorErr.h"

class cRouteCreatorAciMap {

  //"less than" function for the FrAci map definition
  struct less_FrAci
  {
    bool operator()(const FrAci r1, 
                    const FrAci r2) const
    {
       if( r1 < r2 ) {
          return true;
       }
       else {
          return false;
       }
    }
  };

   friend class cRouteCreator;

   typedef map<FrAci, cRouteCreatorInfo *, less_FrAci> RouteTableAciDef;

   private:

      RouteTableAciDef routeTableAci;
      RouteTableAciDef::iterator cur;
      RouteTableAciDef::iterator prev;

      //copy constructor (disabled)
      cRouteCreatorAciMap( const cRouteCreatorAciMap&) { assert(0); };

      //assignment operator (disabled)
      cRouteCreatorAciMap& operator=( const cRouteCreatorAciMap&) { assert(0); };

   public:

      cRouteCreatorAciMap() {}

      virtual ~cRouteCreatorAciMap() {}

      void insert( FrAci aci, cRouteCreatorInfo* routeInfo) 
	{  routeTableAci[aci] = routeInfo; }

      void erase( FrAci aci) 
        {  routeTableAci.erase(aci); }

      cRouteCreatorInfo* find( FrAci aci);

      void iterateBegin();
	      
      cRouteCreatorInfo* iterate();
          
      void eraseCur();

};
              

#endif
