#ifndef _cRouteCreatorTimeoutHandler
#define _cRouteCreatorTimeoutHandler

#include "czkEventHandlerData.h"
#include "czkEventHandler.h"

class cRouteCreator;
class cRouteCreatorInfo;

class cRouteCreatorTimeoutHandlerData : public czkEventHandlerData
{
    enum TimeoutType { routeExpiryTimeout, routeAckTimeout };
    public:
        
        cRouteCreatorInfo *pRouteCreatorInfo;
        TimeoutType type;
        
        cRouteCreatorTimeoutHandlerData(cRouteCreatorInfo *inRouteCreatorInfo )
        {
            assert(inRouteCreatorInfo);
            this->pRouteCreatorInfo = inRouteCreatorInfo; 
        }
        
        virtual ~cRouteCreatorTimeoutHandlerData() {};

        void setRouteExpiryTimeout() { type = routeExpiryTimeout; }
        void setRouteAckTimeout()    { type = routeAckTimeout; }

        bool isRouteExpiryTimeout() { return (type == routeExpiryTimeout); }
        bool isRouteAckTimeout()    { return (type == routeAckTimeout); }
        
};
    
class cRouteCreatorTimeoutHandler : public czkEventHandler
{
    public:
    
        cRouteCreator *pRouteCreator;
        
        cRouteCreatorTimeoutHandler( cRouteCreator *inRouteCreator )
        {
            ZKS_ASSERT(ZKS_ROUTECREATOR_MOD, inRouteCreator);
            this->pRouteCreator = inRouteCreator;
        }    

        virtual ~cRouteCreatorTimeoutHandler() {};
        
        void handleInput(czkSocket*, czkEventHandlerData*) {};
        void handleOutput(czkSocket*, czkEventHandlerData*) {};
        void handleException(czkSocket*, czkEventHandlerData*) {};

        int32_t handleTimeout(czkEventHandlerData *pData);
};

#endif
