#define REV_ID "@(#) $Id: cKeyProvider_stub.cpp,v 1.2 2001/04/18 17:37:36 alainc Exp $"
#include <zkrev.h>
#include "cKeyProvider.h"
#include "global.h"
#include <strstream>

cKeyProvider::cKeyProvider() {}
cKeyProvider::~cKeyProvider() {}
int32_t cKeyProvider::getPruneTime() { return 0; }
int32_t cKeyProvider::getKeyRequestTimeoutVal() { return 0; }
int32_t cKeyProvider::getMaxRetry() { return 0; }
bool cKeyProvider::validateConfig() { return true; }
bool cKeyProvider::initializePrivateData(czkCoreLoop*) { return true; }
void cKeyProvider::cleanupPrivateData() {}
void cKeyProvider::startup() {}
void cKeyProvider::shutdown() {}
void cKeyProvider::connectKQD() {}
void cKeyProvider::sendQry(FrKeyQryQueryExp&) {}
void cKeyProvider::getKeyNoWait(char*, FrEntIdType, FrPubKeyType, uint32_t,
                                cKeyProviderCacheEntryData&) {}
void cKeyProvider::getKeyWait(char*, FrEntIdType, FrPubKeyType, uint32_t, 
                              ZKPRIntervalTime, cKeyProviderCacheEntryData&) {}
void cKeyProvider::cancelKeyRequest(char*, FrEntIdType, FrPubKeyType,
                                    uint32_t, cKeyProviderEventHandler*) {}


void cKeyProvider::makeKeyRequest( char* entity, 
                                   FrEntIdType entity_type, 
                                   FrPubKeyType key_type, 
                                   uint32_t key_version, 
			           cKeyProviderEventHandler* eventhandler,
                                   cKeyProviderCacheEntryData& entryData)
{
   FrKeyQryQueryExp pqry; /* key query */

   // build the key query 

   pqry.keyVersion = key_version;
   pqry.keyType = key_type;
   pqry.keyOwner.type = entity_type;
   memset(pqry.keyOwner.name, 0, sizeof( pqry.keyOwner.name));
   size_t n = strnlen(entity,sizeof(pqry.keyOwner.name)-1)+1;
   if (n > sizeof(pqry.keyOwner.name)) {
     n = sizeof(pqry.keyOwner.name);
   }
   strncpy(pqry.keyOwner.name,
           entity,
           n);

   // pass request to the "real" makeKeyRequest
   makeKeyRequest( pqry, eventhandler, entryData);
}

// make the key request
//
// NOTE that the default action is to delete the eventhandler object
// after it is invoked. To suppress this, call the eventhandler's
// "setDispose( false)" method (before calling this routine)
//
void cKeyProvider::makeKeyRequest ( FrKeyQryQueryExp,
                                    cKeyProviderEventHandler* eventhandler,
                                    cKeyProviderCacheEntryData& entryData)
{
    entryData.setState( FRKEYQRY_ST_VALID);
   
    FrCryptSig* cryptSig = getGnymSig();
    
    entryData.setPubKey(*cryptSig);
    
    if (eventhandler) {
        eventhandler->handleEvent( entryData);
        if (eventhandler->getDispose()) {
          delete eventhandler;
          eventhandler = NULL;
	}
      }

  return;

}
