#define REV_ID "@(#) $Id: cLinkManager_stub.cpp,v 1.2 2001/04/18 17:37:36 alainc Exp $"
#include <zkrev.h>
#include "cLinkManager.h"

#include "cNetInfoProvider.h"
#include "cDHNegotiator.h"
#include "cAipKernel.h"
#include "cLinkMaintainer.h"
#include "cRouteCreator.h"

#include "czkNetAddr.h"

cLinkManager::cLinkManager() {}
cLinkManager::~cLinkManager() {}
void cLinkManager::shutdown() {}
void cLinkManager::openlock() {}
void cLinkManager::closelock() {}
int32_t cLinkManager::getAipDHVersion() { return 0; }
int32_t cLinkManager::getAipDHPort() { return 0; }
int32_t cLinkManager::getClientDHVersion() { return 0; }
int32_t cLinkManager::getClientDHPort() { return 0; }
int32_t cLinkManager::getDHRenegoTime() { return 0; }
int32_t cLinkManager::getDHRenegoTimeMaxDelta() { return 0; }
int32_t cLinkManager::getDHRenegoTimeExpBackoffFactor() { return 0; }
int32_t cLinkManager::getDHRenegoTimeMaxAbsolute() { return 0; }
int32_t cLinkManager::getLinkExpiryTime() { return 0; }
int32_t cLinkManager::getReloadLinkTableTime() { return 0; }
bool cLinkManager::validateConfig() { return true; }
void cLinkManager::cleanupPrivateData() {}
ZKPRIntervalTime cLinkManager::getDHRenegoTimeInterval(LinkState, 
                                                       ZKPRIntervalTime )
{ return 0; }
ZKPRIntervalTime cLinkManager::getLinkExpiryTimeInterval() { return 0; }
void cLinkManager::startup() { updateLinkTable(); }
void cLinkManager::scheduleTableUpdate(bool) {}
bool cLinkManager::checkEntity( cNetInfoEntity::entListType*, FrEntIdExp&)
{ return true; }
void cLinkManager::reportLinkState(LinkState, cLinkManagerInfo*) {}
void cLinkManager::negoResult(FrEntIdExp, DHNegoResult, uint8_t, SymKey,
                              SymKey, ZKPRNetAddr*) {}
void cLinkManager::expiryTimeout(cLinkManagerEventHandlerDataTimeout*) {}
void cLinkManager::renegoTimeout(cLinkManagerEventHandlerDataTimeout*) {}
int32_t cLinkManager::timeout(cLinkManagerEventHandlerDataTimeout*)
{ return 0; }

string cLinkManager::getAipName() 
{
  return pConfigProvider->getOpt_string(UAIP_SECTION_NAME, AIP_ENTITY_NAME,
                                        "uaipName");
}

FrEntIdExp cLinkManager::getAipEntity() 
{
    FrEntIdExp aipEntity;

    string aipName = getAipName();
    strncpy( aipEntity.name, aipName.c_str(), sizeof(aipEntity.name));
    aipEntity.type = FRENT_TYPE_AIP; 

    return aipEntity;
}

// initialize private data
bool cLinkManager::initializePrivateData( czkCoreLoop*)
{
   // get the pointers to other components from the component manager

   pNetInfoProvider = 
     (cNetInfoProvider*)pComponentManager->get(ZKS_NETINFOPROVIDER_MOD);

   linkIdBin = new GenericIdBin;

   return true;
}

// sync the link table with info from netinfo
void cLinkManager::updateLinkTable()
{
   const char* func = "cLinkManager::updateLinkTable";

   cLinkManagerInfo* linkinfo;

      // now add aips into the link table that are only in the netinfo list
   cNetInfoEntity::entListType* pAips = pNetInfoProvider->getAIPs();

   czkNetAddr netaddr;

   FrEntIdExp aipEntity;     
      FrEntIdExp aip;
      ZKPRNetAddr addr; 
      uint16_t dhport;
      ZKPRNetAddr dhaddr; 
      cNetInfoEntity::entListType::iterator j = pAips->begin();
      while (j != pAips->end())
      {

         aip = j->getIdExp();
         addr = j->getAddr();
         dhport = j->getDhPort();
         dhaddr = addr;
         dhaddr.inet.port = netaddr.HtoNs( dhport);

         linkinfo = findLink( aip);
         if (linkinfo == NULL) {
            linkinfo = new cLinkManagerInfo();
            linkinfo->init(*linkIdBin);
            linkinfo->entity = aip;
            linkinfo->initAciBin( aipEntity);
            linkNameTable[aip] = linkinfo;
            linkIdTable[linkinfo->getLinkId()] = linkinfo;
            linkinfo->state = linkUp;
         }
         j++;
      }

}

// lookup entity in link name table and return linkinfo
cLinkManagerInfo* cLinkManager::findLink( FrEntIdExp& entity)
{
   cLinkManagerInfo* linkinfo = NULL;

   LinkNameTable::iterator i = linkNameTable.find( entity);
   if (i != linkNameTable.end()) {
      linkinfo = i->second;
   }
   return linkinfo;
}

// lookup entity in link name table and return linkinfo 
// (only if link is up)
cLinkManagerInfo* cLinkManager::getLink( FrEntIdExp& entity)
{
   cLinkManagerInfo* linkinfo = findLink(entity);
   if (linkinfo) {
      if (linkinfo->state != linkUp) {
         linkinfo = NULL;
      }
   }
   return linkinfo;
}

// lookup linkId in link id table and return linkinfo
cLinkManagerInfo* cLinkManager::findLink( LinkId linkId)
{
   cLinkManagerInfo* linkinfo = NULL;

   LinkIdTable::iterator i = linkIdTable.find( linkId);
   if (i != linkIdTable.end()) {
      linkinfo = i->second;
   }
   return linkinfo;
}

// lookup linkId in link id table and return linkinfo 
// (only if link is up)
cLinkManagerInfo* cLinkManager::getLink( LinkId linkId)
{
   cLinkManagerInfo* linkinfo = findLink( linkId);
   if (linkinfo) {
      if (linkinfo->state != linkUp) {
         linkinfo = NULL;
      }
   }
   return linkinfo;
}

// lookup linkId in link id table and delete the entry
void cLinkManager::removeLinkId( LinkId linkId)
{
   LinkIdTable::iterator i = linkIdTable.find( linkId);
   if (i != linkIdTable.end()) {
      linkIdTable.erase(i);
   }
}
