#! /bin/sh

# Enable ip forwarding
echo 1 > /proc/sys/net/ipv4/ip_forward

# Flush all current rules and user-defined chains
ipchains -F
# Clear all current rules and user-defined chains
ipchains -X
# Zero counters
ipchains -Z

# We don't want to be a masquerading gateway for the world
ipchains -P forward DENY

# create two chains, one for each traffic type
ipchains -N authtraf
ipchains -N coretraf

# jump to a traffic chain, according to the traffic type
ipchains -A forward -s 172.17.0.0/16 -j authtraf
ipchains -A forward -s 172.18.0.0/16 -j coretraf

# Do masquerading for both types of traffic
# (we should filter the authtraf chain from
# traffic not destined to core servers)
ipchains -A coretraf -j MASQ
ipchains -A authtraf -j MASQ

