#ifndef _cStatsHarvestorPktData

#define _cStatsHarvestorPktData

#include "aip-modules.h"

#include "StatsData.h"
#include "cStatsHarvestor.h"
#include "cStatsHarvestorPullHandler.h"

//class to package Pkt stats

class cStatsHarvestorPktData {

   public:

     StatsData<uint64_t>* pktRcvd;  
     StatsData<uint64_t>* pktSent;  
     StatsData<uint64_t>* pktDropped;  
     StatsData<uint64_t>* bytesRcvd;  
     StatsData<uint64_t>* bytesSent;  
     StatsData<uint64_t>* bytesDropped;    

     cStatsHarvestor* pStatsHarvestor;

     cStatsHarvestorPktData(); 
 
     virtual ~cStatsHarvestorPktData()
     {
     } 
 
     void setStatsHarvestor( cStatsHarvestor* pStatsHarv)
     {
        this->pStatsHarvestor = pStatsHarv; 
     } 
 
     void initRegisteredStats(const char* name1, const char* name2, 
                              const char* name3, const char* name4, 
                              const char* name5, const char* name6 );

     void removeRegisteredStats(const char* name1, const char* name2, 
                                const char* name3, const char* name4, 
                                const char* name5, const char* name6 );
     void initNewStats();

     void deleteLocalStats();

     void registerStats(const char* name1, const char* name2, 
                        const char* name3, const char* name4, 
                        const char* name5, const char* name6 );

     void registerStats(const char* name1, const char* name2, 
                        const char* name3, const char* name4, 
                        const char* name5, const char* name6,
                        cStatsHarvestorPullHandler* ph);

     cStatsHarvestorPktData& operator=(const cStatsHarvestorPktData& val);

     cStatsHarvestorPktData& operator+=(const cStatsHarvestorPktData& val);
  
};

#endif
