#ifndef _cStatsPackagerEventHandlerIO

#define _cStatsPackagerEventHandlerIO

#include "frstats.h"

#include "aip-modules.h"
#include "czknspr.h"
  
#include "czkEventHandler.h"

#include "cStatsPackagerErr.h"

class cStatsPackager;

//
// this class will do all the I/O and Timeout event processing
// 
class cStatsPackagerEventHandlerIO : public czkEventHandler {

private:

  cStatsPackager* pStatsPackager;  // pointer to StatsPackager object

  //copy constructor (disabled)
  cStatsPackagerEventHandlerIO( const cStatsPackagerEventHandlerIO& c): czkEventHandler(c) { assert(0); };

  //assignment operator (disabled)
  cStatsPackagerEventHandlerIO& operator=( const cStatsPackagerEventHandlerIO&) { assert(0); };

public:

  //constructor
  cStatsPackagerEventHandlerIO() {};

  //destructor
  virtual ~cStatsPackagerEventHandlerIO() {};

  void setStatsPackager( cStatsPackager* sp);

  void handleInput(czkSocket* socket, czkEventHandlerData* data);
  void handleOutput(czkSocket* socket, czkEventHandlerData* data);
  void handleException(czkSocket* socket, czkEventHandlerData* data);
  int32_t handleTimeout( czkEventHandlerData* data);
 
};

#endif
