#ifndef _cStatsPackagerKeyHandlerCryptData

#define _cStatsPackagerKeyHandlerCryptData

#include "aip-modules.h"

#include "czkEventHandlerData.h"

#include "StatsData.h"
#include "cStatsHarvestor.h"
#include "cStatsHarvestorPktData.h"

//class to pass packet data received from NISS to KeyHandler

class cStatsPackagerKeyHandlerCryptData : public czkEventHandlerData {

public:

   //RouteCreator stats
   const StatsData<uint32_t>* newClients; 
   const StatsData<uint32_t>* clients;
  
   StatsData<uint32_t>* newClientsLast; 
   StatsData<uint32_t>* clientsLast;  

   StatsData<uint32_t>* newClientsCur; 
   StatsData<uint32_t>* clientsCur;  


   //DHNegotiator stats
   cStatsHarvestorPktData* dh;  
   cStatsHarvestorPktData* dhLast;  
   cStatsHarvestorPktData* dhCur;  

   //AipKernel stats
   cStatsHarvestorPktData* ak;  
   cStatsHarvestorPktData* akLast;  
   cStatsHarvestorPktData* akCur;  

   //PktDispatcher stats
   cStatsHarvestorPktData* pd;  
   cStatsHarvestorPktData* pdLast;  
   cStatsHarvestorPktData* pdCur;  

   //KeyProvider stats
   cStatsHarvestorPktData* kp;  
   cStatsHarvestorPktData* kpLast;  
   cStatsHarvestorPktData* kpCur;  

   //StatsPackager stats
   cStatsHarvestorPktData* sp;  
   cStatsHarvestorPktData* spLast;  
   cStatsHarvestorPktData* spCur;  

   //TOTAL stats
   cStatsHarvestorPktData* totLast;  
   cStatsHarvestorPktData* totCur;  

   //constructor
   cStatsPackagerKeyHandlerCryptData();

   //destructor
   virtual ~cStatsPackagerKeyHandlerCryptData() {};

   void init( class cStatsPackager* sp);

   void cleanup();

};

#endif
