#define REV_ID "@(#) $Id: cKeyProvider_stub.cpp,v 1.2 2001/04/18 17:37:57 alainc Exp $"
#include <zkrev.h>
#include "cKeyProvider.h"
#include <strstream>

//constructor
cKeyProvider::cKeyProvider() {}
  
//destructor
cKeyProvider::~cKeyProvider() 
{
}

int32_t cKeyProvider::getPruneTime()
{
  return 0;
}

int32_t cKeyProvider::getKeyRequestTimeoutVal()
{
  return 0;
}

int32_t cKeyProvider::getMaxRetry()
{
  return 0;
}

// validate configuration items
bool cKeyProvider::validateConfig() 
{ 

   
 //pConfigProvider->get("PruneKeyCacheTimeInterval", &prunetime);

  //pConfigProvider->get("KeyRequestTimeout", &keyRequestTimeoutVal);
   
  //pConfigProvider->getParameter("KEY_REQUEST_NRETRY", &maxretry);

  return true; 
}

// initialize private data elements
bool  cKeyProvider::initializePrivateData(czkCoreLoop*) 
{ 
};
void  cKeyProvider::cleanupPrivateData() 
{ 
};

// startup routine
void cKeyProvider::startup()
{
}

void cKeyProvider::shutdown()
{
}

// try to connect to the KQD
void cKeyProvider::connectKQD()
{
}

void cKeyProvider::sendQry(FrKeyQryQueryExp&)
{
}

// make a key request 
void cKeyProvider::makeKeyRequest( char* entity, 
                                   FrEntIdType entity_type, 
                                   FrPubKeyType key_type, 
                                   uint32_t key_version, 
			           cKeyProviderEventHandler* eventhandler,
                                   cKeyProviderCacheEntryData& entryData)
{
   FrKeyQryQueryExp pqry; /* key query */

   // build the key query 

   pqry.keyVersion = key_version;
   pqry.keyType = key_type;
   pqry.keyType = FRCRYPT_KEYTYPE_CRYPTION; //bypass the sig
   pqry.keyOwner.type = entity_type;
   memset(pqry.keyOwner.name, 0, sizeof( pqry.keyOwner.name));
   size_t n = strnlen(entity,sizeof(pqry.keyOwner.name)-1)+1;
   if (n > sizeof(pqry.keyOwner.name)) {
     n = sizeof(pqry.keyOwner.name);
   }
   strncpy(pqry.keyOwner.name,
           entity,
           n);

   // pass request to the "real" makeKeyRequest
   makeKeyRequest( pqry, eventhandler, entryData);
}

// cancel a key request (actually, simply removes the attached eventhandler)
void cKeyProvider::cancelKeyRequest( char* , 
                                     FrEntIdType , 
                                     FrPubKeyType , 
                                     uint32_t , 
			             cKeyProviderEventHandler*)
{
}

// make the key request
//
// NOTE that the default action is to delete the eventhandler object
// after it is invoked. To suppress this, call the eventhandler's
// "setDispose( false)" method (before calling this routine)
//
void cKeyProvider::makeKeyRequest ( FrKeyQryQueryExp pqry,
                                    cKeyProviderEventHandler* eventhandler,
                                    cKeyProviderCacheEntryData& entryData)
{
  CZKS::Exception e;

    entryData.setQry(pqry);
    entryData.setState( FRKEYQRY_ST_VALID);
   
    FrCryptSig nymSig;
  assert(frCryptSigNew(e.zkError(), &nymSig));
  assert(frCryptPubKeySetVersion(e.zkError(), nymSig, 4)); 
  assert(frCryptSigSetKeySize(e.zkError(), nymSig, FRCRYPT_SIGKEYSIZE_1024));
  assert(frCryptSigSetRandomKeys(e.zkError(), nymSig));
  FrEntIdExp ent;
  memset(&ent,0, sizeof(ent));
  strcpy(ent.name,"jajaj");
  ent.type = FRENT_TYPE_NISS;
  assert(frCryptPubKeySetEntity(e.zkError(), nymSig, &ent));
    entryData.setPubKey(nymSig);

    //FrCryptSig* cryptSig = getGnymSig();
    
    //entryData.setPubKey(*cryptSig);
    
    if (eventhandler) {
        eventhandler->handleEvent( entryData);
        if (eventhandler->getDispose()) {
          delete eventhandler;
          eventhandler = NULL;
	}
      }

  return;

}

// make a key request and return entry as is
void cKeyProvider::getKeyNoWait( char* , 
                                 FrEntIdType , 
                                 FrPubKeyType, 
                                 uint32_t ,
                                 cKeyProviderCacheEntryData&)
{
}

// make a key request and wait (at most "timeout" seconds) for response
void cKeyProvider::getKeyWait( char* , 
                               FrEntIdType, 
                               FrPubKeyType , 
                               uint32_t , 
                               ZKPRIntervalTime ,
                               cKeyProviderCacheEntryData&)
{
}

