#ifndef _cDHNegInit

#define _cDHNegInit

#include "cCommandParser.h"

enum DHNegAction {Pass, Fail, Timeout};

class cDHNegInit {

 public:

  FrEntIdExp  entity;
  uint32_t    maxWait;
  DHNegAction action;
  uint32_t    repeatInterval;
  string      message;

  cDHNegInit( QualifierList qualifiers)
  {

    QualifierList::iterator i = qualifiers.begin();
    while (i != qualifiers.end())
    {
      StringList vals = i->getVals();

      StringList::iterator j = vals.begin();
      string val = *j;

      if (i->getQualifier() == qualifierEntityName) {
        memset( entity.name, 0, sizeof(entity.name));
        strcpy( entity.name, val.c_str());
        entity.type = FRENT_TYPE_AIP;
      }
      else if (i->getQualifier() == qualifierClient) {
        if (val == valTRUE) {
          entity.type = FRENT_TYPE_ANON;
        }
      }
      else if (i->getQualifier() == qualifierMaxWait) {
        maxWait = atoi( val.c_str());
      }
      else if (i->getQualifier() == qualifierAction) {
        if (val == valPASS) {
          action = Pass;
	}
        else if (val == valFAIL) {
          action = Fail;
	}
        else if (val == valTIMEOUT) {
          action = Timeout;
	}
      }
      else if (i->getQualifier() == qualifierRepeatInterval) {
        repeatInterval = atoi( val.c_str());
      }
      else if (i->getQualifier() == qualifierMessage) {
        message = val;
      }
      i++;
    }
    //cout << "cDHNegInit entity name " << entity.name << endl;
    //cout << "maxWait " << maxWait << endl;
    //cout << "action " << action << endl;
    //cout << "repeatInterval" << repeatInterval << endl;
  }
};

#endif
  
