#ifndef _cDHNego

#define _cDHNego

#include "frPktFmt.h"
#include "frEnt.h"

#include "czkCoreLoop.h"
#include "czkEventHandler.h"
#include "czkSocket.h"
#include "czkSockAcceptor.h"
#include "czkSockConnector.h"

#include "cDHNegotiatorResultHandler.h"

#include "testFunctionalAip.h"

#include "cLinkMonitor.h"
#include "cLinkMonitorInfo.h"

#include "cDHNegInit.h"

enum DHNegoRespState { tryConnect, sendEntity, waitEntity, waitResponse};
enum DHNegType { dhResp, dhInit};

class cDHNegoData : public czkEventHandlerData {

 public:
    FrPktDifHel      peerDH;
    DHNegoRespState  state;
    FrEntIdExp       sendEntity;
    FrEntIdExp       recvEntity;
    uint8_t          lekv;
    ZKPRNetAddr      addr;
    DHNegAction      action;
    DHNegType        type;
}; 

class cDHNego : public czkEventHandler {

  private:
    cLinkMonitor*    pLinkMonitor;
    czkCoreLoop*     coreloop;
    czkSockAcceptor  peerListenSock;
    czkSockConnector peerConnectSock;
    czkSocket*       peerAcceptSock;

    FrCryptPubKey peerPrivSig;
    FrCryptPubKey peerPubSig;
    FrCryptPubKey myPubSig;

  public:
  
    bool             successResp;
    bool             successInit;
    bool             doResp;
    bool             doInit;

    void init(czkCoreLoop* cl, cLinkMonitor* pl);
    void initSocket(ZKPRNetAddr addr, FrEntIdExp entity, DHNegAction action);
    void closeSocket();

    void initDH(FrPktDifHel * dhDesc, bool sigGenerate, 
                         czkSocket & sock, uint8_t lekv);
/*
    bool validateExchange(cUnitTestResultHandler & rh, 
                                   FrEntIdExp * entity,
                      DHNegoResult dhResult, SymKey encrKey, SymKey decrKey, 
                      uint8_t lekv);
*/

   void handleInput( czkSocket* sock, czkEventHandlerData* d);

   void handleOutput( czkSocket* sock, czkEventHandlerData* d);

   void handleException( czkSocket* sock, czkEventHandlerData* d);

   int32_t handleTimeout(czkEventHandlerData*) {return 0;};

   void connect(ZKPRNetAddr addr, FrEntIdExp entity, 
                DHNegAction action);

   void sendDH(FrPktDifHel& peerDH);

   int32_t recvDH(FrPktDifHel& peerDH);

}; 

#endif
