#define REV_ID "@(#) $Id: cLinkMonitorInfo.cpp,v 1.2 2001/04/18 17:38:01 alainc Exp $"
#include <zkrev.h>
#include "cLinkMonitorInfo.h"
#include "cLinkMonitor.h"


//constructor
cLinkMonitorInfo::cLinkMonitorInfo()
{
  linkId = 0;	
   
  state = linkDown;

  pDHNego = NULL;

  encrKey[0] = NULL;
  encrKey[1] = NULL;
  decrKey[0] = NULL;
  decrKey[1] = NULL;

}

//destructor
cLinkMonitorInfo::~cLinkMonitorInfo() 
{
   freeSymKeys();
}

//free any allocated sym keys
void cLinkMonitorInfo::freeSymKeys() 
{
   const char* func = "cLinkMonitorInfo::freeSymKeys";

   CZKS::Exception e;
   
   if (encrKey[0]) {
     if (!frCryptSymFree( e.zkError(), &encrKey[0])) {
        e.Rethrow(func, "fail");
     }
   }
   if (decrKey[0]) {
     if (!frCryptSymFree( e.zkError(), &decrKey[0])) {
        e.Rethrow(func, "fail");
     }
   }
   if (encrKey[1]) {
     if (!frCryptSymFree( e.zkError(), &encrKey[1])) {
        e.Rethrow(func, "fail");
     }
   }
   if (decrKey[1]) {
     if (!frCryptSymFree( e.zkError(), &decrKey[1])) {
        e.Rethrow(func, "fail");
     }
   }
}
