#ifndef _cNetinfoProviderStub

#define _cNetinfoProviderStub

// class cNetinfoProviderStub
//

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

#include "frEnt.h"
#include "zksocket.h"

#include "czkIntervalTime.h"
#include "czkEventHandler.h"
#include "czkLock.h"
#include "czkCoreLoop.h"

#include "cAipComponent.h"
#include "cAipComponentManager.h"

#include "cNetInfoProvider.h"
#include "cAipKernelStub.h"

class cNetinfoProviderStub : public czkEventHandler {

private:

  ZkSocket zksock;
  czkCoreLoop* coreloop;
  cNetInfoProvider* pNetInfoProvider;
  cAipKernelStub* pAipKernelStub;

 //configuration items


public:

  void handleInput( czkSocket*, czkEventHandlerData*);
  void handleOutput( czkSocket*, czkEventHandlerData*);
  void handleException( czkSocket*, czkEventHandlerData*);
  void retryConnect( czkSocket*);
  int32_t handleTimeout( czkEventHandlerData*);

  int32_t connect(int32_t fd, char* path);
  void initSocket(czkCoreLoop* cl, cNetInfoProvider* p, cAipKernelStub* ak);

};

#endif

