#define REV_ID "@(#) $Id: cNetinfoProvider_stub.cpp,v 1.2 2001/04/18 17:38:01 alainc Exp $"
#include <zkrev.h>
#include "cNetInfoProvider.h"
#include "cNetinfoProviderStub.h"
#include "czkSockNativeTCP.h"
#include "czkNetAddr.h"

#include "global.h"

char buf[BUFSIZ];
uint32_t nbytes = 1;

typedef struct netinfo NETINFO;
struct netinfo {
    FrEntIdExp entity;
    ZKPRNetAddr addr;
    uint16_t    dhport;
}; 

cNetInfoEntity::entListType tmpList;

cNetInfoEntity tmp;

const cNetInfoEntity cNetInfoEntity::NullEntity;

  // constructor
cNetInfoProvider::cNetInfoProvider() 
  {
  }

  // destructor
cNetInfoProvider::~cNetInfoProvider() {}

  // validate configuration
bool cNetInfoProvider::validateConfig() 
{ return true;}

  // initialize private data members
bool cNetInfoProvider::initializePrivateData(czkCoreLoop* cl) 
{ 
  coreloop = cl; 
  NETINFO* p;
  for (uint32_t i = 0; i < (nbytes-1)/sizeof(*p); i++)
  {
    p = (NETINFO*) (buf + 1 + i*sizeof(*p));
    cNetInfoEntity* pe = new cNetInfoEntity( p->entity, p->addr, p->dhport);
    tmpList.push_back( *pe);
    ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, "functionalAip", " loaded entuty name %s ", p->entity.name);
  }
  return true; 
}
void cNetInfoProvider::cleanupPrivateData() {} 

  // startup
void cNetInfoProvider::startup() {signalReady(); }
void cNetInfoProvider::shutdown() {}

  // Connect to the local NIDS
bool cNetInfoProvider::connectNids(uint32_t) {return true;};

  void cNetInfoProvider::prodNid(cNetInfoData *) {};

  // Reload internal structures with new, validated data
  void cNetInfoProvider::refresh() {};

  // Return entity of specified type and name
  const cNetInfoEntity &cNetInfoProvider::getEntity(FrEntIdType, const char *) {return tmp;};

  // Return entity of specified type and id.
  const cNetInfoEntity &cNetInfoProvider::getEntity(FrEntIdType, uint32_t) {return tmp;};

  // Return all entities of specified type
  cNetInfoEntity::entListType *cNetInfoProvider::getEntities(FrEntIdType, bool) { return &tmpList;};


  // Return the next KQS entity (round-robin)
  cNetInfoEntity cNetInfoProvider::getNextKQS(void) {return tmp;};

  // Return the next NISS entity (round-robin)
  cNetInfoEntity cNetInfoProvider::getNextNISS(void) 
  {
     FrEntIdExp entity;
     ZKPRNetAddr addr;
     uint16_t    dhport;
     
     czkNetAddr netaddr;
     netaddr.getNetAddr( (const char *)"10.16.128.20", &addr); // jean  
     addr.inet.port = htons(51109);
       
     memset(entity.name, 0, sizeof( entity.name));

     sprintf(entity.name,"NISS\0"); 
     entity.type = FRENT_TYPE_NISS;

     cNetInfoEntity* pe = new cNetInfoEntity( entity, addr, dhport);

     return *pe;
  };

  // Return a list of AIP entities.
  cNetInfoEntity::entListType *cNetInfoProvider::getAIPs(void) { return &tmpList;};

  // Constructor
  cNetInfoEntity::cNetInfoEntity() {};

  // Destructor
  cNetInfoEntity::~cNetInfoEntity() {};

  // Constructor derived from FrNetInfoDatum
  cNetInfoEntity::cNetInfoEntity(const FrNetInfoDatum) {};

  // Copy constructor
  cNetInfoEntity::cNetInfoEntity(const cNetInfoEntity& e)
 {
    idExp = e.idExp;
    netAddr = e.netAddr;
    dhPort = e.dhPort;
 };

  // Assignment operator
 cNetInfoEntity&  cNetInfoEntity::operator=(const cNetInfoEntity& e)
{
  if (this != &e) {
    idExp = e.idExp;
    netAddr = e.netAddr;
    dhPort = e.dhPort;
   }
  return *this;
};

// connect the socket to a file (for Unix Domain sockets)
int32_t cNetinfoProviderStub::connect(int32_t fd, char* path)
{
     int32_t rc;
 
     struct sockaddr_un  addrun;

     memset(&addrun,0,sizeof(addrun));

     addrun.sun_family = AF_LOCAL;
        
     strncpy( addrun.sun_path, path, sizeof(addrun.sun_path) - 1);

     int32_t status = ::connect( fd, 
                                 (struct sockaddr*)&addrun, sizeof (addrun));
     if (status) {
        rc = ZKPR_FAILURE;
     }
     else {
        rc = ZKPR_SUCCESS;      
     }
     return rc;
}

void cNetinfoProviderStub::initSocket(czkCoreLoop* cl, cNetInfoProvider* p, 
                                      cAipKernelStub* ak)
{
  czkSockNativeTCP* stream = new czkSockNativeTCP;

  CZKS::Exception e;

  pNetInfoProvider = p;
  coreloop = cl;
  pAipKernelStub = ak;

  czkNetAddr netaddr;
  ZKPRNetAddr addr;
  memset(&addr, 0 , sizeof(addr));
  addr.inet.family = ZKPR_AF_INET;
  netaddr.initNetAddr( ZKPR_IpAddrLoopback, 6666, &addr);  
  
  //create UDS socket     
  int32_t fd;
  if (!zkSocketNew( e.zkError(), AF_LOCAL, SOCK_STREAM, IPPROTO_IP, &zksock)) {
     cout << " error creating zksocket " << endl;
     abort();
  } 
  else if (!zkSocketGetFD( e.zkError(), zksock, &fd)) {
     cout << " error getting fd zksocket " << endl;
     abort();
  }

  stream->open(fd); 

  ZKPRSocketOptionData opt;
  opt.option = ZKPR_SockOpt_Reuseaddr;
  opt.value.reuse_addr = ZKPR_TRUE;
  stream->setOption( &opt);
  opt.option = ZKPR_SockOpt_Nonblocking;
  opt.value.non_blocking = 1;
  stream->setOption( &opt);

  coreloop->registerHandler( this, NULL, (czkSocket*)stream, 
                             ZKPR_POLL_READ | ZKPR_POLL_EXCEPT);

  if (connect( fd, "/turf/frankf/UDSnetinfo") != ZKPR_SUCCESS) {
    cout << " uds connect failed " << endl;
    retryConnect((czkSocket*)stream);
  }
  else {
    //pAipKernelStub->retryConnect();
  }

} 

void cNetinfoProviderStub::handleInput( czkSocket* sock, czkEventHandlerData* d)
{
  CZKS::Exception e;
 
  ZKPRIntervalTime timeout;
  czkIntervalTime interval;
  timeout = interval.getSeconds(0);

  nbytes = sock->recv( buf, BUFSIZ, 0, timeout); 

  if (buf[0] == 0) {
     pNetInfoProvider->initializePrivateData(coreloop);
  }
  else {
    FrCryptSig n;
    size_t l = nbytes-1;
    assert(frCryptSigNewFromData(e.zkError(), &n, &buf[1], &l));
    setGnymSig(n);
    //retryConnect(sock); 
  }

}

void cNetinfoProviderStub::handleOutput( czkSocket*, czkEventHandlerData*)
{
}

void cNetinfoProviderStub::retryConnect( czkSocket* sock)
{
  CZKS::Exception e;

  cout << " in  cNetinfoProviderStub::retryConnect" << endl;

  coreloop->removeHandler(sock);

  sock->close();
  if (!zkSocketFree( e.zkError(), &zksock)) {
     cout << " error creating zksocket " << endl;
     cout << flush;
     abort();
  } 

  czkIntervalTime interval;
  ZKPRIntervalTime timeout = interval.getSeconds(10);
  coreloop->scheduleTimer( this, NULL, timeout);

  delete sock;

}

void cNetinfoProviderStub::handleException( czkSocket* sock, 
                                        czkEventHandlerData* d)
{
  CZKS::Exception e;
  retryConnect(sock);
}

int32_t cNetinfoProviderStub::handleTimeout( czkEventHandlerData*)
{
  cout << " in  cNetinfoProviderStub::handleTimeout" << endl;
  initSocket(coreloop, pNetInfoProvider, pAipKernelStub);
  return 0;
}
  
    
  
