#ifndef _cPktMon

#define _cPktMon

// class cPktMon
//

#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

#include "frEnt.h"
#include "zksocket.h"

#include "aip-modules.h"

#include "czkIntervalTime.h"
#include "czkEventHandler.h"
#include "czkLock.h"
#include "czkCoreLoop.h"
#include "czkSockDgram.h"

#include "cAipComponent.h"
#include "cAipComponentManager.h"

#include "cLinkManagerInfo.h"

#include "testFunctionalAip.h"

class cLinkMonitor;
class cRouteMonitor;

class cPktMonTimeoutData : public czkEventHandlerData {

 public:

  ZKPRNetAddr addr;
  LinkId      linkId;
  bool        bad;
};

class cPktMon : public czkEventHandler {

private:
  czkCoreLoop*   coreloop;
  cLinkMonitor*  pLinkMonitor;
  cRouteMonitor* pRouteMonitor;
  czkSockDgram*  stream;
  ZKPRNetAddr    addr;
  cPktMonTimeoutData timeoutData;
  czkTimerProxy* pKeepAliveProxy;
  bool        bound;
 //configuration items


public:
  
  cPktMon() { pKeepAliveProxy = NULL; }
  ~cPktMon() {}

  void handleInput( czkSocket*, czkEventHandlerData*);
  void handleOutput( czkSocket*, czkEventHandlerData*);
  void handleException( czkSocket*, czkEventHandlerData*);
  int32_t handleTimeout( czkEventHandlerData*);

  void initSocket(czkCoreLoop* cl, cLinkMonitor* pl, cRouteMonitor* pr, 
                  ZKPRNetAddr, bool);

  void sendKeepAlive(ZKPRNetAddr* addr, LinkId linkId, bool bad);
  void startKeepAlive(ZKPRNetAddr addr, LinkId linkId, 
                      uint32_t repeatInterval, bool bad);
  void cancelKeepAlive();

  void sendPkt(uint8_t* pkt, size_t pktSize, 
               ZKPRNetAddr addr, LinkId linkId);

  void handlePkt( class cLinkMonitorInfo* linkInfo, uint8_t* pkt, 
                  size_t pktLen);

};

#endif

