#ifndef _cRouteCreate

#define _cRouteCreate


#include "cCommandParser.h"

enum RouteAction {ACK, NOACK, BADACK};
enum RouteAuth { AUTH, ANON, ANONRAND};

class cRouteCreate {

 public:

  uint32_t   id;
  FrEntIdExp client;
  uint32_t   nHops;
  FrEntIdExp hop[5];
  bool       fixedAci;
  FrAci      aci;
  RouteAuth  auth;
  uint32_t   anonRand;
  string     nymName;
  bool       validNymSig;
  uint32_t   routeTTL;
  RouteAction action;
  uint32_t   version;
  uint32_t   repeatInterval;
  string     message;
  class cPktMon* pPktMon;
  bool       bad;

  cRouteCreate( QualifierList qualifiers)
  {

    bad = false;
    fixedAci = false;
    repeatInterval = 0;

    QualifierList::iterator i = qualifiers.begin();
    while (i != qualifiers.end())
    {
      StringList vals = i->getVals();

      StringList::iterator j = vals.begin();
      string val = *j;

      if (i->getQualifier() == qualifierID) {
        id = atoi( val.c_str());
      }
      else if (i->getQualifier() == qualifierClientEntityName) {
        memset(client.name, 0, sizeof(client.name));
        strcpy(client.name, val.c_str());
        client.type = FRENT_TYPE_ANON;
      }
      else if (i->getQualifier() == qualifierNHops) {
        nHops = atoi( val.c_str());
      }
      else if (i->getQualifier() == qualifierHop1) {
        memset(hop[0].name, 0, sizeof(hop[0].name));
        strcpy(hop[0].name, val.c_str());
        hop[0].type = FRENT_TYPE_AIP;
      }
      else if (i->getQualifier() == qualifierHop2) {
        memset(hop[1].name, 0, sizeof(hop[1].name));
        strcpy(hop[1].name, val.c_str());
        hop[1].type = FRENT_TYPE_AIP;
      }
      else if (i->getQualifier() == qualifierHop3) {
        memset(hop[2].name, 0, sizeof(hop[2].name));
        strcpy(hop[2].name, val.c_str());
        hop[2].type = FRENT_TYPE_AIP;
      }
      else if (i->getQualifier() == qualifierFixedAci) {
        aci = atoi(val.c_str());
        fixedAci = true;
      }
      else if (i->getQualifier() == qualifierAuthRoute) {
        if (val == valAUTH) {
          auth = AUTH;
	}
        else if (val == valANON) {
          auth = ANON;
	}
        else if (val == valANONRAND) {
          auth = ANONRAND;
          anonRand = id;
	}
      }
      else if (i->getQualifier() == qualifierAnonRand) {
        anonRand = atoi(val.c_str());
      }
      else if (i->getQualifier() == qualifierNymName) {
        nymName = val;
      }
      else if (i->getQualifier() == qualifierValidNymSig) {
        validNymSig = (val == valTRUE);
      }
      else if (i->getQualifier() == qualifierRouteTTL) {
        routeTTL = atoi( val.c_str());
      }
      else if (i->getQualifier() == qualifierAction) {
        if (val == valACK) {
          action = ACK;
	}
        else if (val == valNOACK) {
          action = NOACK;
	}
        else if (val == valBADACK) {
          action = BADACK;
	}
      }
      else if (i->getQualifier() == qualifierVersion) {
        version = atoi( val.c_str());
      }
      else if (i->getQualifier() == qualifierRepeatInterval) {
        repeatInterval = atoi( val.c_str());
      }
      else if (i->getQualifier() == qualifierMessage) {
        message = val;
      }
      else if (i->getQualifier() == qualifierBad) {
        bad = (val == valTRUE);
      }
      i++;
    }
/*      cout << "cRouteCreate id " << id << endl; */
/*      cout << "ClientEntityName " << client.name << endl; */
/*      cout << "nhops " << nHops << endl; */
/*      cout << "hop1 " << hop[0].name << endl; */
/*      cout << "hop2 " << hop[1].name << endl; */
/*      cout << "hop3 " << hop[2].name << endl; */
/*      if (fixedAci) cout << "Aci " << aci << endl; */
/*      cout << "Auth Route " << auth << endl; */
/*      cout << "AnonRand " << anonRand << endl; */
/*      cout << "nymName " << nymName << endl; */
/*      cout << "validNymSig " << validNymSig << endl; */
/*      cout << "routeTTL " << routeTTL << endl; */
/*      cout << "Action " << action << endl; */
/*      cout << "version " << version << endl; */
/*      cout << "repeatInterval " << repeatInterval << endl; */
  }
};

#endif
  
 
