#define REV_ID "@(#) $Id: testFunctionalIntegrationAip.cpp,v 1.2 2001/04/18 17:38:03 alainc Exp $"
#include <zkrev.h>
//
// test tool for the "functionalAip" integration test
//
     
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>

#include <zks.h>
#include "zksexception.h"
#include "zkserr.h"
#include "zksmodule.h"
#include "zkslog.h"
#include "zkslogagent.h"
#include <zkspath.h>
#include <zksini.h>
#include <zkscmdline.h>
#include <zkspath.h>
#include <zkSignal.h>
    
#include <iostream>
#include <ext/hash_map>

#include <fstream>
#include <strstream>

#include "zksocket.h"
#include "frEnt.h"
   
#include "czkLock.h" 
#include "czkCondition.h" 
#include "czkThread.h"
#include "czkFile.h"
#include "czkDirectory.h"
#include "czkNetAddr.h"
#include "czkSystemInfo.h" 
#include "czkSockAcceptor.h"
#include "czkSockConnector.h"
#include "czkSockDgram.h"
#include "czkSockCoDgram.h"
#include "czkSockNativeTCP.h"
#include "czkSockNativeUDP.h"
#include "czkCoreLoop.h"
#include "czkIntervalTime.h"

#include "cPrivateKeys.h"

#include "cDHNego.h"
#include "cPktMon.h"
#include "cLinkMonitor.h"
#include "cRouteMonitor.h"
#include "testFunctionalAip.h"

#include "global.h"

#include "cCommandParser.h"
#include "cDHNegInit.h"
#include "cDHNegRespond.h"
#include "cKeepAlive.h"
#include "cRouteCreate.h"
#include "cRouteExtend.h"
#include "cRouteAck.h"
#include "cRouteDestroy.h"
#include "setupRouteCreate.h"

#include "cRouteCreatePkt.h"

#define UDSnetinfo "/turf/frankf/UDSnetinfo"

typedef list<cCommandParser> CommandList;
CommandList commandList;
uint32_t gRouteId = 0;

class cNetinfo;
void scheduleCommandList(cNetinfo* pNetinfo, czkCoreLoop* coreloop,
                         cLinkMonitor* pLinkMonitor, 
                         cRouteMonitor* pRouteMonitor);

class cTimerData: public czkEventHandlerData {

public:

  string       command;
  cDHNego*     pDHNego;
  FrEntIdExp   entity;
};

class cTimerHandler: public czkEventHandler {
 
 public: 
   void handleInput( czkSocket*, czkEventHandlerData*) {};
   void handleOutput( czkSocket*, czkEventHandlerData*) {};
   void handleException( czkSocket*, czkEventHandlerData*) {};
   int32_t handleTimeout(czkEventHandlerData* user_data);

};

int32_t cTimerHandler::handleTimeout(czkEventHandlerData*)
{

  //    cTimerData* d = (cTimerData*) data;

    return 1;
}  

 
class cNetinfo: public czkEventHandler {
  
 private:
  int32_t acceptedsock;
  czkCoreLoop* coreloop; 
  czkSockNativeTCP* me;
  czkSocket* stream;
  cLinkMonitor* pLinkMonitor;
  cRouteMonitor* pRouteMonitor;
  cTimerHandler* pTimerHandler;
   
 public: 
   cNetinfo() 
      { acceptedsock = 0; };
   ~cNetinfo() {};
   void handleInput( czkSocket*, czkEventHandlerData*);
   void handleOutput( czkSocket*, czkEventHandlerData*);
   void handleException( czkSocket*, czkEventHandlerData*);
   int32_t handleTimeout(czkEventHandlerData* user_data);

  void init( czkCoreLoop* cl, cLinkMonitor* lm, cRouteMonitor* rm, 
             cTimerHandler* th);
  void send(StringList aips, string functionalAip);

};
 
int32_t cNetinfo::handleTimeout(czkEventHandlerData*)
{
  return 0;
} 

void cNetinfo::handleException(czkSocket* zkfd, 
                                        czkEventHandlerData*)
{ 
  PRErrorCode status = PR_GetError();
  
  cout << " got exception " << status << endl;

  coreloop->removeHandler( zkfd);
  zkfd->close();

  acceptedsock = false;
}

void cNetinfo::handleInput(czkSocket* zkfd, 
                                    czkEventHandlerData*)
{
  czkIntervalTime interval;
  ZKPRIntervalTime timeout; 

  ZKPRNetAddr addrfrom;

  //cout << " in handle input " << endl;

  timeout = interval.getSeconds(0);

  if (!acceptedsock) {
    if (zkfd->accept( &stream, &addrfrom, timeout) == 0) {
      cout << " get a connect " << endl;
      scheduleCommandList(this, coreloop, pLinkMonitor, pRouteMonitor);
      coreloop->removeHandler(zkfd);
      zkfd->close();
     } 
    else {
      cout << " error " << PR_GetError() << endl;
    }
  }
}

void cNetinfo::handleOutput(czkSocket* , 
                            czkEventHandlerData* )
{
}

void cNetinfo::init(czkCoreLoop* cl, cLinkMonitor* lm, cRouteMonitor* rm,
                    cTimerHandler* th)
{
  coreloop = cl;
  pLinkMonitor = lm;
  pRouteMonitor = rm;
  pTimerHandler = th;

  CZKS::Exception e;

  czkFile file;
  file.deleteFile(UDSnetinfo);

  czkNetAddr netaddr;
  ZKPRNetAddr addr;
  memset(&addr, 0 , sizeof(addr));
  addr.inet.family = ZKPR_AF_INET;
  netaddr.initNetAddr( ZKPR_IpAddrLoopback, 6666, &addr);  

  ZkSocket s;
  int32_t fd;
  if (!zkSocketNew( e.zkError(), AF_LOCAL, SOCK_STREAM, IPPROTO_IP, &s)) {
     cout << " error creating zksocket " << endl;
     abort();
  } 
  else if (!zkSocketBind( e.zkError(), s, UDSnetinfo)) {
     cout << " error bindinging zksocket " << endl;
     abort();
  } 
  else if (!zkSocketGetFD( e.zkError(), s, &fd)) {
     cout << " error getting fd zksocket " << endl;
     abort();
  }

  me = new czkSockNativeTCP();
  me->open(fd); 

  me->listen( 1);

  cl->registerHandler( this, NULL, (czkSocket*)me, 
                       ZKPR_POLL_READ  | ZKPR_POLL_EXCEPT);

} 

void cNetinfo::send(StringList aips, string functionalAip)
{

  const int n = 100;
  czkNetAddr netaddr;

  struct {
    FrEntIdExp entity;
    ZKPRNetAddr addr;
    uint16_t dhport;
  } tab[n]; 

  ZKPRNetAddr dhaddr;

  char buffer[BUFSIZ];

  uint32_t i = 0;
  StringList::iterator it = aips.begin();
  while (it != aips.end())
  {

    memset( &tab[i], 0, sizeof(tab[i]));
    strcpy(tab[i].entity.name,it->c_str());
    tab[i].entity.type = FRENT_TYPE_AIP;

    cout << " processing " << tab[i].entity.name << endl;

    if (strcmp( tab[i].entity.name, functionalAip.c_str()) == 0) {

      setMyAipEntity(functionalAip.c_str());
      setMyAipAddr();

      tab[i].addr = getMyAipAddr();
      tab[i].dhport = 51102;  

    }
    else {

      tab[i].addr.inet.family = ZKPR_AF_INET;
      netaddr.initNetAddr( ZKPR_IpAddrLoopback, 6000+i, &tab[i].addr);  
      tab[i].dhport = 6100+i;  
      dhaddr.inet.family = ZKPR_AF_INET;
      netaddr.initNetAddr( ZKPR_IpAddrLoopback, 6100+i, &dhaddr);  
   
      //ZKS_LOGDEBUG_2(ZKS_LOG_ANY_MASK, TESTFUNCTIONALAIP, " i %d dhaddr %x ", i, dhaddr);

      cLinkMonitorInfo* info = new cLinkMonitorInfo;
      info->entity = tab[i].entity;         //entity name
      info->linkId = 0;         //link id
      info->addr = tab[i].addr;           //IP address
      info->dhaddr = dhaddr;         //IP address (for DH)
      info->pktMon = new cPktMon;
      info->pktMon->initSocket(coreloop, pLinkMonitor, pRouteMonitor,
                               tab[i].addr, true);

      pLinkMonitor->addLink( tab[i].entity, 0, info);

    }

    i++;
    it++;

  }

  uint8_t command = 0;
  memcpy( buffer, &command, sizeof(command));  
  memcpy( &buffer[1], tab, i*sizeof(tab[0]));  

  czkIntervalTime interval;
  stream->send( buffer, 1+i*sizeof(tab[0]), 0, interval.getSeconds(0)); 
  sleep(1);

  sendNymSig(stream);

}

class cCommandTimerData: public czkEventHandlerData {

 public:

   cCommandParser* pCommand;

};

class cCommandTimerHandler: public czkEventHandler {
 
 public: 
   
   cNetinfo*       pNetinfo;
   czkCoreLoop*    coreloop;
   cLinkMonitor*   pLinkMonitor;
   cRouteMonitor*  pRouteMonitor;

   void handleInput( czkSocket*, czkEventHandlerData*) {};
   void handleOutput( czkSocket*, czkEventHandlerData*) {};
   void handleException( czkSocket*, czkEventHandlerData*) {};
   int32_t handleTimeout(czkEventHandlerData* user_data);
   void handleDHNegInit(czkEventHandlerData* data, cDHNegInit* p);
   void handleDHNegRespond(czkEventHandlerData* data, cDHNegRespond* p);
   void handleKeepAlive(czkEventHandlerData* data, cKeepAlive* p);
   void handleRouteCreate(czkEventHandlerData* data, cRouteCreate* p);
   void handleRouteExtend(czkEventHandlerData* data, cRouteExtend* p);
   void doRouteCreate(czkEventHandlerData* data, cRouteCreate* p,
                      bool extendRoute, FrAci specAci,
                      cRouteMonitorInfo* routeInfoIn);
   void handleRouteAck(czkEventHandlerData* data, cRouteAck* p);
   void handleRouteDestroy(czkEventHandlerData* data, cRouteDestroy* p);

   void printMessage(string message);

};

void cCommandTimerHandler::printMessage(string message)
{
  if (message.size() > 0) {
    string temp = message.substr(10);
    for (int i = 0; i < temp.size(); i++)
      if (temp[i] == '-') temp[i] = ' ';
    ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, TESTFUNCTIONALAIP, "%s", temp.c_str());
  }
} 

void cCommandTimerHandler::handleRouteDestroy(czkEventHandlerData* data, 
                                              cRouteDestroy* p)
{
  const char* func = " cCommandTimerHandler::handleRouteDestroy";

  (void)data;

  cRouteMonitorInfo* r = pRouteMonitor->findRoute(p->id);
  if (!r) {
     CZKS::Throw( TESTFUNCTIONALAIP, TESTFUNCTIONALAIP_ROUTEIDNOTFOUND_ERR,
                  func, "Route id not found");
   }
 
   printMessage( p->message);
 
   cRouteDestroyPkt pkt;
   pkt.create( p->version, FRPKT_PRIORITY_DEFAULT, r->prevAci, 
               p->errorCode, p->entity);
                
   uint8_t *buf;
   size_t   buflen;
   pkt.getBuffer( &buf, &buflen);

   cLinkMonitorInfo* info;
   info = pLinkMonitor->findLink( r->prevLinkId);
   if (!info) {
      CZKS::Throw( TESTFUNCTIONALAIP, TESTFUNCTIONALAIP_LINKIDNOTFOUND_ERR,
                   func, "pLinkMonitor->findLink failed");
   }
   
   if (info->pktMon == NULL) {
     info->pktMon = new cPktMon;
     info->pktMon->initSocket(coreloop, pLinkMonitor, pRouteMonitor, 
                              info->addr, false);
   }
      
   if (p->bad) buflen--;
   info->pktMon->sendPkt(buf, buflen, 
                         getMyAipAddr(), info->linkId);
   pkt.destroy();
}

void cCommandTimerHandler::handleRouteAck(czkEventHandlerData*, 
                                          cRouteAck* p)
{
  const char* func = "cCommandTimerHandler::handleRouteAck";

  cRouteMonitorInfo* r = pRouteMonitor->findRoute(p->id);
  if (!r) {
     CZKS::Throw( TESTFUNCTIONALAIP, TESTFUNCTIONALAIP_ROUTEIDNOTFOUND_ERR,
                  func, "Route id not found");
   }
  
   printMessage( p->message);
 
   cRouteCreateAckPkt pkt;
   pkt.create( p->version, FRPKT_PRIORITY_DEFAULT, r->exitAci, r->prevAci,
               r->MacKey[0]);
                
   uint8_t *buf;
   size_t   buflen;
   pkt.getBuffer( &buf, &buflen);

   cLinkMonitorInfo* info;
   info = pLinkMonitor->findLink( r->nextLinkId);
   if (!info) {
      CZKS::Throw( TESTFUNCTIONALAIP, TESTFUNCTIONALAIP_LINKIDNOTFOUND_ERR,
                   func, "pLinkMonitor->findLink failed");
   }
   
   if (info->pktMon == NULL) {
     info->pktMon = new cPktMon;
     info->pktMon->initSocket(coreloop, pLinkMonitor, pRouteMonitor, 
                              info->addr, false);
   }
      
   if (p->bad) buflen--;
   info->pktMon->sendPkt(buf, buflen, 
                         getMyAipAddr(), info->linkId);

   pkt.destroy();
 }

void cCommandTimerHandler::doRouteCreate(czkEventHandlerData*, 
                                         cRouteCreate* p,
                                         bool extendRoute, FrAci specAci,
                                         cRouteMonitorInfo*)
{
   const char* func = "cCommandTimerHandler::doRouteCreate";

   CZKS::Exception e;

   uint8_t       * pkt;
   size_t          pktSize;
   FrCryptCrypt    aipKey[5];
   FrCryptSig      nymSig;
   FrAci           aci;
   setupRouteCreatePkt(e.zkError(), p->nHops, p->hop, p->fixedAci, p->aci, 
                       p->nymName.c_str(), p->validNymSig, p->routeTTL,
                       p->version, extendRoute, specAci, 
                       p->auth, p->anonRand,   
                       &pkt, &pktSize, 
                       aipKey, &nymSig, &aci);

   printMessage( p->message);
 
   cRouteCreatePkt* rcPkt = new cRouteCreatePkt;
   rcPkt->attachPkt( pkt, pktSize);

   FrEntIdExp entity = getMyAipEntity();
   uint32_t i;
   bool lastHop = false;
   for (i = 0; i < p->nHops; i++) 
   {
     if (memcmp( &entity, &p->hop[i], sizeof(entity)) == 0) {
       break;
     }
     else {
       lastHop = rcPkt->decrypt( aipKey[i]);
     }
   }
   if (i == p->nHops) {
     CZKS::Throw( TESTFUNCTIONALAIP, TESTFUNCTIONALAIP_FUNCAIPNOTINROUTE_ERR,
                  func, " ");
   }

   lastHop = (i == p->nHops-1);

   rcPkt->getBuffer( &pkt, &pktSize); 
   rcPkt->detachPkt();

   cLinkMonitorInfo* info;
   if (i == 0) {
     info = pLinkMonitor->findLink( p->client);
     if (!info) {
       CZKS::Throw( TESTFUNCTIONALAIP, TESTFUNCTIONALAIP_ENTITYNOTFOUND_ERR,
                    func, "%s", p->client.name);
     }
   } 
   else {
     info = pLinkMonitor->findLink( p->hop[i-1]);
     if (!info) {
       CZKS::Throw( TESTFUNCTIONALAIP, TESTFUNCTIONALAIP_ENTITYNOTFOUND_ERR,
                    func, "%s", p->hop[i-1].name);
     }
   }
   
   if (info->pktMon == NULL) {
     info->pktMon = new cPktMon;
     info->pktMon->initSocket(coreloop, pLinkMonitor, pRouteMonitor, 
                              info->addr, false);
   }
      
   if (p->bad) pktSize--;

   info->pktMon->sendPkt(pkt, pktSize, 
                         getMyAipAddr(), info->linkId);

   cRouteMonitorInfo* routeInfo;
     routeInfo = new cRouteMonitorInfo();
     routeInfo->routeId = p->id;
     routeInfo->lastHop = lastHop;
     routeInfo->nHops = p->nHops;
     routeInfo->iHop = i;
     routeInfo->prevAci = aci;
     routeInfo->prevLinkId = info->linkId;
     //routeInfo->MacKey = getMacKey(p->nHops-1);
     for (int j = 0; j < p->nHops; j++)
     {
        routeInfo->MacKey[j] = getMacKey(j);
        routeInfo->fwdSym[j] = getFwdSym(j);
        routeInfo->bwdSym[j] = getBwdSym(j);
     }
     routeInfo->nextLinkId = 0;
     if (!lastHop) {
       cLinkMonitorInfo* nextinfo = pLinkMonitor->findLink( p->hop[i+1]);
       if (nextinfo) {
         routeInfo->nextLinkId = nextinfo->linkId;
       }
     }
     ZKS_LOGDEBUG_3(ZKS_LOG_ANY_MASK, TESTFUNCTIONALAIP,"adding route id %d prevAci %d prevLinkId %d", routeInfo->routeId, routeInfo->prevAci, routeInfo->prevLinkId);
     pRouteMonitor->insertRouteTableEntry( p->id, routeInfo);   

   routeInfo->gotAck = false;
   routeInfo->gotDestroy = false;
   routeInfo->action = p->action;

}

void cCommandTimerHandler::handleRouteExtend(czkEventHandlerData* data, 
                                             cRouteExtend* p)
{
   const char* func = "cCommandTimerHandler::handleRouteExtend";

  cRouteMonitorInfo* r = pRouteMonitor->findRoute(p->id);
  if (!r) {
     CZKS::Throw( TESTFUNCTIONALAIP, TESTFUNCTIONALAIP_ROUTEIDNOTFOUND_ERR,
                  func, "pRouteMonitor->findRoute failed");
   }
  
   doRouteCreate(data, p, true, p->exitAci ? r->exitAci : 0, r);    

}

void cCommandTimerHandler::handleRouteCreate(czkEventHandlerData* data, 
                                             cRouteCreate* p)
{
   const char* func = "cCommandTimerHandler::handleRouteCreate";

   CZKS::Exception e;

   if (p->id == 0) p->id = ++gRouteId;
   doRouteCreate(data, p, false, 0, NULL);    
   
   if (p->repeatInterval > 0) {
     czkIntervalTime ti;
     coreloop->scheduleTimer( this, data, 
                              ti.getSeconds( p->repeatInterval)); 
   }
}

void cCommandTimerHandler::handleKeepAlive(czkEventHandlerData*, 
                                           cKeepAlive* p)
{
    printMessage( p->message);
 
    cLinkMonitorInfo* info = pLinkMonitor->findLink( p->entity);
    if (info) {
      if (info->pktMon == NULL) {
        info->pktMon = new cPktMon;
        info->pktMon->initSocket(coreloop, pLinkMonitor, pRouteMonitor, 
                                 info->addr, true);
      }
      info->pktMon->startKeepAlive( getMyAipAddr(), info->linkId, 
                                    p->repeatInterval, p->bad);
    }
}

void cCommandTimerHandler::handleDHNegInit(czkEventHandlerData* data, 
                                           cDHNegInit* p)
{
    ZKPRNetAddr dhaddr;
    cLinkMonitorInfo* info = pLinkMonitor->findLink( p->entity);
    if (info) {
      dhaddr = info->dhaddr;
    }
    else if (p->entity.type == FRENT_TYPE_ANON) {
      //ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, TESTFUNCTIONALAIP," adding linkmon entry for %s",
      //               p->entity.name);
      info = new cLinkMonitorInfo;
      info->entity = p->entity;         //entity name
      info->linkId = 0;         //link id
      info->pktMon = new cPktMon;
      info->addr.inet.family = ZKPR_AF_INET;
      czkNetAddr netaddr;
      netaddr.initNetAddr( ZKPR_IpAddrLoopback, 6200, &info->addr);  
      info->pktMon->initSocket(coreloop, pLinkMonitor, pRouteMonitor, 
                               info->addr, true);
      pLinkMonitor->addLink( p->entity, 0, info);
    } 

    if (info->pDHNego && info->pDHNego->doInit) {
      if (!info->pDHNego->successInit && p->action == Pass) {
        ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, TESTFUNCTIONALAIP,"DH Init failed from %s ", 
                       p->entity.name);
      }
      info->pDHNego->doInit = false;
      if (p->repeatInterval > 0) {
         czkIntervalTime ti;
         coreloop->scheduleTimer( this, data, 
                                ti.getSeconds( p->repeatInterval)); 
      }
      return;
    }

    if (!info->pDHNego) {
      info->pDHNego = new cDHNego;
      info->pDHNego->init( coreloop, pLinkMonitor);
    }

    czkNetAddr netaddr;

    ZKPRNetAddr addr;

    //ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, TESTFUNCTIONALAIP, "trying a DHConnect entity %s ", 
    //               p->entity.name);

    addr.inet.family = ZKPR_AF_INET;
    assert(netaddr.getNetAddr("10.16.128.115", &addr) == ZKPR_SUCCESS);

    if (p->entity.type == FRENT_TYPE_AIP) {
       addr.inet.port = htons(51101);
    }
    else {
       addr.inet.port = htons(51102);
    }
    info->pDHNego->doInit = true;
    info->pDHNego->connect( addr, p->entity, p->action);

    printMessage( p->message);
 
    if (p->maxWait > 0) {
       czkIntervalTime ti;
       coreloop->scheduleTimer( this, data, 
                                ti.getSeconds( p->maxWait)); 
    }

}

void cCommandTimerHandler::handleDHNegRespond(czkEventHandlerData* data, 
                                              cDHNegRespond* p)
{
    const char*func = "cCommandTimerHandler::handleDHNegRespond";

    ZKPRNetAddr dhaddr;
    cLinkMonitorInfo* info = pLinkMonitor->findLink( p->entity);
    if (info) {
      dhaddr = info->dhaddr;
    }
    else {
      CZKS::Throw( TESTFUNCTIONALAIP, 1, func, "entity not defined");
    } 

    if (info->pDHNego && info->pDHNego->doResp) {
      if (!info->pDHNego->successResp && 
          p->action == Pass) {
        ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, TESTFUNCTIONALAIP,"No DH Response to %s ", 
                       p->entity.name);
      }
      info->pDHNego->doResp = false;
      if (!p->repeat) {
        info->pDHNego->closeSocket();
        return;
      }
    }

    if (!info->pDHNego) {     
      info->pDHNego = new cDHNego;
      info->pDHNego->init( coreloop, pLinkMonitor);
      info->pDHNego->initSocket( dhaddr, p->entity, 
                                 p->action);
    }

    printMessage( p->message);
 
    info->pDHNego->doResp = true; 
    info->pDHNego->successResp = false;
    czkIntervalTime ti;
    coreloop->scheduleTimer( this, data, 
                             ti.getSeconds( p->maxWait));

}

int32_t cCommandTimerHandler::handleTimeout(czkEventHandlerData* data)
{

    cCommandTimerData* d = (cCommandTimerData*) data;

    string functionalAip;

    QualifierList q = d->pCommand->getQualifiers();

    if (d->pCommand->getCommand() == commandNetInfoList) {

      QualifierList::iterator i = q.begin();
      while (i != q.end())
      {
        if (i->getQualifier() == qualifierFunctionalAip) {
          StringList temp = i->getVals();
	  StringList::iterator j = temp.begin();
          functionalAip = *j;
	}
        else if (i->getQualifier() == qualifierEntityList) {
          StringList aips = i->getVals();
          pNetinfo->send( aips, functionalAip);
	}
	i++;
      }
    }
    else if (d->pCommand->getCommand() == commandStop) {

      ZKS_LOGDEBUG_0(ZKS_LOG_ANY_MASK, TESTFUNCTIONALAIP,"STOP");    
      exit(1);
      
    }
    else if (d->pCommand->getCommand() == commandDHNegInit) {
     
      cDHNegInit* p = new cDHNegInit(q);

      handleDHNegInit( data, p);
      
    }
    else if (d->pCommand->getCommand() == commandDHNegRespond) {
     
      cDHNegRespond* p = new cDHNegRespond(q);

      handleDHNegRespond( data, p);
      
    }
    else if (d->pCommand->getCommand() == commandKeepAlive) {
     
      cKeepAlive* p = new cKeepAlive(q);

      handleKeepAlive( data, p);
      
    }
    else if (d->pCommand->getCommand() == commandRouteCreate) {
     
      cRouteCreate* p = new cRouteCreate(q);

      handleRouteCreate( data, p);
      
    }
    else if (d->pCommand->getCommand() == commandRouteExtend) {
     
      cRouteExtend* p = new cRouteExtend(q);

      handleRouteExtend( data, p);
      
    }
    else if (d->pCommand->getCommand() == commandRouteAck) {
     
      cRouteAck* p = new cRouteAck(q);

      handleRouteAck( data, p);
      
    }
    else if (d->pCommand->getCommand() == commandRouteDestroy) {
     
      cRouteDestroy* p = new cRouteDestroy(q);

      handleRouteDestroy( data, p);
      
    }

    return 0;
}  

 
void scheduleCommandList(cNetinfo* pNetinfo, czkCoreLoop* coreloop,
                         cLinkMonitor* pLinkMonitor, 
                         cRouteMonitor* pRouteMonitor)
{
    cCommandTimerHandler* commandHandler = new cCommandTimerHandler;

    commandHandler->pNetinfo     = pNetinfo;
    commandHandler->coreloop     = coreloop;
    commandHandler->pLinkMonitor = pLinkMonitor;
    commandHandler->pRouteMonitor = pRouteMonitor;
    
    CommandList::iterator cl = commandList.begin();
    while (cl != commandList.end())
    {
    
       cout << " time " << cl->getTime() << endl;

       czkIntervalTime ti;
       cCommandTimerData* d = new cCommandTimerData;
       d->pCommand = &(*cl);
       coreloop->scheduleTimer( commandHandler, d, 
                                ti.getSeconds( cl->getTime())); 

       cout << " command " << cl->getCommand() << endl;

       QualifierList ql = cl->getQualifiers();

       QualifierList::iterator i = ql.begin();
       while (i != ql.end())
       {
          cout << " qual " << i->getQualifier() << endl;

          StringList vals = i->getVals();
  
          StringList::iterator j = vals.begin();
          while (j != vals.end())
          {
	     cout << " val " << *j << endl;
             j++;
          }
          i++;
       }

       cl++;
    }   

}

int main( int argc, char** argv)
{
    (void)argc;

    cNetinfo netinfo;

    const char         * func = "testFunctionalAip";
    ZksErr               zkserr = NULL;
    ZksLogAgent          logAgent = NULL;
    CZKS::Exception      zksException;

    if( !::zksLogInit(CZKS::Path(argv[0]).basename().c_str()) ||
        !::zksLogTermInit() ) {
      return 1;
    }

    if( !zksErrNew(&zkserr) ) {
      fprintf(stderr,"zksErrNew failed");
      exit(1);
     }

    if (!zksLogAgentFileNew( zkserr, &logAgent, "./test.log",
                             ZKS_LOGAGENT_FILEPERM_USER_READ   |
                             ZKS_LOGAGENT_FILEPERM_USER_WRITE  |
                             ZKS_LOGAGENT_FILEPERM_GROUP_READ  |
                             ZKS_LOGAGENT_FILEPERM_GROUP_WRITE |
                             ZKS_LOGAGENT_FILEPERM_OTHER_READ) ) {
      fprintf(stderr, "%s: can't allocate the log agent.\n",
              TESTFUNCTIONALAIP);
      exit(1);
    }
  
    if (argc < 2) {
      fprintf(stderr, "%s: USAGE: testFunctionalAip input-file.\n",
              TESTFUNCTIONALAIP);
      exit(1);
    }


    ifstream ins(argv[1]);
    //output it to filebuf.out
    ostrstream os;
    os << ins.rdbuf() << endl;

    cParser p;
    StringList commands;
    string commandbuf = os.str();
    string sep = "\n";
    p.split(commandbuf, sep, commands);

    StringList::iterator c = commands.begin();
    while (c != commands.end())
    {
       cCommandParser cp(*c);

       commandList.push_back(cp);

       c++;
    }

    try {
      try {
        if (!frCryptInit(zksException.zkError(), 0)) {
          CZKS::Throw(zksException);
        }

        czkCoreLoop* coreloop = new czkCoreLoop;
  
        setPrivateKeys(coreloop);

        cRouteMonitor routeMonitor;
        
        cLinkMonitor linkMonitor;
        linkMonitor.init(coreloop);

        cTimerHandler th;

        netinfo.init(coreloop, &linkMonitor, &routeMonitor, &th);

        coreloop->runEventLoop();
      }
      catch (CZKS::Exception& e) {
        e.Rethrow(TESTFUNCTIONALAIP, " aborting main");
      }
      catch (...) {
        CZKS::Rethrow("main", "... abort");
      }
  }
  catch (CZKS::Exception& e) {
    CZKS::LogException(e);
  }
}  



