#ifndef __CUAIPKAIPINTCOMMCENTER_H
#define __CUAIPKAIPINTCOMMCENTER_H

#include "czkNetAddr.h"
#include "czkSocket.h"
#include "czkSockAcceptor.h"
#include "czkSockConnector.h"
#include "commonUtils.h"

class cCommCenter
{
private:
    // copy constructor
    cCommCenter(const cCommCenter &) { assert(0); };
    
    // assignment operator
    void operator=(const cCommCenter &) { assert(0); };

    
public:
    // constructor
    cCommCenter();
    
    // destructor
    virtual ~cCommCenter();

    // initializor
    void init(bool isServer);

    // process a request
    void processRequest(Request & request);


    
    //
    // server only
    //
     
    // handle functional aip request
    void getRequest();

    // set netinfo list
    void setNetInfoList(NetInfoList & niList);

    // await functional aip
    void awaitClient();

    // get the keepalive count of functional aip for the specified peer aip
    uint32_t getKeepAliveCount(AipInfo &);

    // cause a (faked) link breakdown to specified aip for the functional aip
    void setAipDown(AipInfo &);

    // set the result of the subsequent DH nego as set by the stubbed DHNegotiator
    // of the functional aip
    void setDHResult(DHNegoResult result);

    // cause a (faked) DH nego between the functional aip and the specified aip
    void doDH(AipInfo & aipInfo, uint8_t lekv);


    //
    // client only
    // 

    NetInfoList & getAipList();
    void getNetinfo();

private:
    czkNetAddr             netAddr;
    bool                   server;      // indicates if the object is a server (or client)  
                                        // (server = test tool; client = funct aip)
    bool                   initialized; // indicates if the object was initialized
    NetInfoList            netinfoList;

     // reference to netinfo
    czkSockAcceptor        acceptSock;  // connection acceptor socket (server only)
    czkSockConnector     * commSock;    // reference to communication socket

public:
    czkSocket * getCommSock();
};

#endif // __CUAIPKAIPINTCOMMCENTER_H
