#ifndef _CUAIPKAIPINTAIP_H
#define _CUAIPKAIPINTAIP_H

#include "zkPrdefs.h"
#include "czkSockDgram.h"
#include "czkNetAddr.h"
#include "commonUtils.h"
#include "cKeyStore.h"


#define AIP_PKT_SIZE      128


#define MAX_HOP 
class cRouteInfo
{
public:
    uint8_t             nbNextHops;         // nb of hops following the current aip
    AipInfo             hopInfo[MAX_HOP];   // aip info of each following hops
    uint32_t            timeout;            // route duration (in secs)
    uint8_t             version;            // route version
    FrAci               aci;
};

class cFakeAip
{
private:
    // copy constructor (disabled)
    cFakeAip(const cFakeAip &) { assert(0); };
    
    // assignment operator (disabled)
    void operator=(const cFakeAip &) { assert(0); };

public:
    // constructor
    cFakeAip(cKeyStore & keyStoreIn, AipInfo &aipInfo);

    // destructor
    virtual ~cFakeAip();

    // initializor
    void init();
    
    // send a keepalive to a peer aip
    void sendKeepalive(AipInfo &, uint8_t lekv);

    // format and send a route create packet
    void buildRoute(cRouteInfo &, uint8_t lekv);

    // receive an ack packet that indicates completion of route creation
    void completeRoute(cRouteInfo &, FrAci * exitAci);

    // send data pkt through specified route
    void sendDataPkt(cRouteInfo & routeInfo,
                     char * pkt, size_t size, uint8_t lekv);
                       
private:
    czkNetAddr             netAddr;
    cKeyStore            * keyStore;     // reference to the key store
    FrEntIdExp             entity;       // AIP entity id
    ZKPRNetAddr            addr;         // AIP IP address and freedom port number
    czkSockDgram           sock;         // Freedom in/out packets socket
    
};

#endif // _CUAIPKAIPINTAIP_H
