#include "netinet/ip.h"
#include "netinet/udp.h"
#include "czkNetAddr.h"
#include "czkSockDgram.h"

#define INETSERVER_PORT  28433
#define INETSERVER_PKT_PAYLOAD_SIZE   40
#define INETSERVER_PKT_SIZE     (sizeof(struct iphdr) + sizeof(struct udphdr) + INETSERVER_PKT_PAYLOAD_SIZE)

class cInetServer
{
private:
    // copy constructor (disabled)
    cInetServer(const cInetServer &) { assert(0); };

    // assignment operator (disabled)
    void operator=(const cInetServer &) { assert(0); };

public:
    // constructor
    cInetServer();

    // destructor
    ~cInetServer();

    // initializor
    void init();

    // build an internet server packet
    void buildPkt(char * pkt);

    // receive a pkt that was originally built with buildPkt()
    // and verify the validity of the content
    bool recvAndVerifyPkt(uint16_t * sourcePort);
    
private:
    bool         initialized;
    czkNetAddr   netAddr;
    czkSockDgram sock;
};
