#define REV_ID "@(#) $Id: cKeyStore.cpp,v 1.2 2001/04/18 18:25:51 alainc Exp $"
#include <zkrev.h>
#include "zksexception.h"
#include "commonUtils.h"
#include "cKeyStore.h"

cKeyStore::cKeyStore()
{
    pubCryptKey = NULL;
    privCryptKey = NULL;
    pubSigKey = NULL;
    privSigKey = NULL;
    symKey[0] = NULL;
    symKey[1] = NULL;
}

cKeyStore::~cKeyStore()
{
    CZKS::Exception e;
    
    if (pubCryptKey != NULL)
    {
        assert(frCryptPubKeyFree(e.zkError(), &pubCryptKey));
    }
    if (privCryptKey != NULL)
    {
        assert(frCryptPubKeyFree(e.zkError(), &privCryptKey));
    }
    if (pubSigKey != NULL)
    {
        assert(frCryptSigFree(e.zkError(), &pubSigKey));
    }
    if (privCryptKey != NULL)
    {
        assert(frCryptSigFree(e.zkError(), &privSigKey));
    }
    if (symKey[0] != NULL)
    {
        assert(frCryptSymFree(e.zkError(), &symKey[0]));
    }
    if (symKey[1] != NULL)
    {
        assert(frCryptSymFree(e.zkError(), &symKey[1]));
    }
}

void cKeyStore::init()
{
    const char * func = "cKeyStore::init";
    const char * msg = NULL;

    try
    {
        msg = "generating public crypto key";
        generatePubCryptKey(&pubCryptKey);

        msg = "generating private crypto key";
        generatePrivCryptKey(&privCryptKey);
        
        msg = "generating public signature key";
        generatePubCryptKey(&pubSigKey);

        msg = "generating private signature key";
        generatePrivCryptKey(&privSigKey);
        
        msg = "generating symmetric key 0";
        generateSymKey(&symKey[0], 0);

        msg = "generating symmetric key 1";
        generateSymKey(&symKey[1], 1);
    }
    catch(...)
    {
        CZKS::Rethrow(func, msg);
    }
}
