#ifndef __CKEYSTORE_H
#define __CKEYSTORE_H

#include <assert.h>
#include "frCrypt.h"


class cKeyStore
{
private:
    // copy constructor (disabled)
    cKeyStore(const cKeyStore &) { assert(0); }

    // assignment operator (disabled)
    void operator=(const cKeyStore &) { assert(0); }
    
public:
    // constructor
    cKeyStore();

    // destructor
    virtual ~cKeyStore();

    // initialize
    void init();

private:
    FrCryptPubKey pubCryptKey;
    FrCryptPubKey privCryptKey;
    FrCryptPubKey pubSigKey;
    FrCryptPubKey privSigKey;
    FrCryptSym    symKey[2];

public:
    FrCryptPubKey& getPubCryptKey() { return(pubCryptKey); };
    FrCryptPubKey& getPrivCryptKey() { return(privCryptKey); };
    FrCryptPubKey& getPubSigKey() { return(pubSigKey); };
    FrCryptPubKey& getPrivSigKey() { return(privSigKey); };
    FrCryptSym&    getSymKey(uint8_t lekv) { return(symKey[lekv]); };
};

#endif //__CKEYSTORE_H
