#define REV_ID "@(#) $Id: cLinkMaintainerStub.cpp,v 1.2 2001/04/18 18:25:51 alainc Exp $"
#include <zkrev.h>
#include <map>
#include "cLinkManagerInfo.h"
#include "cLinkManager.h"
#include "cLinkMaintainer.h"
#include "commonUtils.h"

//"less than" function for the LinkNameTable map definition
struct lessentname
{
  bool operator()(const FrEntIdExp s1, const FrEntIdExp s2) const
  {
    bool rc = (memcmp(&s1, &s2, sizeof(s1)) < 0);
    return rc;
  }
};

typedef struct
{
    uint32_t           keepaliveCount;
    cLinkManagerInfo * linkInfo;
} LinkInfo;

typedef map<FrEntIdExp, LinkInfo, lessentname> LinkInfoTable;
LinkInfoTable linkInfoTable;


cAipComponentManager * cm;

uint32_t getKeepaliveCount(FrEntIdExp & entity)
{
    return (linkInfoTable[entity].keepaliveCount);
}

void reportAipDown(FrEntIdExp & entity)
{
    cLinkManager * lm = (cLinkManager*)cm->get(ZKS_LINKMANAGER_MOD);
    LinkInfoTable::iterator i = linkInfoTable.find(entity);
    lm->reportLinkState(linkDown, i->second.linkInfo);
}


//
// cLinkMaintainer stubs
// 
// 

cLinkMaintainer::cLinkMaintainer()
{
}

cLinkMaintainer::~cLinkMaintainer()
{
}

bool cLinkMaintainer::validateConfig(cConfigProvider*)
{
    return true;
}

bool cLinkMaintainer::initializePrivateData(czkCoreLoop *pCoreloop)
{
  coreloop = pCoreloop;
  cm = pComponentManager;
  return true;
}
 
void cLinkMaintainer::startup()
{
  cPktDispatcher *pPD = (cPktDispatcher *)
    pComponentManager->get(ZKS_PACKETDISPATCHER_MOD);

  pPD->registerHandler(FRPKTTYPE_AIP_ALIVE, this);
}

void cLinkMaintainer::shutdown()
{
}

void cLinkMaintainer::registerLink(cLinkManagerInfo *linkManInfo)
{
    LinkInfoTable::iterator i = linkInfoTable.find(linkManInfo->getEntity());
    if (i == linkInfoTable.end()) 
    {
        LinkInfo info;
        info.keepaliveCount = 0;
        info.linkInfo = linkManInfo;
        linkInfoTable[linkManInfo->getEntity()] = info;
    }
}

void cLinkMaintainer::removeLink(cLinkManagerInfo *linkManInfo)
{
    LinkInfoTable::iterator i = linkInfoTable.find(linkManInfo->getEntity());
    if (i != linkInfoTable.end()) 
    {
        linkInfoTable.erase(i);
    }
}

void cLinkMaintainer::handleInput(czkSocket *, czkEventHandlerData *)
{
}

void cLinkMaintainer::handleOutput(czkSocket *, czkEventHandlerData *)
{
}

void cLinkMaintainer::handleException(czkSocket *, czkEventHandlerData *)
{
}

int32_t cLinkMaintainer::handleTimeout(czkEventHandlerData *)
{
    return 0;
}

void cLinkMaintainer::handlePkt(cLinkManagerInfo *info, 
                                uint8_t *someint, size_t size)
{
  linkInfoTable[info->getEntity()].keepaliveCount++;
  printf("Yeah\n");
}

