#define REV_ID "@(#) $Id: cNetInfoProviderStub.cpp,v 1.2 2001/04/18 18:25:51 alainc Exp $"
#include <zkrev.h>
#include "zksexception.h"
#include "cNetInfoEntity.h"
#include "cNetInfoProvider.h"
#include "cCommCenter.h"


extern cCommCenter commCenter;

cNetInfoEntity::entListType netInfoAipList;


// 
// cNetInfoEntity stubs
// 
// 

const cNetInfoEntity cNetInfoEntity::NullEntity;

cNetInfoEntity::cNetInfoEntity()
{
}

cNetInfoEntity::~cNetInfoEntity()
{
}

cNetInfoEntity::cNetInfoEntity(const cNetInfoEntity& toCopy)
{
    CZKS::Exception e;
    idNum = toCopy.idNum;

    if (!frEntCopy(e.zkError(), &idExp, 
		   const_cast<FrEntIdExp*> (&toCopy.idExp))) {
      CZKS::Throw(e);
    }

    dhPort = toCopy.dhPort;

    netAddr.inet.family = toCopy.netAddr.inet.family;
    netAddr.inet.ip     = toCopy.netAddr.inet.ip;
    netAddr.inet.port   = toCopy.netAddr.inet.port;
}

// 
// cNetInfoProvider stubs
// 
// 

cNetInfoProvider::cNetInfoProvider()
{
}

cNetInfoProvider::~cNetInfoProvider()
{
}

bool cNetInfoProvider::validateConfig(cConfigProvider*)
{
    return true;
}

bool cNetInfoProvider::initializePrivateData(czkCoreLoop *pCoreloop)
{
  coreloop = pCoreloop;
  return true;
}
 
void cNetInfoProvider::startup()
{
}

void cNetInfoProvider::shutdown()
{
}

cNetInfoEntity::entListType * cNetInfoProvider::getAIPs()
{
    NetInfoList aipList = commCenter.getAipList();

    // Empty the list
    while (netInfoAipList.size() > 0)
    {
        netInfoAipList.erase(netInfoAipList.begin());
    }
    
    // Fill up the list
    for (uint32_t i = 0; i < aipList.nbAipInfo; i++)
    {
        cNetInfoEntity entity(aipList.aipInfo[i].entity,
                              aipList.aipInfo[i].addr,
			      ntohs(aipList.aipInfo[i].addr.inet.port) );
	//                              24363);  // DH is stubbed, so can be anything
	
	netInfoAipList.push_front(entity);
	//        netInfoAipList.insert(0, entity);
    }

    return(&netInfoAipList);
}
