#define REV_ID "@(#) $Id: cPrivateKeysStub.cpp,v 1.2 2001/04/18 18:25:51 alainc Exp $"
#include <zkrev.h>
#include "zksexception.h"
#include "frCrypt.h"
#include "cPrivateKeys.h"
#include "commonUtils.h"


static FrCryptPubKey privCryptKey;
static FrCryptSig    privSigKey;

cPrivateKeys::cPrivateKeys()
{
    generatePrivCryptKey(&privCryptKey);
    generatePrivSigKey(&privSigKey);
}

cPrivateKeys::~cPrivateKeys()
{
    CZKS::Exception e;
    
    assert(frCryptPubKeyFree(e.zkError(), &privCryptKey));
    assert(frCryptSigFree(e.zkError(), &privSigKey));
}

bool cPrivateKeys::validateConfig(cConfigProvider*)
{
    return true;
}

bool cPrivateKeys::initializePrivateData(czkCoreLoop *pCoreloop)
{
  coreloop = pCoreloop;
  return true;
}
 
void cPrivateKeys::startup()
{
}

void cPrivateKeys::getCryptKey(uint32_t, FrCryptPubKey* key)
{
    *key = privCryptKey;
}

void cPrivateKeys::getSigKey(uint32_t, FrCryptPubKey* key)
{
    *key = privSigKey;
}
