/*
 * $Id: dispatcher.h,v 1.1 2000/02/03 03:42:28 philippe Exp $
 */

#ifndef DISPATCHER_H_
#define DISPATCHER_H_

#include "dispatcherTypes.h"
#include "msgstr.h"

#define VERSION_STR "Zero-Knowledge Connection Dispatcher V1.0 ("__DATE__", "__TIME__")"

/*
 * Function prototypes
 */

int commandWrite_va ( enum ResponseCode code , Context * c ,
                      int line , int sd , const char * fmt , ... );
int dispatcherRedirectContextRelease ( Context * c , int id );
int commandHandler ( Context * c , int sd );
int parseInetAddress ( ZkError err , const char * s , 
                       struct sockaddr_in * addr );
int storeAddress ( ZkError err , char * buf , size_t sz , 
                   struct sockaddr * addr , int flags );
int dispatcherDeleteAddress ( Context * c , int id );
int dispatcherAddAddress ( Context * c , struct sockaddr_in * addr );
void * redirectConnection ( void * rtc );
char * utilRemoveWhiteSpace ( char * s );

int dispatcherLogError ( Context * c , ZkError err );
int dispatcherLogWrite_va ( Context * c , const char * fmt , ... );
int dispatcherRotateLog ( Context * c );



#endif /* ! DISPATCHER_H_ */
