/*
 * $Id: dispatcherDefaults.h,v 1.2 2000/04/03 18:32:06 philippe Exp $
 */

#ifndef DISPATCHERDEFAULTS_H_
#define DISPATCHERDEFAULTS_H_

/*
 * These are the default dispatcher settings applied to the application's
 * Context structure.  These settings are set in the dispatcherInit()
 * function.
 */

#define CONTEXT_DFLT_PROGNAME       "dispatcher"
#define CONTEXT_DFLT_FLAGS          FL_DAEMON
#define CONTEXT_DFLT_EXIT_STATUS    EXIT_FAILURE
#define CONTEXT_DFLT_PORT           8000
#define CONTEXT_DFLT_CMD_PORT       8001
#define CONTEXT_DFLT_ADDRS          0
#define CONTEXT_DFLT_ADDR           NULL
#define CONTEXT_DFLT_SD             -1
#define CONTEXT_DFLT_CMD_SD         -1
#define CONTEXT_DFLT_LISTEN_QUEUE   32
#define CONTEXT_DFLT_STD_OUT        stdout
#define CONTEXT_DFLT_STD_ERR        stderr
#define CONTEXT_DFLT_IDLE_TIMEOUT   10
#define CONTEXT_DFLT_CONFIG_FILE    NULL
#define CONTEXT_DFLT_LOG_FILE       NULL
#define CONTEXT_DFLT_PID_FILE       "dispatcher.pid"

/*
 * These defaults control various specific bits inside the dispatcher
 */

/*
 * This is the basic select() timeout value for the server loop when it is
 * able to redirrect new connections
 */

#define SRVLOOP_SEC_TIMEOUT           10 
#define SRVLOOP_USEC_TIMEOUT           0

/*
 *
 */

#define SRVLOOP_USEC_TIMEOUT_BUSY  50000
#define SRVLOOP_SEC_TIMEOUT_BUSY       0

#endif /* DISPATCHERDEFAULTS_H_ */
