/*
 * $Id: msgstr.h,v 1.4 2000/04/03 18:32:08 philippe Exp $
 */

#ifndef MSGSTR_H_
#define MSGSTR_H_

/*
 * This file contains all of the message strings which can be output to the
 * console, the command connection, or the log files.
 */

/*
 * This is the help message which is issued by the dispatcherUsage() function.
 * This code is triggered by running the dispatcher with the --help command
 * line option.  
 */

#define mesg_help_ "\n"VERSION_STR"\n\nUsage: %s options ...\n\n" \
"  [ --"P_CONFIG" filename ]             Configuration file name (%s)\n" \
"  [ --"P_DEBUG" yes | no ]              Enable debug mode (%s)\n" \
"  [ --"P_NUMERIC" yes | no ]            Suppress name lookup of IP addresses (%s)\n" \
"  [ --"P_TCP_NO_DELAY" yes | no ]         Disable Nagle algorithm (%s)\n" \
"  [ --"P_HELP" ]                        Show this information\n" \
"  [ --"P_DAEMON" yes | no ]             Run in daemon mode (%s)\n" \
"  [ --"P_TIMEOUT" seconds ]             Idle timeout (%d seconds)\n" \
"  [ --"P_PORT" port ]                   Redirection listening port (%d)\n" \
"  [ --"P_CMDPORT" port ]                Dispatcher command port (%d)\n" \
"  [ --"P_LISTEN_QUEUE_LENGTH" backlog ]   Size of the listen() queue (%d)\n" \
"  [ --"P_LOGFILE" filename ]            Log file name (%s)\n" \
"  [ --"P_PIDFILE" filename ]            Dispatcher PID file (%s)\n" \
"  [ --"P_QUEUE" yes | no ]              Enable special queueing mode (%s)\n" \
"\nIf an option is not specified, the deault value (identified in \n" \
"parentheses) will be used.  Redirection addresses must be specified in the\n" \
"configuration file using the \""P_ADDRESS"\" tag.  They are represented\n" \
"in hostname:port format.\n\n"

/*
 * These are the various messages which can be issued to the console or in
 * the log file.
 */

#define mesg_1_  "%s:  Failed to initialize the application context.\n"
#define mesg_2_  "%s:  Failed to load configuration \"%s\".\n"
#define mesg_3_  "%s:  Failed to initialize the server process.\n"
#define mesg_4_  "%s:  Server loop failed.\n"
#define mesg_5_  "New connection from %s to %s"
#define mesg_6_  "%s:  Failed to verify the application context.\n"
#define mesg_7_  "Debug logging mode activated"
#define mesg_8_  "EOF detected on command port connection"
#define mesg_9_  "Command port connection has been closed"
#define mesg_10_ "Dispatcher terminating (received SIGINT or SIGTERM)"
#define mesg_11_ "Dispatcher running on port %d (command port %d)"
#define mesg_12_ "Accepted connection to the command port"
#define mesg_13_ "Closing redirected connnection from %s"
#define mesg_14_ "Waiting for redirected connections to terminate"
#define mesg_15_ "Redirected connections are all terminated"
#define mesg_16_ "Rotating log file"
#define mesg_17_ "That host name may have multiple IP addresses, state an "\
                 "explicit address in the configuration file instead"
#define mesg_18_ "Refusing a connection redirection request"
#define mesg_19_ "%s:  Failed to verify address for %s, use the specific "\
                 "IP address instead.\n"

/*
 * These are all of the error messages.  They are passed to the zkErrorSet()
 * and zkErrorSet_va() functions.
 */

#define err_1_   "Failed to close() a refused connection to the cmd_port: %s"
#define err_2_   "Failed to accept() a refused connection to the cmd_port: %s"
#define err_3_   "Failed to close() a valid connection to the cmd_port: %s"
#define err_4_   "Select() returned an error: %s"
#define err_5_   "Select() timed out (This was not supposed to happen)"
#define err_6_   "Null pointer"
#define err_7_   "Failed to create a socket using socket(): %s"
#define err_8_   "Failed to set SO_REUSEADDR option using setsockopt(): %s"
#define err_9_   "Failed to bind socket using bind(): %s"
#define err_10_  "Failed to set the socket listening queue using listen(): %s"
#define err_11_  "Failed to close() the socket: %s"
#define err_12_  "Failed to accept() a redirection request: %s"
#define err_13_  "Failed to close() a refused redirection request: %s"
#define err_14_  "Failed to accept connection from %s"
#define err_15_  "Failed to close() a redirected socket connection: %s"
#define err_16_  "Incorrect redirection id returned (%d)"
#define err_17_  "Thread context free list is empty"
#define err_18_  "Failed to spawn thread to handle redirection request"
#define err_19_  "Bad parameter"
#define err_20_  "Thread context free list is full"
#define err_21_  "Failed to duplicate address string using strdup(): %s"
#define err_22_  "Address contains no data"
#define err_23_  "Address is missing a port number"
#define err_24_  "Port number is out of range"
#define err_25_  "No available redirection addresses"
#define err_26_  "Redirection address table is full"
#define err_27_  "Redirection address table is empty"
#define err_28_  "Insufficient space to store address string"
#define err_29_  "Failed to read() from the command port connection: %s"
#define err_30_  "Output buffer is too short to hold response string"
#define err_31_  "Failed to duplicate source command handler help string"
#define err_32_  "Failed to connect to redirected address"
#define err_33_  "Failed to initialize redirected connection statistics"
#define err_34_  "There are redirected connections which are not terminated"
#define err_35_  "Failed to release redirection context, queue is full!"
#define err_36_  "Failed to write() %d bytes to command connection"
#define err_37_  "No remote address is currently available"
#define err_38_  "Failed to set TCP_NODELAY option for destination socket"
#define err_39_  "Failed to set TCP_NODELAY option for source socket"

/*
 * This is the runtime command help.  Issue the ? or H command to the 
 * command port in order to see it.
 */

#define cmd_help_ VERSION_STR"\n\nRuntime commands\n\n" \
"L                 Show list of active connections IDs\n" \
"K connection_id   Kill an active connection\n" \
"S                 Show list of available redirection address IDs\n" \
"A hostname:port   Add a redirection address\n" \
"D address_id      Delete a redirection address ID\n" \
"Q                 Terminate the command connection\n" \
"?                 Show this help screen\n"

/*
 * These are the command response strings which are returned by the 
 * command handler.
 */

#define cmd_1_   "Command '%c' unrecognized"
#define cmd_2_   "Internal error, unable to produce response"
#define cmd_3_   "source %s destination %s duration %d seconds"
#define cmd_4_   "There are %d active redirections"
#define cmd_5_   "No help is currently available, life sucks"
#define cmd_6_   "Connection id %d is out of range"
#define cmd_7_   "Connection id %d has been terminated"
#define cmd_8_   "Connection id %d is not currently in use"
#define cmd_9_   "redirection address %s"
#define cmd_10_  "There are %d available redirection addresses"
#define cmd_11_  "Unable to delete address %d"
#define cmd_12_  "Address %d deleted"
#define cmd_13_  "Unable to parse address"
#define cmd_14_  "Unable to add address"
#define cmd_15_  "Address inserted"
#define cmd_16_  "Runtime command list"
#define cmd_17_  "There is already an active command connection"
#define cmd_18_  "See you later, alligator"
#define cmd_19_  "Cannot delete addresses in queue mode"

#endif /* ! MSGSTR_H_ */

