/*
 * $Id: alias.h,v 1.3 1999/09/28 18:36:39 roger Exp $
 */

#ifndef FMG_ALIAS_H_
#define FMG_ALIAS_H_

#ifndef ZKHASH_H_
#include <zkHash.h>
#endif /* ZKHASH_H_ */
#ifndef _ZKCONFIG_H
#include <zkConfig.h>
#endif /* _ZKCONFIG_H */

#define FMG_EMAILADDR_SZ  128  /* Target email address size */
#define FMG_EMAILALIAS_SZ  32  /* Source user alias size */

struct T_FMG_Alias {
  int aliases;
  ZkHash a_list;
};

typedef struct T_FMG_Alias * FMGAlias;


DLLExport int FMGAliasNew (
  ZkError ,                 /* Return the error if one occured */
  FMGAlias *  );            /* Returns a new alias list */

DLLExport int FMGAliasNewFromConfig (
  ZkError ,                 /* Return the error if one occured */
  FMGAlias * ,              /* Returns a new alias list */
  ZkConfig );               /* Source config object */

DLLExport int FMGAliasFree (
  ZkError ,                 /* Return the error if one occured */
  FMGAlias * );             /* Alias list to destroy */

DLLExport int FMGAliasAdd (
  ZkError ,                 /* Return the error if one occured */
  FMGAlias ,                /* The alias list */
  const char * ,            /* Alias name to add */
  const char * );           /* Email address for the alias */

DLLExport int FMGAliasLookup (
  ZkError ,                 /* Return the error if one occured */
  FMGAlias ,                /* The alias list */
  const char * ,            /* Username / alias to search for */  
  const char **  ,          /* Returns the email address */
  int * );                  /* Set to non-zero if alias is found */


#endif /* FMG_ALIAS_H_ */
