#ifndef FRLODECMD_H_
#define FRLODECMD_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * Authenticate a user through the zkAuth system
 */

DLLExport int frLodeCmdLogin (
  ZK_INOUT ZkError err ,            /* Returns the error if one occured */
  ZK_IN    ZkipSession session ,    /* Current ZKIP session */
  ZK_IN    void * data );           /* Points to current server context */

/*
 * Cleanly terminate a user connection through the zkAuth system
 */

DLLExport int frLodeCmdLogout (
  ZK_INOUT ZkError err ,            /* Returns the error if one occured */
  ZK_IN    ZkipSession session ,    /* Current ZKIP session */
  ZK_IN    void * data );           /* Points to current server context */

/*
 * Change the users password
 */

DLLExport int
frLodeCmdPassphrase (
  ZK_INOUT ZkError err ,            /* Returns the error if one occured */
  ZK_IN    ZkipSession session ,    /* Current ZKIP session */
  ZK_IN    void * data );           /* Points to current server context */

/*
 * Check if the user has access to a service request
 */

DLLExport int
frLodeCmdCheckAccess (
  ZK_INOUT ZkError err ,            /* Returns the error if one occured */
  ZK_IN    ZkipSession session ,    /* Current ZKIP session */
  ZK_IN    void * data );           /* Points to current server context */

/*
 * Use a loadable service command
 */

DLLExport int frLodeCmdService (
  ZK_INOUT ZkError err ,            /* Returns the error if one occured */
  ZK_IN    ZkipSession session ,    /* Current ZKIP session */
  ZK_IN    void * data );           /* Points to current server context */

/*
 * Get information (a list) of loadable service commands
 */

DLLExport int frLodeCmdInfo (
  ZK_INOUT ZkError err ,            /* Returns the error if one occured */
  ZK_IN    ZkipSession session ,    /* Current ZKIP session */
  ZK_IN    void * data );           /* Points to current server context */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ! FRLODECMD_H_ */
