/* $Id: frpostnews.h,v 1.4 2000/07/06 18:23:33 patricep Exp $ */
#ifndef FRPOSTNEWS_H_
#define FRPOSTNEWS_H_

#include "zks.h"
#include "zkParms.h"
#include "zkError.h"
#include "zkConfig.h"
#include "zkFile.h"
#include "zkIntTypes.h"
#include "zkMIME.h"
#include "frNetworkDefaults.h"
#include <sys/types.h>
#include <sys/socket.h> 
#include <netinet/in.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef 
struct fr_postnews_ctx {
  const char *progname;         /* My program name */
  const char *configfile;       /* Configuration file */
  const char *logfile;          /* Log file */
  const char *pidfile;          /* PID file */
  int debug;                    /* Debugging */

  const char *mta;              /* Mail Transfer Agent (sendmail) */
  const char *spooldir;         /* Spool directory */
  uint32_t sleeptime;           /* Sleep time between looking in spooldir */

  const char *organization;     /* Organization: field */
  const char *xheader;          /* X-ZKS-Freedom-Comment: field */
  const char *path;             /* Path: field */
  uint32_t crosspost_limit;     /* Maximum number of target newsgroups per post */


  ZkError err;                  /* Application error object */
  ZkConfig config;              /* Config object */
  ZkLog log;                    /* Log object */

  const char *nntpserver;       /* NNTP server hostname */
  unsigned short nntpport;      /* NNTP server port */
  uint32_t nntptimeout;         /* NNTP server timeout */
  unsigned short nntpretries;   /* NNTP server connection retries */
  struct sockaddr_in nntpaddr;  /* Sockaddr for the NNTP server */

  int post;                     /* Post mode or spool mode */
  int daemon;                   /* Daemonize or not... */
  uint32_t maxconn;             /* Maximum connections */

  FILE *pidfptr;                /* PID file */
} FrPostNewsCtx;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FRPOSTNEWS_H_ */
