/*
 *  lad: list audio device.
 */

#include <sys/audioio.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stropts.h>
#include <unistd.h>


static char *prog;


static void prtAudioDevInfo(int fd)
{
  audio_device_t ad;

  if (ioctl(fd, AUDIO_GETDEV, &ad) == -1) {
    fprintf(stderr, "AUDIO_GETDEV ioctl failed: %s\n",
            strerror(errno));
  } else {
    printf("name:    %s\n", ad.name);
    printf("version: %s\n", ad.version);
    printf("config:  %s\n", ad.config);
  }
}


int main(int ac, char **av)
{
  char adev[] = "/dev/audio";
  int afd = -1;
  int ok = 0;
  
  prog = av[0];

  if ((afd = open(adev, O_RDONLY)) == -1) {
    fprintf(stderr, "%s: error opening %s: %s\n",
            prog, adev, strerror(errno));
    goto done;
  }

  prtAudioDevInfo(afd);
  
  ok = 1;
  
 done:
  
  if (afd != -1) { close(afd); }
  
  exit(ok ? EXIT_SUCCESS : EXIT_FAILURE);
}
