/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef CLIENT_H
#define CLIENT_H
#include <string>
#include "cliententity.h"
#include "event.h"
#include "stime.h"
#include "freedomevent.h"
#include "statemachinehandler.h"


class Client : public ClientEntity {
  typedef StateMachineHandler::Id   sm_id;

  enum {
    MODEM_CLIENT    = 0x00000001UL,
    ETHERNET_CLIENT = 0x00000002UL,
    ONE_HOP         = 0x00000004UL,
    TWO_HOP         = 0x00000008UL,
    THREE_HOP       = 0x00000010UL,
  };

public:
  static const std::string EntityName;

public:
	Client():ClientEntity(),m_states() {}

  inline const std::string & isA() const { return EntityName; }

  virtual Entity &  init();
  void              execute(FreedomEvent * aFreedomEventP);

 private:
  FreedomEvent *    request_new(Event::Type type, 
                                Time        launchTime, 
                                Entity::Id  destination, 
                                bool        anonRoute);

 private:
  sm_id             sm_factory(const std::string & name);
  void              sm_run(StateMachine::name_type & state_machine_name);

 private:
  StateMachineHandler m_states;
};


#endif //CLIENT_H
