/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef CLOCK_H
#define CLOCK_H
#include "stime.h"
#include "frsimexception.h"

class Clock {
public:
    Clock():m_curtime() {}

    inline const Time & getTime() const;
    inline void         setTime(const Time & aTime);

private:
    Time m_curtime;

    /**
     * @link dependency
     * @stereotype UpdatedBy
     */

  /*#  Scheduler lnkScheduler; */
};


inline const Time & Clock::getTime() const
{ 
  return m_curtime; 
}


inline void Clock::setTime(const Time & aTime)
{
  if( aTime < m_curtime ) {
    throw FrsimException("Clock::setTime: try to decrease current time");
  }
  m_curtime = aTime; 
}

extern Clock g_clock;

#endif             //CLOCK_H
