/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#include <algorithm>
#include "entityidlist.h"
#include "frsimexception.h"
#include "idbin.h"

EntityIdList::EntityIdList(const EntityIdList & aEntityList)
:m_list(aEntityList.m_list)
{
}


EntityIdList EntityIdList::operator+ (const EntityIdList & aEntityList) const
{
  return (EntityIdList(*this) += aEntityList);
}


EntityIdList & EntityIdList::operator+=(const EntityIdList & aEntityList)
{
  if( this != &aEntityList ) {
    std::copy(aEntityList.m_list.begin(), aEntityList.m_list.end(), m_list.end());
  }
  return *this;
}



void EntityIdList::remove(const Entity::Id & aId)
{
  // Search for the Entity
  iterator it=std::find(begin(), end(), aId);
  // if found
  if( it != m_list.end() ) {
      m_list.erase(it);
  }
}


void EntityIdList::add(const Entity::Id & aId)
{
  m_list.push_back(aId);
}


void EntityIdList::clear()
{
  while ( ! m_list.empty() ) {
    m_list.pop_back(); //bugbug: Should I use delete here
  }
}


const Entity::Id & EntityIdList::operator[](const size_type pos) const
{
  if( pos < m_list.size() ) {
    return m_list[pos];
  }
  return GenericId::null();
}
