/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef ENTITYIDLIST_H
#define ENTITYIDLIST_H

#include <vector>
#include <algorithm>
#include "entity.h"


class EntityIdList {
 private:
  typedef std::vector<Entity::Id>           list_type;
 
 public:
  typedef Entity::attr_type                 attr_type;

  typedef list_type::value_type             value_type;
  typedef list_type::size_type              size_type;
  typedef list_type::iterator               iterator;
  typedef list_type::const_iterator         const_iterator;
  typedef list_type::reverse_iterator       reverse_iterator;
  typedef list_type::const_reverse_iterator const_reverse_iterator;

 public:
  EntityIdList() {}

  EntityIdList(const EntityIdList & aEntityList);

  ~EntityIdList() {}

  iterator       begin()         { return m_list.begin(); }
  iterator       end()           { return m_list.end(); }
  const_iterator begin()   const { return m_list.begin(); }
  const_iterator end()     const { return m_list.end(); }
  size_type      size()    const { return m_list.size(); }
  bool           empty()   const { return m_list.empty(); }
  void           reverse()       { std::reverse(begin(), end()); }

  const Entity::Id & operator[] (const size_type pos) const;


  EntityIdList   operator+  (const EntityIdList & aEntityList) const;
  EntityIdList & operator+= (const EntityIdList & aEntityList);

  void           add(const Entity::Id & aId);
  void           remove(const Entity::Id & aId);

  void           clear();
  
private:
    /**
     * @supplierCardinality * 
     */
    list_type m_list;
};
#endif //ENTITYIDLIST_H
