/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#include <string>
#include "event.h"
#include "clock.h"


Event::Event(Type type, Time launchTime):m_type(type),m_launchTime(launchTime)
{
}


bool Event::operator> (const Event & aEvent) const
{
  return m_launchTime > aEvent.launchTime();
}

bool Event::operator>=(const Event & aEvent) const
{
  return m_launchTime >= aEvent.launchTime();
}


bool Event::operator< (const Event & aEvent) const
{
  return m_launchTime < aEvent.launchTime();
}

bool Event::operator<=(const Event & aEvent) const
{
  return m_launchTime <= aEvent.launchTime();
}

bool Event::operator==(const Event & aEvent) const
{

  return m_launchTime == aEvent.launchTime();
}

 
bool Event::operator!=(const Event & aEvent) const
{
  return m_launchTime != aEvent.launchTime();
}


Event & Event::operator+=(const Time & aTime)
{
  m_launchTime += aTime;
  return *this;
}
