/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef EVENT_H
#define EVENT_H

#include <string>
#include "stime.h"
#include "clock.h"

class Event {
 public:
  typedef unsigned long Type;

 public:
  Event(Type type, Time launchTime);
  virtual ~Event() {}

  inline virtual const std::string & isA() const = 0;

  bool operator> (const Event & aEvent) const;
  bool operator>=(const Event & aEvent) const;
  bool operator< (const Event & aEvent) const;
  bool operator<=(const Event & aEvent) const;
  bool operator==(const Event & aEvent) const;
  bool operator!=(const Event & aEvent) const;

  Type        & type()       { return m_type; }
  const Type  & type() const { return m_type; }

  Time        & launchTime()       { return m_launchTime; }
  const Time  & launchTime() const { return m_launchTime; }
  
  Event &       operator+=(const Time & aTime);

 protected:
  Type          m_type;
  Time          m_launchTime;
};


#endif  //EVENT_H
