/* Zeroknowledge Systems Inc. - Freedom Simulation  */
class Event;
class EventList;
class Time;

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef EVENTLIST_H
#define EVENTLIST_H
#include <queue>
#include <vector>
#include <list>
#include <functional>
#include "event.h"


class EventList {
  template <class T>
    struct eventP_greater {
      bool operator()(const T& x, const T& y) const { 
        return (*x) > (*y); 
      }
    };

  typedef std::priority_queue<Event *, std::vector<Event *>, eventP_greater<Event *> > queue_type;

 public:
  typedef queue_type::size_type size_type;

 public:
  EventList();
  ~EventList();

  size_type size() const { return m_list.size(); }

  void      push(Event * aEventP);
  Event *   next();

  void clear();

 private:

  /**
   * @supplierCardinality **/
    
  queue_type m_list;
};
#endif /*EVENTLIST_H*/
