/* Generated by Together */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef FREEDOMEVENT_H
#define FREEDOMEVENT_H
#include "stime.h"
#include "entityidlist.h"
#include "entity.h"
#include "packet.h"
#include "event.h"

class FreedomEvent: public Event {
 public:
  enum state_type {
    QUERY,
    SUCCESS,                         // success answer
    FAILURE,                         // failure answer
  };

	enum Type {
    // protocol related
    TCP_CONNECT,
    TCP_DISCONNECT,
    // aip related
    UDP_AIP_ROUTE_CREATE,
    UDP_AIP_PACKET_SEND,
    // niqs related
    TCP_NIQS_QUERY_FULL_ENTITY_LIST,
    TCP_NIQS_QUERY_FULL_ENTITY_STATUS,
    TCP_NIQS_QUERY_PARTIAL_ENTITY_LIST,
    TCP_NIQS_QUERY_PARTIAL_ENTITY_STATUS,
    TCP_NIQS_QUERY_ENTITTDESCRIPTION,
    // kqd related
    TCP_KQD_REQUEST_ONE_KEYS,
    TCP_KQD_REQUEST_ALL_KEYS,
    // niqs related
    UDP_NIQS_AIP_STATS_UPDATE,
    UDP_NIQS_LINK_STATS_UPDATE,
    UDP_NIQS_WH_STATS_UPDATE,
    UDP_NIQS_MAIP_STATS_UPDATE,
    UDP_NIQS_FMG_MAIP_STATS_UPDATE,
	};

 public:
  typedef EntityIdList::size_type size_type;

 public:
	static const std::string EventName;

 public:
	FreedomEvent(Event::Type type, Time launchTime):Event(type,launchTime),m_state(QUERY) {}

	virtual              ~FreedomEvent() { }

	inline const std::string & isA() const { return EventName; }

	void							    reply(bool success);

	bool						  	  isQuery()  const;
	bool						  	  isAnswer() const;

	const Entity::Id &    first()    const;
	const Entity::Id &    last()     const;
	const Entity::Id &    current()  const;

  const Entity::Id &    operator+(size_type increment);
  const Entity::Id &    operator-(size_type decrement);

	const Entity::Id &    operator++();
  const Entity::Id &    operator--();
  const Entity::Id &    operator++(int);
  const Entity::Id &    operator--(int);

	void					  		  addEntity(const Entity::Id & aEntityId);

	void                  addLatency(Time latency);

	void							    clear();

  inline Packet       & packet();
  inline const Packet & packet() const;

 private:
	/** @supplierCardinality 0..1 */
	Packet					      m_packet;
	size_type             m_pos;
	EntityIdList          m_path;
  state_type            m_state;
};
  

inline Packet & FreedomEvent::packet()
{
  return m_packet; 
}

inline const Packet & FreedomEvent::packet() const
{
  return m_packet; 
}

#endif  //FREEDOMEVENT_H
