/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#include <string>
#include "event.h"
#include "frsimevent.h"


const std::string FrsimEvent::EventName = std::string("FRSIMEVENT");



FrsimEvent::FrsimEvent(Type type, Time launchTime, Time repeatDelta)
:Event(type, launchTime)
,m_repeatDelta(repeatDelta)
{
}


bool FrsimEvent::reschedule()
{
  if( !m_repeatDelta ) {
    return false;
  }
  *this += m_repeatDelta;
  return true;
}
