/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef FRSIMEVENT_H
#define FRSIMEVENT_H
#include <string>
#include "stime.h"
#include "event.h"


class FrsimEvent: public Event {
 public:  
  typedef Event::Type      Type;

 public:
  static const std::string EventName;

 protected:
  FrsimEvent(Type type, 
             Time launchTime, 
             Time repeatDelta);

 public:
  inline const std::string & isA() const  {return EventName; }

  inline const Time & repeatDelta() const { return m_repeatDelta; }

  bool         reschedule();

 private:
  Time         m_repeatDelta;
};

#endif  //FRSIMEVENT_H
