/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef FRSIMEVENTCONTROL_H
#define FRSIMEVENTCONTROL_H
#include <string>
#include "stime.h"
#include "frsimevent.h"


//
// Event sent to the monitor to manage the simulation
//
class FrsimEventControl: public FrsimEvent {
 public:
  enum Type {
    SIMULATION_STOP,             // Stop the Simulation
    SIMULATION_STATUS_UPDATE,    // Report the Actual Status of the Simulation
  };

 public:
  static const std::string EventName;

 public:
  FrsimEventControl(Type type, 
                    Time launchTime, 
                    Time repeatDelta);

  inline const std::string & isA() const  {return EventName; }
};

#endif  //FRSIMEVENTCONTROL_H
