/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef FRSIMEVENTGENERIC_H
#define FRSIMEVENTGENERIC_H
#include <string>
#include "stime.h"
#include "frsimevent.h"


//
// Event sent to the MetaEntities to manage the entities life time
//
class FrsimEventGeneric: public FrsimEvent {
 public:
  enum Type {
    ENTITY_SCHEDULE,            // Schedule the creation of a new entity
    ENTITY_CREATE,              // Create a new entity
    ENTITY_BIRTH_RATE_INC,      // Add a new entity schedule event
  };

 public:
  static const std::string EventName;

 public:
  FrsimEventGeneric(Type              type, 
                    Time              launchTime, 
                    Time              repeatDelta,
                    const std::string entityName);

  inline const std::string & isA()        const  { return EventName; }
  inline       std::string & entityName()        { return m_entityName; }
  inline const std::string & entityName() const  { return m_entityName; }

 private:
  mutable std::string m_entityName;
};

#endif  //FRSIMEVENTGENERIC_H
