/* Zero-Knowledge Systems Inc, Freedom Simulator */
#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef FRSIMEXCEPTION_H
#define FRSIMEXCEPTION_H
#include <exception>
#include <iostream>
#include <string>

class FrsimException: public exception {
  mutable std::string m_msg;

 public:
  FrsimException():m_msg("") {}

  explicit FrsimException(const char * const msg):m_msg(msg) {}
  explicit FrsimException(const std::string msg):m_msg(msg) {}

  friend std::ostream & operator<< (std::ostream & ostr, const FrsimException & ex);
};


inline std::ostream & operator<< (std::ostream & ostr, const FrsimException & ex)
{
  ostr << ex.m_msg;
  return ostr;
}


#endif //FRSIMEXCEPTION_H
