/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#include "link.h"
#include "freedomevent.h"
#include "scheduler.h"


void Link::execute(FreedomEvent * aFreedomEventP)
{
  const Time latency = Link::latency(aFreedomEventP->packet().size());

  //
  // Added latency impacted by the incomming packet to the Event 
  //
  aFreedomEventP->addLatency(latency);

  //
  // Count concurrent connection
  //
  Entity::startStopConnection(g_clock.getTime(), latency);

  //
  // Perform the default Entity behavior: cummulate metrics and 
  // forwording the FreedomEvent to the next entity.
  //
  Entity::execute(aFreedomEventP);
}



//
// Return the latency associate withe this givent link.
//
Time Link::latency(unsigned long bytes)
{
  return Time((double)bytes/m_throughput);
}
