/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef LINK_H
#define LINK_H
#include "networkentity.h"
#include "freedomevent.h"

class Link : public NetworkEntity {
public:
    inline Link(unsigned long mtu, unsigned long bytes_per_sec);

    inline unsigned long throughput() const; // Link speed: Bytes/sec
    inline unsigned long mtu()        const; // Max transport unit: Bytes

    void execute(FreedomEvent * aFreedomEventP);

protected:
    Time latency(unsigned long bytes);

protected:
    unsigned long m_mtu;
    unsigned long m_throughput;
};


inline Link::Link(unsigned long mtu, unsigned long bytes_per_sec)
:m_mtu(mtu)
,m_throughput(bytes_per_sec)
{
}


inline unsigned long Link::throughput() const 
{
  return m_throughput;
}


inline unsigned long Link::mtu() const 
{
  return m_mtu;
}

#endif //LINK_H
