/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#include <iostream>
#include <exception>
#include "monitor.h"
#include "scheduler.h"
#include "supervisor.h"
#include "frsimexception.h"
#include "randomizer.h"
#include "utility.h"



int main()
{
  //
  // Main execution
  //
  try {
    g_supervisor.run();
  } 
  //
  // Catch runtime exception 
  //
  catch( const FrsimException & ex ) {
    std::cerr << "Runtime exception " << ex << std::endl;
  }
	catch( const std::exception & ex ) {
    std::cerr << "Runtime exception " << ex.what() << std::endl;
  }
  catch( ... ) {
    std::cerr << "Unknown exception" << std::endl;
  }
  return 0;
}
