/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

class Entity;

#ifndef PACKET_H
#define PACKET_H

#include "idbin.h"
#include "propertylist.h"

class Packet {    
 public:
  Packet():m_size(0) {}

  unsigned long         & size()        { return m_size; }
  const unsigned long   & size()  const { return m_size; }

  inline Property       & operator[] (const std::string & aTag);
  inline const Property & operator[] (const std::string & aTag) const;

  inline void             clear();

 private:
  unsigned long           m_size;      // Packet size
  PropertyList            m_property;  // List of property that can be associate to a packet
};


inline void Packet::clear()
{
  m_size = 0;
}


inline Property & Packet::operator[] (const std::string & aTag)
{
  return m_property[aTag];
}


inline const Property & Packet::operator[] (const std::string & aTag) const
{
  return m_property[aTag];
}


#endif //PACKET_H
