/* Zeroknowledge Systems Inc. - Freedom Simulation  */
#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#include <strstream>
#include "property.h"
#include "frsimexception.h"

#ifndef WIN32
# warning "Should use istringstream/ostringstream once gcc support it"
#endif


Property::Attr & Property::Attr::operator=(const bool & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}


Property::Attr & Property::Attr::operator=(const char & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const short & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const long & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const int & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const unsigned char & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const unsigned short & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const unsigned long & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const unsigned int & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const Time & val)
{
  char buff[256] = {0};

  std::ostrstream ostr(buff, 256);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const TimeRange & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const GenericId & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const Frequency & val)
{
  char buff[64] = {0};

  std::ostrstream ostr(buff, 64);
  ostr << val;
  value = buff;
  return *this;
}

Property::Attr & Property::Attr::operator=(const std::string & val)
{
  value = val ;
  return *this;
}

bool Property::Attr::asBool() const
{
  bool val = false;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asBool: parsing failure, ") + value);
	}
  return val;
}


char Property::Attr::asChar() const
{
  char val = 0;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asChar: parsing failure, ") + value);
	}
  return val;
}

short Property::Attr::asShort() const
{
  short val = 0;

  std::istrstream istr(value.c_str(), value.size());
  try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asShort: parsing failure, ") + value);
	}
  return val;
}

long Property::Attr::asLong() const
{
  long val = 0;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asLong: parsing failure, ") + value);
	}
  return val;
}

int Property::Attr::asInt() const
{
  int val = 0;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asInt: parsing failure, ") + value);
	}
  return val;
}

unsigned char Property::Attr::asUnsignedChar() const
{
  unsigned char val = 0;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asUnsignedChar: parsing failure, ") + value);
	}
  return val;
}

unsigned short Property::Attr::asUnsignedShort() const
{
  unsigned short val = 0;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asUnsignedShort: parsing failure, ") + value);
	}
  return val;
}

unsigned long Property::Attr::asUnsignedLong() const
{
  unsigned long val = 0;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asUnsignedLong: parsing failure, ") + value);
	}
  return val;
}

unsigned int Property::Attr::asUnsignedInt() const
{
  unsigned int val = 0;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asUnsignedInt: parsing failure, ") + value);
	}
  return val;
}

Frequency Property::Attr::asFrequency() const
{
  Frequency val;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asFrequency: parsing failure, ") + value);
	}
  return val;
}

Time Property::Attr::asTime() const
{
  Time val;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asTime: parsing failure, ") + value);
	}
  return val;
}

GenericId Property::Attr::asGenericId() const
{
  GenericId val;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asGenericId: parsing failure, ") + value);
	}
  return val;
}


TimeRange Property::Attr::asTimeRange() const
{
  TimeRange val;

  std::istrstream istr(value.c_str(), value.size());
	try {
		istr >> val;
	} catch( ...) {
		throw FrsimException(std::string("Property::Attr::asTimeRange: parsing failure, ") + value);
	}
  return val;
}

std::string Property::Attr::asString() const
{
  return value;
}

