/* Zeroknowledge Systems Inc. - Freedom Simulation  */

class Property;

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef PROPERTYLIST_H
#define PROPERTYLIST_H
#include <string>
#include <map>
#include "property.h"

class PropertyList {
  typedef std::map<const std::string, Property> list_type;

 public:
  typedef list_type::iterator                   iterator;
  typedef list_type::const_iterator             const_iterator;

 public:
  PropertyList();

  Property       & operator[] (const std::string aTag);
  const Property & operator[] (const std::string aTag) const;

  iterator       begin()       { return m_list.begin(); }
  iterator       end()         { return m_list.end(); }
  const_iterator begin() const { return m_list.begin(); }
  const_iterator end() const   { return m_list.end(); }

 private: 
  mutable list_type m_list;
};

#endif /*PROPERTYLIST_H*/
