/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

class Frequency;

#ifndef RANDOMIZER_H
#define RANDOMIZER_H
#include <set>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#include "timerange.h"
#include "stime.h"
#include "frequency.h"


class Randomizer {	
public:
	typedef std::set<Time> list_type;

public:
	Randomizer();
	
	void seed(unsigned long aSeed);

	unsigned long rand(unsigned long     max);
	Time          rand(const Time      & max);
	Time          rand(const TimeRange & range);
	list_type     rand(const Frequency & freq);
	list_type     rand(const Time & start, const Frequency & freq);	
	
private:
	void srand( unsigned int seed );
};

extern Randomizer g_randomizer;

#endif //RANDOMIZER_H
