/* Zeroknowledge Systems Inc. - Freedom Simulation  */
#include "event.h"
#include "frsimexception.h"
#include "scheduler.h"
#include "stime.h"
#include "clock.h"


Scheduler g_scheduler;

Event * Scheduler::getNext()
{
  Event * aEventP =  m_EventList.next();

  if ( !aEventP) {
    throw FrsimException("Scheduler::getNext: no more event in the queue");
  }

  //
  // Update the clock from this event's time
  //
  g_clock.setTime(aEventP->launchTime());
  
  return aEventP;
}


void Scheduler::push(Event * aEventP)
{
  m_EventList.push(aEventP);
}


Scheduler & Scheduler::init()
{
  g_clock.setTime(Time(0));
  return *this;
}


void Scheduler::clear()
{
  m_EventList.clear();
}
