/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#include "frsimexception.h"
#include "statemachinehandler.h"


StateMachineHandler::Id StateMachineHandler::create(const StateMachine::name_type & aName)
{
  Id aId    = m_idbin.pop(aName);
  m_sm[aId] = aName;
  return aId;
}


void StateMachineHandler::destroy(const Id & aId)
{
  m_sm.erase(aId);
  m_idbin.push(aId);
}


StateMachine & StateMachineHandler::operator[](const Id & aId)
{
  if( m_sm.find(aId) == m_sm.end() ) {
    throw FrsimException("StateMachineHandler::operator[]: invalid Id");
  }
  return m_sm[aId];
}


bool StateMachineHandler::done(const Id & aId)
{
  return ((*this)[aId].current() == StateMachine::final) ? true : false;
}
