/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

#ifndef STATEMACHINEHANDLER_H
#define STATEMACHINEHANDLER_H

#include "statemachine.h"
#include "idbin.h"


class StateMachineHandler {  
  typedef GenericId                  Id;
  typedef std::map<Id, StateMachine> map_type;

 public:
  StateMachineHandler() {}

  Id   create(const StateMachine::name_type & aName);
  void destroy(const Id & aId);

  bool done(const Id & aId);
  
  StateMachine & operator[] (const Id & aId);
  
 private: 
  map_type      m_sm;
  GenericIdBin  m_idbin;
};



#endif //STATEMACHINEHANDLER_H
