/* Zeroknowledge Systems Inc. - Freedom Simulation  */

#ifdef WIN32
# pragma warning( disable: 4786 )
#endif

//class Metrics;

#ifndef SUPERVISOR_H
#define SUPERVISOR_H
#include <string>
#include <map>
#include "statusreport.h"
#include "metrics.h"
#include "initinfolist.h"
#include "stime.h"

class Supervisor {
  typedef std::map< std::string, StatusReport > report_map;
  typedef report_map::iterator                  iterator;
  typedef report_map::const_iterator            const_iterator;

 public:
  Supervisor():m_lastreport(Time::MAX_TIME_IN_SEC) {}

  void           run();
  void           update(const std::string aEntityName, const StatusReport & report);
  void           report() const;

 private:
  iterator       begin()       { return m_status.begin(); }
  iterator       end()         { return m_status.end(); }
  const_iterator begin() const { return m_status.begin(); }
  const_iterator end()   const { return m_status.end(); }

  void           populateInitInfo(InitInfoList & aInitInfoList);

 private:
  report_map     m_status;
  mutable Time   m_lastreport; 
};

extern Supervisor g_supervisor;

#endif     //SUPERVISOR_H
