#ifndef HARVESTER_DEFAULT_H
# define HARVESTER_DEFAULT_H


//
// Application default configuration parameters
//
#define DEFAULT_DEBUG_MODE                           false
#define DEFAULT_VERBOSE_MODE                         false
#define DEFAULT_DAEMON_MODE                          false

#define DEFAULT_PIDFILE_NAME                         "/freedom/var/log/harvester.pid"

#define DEFAULT_PERIOD                               3600

#define DEFAULT_ENTITY_NAME                          "host1"
#define DEFAULT_ENTITY_TYPE                          "aip"

#define DEFAULT_PASSPHRASE_PROMPT                    ""
#define DEFAULT_PASSPHRASE_FILE                      ""

#define DEFAULT_PRIV_CRYPT_DIR_KEY                   "/freedom/privkey/AIP/crypt"
#define DEFAULT_PRIV_SIG_DIR_KEY                     "/freedom/privkey/AIP/sig"

#define DEFAULT_PRIV_CRYPT_VERSION_KEY               1
#define DEFAULT_PRIV_SIG_VERSION_KEY                 1

//
// Network default configuration parameters
//
#define DEFAULT_INET_COUNT                           20                       // uint16_t
#define DEFAULT_INET_PORT                            51555                    // uint16_t

#define DEFAULT_INET_BACKLOG                         (SOMAXCONN)              // int
#define DEFAULT_INET_REUSEADDR_FLAG                  true                     // bool
#define DEFAULT_INET_ADDR_ANY_FLAG                   false                    // bool

#define DEFAULT_LOCAL_BACKLOG                        (SOMAXCONN)              // int
#define DEFAULT_LOCAL_REUSEADDR_FLAG                 true                     // bool

#define DEFAULT_BUFFER_LENGTH                        (64*1024)                // in bytes
#define DEFAULT_RCVBUF_LENGTH                        (DEFAULT_BUFFER_LENGTH)  // in bytes
#define DEFAULT_SNDBUF_LENGTH                        (DEFAULT_BUFFER_LENGTH)  // in bytes

#define DEFAULT_SERVER_INET_RCV_TIMEOUT              30                       // in seconds
#define DEFAULT_SERVER_INET_SND_TIMEOUT              10                       // in seconds

#define DEFAULT_SERVER_LOCAL_RCV_TIMEOUT              5                       // in seconds
#define DEFAULT_SERVER_LOCAL_SND_TIMEOUT              5                       // in seconds

#define DEFAULT_WAIT_FOR_ITERATION_TIMEOUT            1                       // in seconds

#define DEFAULT_KQD_HOSTNAME                         "kqd.freedom.net"
#define DEFAULT_KQD_PORT                             51109

#define DEFAULT_DEST_HOSTNAME                        "danp"
#define DEFAULT_DEST_PORT                            51201


#endif /* ICS_DEFAULT_H */
