#ifndef HARVESTER_H
# define HARVESTER_H

// Module name
# define ZKS_HARVESTER_MOD                                     "Harvester"



// Errors definition
# define ZKS_HARVESTER_EXIT_ERR                                 0x0001
# define ZKS_HARVESTER_ABORT_ERR                                0x0002
# define ZKS_HARVESTER_PIDFILE_ERR                              0x0003
# define ZKS_HARVESTER_OPEN_ERR                                 0x0004
# define ZKS_HARVESTER_SOCKET_ERR                               0x0005
# define ZKS_HARVESTER_GETHOSTBYNAME_ERR                        0x0006
# define ZKS_HARVESTER_GETPROTOBYNAME_ERR                       0x0007
# define ZKS_HARVESTER_UNAME_ERR                                0x0008
# define ZKS_HARVESTER_KEYCHAIN_ERR                             0x0009
# define ZKS_HARVESTER_FRSEC_ERR                                0x000a
# define ZKS_HARVESTER_SENDTO_ERR                               0x000b
# define ZKS_HARVESTER_PIPE_ERR                                 0x000c
# define ZKS_HARVESTER_FORK_ERR                                 0x000d
# define ZKS_HARVESTER_CRYPTO_ERR                               0x000e
# define ZKS_HARVESTER_DATAFILE_ERR                             0x000f
# define ZKS_HARVESTER_SIGNAL_ERR                               0x0010


// Application version
# define ZKS_HARVESTER_VERSION                                    "1.0"

// Ini section
# define ZKS_HARVESTER_SECTION                                    "Harvester"

// Ini keys
# define ZKS_HARVESTER_LOG_FILE_KEY                               "logfile"                   // path
# define ZKS_HARVESTER_PIDFILE_KEY                                "pidfile"                   // path

# define ZKS_HARVESTER_DEBUG_KEY                                  "debug"                     // bool
# define ZKS_HARVESTER_VERBOSE_KEY                                "verbose"                   // bool
# define ZKS_HARVESTER_DAEMON_KEY                                 "daemon"                    // bool

# define ZKS_HARVESTER_PERIOD_KEY                                 "period"                    // uint16_t

# define ZKS_HARVESTER_ENTITY_NAME_KEY                            "entity.name"               // string
# define ZKS_HARVESTER_ENTITY_TYPE_KEY                            "entity.type"               // string

# define ZKS_HARVESTER_PASSPHRASE_FILE_KEY                        "passphrase.file"           // path
# define ZKS_HARVESTER_PASSPHRASE_PROMPT_KEY                      "passphrase.prompt"         // string

# define ZKS_HARVESTER_KEY_PRIV_CRYPT_DIR_KEY                     "key.crypt.dir"             // path
# define ZKS_HARVESTER_KEY_PRIV_SIG_DIR_KEY                       "key.sig.dir"               // path
# define ZKS_HARVESTER_KEY_PRIV_CRYPT_VERSION_KEY                 "key.crypt.version"         // uint16_t
# define ZKS_HARVESTER_KEY_PRIV_SIG_VERSION_KEY                   "key.sig.version"           // uint16_t

# define ZKS_HARVESTER_KQD_HOSTNAME                               "kqd.hostname"              // string
# define ZKS_HARVESTER_KQD_PORT                                   "kqd.port"                  // uint16_t

# define ZKS_HARVESTER_DEST_HOSTNAME                              "dest.hostname"              // string
# define ZKS_HARVESTER_DEST_PORT                                  "dest.port"                  // uint16_t

#endif // ZKHARVEST_H
