#ifndef TKSRV_FDMASK_H
# define TKSRV_FDMASK_H

# ifdef __cplusplus  

# include "zkslogwrap.h"

//
// File Descriptor mask
//
class FdMask {
 public:
  FdMask():m_max(0) { clear(); }

  bool           get(int fd) const { return FD_ISSET(fd, &m_mask) ? true : false; }
  void           set(int fd)       
    { 
      CZKS::Log::debug(CZKS::Log::TRACE, ZKS_TKSRV_MOD, "FdMask.set(%d)", fd);
      FD_SET(fd, &m_mask); m_max = std::max<int>(fd+1, m_max); 
    }

  void           clear(int fd)     { FD_CLR(fd, &m_mask); }
  void           clear()           { FD_ZERO(&m_mask); m_max = 0; }

  const fd_set & mask()      const { return m_mask;  }
  fd_set       & mask()            { return m_mask;  }
  int            maximum()   const { return m_max-1; }

 protected:
  fd_set m_mask;
  int    m_max;
};


# endif /* __cplusplus */

#endif /* TKSRV_FDMASK_H */
