#define REV_ID "@(#) $Id: main.cpp,v 1.2 2001/05/16 18:08:31 build Exp $"
#include "zkrev.h"


#include "harvester.h"

#include "app.h"

#include "zks.h"
#include "zksexception.h"
#include "zkslogwrap.h"
 
#include <stdlib.h>




// /////////////////////////////////////////////////////////////////////////////
// Main entry point
//
int main(int32_t argc, const char **argv)
{   
  DECL_FUNC("main");

  const char * ctx      = 0;
  int32_t      exitcode = EXIT_FAILURE;
  Application  apps;

  // Shutdown logging
  apps.init_appname(argc, argv);

  // Init logging
  CZKS::Log::init(apps.name());

  // Runtime
  try {
    try {
        
        // init log agent

        ctx = "init term agent";
        CZKS::Log::setTermAgent(new CZKS::Log::TermAgent);

        //
        // bunch of init
        //
        ctx = "init_cmdline";
        apps.init_cmdline(argc, argv);

        ctx = "init_ini";
        apps.init_ini();

        ctx = "init_logfile";
        apps.init_logfile();

        ctx = "init_debug_status";
        apps.init_debug_status();

        ctx = "init_verbose_status";
        apps.init_verbose_status();

        ctx = "init_passphrase";
        apps.init_passphrase();

        ctx = "init_daemon_status";
        apps.init_daemon_status();

        ctx = "init_period";
        apps.init_period();

        ctx = "init_priv_keys";
        apps.init_priv_keys();

        ctx = "init_public_key";
        apps.init_public_key();

        ctx = "init_dest";
        apps.init_dest();

        // signal handling
        ctx = "init_sighandler";
        apps.init_sighandler();

        // start message after log file is initialyse ... 
        CZKS::Log::mesg(ZKS_HARVESTER_MOD,
                        "Starting");

        //
        // run
        //
        ctx = "run";
        apps.run();

        exitcode = EXIT_SUCCESS;

    } catch( ... ) {
      CZKS::Rethrow(func, ctx);
    } 
  } catch( CZKS::Exception & e ) {
    if( e.isErrCode(ZKS_HARVESTER_MOD, ZKS_HARVESTER_EXIT_ERR) ) {
      exitcode = EXIT_SUCCESS;

    } else if( e.isErrCode(ZKS_HARVESTER_MOD, ZKS_HARVESTER_ABORT_ERR) ) {  
      exitcode = EXIT_FAILURE;      

    } else {
      CZKS::Log::error(e.zksErr());
    }
  }

  CZKS::Log::mesg(ZKS_HARVESTER_MOD,
                  "Shutting down");

  // Shutdown logging
  CZKS::Log::shutdown();
 
  return exitcode;
}

