/*
 *  $Id: Ics.h,v 1.2 2001/05/16 18:06:22 build Exp $
 *
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is Freedom code.
 *
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2001
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 *
 * Contributors:
 *   Dan Kha Pham danp@zeroknowledge.com
 */


#ifndef __ICS_H__
#define __ICS_H__

#include "IcsContext.h"


// Application specific information
#define ICS_APPNAME            "zkics"
#define ICS_APPDESCRIPTION     "Information Collection Server - collects ZKS entities' incoming information reports"
#define ICS_APPVERSION         "ics v1.0"


class Ics
{

public:
  Ics();
  virtual ~Ics();
  int init( int argc, const char **argv );
  void sendToBackground();
  void run();
  void stop();

private:
  IcsContext      m_Context;
  CZKS::Exception m_Exception;
  int             m_Continue;

  int select();

};


#endif   // ifndef __ICS_H__
