/*
 *  $Id: Icsmain.cpp,v 1.2 2001/05/16 18:06:22 build Exp $
 *
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is Freedom code.
 *
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2001
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 *
 * Contributors:
 *   Dan Kha Pham danp@zeroknowledge.com
 */



#include "Ics.h"
#include "zkSignal.h"

void handleSignal( int signal );
Ics *pServer;


int main( int argc, const char **argv )
{
  pServer = new Ics();

  // for now only SIGTERM is trapped to shutdown daemon
  zkSignalIntr( SIGTERM, handleSignal );
  zkSignalIntr( SIGHUP, handleSignal );
  zkSignalIntr( SIGUSR1, handleSignal );
  zkSignalIntr( SIGUSR2, handleSignal );

  if( pServer->init(argc,argv) )
    pServer->run();

  if( pServer )
    delete pServer;

  return 0;
}


void handleSignal( int signal )
{
  switch( signal )
  {
    // for now only SIGTERM is trapped to shutdown daemon

  case SIGTERM:
      // shutdown
      if( pServer ) pServer->stop();
      break;

  case SIGHUP:
      // reload config / refresh period ?

  case SIGUSR1:
  case SIGUSR2:
      // undefined

  default:
      break;
  }
}
