/*
 *  $Id: english2bin.c,v 1.1 1999/11/01 16:38:26 bill Exp $
 */

#include <stdio.h>
#include <string.h>

extern int etob(char *out, char *e);

/* Read stdin one line at a time, and convert 6 english words to 8 bytes
   a la S/KEY */

int main(void)
{
  unsigned char buf[8];
  char engline[36];  /* Enough for 6 words of 4 chars plus spaces and NUL */

  while(1) {
    int res;
    int len;

    /* Read a line from stdin */
    if (!fgets(engline, 36, stdin)) break;

    /* Strip the \n */
    len = strlen(engline);
    if(len > 0 && engline[len-1] == '\n') {
	    engline[len-1] = '\0';
    }
	
    res = etob(buf, engline);
    switch(res) {
    case 1: /* All OK */
	    fwrite(buf, 8, 1, stdout);
	    break;
    case 0: /* Word not in data base */
	    fprintf(stderr, "Error: word not in data base.  Re-enter line.\n");
	    break;
    case -1: /* Badly formed word */
	    fprintf(stderr, "Error: badly formed word.  Re-enter line.\n");
	    break;
    case -2: /* Bad parity */
	    fprintf(stderr, "Error: parity incorrect.  Re-enter line.\n");
	    break;
    default: /* Huh? */
	    fprintf(stderr, "Error: unknown error.  Re-enter line.\n");
	    break;
    }
  }
  return 0;
}
