#ifndef CONFIG_H_
#define CONFIG_H_


#include <zks.h>


/*
 *  All the program parameters that may be set from the configuration file, or
 *  from the command line.  (Except for --config-file, which only makes sense
 *  on the command line.
 */

struct config {
  int daemon; /* 0: run in foreground; 1: run as daemon */
  int verbose; /* 0: normal logging; 1: extra logging */
  int ncopies; /* how many copies of the server to run (i.e. fork) */

  char *rundir; /* directory in which to run */
  char *logfile; /* where to log errors */
  char *pidfile; /* process ID file */
  char *dbname; /* the sub-directory in which our database exists */

  char *service; /* name of service or port number */
  int sockretries; /* number of times to attemp to create socket */
  int retrysleep; /* number of seconds to sleep between retries */

  int dbreopentime; /* number of seconds after which to reopen the database */

  int nresponses; /* number of responses to send per request */

  int passphrasefd; /* -1: read passphrase from tty; #: read from given fd */

  int dbgNotFound;

  int dbreopenwait; /* number of seconds to wait between attempts to reopen the
                       database */
};


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern DLLExport int getConfig(struct config *conf, int ac, char **av);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* CONFIG_H_ */
