/* $Id: laipAciMapping.h,v 1.2 1999/05/21 00:18:34 kent Exp $ */
#ifndef LAIPACIMAPPING_H_
#define LAIPACIMAPPING_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  typedef struct laip_acimap *LaipAciMap;

  extern int laipAciMapNew(ZkError err, 
                           LaipAciMap *aciMap);

  /* Add a destination IP/port for an ACI */
  extern int laipAciMapAddDest(ZkError err, 
                               LaipAciMap aciMap,
                               ZkACI aci,
                               const char *ipaddr,
                               unsigned short port);

  /* Delete a destination IP/port from the ACI maps */
  extern int laipAciMapDeleteDest(ZkError err, 
                                  LaipAciMap aciMap,
                                  unsigned long int ipaddr,
                                  unsigned short port);

  extern int laipAciMapFree(ZkError err, 
                            LaipAciMap *aciMap);

  /* Given a ipaddr and port, check to see if we have a mapping to an ACI */
  extern int laipAciMapGetAci(ZkError err,
                              LaipAciMap aciMap, 
                              unsigned long int ipaddr, /* network byteorder */
                              unsigned short port, /* host byteorder */
                              ZkACI *aci,
                              int *found);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* LAIPACIMAPPING_H_ */
