/* $Id: laipCmd.h,v 1.10 1999/05/21 20:11:04 kent Exp $ */
#ifndef LAIPCMD_H_
#define LAIPCMD_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "laip.h"

  extern int laipCmdOpenPort(ZkError, unsigned short, int, int *);

  extern int laipCmdAccept(ZkError, int, const char *, size_t, int *);

  extern int laipCmdInterpret(ZkError, LaipCtx *, int *);

  extern int laipCmdConfirmDestroyAll(ZkError, int);
  extern int laipCmdConfirmDestroy(ZkError, int, ZkACI);
  extern int laipCmdConfirmCreate(ZkError, int, ZkACI, int);
  extern int laipCmdConfirmSetNym(ZkError, int, const char *);
  extern int laipCmdConfirmSetNymFailed(ZkError, int, const char *);

  extern int laipCmdConfirmPort(ZkError err,
                                int s, 
                                unsigned short port, 
                                int success, 
                                ZkACI aci);

  extern int laipCmdPrintString(ZkError err,
                                int s,
                                const char *string,
                                size_t sz);

  extern int laipCmdConfirmNumHops(ZkError err,
                                   int s,
                                   int nhops, 
                                   int success);

  extern int laipCmdConfirmRulesCleared(ZkError err,
                                        int s,
                                        int success);

  extern int laipCmdConfirmFirstHop(ZkError err,
                                    int s,
                                    uint32_t id,
                                    int success);

  extern int laipCmdConfirmExitFunnel(ZkError err,
                                      int s,
                                      uint32_t id, 
                                      int success);

  extern int laipCmdConfirmHop(ZkError err, 
                               int s, 
                               uint32_t id, 
                               int success);

  extern int laipCmdConfirmMustUse(ZkError err, 
                                   int s,
                                   uint32_t id, 
                                   int success);

  extern int laipCmdConfirmDontUse(ZkError err, 
                                   int s,
                                   uint32_t id, 
                                   int success);

  extern int laipCmdNoRoutes(ZkError err, 
                             int s);
  
  extern int laipCmdPortAlreadyBlocked(ZkError err, 
                                       int s,
                                       unsigned short port,
                                       ZkACI aci);

  extern int laipCmdPortNotBlocked(ZkError err,
                                   int s,
                                   unsigned short port);

  extern int laipCmdDelShimRuleConfirm2(ZkError err, 
                                       int s,
                                       struct sockaddr_in addr,
                                       int success);

  extern int laipCmdAddShimRuleConfirm2(ZkError err,
                                        int s,
                                        struct sockaddr_in addr,
                                        ZkACI aci,
                                        int success);

  extern int laipCmdPrintRoute(ZkError err,
                               int s,
                               uint32_t *routers, 
                               size_t nhops);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* LAIPCMD_H_ */
