/* $Id: laipRoute.h,v 1.5 1999/02/17 21:30:04 kent Exp $ */
#ifndef LAIPROUTE_H_
#define LAIPROUTE_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "laip.h"

  typedef struct laip_route *LaipRoute;

  extern int laipRouteNew(ZkError, LaipRoute *, size_t);
  extern int laipRouteFree(ZkError, LaipRoute *);

  extern int laipRouteAdd(ZkError, LaipRoute, ZkACI, struct sockaddr_in,
                          ZkList, const char *);

  extern int laipRouteDestroyRoutes(ZkError, int, FrLocalAipCtx, LaipRoute, 
                                    ZkACI, int);

  extern int laipRouteInitDH(ZkError, LaipRoute, ZkACI, int, unsigned short,
                             unsigned long, uint8_t, int, struct sockaddr_in,
                             FrKeyQry);

  extern int laipRouteDHExchange(ZkError, LaipRoute, ZkACI, int *, int *);

  extern int laipRouteDHKeys(ZkError, LaipRoute, FrKeyQry, int, ZkACI,
                             int *, int *);

  extern int laipRouteSetRouteParams(ZkError, LaipRoute, FrLocalAipCtx, 
                                     ZkACI);

  extern int laipRouteGetFirstHop(ZkError, LaipRoute, ZkACI, 
                                  struct sockaddr_in *);

  extern int laipRouteSendRouteCreate(ZkError, LaipRoute, FrLocalAipCtx,
                                      ZkACI, int);

  extern int laipRouteSetAcked(ZkError, LaipRoute, ZkACI, int);
  extern int laipRouteGetAcked(ZkError, LaipRoute, ZkACI, int *);

  extern int laipRouteCheckRouteCreateTimeout(ZkError, LaipRoute, ZkACI, 
                                              unsigned long, int *);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* LAIPROUTE_H_ */
