/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef ELGPARMS_H_
#define ELGPARMS_H_

#include "zkStdio.h"
#include "zks.h"
#include "openssl/bn.h"
#include "zkError.h"
#include "fr_gencrypt.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern FRCRYPT_API BIGNUM frBn_ElG_p_1024;
  extern FRCRYPT_API BIGNUM frBn_ElG_p_1536;
  extern FRCRYPT_API BIGNUM frBn_ElG_p_2048;
  extern FRCRYPT_API BIGNUM frBn_ElG_p_3072;
  extern FRCRYPT_API BIGNUM frBn_ElG_p_4096;
  
  extern FRCRYPT_API BIGNUM frBn_ElG_g;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ELGPARMS_H_ */
