/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */


#ifndef FRBLINDING_H_
#define FRBLINDING_H_

/*
 *
 * General public blinding routines.
 *
 */

#include "zks.h"

#include "zkStdio.h"
#include "zkError.h"
#include "fr_gencrypt.h"
#include "fr_elg.h"

typedef struct fr_blinding *FrCryptBlinding;


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


FRCRYPT_API int fr_CryptBlindingNew(ZkError err, FrCryptBlinding *blinding);
FRCRYPT_API int fr_CryptBlindingFree(ZkError err, FrCryptBlinding *blinding);
FRCRYPT_API int fr_CryptBlindingElGKeyExchangePre(ZkError err, FrCryptCrypt key, BIGNUM* base);
FRCRYPT_API int fr_CryptBlindingElGKeyExchangePost(ZkError err, FrCryptCrypt key, BIGNUM* base);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FRPK_H_ */
