/*
 *  $Id: fr_hash.h,v 1.8 2001/04/19 19:59:57 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FR_HASH_H_
#define FR_HASH_H_

/*
 *
 *
 *                                Hashes
 *
 *
 */


#include "zkError.h"
#include "fr_gencrypt.h"


#define FRCRYPT_HASH_SIZE 20
#define FRCRYPT_SALT_SIZE  8  

typedef struct fr_crypt_hash *FrCryptHash;

typedef enum  hashtype { sha1, md5 } hashtype;


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern FRCRYPT_API int frCryptHashNew(ZkError err, FrCryptHash *hash);
  extern FRCRYPT_API int frCryptHashFree(ZkError err, FrCryptHash *hash);
  extern FRCRYPT_API int frCryptHashReset(ZkError err, FrCryptHash hash);  
  extern FRCRYPT_API int frCryptHashUpdate(ZkError err, FrCryptHash hash, const void *data, size_t dsz);
  extern FRCRYPT_API int frCryptHashGetHash(ZkError err, FrCryptHash hash, void *hbuf, size_t hsz);

  extern FRCRYPT_API int frCryptHashGenerate(ZkError err, void *data, size_t dsz, void *hbuf, size_t hsz);
  extern FRCRYPT_API int frCryptHashVerify(ZkError err, void *data, size_t dsz, void *hbuf, size_t hsz, int *valid);


  extern FRCRYPT_API int frCryptHashNew2(ZkError err, FrCryptHash *hash, const hashtype ht);
  extern FRCRYPT_API int frCryptHashUpdate2(ZkError err, FrCryptHash hash, const void *data, size_t dsz);
  extern FRCRYPT_API int frCryptHashGetHash2(ZkError err, FrCryptHash hash, void *hbuf, size_t hsz, const hashtype ht);
  extern FRCRYPT_API int frCryptHashReset2(ZkError err, FrCryptHash hash);
  extern FRCRYPT_API int frCryptHashGenerate2(ZkError err, void *data, size_t dsz, void *hbuf, size_t hsz, const hashtype ht);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FR_HASH_H_ */
