/*
 *  $Id: fr_mac.h,v 1.8 2001/04/19 19:59:57 alainc Exp $
 */

#ifndef FR_MAC_H_
#define FR_MAC_H_

/*
 *
 *
 *                 Message Authentication Codes (MACs)
 *
 *
 */

#include "zks.h"
#include "zkError.h"


#define FRCRYPT_MACKEY_SIZE 20
#define FRCRYPT_MAC_SIZE 20

typedef struct fr_crypt_mac_key *FrCryptMacKey;


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern FRCRYPT_API int frCryptMacKeyNew(ZkError err, FrCryptMacKey *key);
  extern FRCRYPT_API int frCryptMacKeyFree(ZkError err, FrCryptMacKey *key);
  extern FRCRYPT_API int frCryptMacKeySetFromData(ZkError err, FrCryptMacKey key, void *data, size_t dsz);
  extern FRCRYPT_API int frCryptMacKeyLoad(ZkError err, FrCryptMacKey key, void *data, size_t dsz);
  extern FRCRYPT_API int frCryptMacKeyStore(ZkError err, FrCryptMacKey key, void *data, size_t dsz);
  extern FRCRYPT_API int frCryptMacSetKeyFromSym(ZkError err, FrCryptMacKey mac, FrCryptSym sym);
  extern FRCRYPT_API int frCryptMacSetKeyZero(ZkError err, FrCryptMacKey key);
  extern FRCRYPT_API int frCryptMacIntoBuffer(ZkError err, FrCryptMacKey key, void *data, size_t dsz, void *mac, size_t msz);
  extern FRCRYPT_API int frCryptMacVerifyFromBuffer(ZkError err, FrCryptMacKey key, void *data, size_t dsz, void *mac, size_t msz, int *valid);

  extern FRCRYPT_API int frCryptMac2IntoBuffer(ZkError err, FrCryptMacKey key, void *data1, size_t dsz1, void *data2, size_t dsz2, void *mac, size_t msz);
  extern FRCRYPT_API int frCryptMac2VerifyFromBuffer(ZkError err, FrCryptMacKey key, void *data1, size_t dsz1, void *data2, size_t dsz2, void *mac, size_t msz, int *valid);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FR_MAC_H_ */
