/*
 *  $Id: frBn.h,v 1.11 2001/04/19 19:59:58 alainc Exp $
 */

#ifndef FR_BN_
#define FR_BN_

#include "zks.h"

#include "zkError.h"
#include "zkStdio.h"
#include "openssl/opensslv.h"
#include "openssl/err.h"
#include "openssl/bn.h"
#include "fr_gencrypt.h"


/*
 *  A flags field was added to the bignum structure in later versions of
 *  SSLeay.  We'll assume that it exists in all versions in which
 *  OPENSSL_VERSION_NUMBER is defined.
 */
#ifdef OPENSSL_VERSION_NUMBER
# define ZK_BN_FLAGS_DFL , 0 /* the comma is important! */
#else    
# define ZK_BN_FLAGS_DFL
#endif


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


  extern FRCRYPT_API BIGNUM *fr_BnNewFromData(ZkError err, const void *d, size_t dsz);
#if !defined(ZK_KERNEL)
  extern FRCRYPT_API int fr_BnPrint(ZkError err, const char *name, BIGNUM *b);
  extern FRCRYPT_API int fr_BnPrintAsC(ZkError err, const char *name, BIGNUM *b, FILE *fp);
#endif
  extern FRCRYPT_API int fr_BnLoad(ZkError err, BIGNUM *b, void *data, size_t dsz);
  extern FRCRYPT_API int fr_BnStore(ZkError err, BIGNUM *b, void *data, size_t dsz);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FR_BN_ */
