/*
 *  $Id: frRand.c,v 1.42 2001/04/19 19:59:58 alainc Exp $
 */


#include "zks.h"
#include "fr_rand.h"
#include "zkrand.h"

#if !defined(ZK_KERNEL_MAC_OS8_ASYNC_ONLY)

FRCRYPT_API int frCryptAddEntropy(ZkError err, void *data, size_t dsz)
{
  return zkRandEntropyAdd(err, data, dsz);
}

FRCRYPT_API int frCryptSetRandomData(ZkError err, void *data, size_t dsz)
{
  return zkRandGetData(err, data, dsz);
}

#endif	/* !defined(ZK_KERNEL_MAC_OS8_ASYNC_ONLY) */

#if !defined(ZK_KERNEL_MAC_OS8)

FRCRYPT_API int frCryptRandomUInt32InRange(ZkError err, 
					 uint32_t min, uint32_t max,
					 uint32_t * rn)
{
  return zkRandGetUInt32InRange(err, min, max, rn);
}

#endif	/* !defined(ZK_KERNEL_MAC_OS8) */

FRCRYPT_API void frRand_Debug(void)
{
  zkRand_Debug();
}

extern int fr_CryptRandInit(ZkError err, const char *entropyfile)
{
  return zkRand_Init(err, entropyfile);
}

extern int fr_CryptRandFinal(ZkError err)
{
  return zkRand_Final(err);
}

#if !defined(ZK_KERNEL_MAC_OS8)

FRCRYPT_API int frCryptAddEntropyFromSource(ZkError err, int source_id,
					  void *data, size_t dsz,
					  unsigned int bits)
{
  return zkRandEntropyAddFromSource(err, source_id, data, dsz, bits);
}

FRCRYPT_API int frCryptGetEntropyCount(ZkError err, int *enough,
				     int *num_sources, unsigned *source_id,
				     size_t *entropy_bits,
				     size_t *entropy_max)
{
  return zkRandEntropyGetCount(err, enough, num_sources, source_id,
			       entropy_bits, entropy_max);
}

FRCRYPT_API int frCryptNewSource(ZkError err, unsigned *source)
{
  return zkRandEntropyAddSource(err, source);
}

#endif	/* !defined(ZK_KERNEL_MAC_OS8) */

FRCRYPT_API void frRand_DontBlock(void)
{
  /* obsolete, blocking has been disabled */
}
