/*
 *  $Id: keyinfo.c,v 1.3 2001/04/19 19:59:59 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *  
 *  General routines to provide information about keys.  Mostly used for
 *  logging and debugging, etc.
 */


#include "zks.h"

#include "fr_gencrypt.h"
#include "fr_keyinfo.h"


/*
 *  Return 'c' for cryption, 's' for signing and '?' for any other value.
 */
FRCRYPT_API char fr_CryptKeyTypeChar(FrPubKeyType type)
{
  char c;
  
  switch (type) {
  case FRCRYPT_KEYTYPE_CRYPTION: c = 'c'; break;
  case FRCRYPT_KEYTYPE_SIGNING:  c = 's'; break;
  default:                       c = '?'; break;
  }

  return c;
}
