#ifndef PK_H_
#define PK_H_

/*
 *  $Id: pk.h,v 1.11 2001/04/19 19:59:59 alainc Exp $
 */

#include "zks.h"
#include "zkIntTypes.h"
#include "zkClock.h"
#include "openssl/bn.h"
#include "frEnt.h"
#include "fr_blinding.h"


#define NUM_PARMS 8


struct fr_crypt_pubkey {
  uint8_t vers;
  uint8_t type;
  uint8_t alg; /* currently one-to-one with type */
  uint16_t size; /* indication of key size, in bits */
  ZkClock expires; /* expiry date in seconds.  NB. A magic expiration date
                      governs the ability to create routes. see pk.c */

  FrEntIdExp ent; /* associated entity (e.g. key owner) */

  uint8_t freeMask; /* 0: don't free corresponding bignum; 1: free it */
  uint8_t saveMask; /* 0: don't save corresponding bignum; 1: save it */
  BIGNUM *parm[NUM_PARMS]; /* allow up to 8 bignum parameters */

  uint8_t blinding_flag; /* 0: don't do blinding; 1: do blinding. */
  FrCryptBlinding bl;
    
};


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* PK_H_ */
