/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

/*
 *  Generate a g value for each of the DSA key sizes.
 */

#include <assert.h>
#include "zkStdio.h"
#include "zkStdlib.h"
#include "frCrypt.h"
#include "zkError.h"
#include "elgparms.h"
#include "dsaparms.h"


#define A(x) #x, x


static void prtBn(const char *bnName, const BIGNUM *bn)
{
  int i;
  
  zkPrintf("static const BN_ULONG %s_digits[] = {", bnName);
  for (i = 0; i < bn->top; i++) {
    if (i % 6 == 0) { zkPrintf("\n  "); }
    zkPrintf("%10luU%s", bn->d[i], i == bn->top - 1 ? "\n" : ", ");
  }
  zkPrintf("};\n\n");
  
  zkPrintf("const BIGNUM %s = {\n", bnName);
  zkPrintf("  %s_digits,\n", bnName);
  zkPrintf("  %d,\n", bn->top);
  zkPrintf("  sizeof %s_digits / sizeof %s_digits[0],\n", bnName, bnName);
  zkPrintf("  0\n");
  zkPrintf("};\n\n");
}

int main(void)
{
  /*ZkError err;*/

  /* DSA */
  
  const BIGNUM frBn_Dsa_p_1024;
  const BIGNUM frBn_Dsa_q_1024;
  const BIGNUM frBn_Dsa_p_1536;
  const BIGNUM frBn_Dsa_q_1536;
  const BIGNUM frBn_Dsa_p_2048;
  const BIGNUM frBn_Dsa_q_2048;
  const BIGNUM frBn_Dsa_p_4096;
  const BIGNUM frBn_Dsa_q_4096;
/*  
  frBn_Dsa_p_1024 = fr_Bn_Dsa_p_1024(err);
  frBn_Dsa_q_1024 = fr_Bn_Dsa_q_1024(err);
  frBn_Dsa_p_1536 = fr_Bn_Dsa_p_1536(err);
  frBn_Dsa_q_1536 = fr_Bn_Dsa_q_1536(err);
  frBn_Dsa_p_2048 = fr_Bn_Dsa_p_2048(err);
  frBn_Dsa_q_2048 = fr_Bn_Dsa_q_2048(err);
  frBn_Dsa_p_4096 = fr_Bn_Dsa_p_4096(err);
  frBn_Dsa_q_4096 = fr_Bn_Dsa_q_4096(err);
*/
  
  /*assert(pick_g(frBn_Dsa_p_1024, frBn_Dsa_q_1024));*/
/*
  prtBn("frBn_Dsa_p_1024", &frBn_Dsa_p_1024);
  prtBn("frBn_Dsa_q_1024", &frBn_Dsa_q_1024);
  prtBn("frBn_Dsa_p_1536", &frBn_Dsa_p_1536);
  prtBn("frBn_Dsa_q_1536", &frBn_Dsa_q_1536);
  prtBn("frBn_Dsa_p_2048", &frBn_Dsa_p_2048);
  prtBn("frBn_Dsa_q_2048", &frBn_Dsa_q_2048);
  prtBn("frBn_Dsa_p_4096", &frBn_Dsa_p_4096);
  prtBn("frBn_Dsa_q_4096", &frBn_Dsa_q_4096);
*/
  exit(EXIT_SUCCESS);
  return 1;
}
