/*
 *  $Id: trand.c,v 1.6 2001/04/19 20:00:05 alainc Exp $
 *  
 *  Test the random data routines.
 */

#include "zks.h"

#include <assert.h>
#include <signal.h>
#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkTime.h"
#include "zkUnistd.h"
#include "frCrypt.h"
#include "zkError.h"

static char seedfile[] = "seedfile";

static sig_atomic_t done = 0;


static void dosig(int sig)
{
  (void)sig;
  done = 1;
}


int main(void)
{
  ZkError err;
  char buf[2048];
  size_t bsz;

  srand(time(0));

  assert(zkErrorNew(&err));
  assert(frCryptInit(err, NULL));
  signal(SIGINT, dosig);

  while ( ! done) {
    size_t got;
    
    bsz = 1 + rand() % sizeof buf;
    assert(frCryptInit(0,seedfile));
    assert(zkRandGetData(err, buf, bsz));
    zkFprintf(stderr, "get data\n");
#if 1
    zkSleep(1);
#endif
  }

  assert(frCryptFinal(err, NULL));
  assert(zkErrorFree(&err));

  return (EXIT_SUCCESS);
}
