/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include <assert.h>
#include <limits.h>
#include "zkStdio.h"
#include "zkStdlib.h"
#include "frCrypt.h"
#include "zkError.h"

static char seedfile[] = "seedfile";

int main( int argc, char * argv[] )
{
  ZkError err;
  int enough;
  unsigned s[20];
  int i,j;
  int ent,max;

  assert(zkErrorNew(&err));
  assert(frCryptInit(err, seedfile));

  for (i=0;i<3;i++) {
    assert(zkRandEntropyAddSource(err, s+i));
    for (j=0;j<100;j++) {
      assert(zkRandEntropyGetCount(err, &enough, 0, 0, &ent, &max));
      zkPrintf("enough=%d ent=%d max=%d\n",enough, ent, max);
      assert(zkRandEntropyAddFromSource(err, s[i], "dnhfiuawryvciuyncxliuhvrliuahfoic87u3", 10, 80));
    }
  }

  assert(zkRandEntropyGetCount(err, &enough, 0, 0, &ent, &max));
  zkPrintf("enough=%d ent=%d max=%d\n",enough, ent, max);

  return 0;
}
