/*
 * Freedom defined database object types
 * $Id: frDBOTypeNidbObj.h,v 1.13 2001/04/19 20:00:19 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 *
 *
 */
#ifndef FRDBO_TYPE_NIDB_OBJ_H_
#define FRDBO_TYPE_NIDB_OBJ_H_


#include "zkSysTypes.h"
#include "zkSysSocket.h"
#include "zkNetinetIn.h"
#include "zkArpaInet.h"

#include "zkIntTypes.h"
#include "zkDBO.h"
#include "zkDBODefs.h"
#include "zkDBOTypes.h"
#include "frEnt.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


  /**
   * A typedef for representing the entity identifier
   */

  typedef enum {
    FRNIDBOBJ_UNUSED_,
    FRNIDBOBJ_SERVER,
    FRNIDBOBJ_AIP,
    FRNIDBOBJ_NEIGHBOUR_LIST,
    FRNIDBOBJ_STATUS_RESP,
    FRNIDBOBJ_LONG_STATUS_RESP,
    FRNIDBOBJ_LIST_RESP
  } FrNidbObjType;
  

  typedef struct FrDBOTypeNidbObj_T *FrNidbObj;

#define SIZEOF_FRNIDBOBJ  sizeof(struct FrDBOTypeNidbObj_T)
#define FRNIDBOBJ_STATUS_INDICATOR 0xf0000000
#define FRNIQSOBJ_OPERATOR_MAX 64
#define FRNIQSOBJ_REGION_MAX 16

#define FRNIDBOBJ_CURRENT_VERSION      5
#define FRNIDBOBJ_VERSION_ENTITY_ADDED 5
  
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
