/**
 * Database packing/unpacking routines
 *
 * Defines the contents of a database
 *
 * $Id: zkDBOTypes.h,v 1.8 2001/04/19 20:00:19 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 */
#ifndef ZKDBOTYPES_H
#define ZKDBOTYPES_H

#include "zkDBO.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  DLLExport extern int zkDBOPackUint64 (ZkError, const char *, void *, size_t,
                                     void **, size_t *);
  DLLExport extern int zkDBOUnpackUint64 (ZkError, const char *, void **, size_t *,
                                       void *, size_t *);
  DLLExport extern int zkDBOPackUint32 (ZkError, const char *, void *, size_t,
                                     void **, size_t *);
  DLLExport extern int zkDBOUnpackUint32 (ZkError, const char *, void **, size_t *,
                                       void *, size_t *);
  DLLExport extern int zkDBOPackUint16 (ZkError, const char *, void *, size_t,
                                     void **, size_t *);
  DLLExport extern int zkDBOUnpackUint16 (ZkError, const char *, void **, size_t *,
                                       void *, size_t *);
  DLLExport extern int zkDBOPackBuf (ZkError, const char *, void *, size_t,
                                  void **, size_t *);
  DLLExport extern int zkDBOUnpackBuf (ZkError, const char *, void **, size_t *,
                                    void *, size_t *);
  DLLExport extern int zkDBOPackStr (ZkError, const char *, void *, size_t,
                                  void **, size_t *);
  DLLExport extern int zkDBOUnpackStr (ZkError, const char *, void **, size_t *,
                                    void *, size_t *);
  DLLExport extern int zkDBOPackIpAddr (ZkError, const char *, void *, size_t,
                                     void **, size_t *);
  DLLExport extern int zkDBOUnpackIpAddr (ZkError, const char *, void **, size_t *,
                                       void *, size_t *);

#ifndef NDEBUG  
  DLLExport extern int zkDBOTestUint16 (ZkError, uint16_t);
  DLLExport extern int zkDBOTestUint32 (ZkError, uint32_t);
  DLLExport extern int zkDBOTestUint64 (ZkError, UINT64_T);
  DLLExport extern int zkDBOTestBuf (ZkError, char *, size_t);
  DLLExport extern int zkDBOTestStr (ZkError, char *, size_t);
  DLLExport extern int zkDBOTestIpAddr (ZkError err, char *ipaddr);
#endif
  
#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* ZKDBOTYPES_H */
