/*
 * $Id: fr_keyqry_db.h,v 1.4 2001/04/19 20:25:03 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *
 * Copyright (C) 1999 Zero-Knowledge Systems Inc.  All Rights Reserved
 */

/* 
 * This file includes functions which are used for accessing the key database
 * directly.
 *
 */

#ifndef FR_KEYQRY_DB_H
#define FR_KEYQRY_DB_H

#include "zkDB.h"
#include "frEnt.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* Structures for holding groups of keys. 
 *
 */

typedef struct fr_keyqry_nymkeys * frNymKeys;

/* These functions are used to manipulate all the keys for a nym. */

DLLExport int
fr_KeyQryDB_GetNymKeys(
  ZK_OUT   ZkError,
  ZK_IN    ZkDB,
  ZK_IN    const char *,
  ZK_OUT   frNymKeys *);

DLLExport int
fr_KeyQryDB_WriteNymKeys(
  ZK_OUT   ZkError,
  ZK_IN    ZkDB,
  ZK_IN    frNymKeys);

DLLExport int
fr_KeyQryDB_FreeNymKeys(
  ZK_OUT   ZkError,
  ZK_INOUT frNymKeys *);

DLLExport int
fr_KeyQryDB_ExpungeNymKeys(
  ZK_OUT   ZkError,
  ZK_IN    ZkDB,
  ZK_IN    const char *);


/* This function is used to remove all the keys for a given entity. 
 * The number of keys deleted is returned. 
 */
DLLExport int
fr_KeyQryDB_ExpungeKeys(
  ZK_OUT   ZkError,
  ZK_IN    ZkDB,
  ZK_IN    FrEntIdType,
  ZK_IN    const char *,
  ZK_OUT   int *);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FR_KEYQRY_DB_H */
