/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef TEST_SUPPORT_H_
#define TEST_SUPPORT_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern int connectTcp(ZkError, struct sockaddr_in, int, int *);

  extern int setSockaddrIn(ZkError, char *, char *, const char *, 
                           struct sockaddr_in *);

  extern int bindTCPSocket(ZkError, int, int *);

  extern int bindUDPSocket(ZkError, int, int *);

  extern int setAlg(char *, FrCryptSymAlg *);

  extern int getLEKeys(FrCryptSymAlg *, char *, char *, char *);

  extern int keyPrefetch(ZkError, FrKeyQry, int, struct sockaddr_in, 
                         char [][64], FrPubKeyType);

  extern int readNymSigKey(ZkError, FrCryptSig *, const char *, size_t,
                           const char *, size_t);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
