#ifndef __auth_common_hh
#define __auth_common_hh

#include <zkError.h>
#include <frMailAuth.h>
#include <zkBase64.h>
#include <string>

#define FRMAILENV_NYM_TYPE         "fr_NYM_TYPE"
#define FRMAILENV_SEND_LIMIT       "fr_SEND_LIMIT"
#define FRMAILENV_CROSSPOST_LIMIT  "fr_CROSSPOST_LIMIT"
#define FRMAILENV_STORAGE_QUOTA    "fr_STORAGE_QUOTA"
#define FRMAILENV_VOLUME_LIMIT     "fr_VOLUME_LIMIT"

#define FRMAILPARM_NYM_TYPE         "type"
#define FRMAILPARM_SEND_LIMIT       "send-limit"
#define FRMAILPARM_CROSSPOST_LIMIT  "crosspost-limit"
#define FRMAILPARM_STORAGE_QUOTA    "quota"
#define FRMAILPARM_VOLUME_LIMIT     "volume-limit"

using namespace std;

bool legal(string &str);
string guid(string &nym);
string slurpConfigFile(const char *file);
void die(const char *msg);
void dietmp(const char *msg);
void dieOnError(ZkError err_, const char *msg);
void loadMacKey(ZkError err_, FrCryptMacKey &mkey, const char* file);
void nym2Entity(ZkError err_, const string &nym, FrEntIdExp &ent);
void Base64(ZkError err_, string &str);
void unBase64(ZkError err_, string &str);
string calculateUserDir(ZkError err_, string &root, string &user);


extern const char* qmailCtlDirDefault;
extern const char* qmailBinDirDefault;
#endif
