#! /bin/sh
# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is Freedom code.
# 
# The Initial Developer of the Original Code is Zero-Knowledge Systems,
# Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
# Zero-Knowledge Systems, Inc.  All Rights Reserved.
# 
# Contributor(s):


if [ $# -lt 6 ]
then
    echo "> Usage:"
    echo ">"
    echo ">    $0 type send-limit crosspost-limit quota volume name"
    echo ">"
    echo "> Where:"
    echo ">"
    echo ">    type             the numeric value for the nym type"
    echo ">    send-limit       the numeric value for the send limit"
    echo ">    crosspost-limit  the numeric value for the crosspost limit"
    echo ">    quota            the storage quota (in KB)"
    echo ">    volume           the sending volume limit (in KB)"
    echo ">    name             the name of the nym"
    exit
fi

export fr_NYM_TYPE="$1"
export fr_SEND_LIMIT="$2"
export fr_CROSSPOST_LIMIT="$3"
export fr_STORAGE_QUOTA="$4"
export fr_VOLUME_LIMIT="$5"

shift 5

${ZK_ROOT}/arch/${ZK_ARCH}/Debug/bin/ensure-user $*
