/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

/*
 *
 *  Test the generation of the nym-mail system mac key
 *
 */


#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "frMailAuth.h"

#define ensure(x) if(!x) { printf("failed in library call\n"); exit(1);}


int main() {
  
  ZkError err;
  
  FrCryptMacKey mkey;
  FrEntIdExp ent;
  char secret[100];
  int i;

  /* generate secret */
  for (i=0; i<100; i++) secret[i] = (2*i + 5)%255;
  
  ensure(zkErrorNew(&err));
  
  /* generate a mac key */
  ensure(frCryptMacKeyNew(err, &mkey));
  frEntSetFromStr2(err, &ent, "nym", "Bozo");
  
  frGenSharedNymMailMacKey(err, secret, 100, &ent, mkey);

  /*
   *  Clean up.
   */
  ensure(frCryptMacKeyFree(err, &mkey));
  ensure(zkErrorFree(&err));
  
  exit(EXIT_SUCCESS);
  return 0; /* to shut up insure */
}



