/* ==========================================================================
 * $Id: frMailBlockList_client.h,v 1.4 2000/11/23 15:13:04 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *
 * This file defines functions which facilitate the creation of the entries
 * which are used in the mail system block-list.
 *
 * Copyright (c) 2000 Zero-Knowledge Systems.  All rights reserved.
 */

# ifndef frMailBlockList_client_h_included
# define frMailBlockList_client_h_included

# include "zkError.h"
# include "fr_hash.h"
# include "zkBase64.h"

# define FRMAILBLOCKLIST_ENTRY_LEN  (zkBinarySizeToBase64Size(FRCRYPT_HASH_SIZE))

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

extern DLLExport int frMailBlockList_CreateSenderEntry(
    ZK_INOUT ZkError            error,
    ZK_IN    const char * const in_sender,
    ZK_OUT   char *             out_entry,
    ZK_IN    size_t             max_entry_size,
    ZK_OUT   size_t *           out_entry_size );


extern DLLExport int frMailBlockList_CreateRecipientEntry(
    ZK_INOUT ZkError            error,
    ZK_IN    const char * const in_recipient,
    ZK_OUT   char *             out_entry,
    ZK_IN    size_t             max_entry_size,
    ZK_OUT   size_t *           out_entry_size );


extern DLLExport int frMailBlockList_CreateSenderRecipientEntry(
    ZK_INOUT ZkError            error,
    ZK_IN    const char * const in_sender,
    ZK_IN    const char * const in_recipient,
    ZK_OUT   char *             out_entry,
    ZK_IN    size_t             max_entry_size,
    ZK_OUT   size_t *           out_entry_size );

#ifdef __cplusplus
}
#endif /* __cplusplus */

# endif /* frMailBlockList_client_h_included */
