/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FRMAILMID_H_
#define FRMAILMID_H_

#include "zks.h"
#include "zkError.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

DLLExport int frCryptSetMsgID(ZkError err, const char *id, char *newid,
			      size_t nsize_max, const char *nym,
			      const char *secret, size_t secretlen);

DLLExport int frCryptRecoverMsgID(ZkError err, int *ret, char *id,
				  const char *nym, const char *secret,
				  size_t secret_len);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FRMAILMID_H_ */
