#!/bin/sh
# This script adds a tagline to the message going through
# It takes the message from stdin. stdin should not be 
# a pipe as it needs to be seekable.
# The $1 argument is the account where the .tagline is located.

#define what dir we are using.
QMAIL_DIR=/usr/freedom/qmail
QMAIL_BIN=${QMAIL_DIR}/bin
QMAIL_CONTROL=${QMAIL_DIR}/control

# First check if we need to add the tagline
if [ $(grep -i -s 'off' ${1}/.tagline) ] 
then 
	# we put the message on stdout and exit
	cat -;
	exit 0;
fi

#we add a tagline, so what kind?
if [ ` ${QMAIL_BIN}/reformime -i -s 1 | grep 'content-type:' | awk '{print $2}'`   = 'text/plain' ]
then
	# we now check if it is 7bit (so only text message are tagged)
	# these are most likely a unix message or a news posting.
	${QMAIL_BIN}/seek 0 0
	if [ ` ${QMAIL_BIN}/reformime -i -s 1 | grep 'content-transfer-encoding:' | awk '{print $2}'`   = 'base64' ]
	then
	${QMAIL_BIN}/seek 0 0;
	${QMAIL_BIN}/add-tagline ${QMAIL_CONTROL} 
	else
	# simple, we add a tagline to the end of the message

	${QMAIL_BIN}/seek 0 0
	cat - ${QMAIL_CONTROL}/tagline.txt
	fi	
else
	${QMAIL_BIN}/seek 0 0;
	${QMAIL_BIN}/add-tagline ${QMAIL_CONTROL}
fi
exit 0;
