#!/usr/bin/perl -s
#
# Script that extract some information from an email and verifies 
# the validity of the X-Freedom-Envelope-Sig signature.
#
# $Id$

$from = "From:";
$xsig = "X-Freedom-Envelope-Sig:";
$defaulthost = "207.107.115.16";
#$defaulthost  = "kqd.gamma.freedom.net";

$tmp = `reformail -x $from -x $xsig`;

($sender, $recip_sig) = split( "\n", $tmp );
($recip,$sig) = split(" ", $recip_sig);

if (not $sender or not $recip or not $sig) {
  print STDERR "Email not well-formed.\n";
  exit 0;
}

# if $sender has more than one token, then take the one between < >
if ($sender =~ /<.*>/) {
  $found = 0;
  @word_array = split / /, $sender;
  while ($found == 0) {
    $sender = pop @word_array;
    if ($sender =~ /<.*>/) {
      $sender =~ s/<//;
      $sender =~ s/>//;
      $found = 1;
    }
  }
}

# verification program
$cmd = "verify-envsig --sender $sender --recip $recip --sig $sig";

# optional arguments
if ($host) { $cmd .= " --host $host"; }
else { $cmd .= " --host $defaulthost"; }
if ($service) { $cmd .= " --service $service"; }

# call program and print its output
print `$cmd`;

exit 1;
