# execute 2 test cases for extract-bounce unit test plan.

# $Id: extract-bounce.t,v 1.2 2000/10/04 12:55:38 marcp Exp $

# template!

print "1..2\n";

# 
sub is_valid_base64
{
    my($string) = shift;
    if ($string =~ /[^a-zA-Z0-9+\/=\r\n]/) { # check for valid chars...
	return 0;
    }
    # for now...
    return 1;
}

# Test 1.

# identity test

my($input) = `echo hello`;
my($output) = `echo hello | extract-bounce`;

if ($input eq $output) {
    print "ok 1\n";
} else {
    print "not ok 1\n";
}

# Test 2.

# Test extraction of bounce message.

# Set environment variable for imep-encrypt
$ENV{'SENDER'} = 1;

my($bounce_message) = "";
# generate a normalized, encrypted message with a bounce message
$bounce_message = `echo hello | imep-encrypt -t | normalize-mail | extract-bounce | normalize-mail`;

# split on blank lines
my(@pieces) = split(/\r\n\r\n/, $bounce_message);

# should be 2 pieces...
if ($#pieces != 1) {
    print "not ok 2\n";
# There should be an X-Freedom-Message-Auth field...
} elsif (!($pieces[0] =~ /^X-Freedom-Message-Auth:/)) {
    print "not ok 2\n";
# The second part should be valid base 64
} elsif (!is_valid_base64($pieces[1])) {
    print "not ok 2\n";
} else {
    print "ok 2\n";
}

