#! /bin/bash
# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is Freedom code.
# 
# The Initial Developer of the Original Code is Zero-Knowledge Systems,
# Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
# Zero-Knowledge Systems, Inc.  All Rights Reserved.
# 
# Contributor(s):

#
# this is a simple test of the email encryption pipeline, using imep-encrypt's self-test code.
# the normalization is needed to massage the mail format library's output (and the bounce
# message) into an rfc822-compliant email.
#
# as a result of this test, you ought to see an email that looks something like this:
#
#X-Freedom-Message-Auth: AQsBAwcAAACxAQEBAQEBAZSrQlTGZ17lvB5R9tliH8tEnN
# LO0H0gYIHnqTI0eLuoQciiaand3W7zlbm0mX7CGogy+Vt8hToWFftV0h8da1Y1BKi0vjEC
# PR/uLuu/zCzRttdWNeOm7JW5v3zyZS9NsuOOau4wH4Xdn8X92jqAAFu4RFLLRJ/SNDuQI4
# 5kU+rVAeLmIg2Bxr1U5EsBCxg0gN6yY3a2QJQjkWSBbBsUmmkDswTSS7TGP0+B1U8qwdbL
# 2mkU806RyUj4TZvDhJFRrnByMp2YnIH/3Rj6ZKAIbyF8MS6LlCa/mw9+JG8EvFjACTAUdo
# 7kMPImOlyV1ttqVZpiH0wnM6zZw6LBTsHxJj0WJTQOvFsg9Szb+nzTIcyV7PTFeMz75WcO
# d26wym+n/azLb7adB13/OGKNL4GtcEo2vv90dejPSr4jMaSt97aT
#
#ARMCAgICAgIzpgqeqDbIwVu3S22jZ9dtQp4DGqf5IfsgGV6AoFJ1u3WmtRhkdB8m20sjcD
#GQdl7HLZMP7hn0evOP9WpphZDf852TxN9JZzY3b48Snx3AtnRsnd6b2E4aW4rG0T6gNi0=
#
#
# although the exact characters will be different. the things to be looking for are:
# (1) the 1-space indent on each subsequent line of the auth header
# (2) the blank line with only a CRLF on it between the header and the message
# (3) compliant base64 encoding of the auth header and the body
# (4) if you feel so inclined, check the auth header to make sure it's ok. we don't do that here.
#
export SENDER=test@nowhere.com
export LOCAL=test_nym_97
echo "test email message" | imep-encrypt -t | normalize-mail | extract-bounce | normalize-mail
