/*
 * $Id: frMaipUtil.c,v 1.9 2001/04/19 20:28:16 alainc Exp $
 */


static const char * module_id_ = "$Id: frMaipUtil.c,v 1.9 2001/04/19 20:28:16 alainc Exp $";

#include "zks.h"

#include "zkIntTypes.h"
#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkUnistd.h"
#include "zkString.h"
#include "zkError.h"
#include "zkBase64.h"
#include "frCrypt.h"
#include "frSec.h"
#include "frNetInfo.h"
#include "frMaip.h"

/*
 * This is quite incomplete at this time
 */

DLLExport int
frMaipGenerateMessageID (
  ZkError err ,
  unsigned char * buf ,
  size_t bsz )
{
  static const char * digit = 
        "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-.";

  zkErrorClear(err);
  if (buf) {
                /* 0       1       2       3       4       5       6        */
                /* 01234567012345670123456701234567012345670123456701234567 */
    if (zkRandGetData(err,buf,bsz - 1)) {
      size_t n = 0;
      for (n = 0; n < (bsz - 1); n++) {
        buf[n] = digit[buf[n] % 64];
      }
      buf[bsz -1 ] = (char) 0;
    } else {
      return 0;
    }

    return 1;
  }
  zkErrorSet(err,"frMaipGenerateMessageID",ZKERR,ZKMFRMAIP,ZKENULLPTR,NULL);
  return 0;
}

/*
 * 
 */

DLLExport int
frMaipProcessMessageID (
  ZkError err ,
  char * raw,  /* Raw message ID */
  size_t rsz,  /* Size of the message ID */
  char ** buf ,   /* Returns a NUL terminated allocated string buffer */
  FrCryptCrypt crpt ,
  FrCryptSig sig )
{
#define MESGID_SZ 64
  const char * func = "frMaipProcessMessageID";
  char * encr = NULL;
  char * sig1 = NULL;
  char * sig2 = NULL;
  size_t esz = 0;
  size_t ssz1 = 0;
  size_t ssz2 = 0;
  int return_code = 0;

  (void) module_id_; /* Get rid of the compile warning */
  zkErrorClear(err);
  if (buf && raw) {

    if (crpt && sig) {
      if (!frSecPubKeyEncryptData(err,crpt,FRCRYPT_SYMALG_BLOWFISH,raw,rsz,
                                  (void **) &encr,&esz)) {
        goto finish;
      }
      if (!frSecSignData(err,sig,encr,esz,
                         (void **) &sig1, &ssz1)) {
        goto finish;
      }
      if (!frSecSignData(err,sig,sig1,ssz1,
                         (void **) &sig2, &ssz2)) {
        goto finish;
      }
      
      *buf = (char *) zkMalloc(sizeof(char) * ((ssz2 * 4) / 3 + 5));
      if (*buf == NULL) {
        zkErrorSet(err,func,ZKERR,ZKMFRMAIP,ZKENOMEM,"malloc");
        goto finish;
      }

      if (!zkConvertToBase64(err,(unsigned char *) sig2, (unsigned char *) *buf,ssz2)) {
        goto finish;
      } 
      return_code = 1; 

    } else {
      *buf = (char *) zkMalloc(sizeof(char) * ((rsz * 4) / 3 + 5));
      if (*buf == NULL) {
        zkErrorSet(err,func,ZKERR,ZKMFRMAIP,ZKENOMEM,"malloc");
        goto finish;
      }
      if (!zkConvertToBase64(err,(unsigned char *) raw, (unsigned char *) *buf,rsz)) {
        goto finish;
      } 
      return_code = 1;
    }

finish:
    if (encr) {
      zkFree(encr);
    }
    if (sig1) {
      zkFree(sig1);
    }
    if (sig2) {
      zkFree(sig2);
    }
    return return_code;
  }
  zkErrorSet(err,func,ZKERR,ZKMFRMAIP,ZKENULLPTR,NULL);
  return 0;
}

