/* $Id: frNDBpkt.h,v 1.7 2001/04/19 20:28:36 alainc Exp $ */
/*
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FRNDBPKT_H_
#define FRNDBPKT_H_

#include <zks.h>
#include <zkError.h>
#include <netinet/in.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  typedef enum {
    FRNDB_PKT_DROP    /* Drop this packet */,
    FRNDB_PKT_RTS     /* Return to sender */,
    FRNDB_PKT_FORWARD /* Forward the packet to
			 everyone other than the source */,
    FRNDB_PKT_BCAST   /* Broadcast the packet to everyone */
  } FrNDBPktDest;

/*
 * Process NDB packet
 */

  extern int frNDBHandlePkt (ZkError,
			   struct sockaddr_in  /* source of packet */,
			   char *              /* buffer */,
			   size_t              /* size of buffer */,
                           size_t *            /* payload size */,
                           FrNDBPktDest *      /* dest of processed packet */ );

  extern int frNDBLinkDown (ZkError,
			  struct sockaddr_in  /* hsot that just went down */,
			  char *              /* buffer */,
			  size_t *            /* buffer/payload size */,
			  FrNDBPktDest *      /* dest of processed packet */ );

  extern int frNDBLinkUp (ZkError,
			  struct sockaddr_in  /* host that just came up */,
			  char *              /* buffer */,
			  size_t *            /* buffer/payload size */,
			  FrNDBPktDest *      /* dest of processed packet */ );

  /* Called when child has something to send */
  extern int frNDBStatus (ZkError,
			  char *              /* buffer */,
			  size_t *            /* buffer/payload size */,
			  FrNDBPktDest *      /* dest of processed packet */ );
			  
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FRNDBPKT_H_ */
