/*
 * zkConfFile.h
 * $Id: zkConfFile.h,v 1.3 2001/04/19 20:28:37 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 * 
 */

#ifndef ZKCONFFILE_H_
#define ZKCONFFILE_H_
#include <zkMemPool.h>
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  typedef int (* ZkConfCvtFn)(const char *, void *, ZkMemPool);  
  
  struct T_ZkConfSectionProto {
    const char *name;
    ZkConfCvtFn cvtFunc;
    int optional;
    void *variable;
    const char *dflt;
    
  };
  
  typedef struct T_ZkConfSectionProto *ZkConfSectionProto;
  
  struct T_ZkConfProto {
    const char *name;
    ZkConfSectionProto section;
  };
  
  typedef struct T_ZkConfProto *ZkConfProto;
  
  extern int cvtBool(const char *, int *, ZkMemPool);
  extern int cvtInt(const char *, void *, ZkMemPool);
  extern int cvtStr(const char *, void *, ZkMemPool);
  
  DLLExport extern int zkConfLoadFromBuffer (ZkError,
					     char *,
					     size_t,
					     ZkConfProto,
					     ZkMemPool);
  
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ZKCONFFILE_H_ */
