 /* $Id: frtest2.c,v 1.3 2001/04/19 20:28:38 alainc Exp $ */
/*
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */


#include "zks.h"

#include <stdio.h>
#include <netinet/in.h>
#include <time.h>
#include <assert.h>
#include <zkIntTypes.h>
#include <zkError.h>
#include <zkDebug.h>
#include <frNDB.h> 
#include <frNCDB.h> 
#include <frNRDB.h> 

void myaddr;

int main(int ac, char **av)
{

  ZkError err;
  ZkLog	log;
  FrNDB	ndb;
  time_t timeout;

  zkErrorNew(&err);
  zkErrorLog (err, &log);
  zkLogSetStream (log, stdout);
  zkLogEnable (log);

#ifndef WIN32
  zkLogWrite (log, "Freedom Network Configuration Database version 1 Program Starting...");
#endif

  /* Starting the test */

  zkDebugOn();
  assert(frNDBEnv(err, "/home/luc/work/zk/etc/ndb/v5253/frnetconf.ini", &timeout));
  assert(frNDBOpen(err, &ndb, NULL, NULL));
  assert(frNDBDump(ndb));
  assert(frNDBOpen(err, &ndb, NULL, NULL));
  assert(frNDBDump(ndb));
  assert(frNDBClose(err, &ndb));
  assert(frNDBDump(ndb));
  assert(frNDBClose(err, &ndb));
  assert(frNDBDump(ndb));
  
  
  return 0;
}
     
