/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#if !defined(_CacheObj_H)
#define _CacheObj_H

#include "zkStdio.h"

typedef struct CacheObjStruc *P_CacheObj;
struct CacheObjStruc {
  char* idname;
  char* filename;
};

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

int CacheObjNew(ZkError, P_CacheObj*cache, const char*, const char*);
int CacheObjFree(ZkError, P_CacheObj*);
int CacheObjWrite(ZkError, P_CacheObj, void*, size_t);
int CacheObjRead(ZkError, P_CacheObj, void**, size_t*, time_t*);

#ifdef __cplusplus
} // extern "C"
#endif /* __cplusplus */

#endif /* _CacheObj_H */
