/* 
 * $Id: nihash.h,v 1.4 2000/11/23 15:13:10 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef NIHASH_H_
#define NIHASH_H_

#include "zks.h"
#include "zkError.h"
#include "zkHash.h"
#include "niobj.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  DLLExport extern 
  int niHashKeyFree(ZkHash h,            /* Hash object */
                    void *key,           /* FrNetInfoKey */
                    void *userData);     /* Unused at this point */

  DLLExport extern 
  int niHashInsert(ZkError err,          /* Error object */
                   ZkHash h,             /* Hash Table */
                   FrNetInfoDatum data); /* Hash table datum */

  DLLExport extern
  int niHashDelete(ZkError err,
                   ZkHash h, 
                   FrNetInfoDatum data);

  DLLExport extern 
  int niHashInTable(ZkError err,
                    ZkHash h, 
                    FrNetInfoDatum data, 
                    int *found);

  DLLExport extern
  int niHashKeySize(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* NIHASH_H_ */
