/* $Id: netroute.h,v 1.6 2001/04/19 20:29:00 alainc Exp $ */
#ifndef NETROUTE_H_
#define NETROUTE_H_

#include "zks.h"
#include "zkError.h"
#include "zkSysTypes.h"
#include "zkStdlib.h"
#include "frNetRoute.h"
#include "zkIntTypes.h"
#include "zkGraph.h"
#include "frPktFmt.h"
#include "zkList.h"
#include "frNetInfo.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  typedef 
  struct T_FrNetRouteHops {
    size_t nhops;               /* Number of hops in this route */
    uint32_t router[FRPKT_NUM_ROUTES_MAX];
    int valid;
  } FrNetRouteHops;

  struct T_FrNetRoute {
    size_t nroutes;             /* Number of routes computed */
    FrNetRouteHops *routes;     /* Array of routes computed */
    uint32_t rules;             /* Bitwise */

    uint32_t *excludes;         /* Excluded IDs */
    int nexcludes;              /* Number of excluded IDs */

    uint32_t *includes;         /* Must be in route IDs */
    int nincludes;              /* Number of included IDs */

    uint32_t fh;                /* First hop */
    uint32_t lh;                /* Last hop */

    FrNetInfo ni;               /* Read-only copy of the network */
    ZkGraph graph;              /* Current network graph based on rules */
  };

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* NETROUTE */
