/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 */

/*
 */

#include "zks.h"
#include "zkStdio.h"
#include "zkStdlib.h"
#include <assert.h>
#include "zkError.h"
#include "zkLog.h"
#include "zkDebug.h"
#include "zkBase64.h"
#if 0
#include "frNidbClib.h"
#endif

#ifdef ZKMOD
# undef ZKMOD
#endif
#define ZKMOD ZKMNIDB

int main(void)
{
#if 0
  ZkError err;
  ZkLog log;
  FrNidbClibObjList objlist = NULL;
  FrNidbClibObj obj = NULL;
  FrEntIdExp *ent = NULL;
  char *name = NULL;
  FrEntIdent ent_ident = 0;
  struct in_addr sin_addr;
  uint32_t reid = 0, leid = 0;
  uint16_t dh_port = 0, fr_port = 0, port = 0;
  size_t num = 0;
  size_t numn = 0;
  size_t idx = 0;
  size_t ndx = 0;

  zkDebugOn();	

  assert(zkErrorNew(&err));
  assert(zkErrorLog (err, &log));
  assert(zkLogSetStream (log, stdout));
  assert(zkLogEnable (log));

  assert(frNCObjListDebugNew (err, &objlist));

  assert(frNCObjListGetNumElems (err, objlist, &num ));
  zkDebug ("Number of objects = %u", num);
  for (idx = 0 ; idx < num; idx ++) {
    zkDebug ("objects #%u", idx);
    assert(frNCObjListGetElement (err, objlist, idx, &obj));
    assert(frNCObjGetEntity (err, obj, &ent));
    assert(frNCObjGetType (err, obj, &(ent->type)));
    assert(frNCObjGetEntName (err, obj, &name));
    assert(frNCObjGetEntIdent (err, obj, &ent_ident));
    zkDebug ("  [%u] ent: %s/%d", ent_ident, ent->name, ent->type);
    if (ent->type != FRENT_TYPE_AIP) {
      assert(frNCObjGetServerParams (err, obj, &sin_addr, &port));
      zkDebug ("  Server: %s:%u\n", zkInet_ntoa(sin_addr), port);
    } else {
      assert(frNCObjGetAipParams (err, obj, &sin_addr, &dh_port,
			      &fr_port, &numn));
      zkDebug ("  AIP: %s:%u:%u [%u neighbours]\n",
	       zkInet_ntoa(sin_addr),
	       dh_port, fr_port, numn);
      for (ndx = 0 ; ndx < numn; ndx ++) {
	assert(frNCObjGetAipNeighbour (err, obj, ndx, &reid, &leid));
	zkDebug ("     | r_aip=%u, lnk=%u", reid, leid);
      }
      zkDebug(" ");
    }
  }
  zkFree(objlist);
#endif
  
  return EXIT_SUCCESS;
}
