/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include "zks.h"

#include "zkIntTypes.h"
#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkUnistd.h"
#include "zkError.h"
#include "zkLog.h"
#include "zkList.h"
#include "frNym.h"
#include "frNymUtil.h"
#include "zkString.h"

#define S1 "This is string number 1"

#define S2 "This is another string shoved right into the nym"

int 
main (
  int argc ,
  char ** argv )
{
  ZkError err = NULL;
  ZkLog log = NULL;
  FrRemoteNym nym = NULL;
  void * ptr = NULL;
  char foobar[128] = "mynymname";
  ZkList list = NULL;
  ZkList foo_bar = NULL;
  char * str = NULL;

  zkErrorNew(&err);
  zkErrorLog(err,&log);
  zkLogSetStream(log,stderr);
  zkLogEnable(log);
  zkListNew(err,&list);


  zkListInsert(err,list,"String1",LIST_HEAD);
  zkListInsert(err,list,"String two",LIST_HEAD);
  zkListInsert(err,list,"troisieme string",LIST_HEAD);
  zkListInsert(err,list,"quatro string-o",LIST_HEAD);
  zkListInsert(err,list,"5555555555555",LIST_HEAD);
  zkListInsert(err,list,"six six six",LIST_HEAD);
  zkListInsert(err,list,"SEVEN",LIST_HEAD);
  frRemoteNymNew(err,&nym);

  frRemoteNymAddParameter(err,nym,NymLongName,(const unsigned char *)S1,strlen(S1));
  frRemoteNymAddParameter(err,nym,NymLongName,(const unsigned char *)S2,strlen(S2));
  frRemoteNymAddParameterPtr(err,nym,NymName,(const unsigned char *)foobar,strlen(foobar),&ptr);
   ptr = foobar;
  zkPrintf("POINTER 0x%X\n",ptr);
  if (!frRemoteNymAddStringListParameter(err,nym,NymBlockList,list)) {
    zkFprintf(stderr,"frRemoteNymAddStringlistParameter:  failed\n");  
  }
  if (!frRemoteNymAddStringListParameter(err,nym,NymScanWord,list)) {
    zkFprintf(stderr,"frRemoteNymAddStringlistParameter:  failed\n");  
  }
  if (!frRemoteNymAddStringListParameter(err,nym,NymBlockList,list)) {
    zkFprintf(stderr,"frRemoteNymAddStringlistParameter:  failed\n");  
  }
  if (!frRemoteNymAddStringListParameter(err,nym,NymTokenCache,list)) {
    zkFprintf(stderr,"frRemoteNymAddStringlistParameter:  failed\n");  
  }
  
  frRemoteNymVDump(err,nym,zkDumpToStream,stdout);
  zkPrintf("Deleting...\n");

  frRemoteNymDeleteParameterPtr(err,nym,&ptr);
  frRemoteNymVDump(err,nym,zkDumpToStream,stdout);
  zkPrintf("POINTER 0x%X\n",ptr);

  frRemoteNymGetStringListParameter(err,nym,NymBlockList,&foo_bar);
  zkListMoveCursor(err,foo_bar,LIST_HEAD);
  while (zkListGet(err,foo_bar,(void **)&str,LIST_FORWARDS)) {
    zkFprintf(stdout,"%s\n",str);
  }
  return(0);
}


