/*
 * $Id: frnymsdb.h,v 1.3 2000/11/23 15:13:22 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *
 * Copyright (C) 1999 Zero-Knowledge Systems Inc.  All Rights Reserved
 */

#ifndef FRNYMSDB_H
#define FRNYMSDB_H

#include "zkDB.h"
#include "frNym.h"

/* This library exposes functions for accessing the nsdb (and nsdb-dis),
   usually found at /freedom/db/nsdb-1.1 and /freedom/db/nsdb-1.1-dis */


/* Gets a nym given its name */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

DLLExport int 
frnymsdbGetNym (ZkError,
                ZkDB,
                const char *,
                FrRemoteNym *,
                int *);

/* Add a nym given its name and data */

DLLExport int
frnymsdbAddNym (ZkError,
                ZkDB,
                const char *,
                FrRemoteNym);

/* Update a nym with new data, given its name */

DLLExport int
frnymsdbReplaceNym (ZkError,
                    ZkDB,
                    const char *,
                    FrRemoteNym);

/* Wrapper which can do either Add or Replace, as specified by Mode.
 *
 * Second parameter is a flag which can take any of the following values
 */

#define FRNYMSDB_MODE_ADDORREPLACENYM_ADD      1
#define FRNYMSDB_MODE_ADDORREPLACENYM_REPLACE  2

DLLExport int
frnymsdbAddOrReplaceNym (ZkError,
                         int,
                         ZkDB,
                         const char *,
                         FrRemoteNym);

/* Delete a nym given its name */

DLLExport int
frnymsdbDeleteNym (ZkError,
                   ZkDB,
                   const char *);

/* Nuke a nym given its name, and optionally its data.
 */
DLLExport int
frnymsdbNukeNym (ZkError,
                 ZkDB,
                 const char *,
                 FrRemoteNym);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif  /* FRNYMSDB_H */
