/*
 * $Id: frnymsdbInt.h,v 1.2 2000/11/23 15:13:22 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *
 * Copyright (C) 1999 Zero-Knowledge Systems Inc.  All Rights Reserved
 */

#ifndef FRNYMSDBINT_H
#define FRNYMSDBINT_H


/* This header contains internal information, such as strings for the frnymsdb
   library stuff. */

/* Nuked nyms in the database are identified by the nuked nym parameter.  They
 * have their NymEncryptionKey and NymSigningKey erased, and replaced with the
 * following string.
 */

#define FRNYMSDB_DB_NUKEDKEY  "Nuked Nym"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/* simple libc-style function, for converting nym names.
 *
 * It copys a lower case version of the src to the dest and returns the dest,
 * to a maximum of n bytes.  Destination may not be NUL-terminated if src is
 * too large.
 *
 *
 */
char * 
strntolower(char *,       /* dest */
            const char *, /* src */
            size_t);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* FRNYMSDBINT_H */
