/*
 *  $Id: fr_datapkt.h,v 1.5 2001/04/19 20:30:02 alainc Exp $
 */

#ifndef FR_DATAPKT_H_
#define FR_DATAPKT_H_


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  /*
   *
   *
   *  Routines for AIP data packets.
   *
   *
   */
  
  typedef struct fr_pkt_aip_data *FrPktAD;

  DLLExport size_t frPktAipDataBufferSize(void);
  DLLExport size_t frPktAipDataXmitSize(void);

  DLLExport int frPktAipDataNew(ZkError err, FrPktAD *pkt);
  DLLExport int frPktAipDataNewNoBuffer(ZkError err, FrPktAD *pkt);
  DLLExport int frPktAipDataNewUsingBuffer(ZkError err, FrPktAD *pkt, void *data, size_t len);
  DLLExport int frPktAipDataFree(ZkError err, FrPktAD *pkt);

  DLLExport int frPktAipDataSetAci(ZkError err, FrPktAD pkt, FrAci aci);
  DLLExport int frPktAipDataGetAci(ZkError err, FrPktAD pkt, FrAci *aci);

  DLLExport int frPktAipDataPayloadMaxSize(ZkError err, uint8_t vers, size_t *sz);
  DLLExport int frPktAipDataGetMaxSize(ZkError err, unsigned int vers, size_t *sz);
  DLLExport int frPktAipDataNew(ZkError err, FrPktAD *pkt);
  DLLExport int frPktAipDataFree(ZkError err, FrPktAD *pkt);
  DLLExport int frPktAipDataGetCheckSpec(ZkError err, FrPktAD pkt, int *boolean);
  DLLExport int frPktAipDataSetCheckSpec(ZkError err, FrPktAD pkt, int boolean);
  DLLExport int frPktAipDataGetSpec(ZkError err, FrPktAD pkt, void *buf, size_t *bsz);
  DLLExport int frPktAipDataSetSpec(ZkError err, FrPktAD pkt, void *buf, size_t bsz);
  DLLExport int frPktAipDataGetAci(ZkError err, FrPktAD pkt, FrAci *aci);
  DLLExport int frPktAipDataSetAci(ZkError err, FrPktAD pkt, FrAci aci);
  DLLExport int frPktAipDataGetType(ZkError err, FrPktAD pkt, FrPktType *type);
  DLLExport int frPktAipDataSetType(ZkError err, FrPktAD pkt);
  DLLExport int frPktAipDataGetVersion(ZkError err, FrPktAD pkt, unsigned int *vers);
  DLLExport int frPktAipDataSetVersion(ZkError err, FrPktAD pkt, unsigned int vers);
  DLLExport int frPktAipDataGetUseMac(ZkError err, FrPktAD pkt, int *boolean);
  DLLExport int frPktAipDataSetUseMac(ZkError err, FrPktAD pkt, int boolean);
  DLLExport int frPktAipDataGetPayload(ZkError err, FrPktAD pkt, FrCryptMacKey mk, void **pay, size_t *psz);
#if !defined(ZK_KERNEL_MAC_OS8_ASYNC_ONLY)
  DLLExport int frPktAipDataSetPayload(ZkError err, FrPktAD pkt, FrCryptMacKey mk, void *pay, size_t psz);
#endif
#if !defined(ZK_KERNEL_MAC_OS8)
  DLLExport int frPktAipDataSetRandomFiller(ZkError err, FrPktAD pkt);
#endif
  DLLExport int frPktAipDataCreateInBuffer(ZkError err, FrPktAD pkt, void *buf, size_t bsz);
  DLLExport int frPktAipDataReceiveInBuffer(ZkError err, FrPktAD pkt, void *data, size_t dsz);
  DLLExport int frPktAipDataEncryptPayload(ZkError err, FrPktAD pkt, FrCryptSym sym);
  DLLExport int frPktAipDataDecryptPayload(ZkError err, FrPktAD pkt, FrCryptSym sym);
  DLLExport int frPktAipDataGetCurrentSize(ZkError err, FrPktAD pkt, size_t *sz);
  /*
   *  Internal library routines.  (I.e. for use within other parts of this
   *  library.)
   */

  DLLExport int frPktAipData_SetType(ZkError err, FrPktAD pkt, FrPktType type);

  /*
   *  Test routines.
   */
  
  DLLExport int frPktAipData_SetPayloadSize(ZkError err, FrPktAD pkt, size_t psz);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FR_DATAPKT_H_ */
