/*
 *  $Id: fr_difhel.h,v 1.10 2001/04/19 20:30:02 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FR_DIFHEL_H_
#define FR_DIFHEL_H_


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  /*
   *
   *
   *  Routines for Diffie-Hellman key agreement.
   *
   *
   */
  
  typedef struct fr_difhel *FrPktDifHel;

#if !defined(ZK_KERNEL)
  DLLExport int frPktDifHelNew(ZkError err, FrPktDifHel *dh);
  DLLExport int frPktDifHelFree(ZkError err, FrPktDifHel *dh);
#endif	/* !defined(ZK_KERNEL) */
  DLLExport size_t frPktDifHelPktSize(void);
  DLLExport int frPktDifHelSetSigGenerate(ZkError err, FrPktDifHel dh, int boolean);
  DLLExport int frPktDifHelSetSigCheck(ZkError err, FrPktDifHel dh, int boolean);
  DLLExport int frPktDifHelSetFd(ZkError err, FrPktDifHel dh, int fd);
  DLLExport int frPktDifHelSetMySigKey(ZkError err, FrPktDifHel dh, FrCryptSig sig);
  DLLExport int frPktDifHelGetRemoteSigEntity(ZkError err, FrPktDifHel dh, FrEntIdExp *ent);
#if !defined(ZK_KERNEL)
  DLLExport int frPktDifHelGetRemoteSigVersion(ZkError err, FrPktDifHel dh, unsigned int *vers);
#endif	/* !defined(ZK_KERNEL) */
  DLLExport int frPktDifHelSetSymAlg(ZkError err, FrPktDifHel dh, FrCryptSymAlg alg);
  DLLExport int frPktDifHelGetLekv(ZkError err, FrPktDifHel dh, uint8_t *lekv);
  DLLExport int frPktDifHelSetLekv(ZkError err, FrPktDifHel dh, uint8_t lekv);
  DLLExport int frPktDifHelGetRemotePort(ZkError err, FrPktDifHel dh, uint16_t *port);
  DLLExport int frPktDifHelSetLocalPort(ZkError err, FrPktDifHel dh, uint16_t port);
  DLLExport int frPktDifHelGetRemoteTimeOffset(ZkError err, FrPktDifHel dh, ZkClock *off);
#if !defined(ZK_KERNEL)
  DLLExport int frPktDifHelSend(ZkError err, FrPktDifHel dh, int *done);
  DLLExport int frPktDifHelReceive(ZkError err, FrPktDifHel dh, int *done);
  DLLExport int frPktDifHelGetKey(ZkError err, FrPktDifHel dh, FrCryptSig otherSig, FrCryptSym sym);
#endif	/* !defined(ZK_KERNEL) */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FR_DIFHEL_H_ */
