/*
 *  $Id: fr_rdpkt.h,v 1.2 2001/04/19 20:30:02 alainc Exp $
 */

#ifndef FR_RDPKTH_
#define FR_RDPKTH_


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  /*
   *
   *
   *  Routines for AIP route destroy packets.
   *
   *
   */
  
  typedef struct fr_pkt_rte_dest *FrPktRteDest;

  DLLExport int frPktAipRteDestNew(ZkError err, FrPktRteDest *pkt);
  DLLExport int frPktAipRteDestFree(ZkError err, FrPktRteDest *pkt);
  DLLExport int frPktAipRteDestCreateInBuffer(ZkError err, FrPktRteDest pkt, void *buf, size_t bsz);
  DLLExport int frPktAipRteDestReceiveInBuffer(ZkError err, FrPktRteDest pkt, void *data, size_t dsz);
  DLLExport int frPktAipRteDestGetVersion(ZkError err, FrPktRteDest pkt, unsigned int *vers);
  DLLExport int frPktAipRteDestSetVersion(ZkError err, FrPktRteDest pkt, unsigned int vers);
  DLLExport int frPktAipRteDestSetType(ZkError err, FrPktRteDest pkt);
  DLLExport int frPktAipRteDestGetAci(ZkError err, FrPktRteDest pkt, FrAci *aci);
  DLLExport int frPktAipRteDestSetAci(ZkError err, FrPktRteDest pkt, FrAci aci);
  DLLExport int frPktAipRteDestGetErrorCode(ZkError err, FrPktRteDest pkt, uint32_t *code);
  DLLExport int frPktAipRteDestSetErrorCode(ZkError err, FrPktRteDest pkt, uint32_t code);
  DLLExport int frPktAipRteDestGetIssuer(ZkError err, FrPktRteDest pkt, FrEntIdExp *issuer);
  DLLExport int frPktAipRteDestSetIssuer(ZkError err, FrPktRteDest pkt, FrEntIdExp issuer);
  DLLExport int frPktAipRteDestDecrypt(ZkError err, FrPktRteDest pkt, FrCryptSym sym);
  DLLExport int frPktAipRteDestEncrypt(ZkError err, FrPktRteDest pkt, FrCryptSym sym);
  DLLExport int frPktAipRteDestGetCurrentSize(ZkError err, FrPktRteDest pkt, size_t *sz);
  DLLExport int frPktAipRteDestGetMaxSize(ZkError err, unsigned int vers, size_t *sz);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FR_RDPKTH_ */
