/*
 *  $Id: fr_stats.h,v 1.5 2001/04/19 20:30:02 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FR_STATS_H_
#define FR_STATS_H_


#include "frCrypt.h"
#include "zkError.h"
#include "zks.h"


#if !defined(ZK_KERNEL)

#if 0	/* NOTE: Replacing packed struct with calls to zkPackBuf */
#pragma pack(1)

struct fr_aip_stats_pk {
  char rand[FRCRYPT_RAND_SIZE];
  uint32_t pktsSent;
  uint32_t pktsRecv;
  uint32_t absTime;
  /* I wonder who got the brilliant idea of placing a non-packed struct 
  inside a packed struct ... */
  FrEntIdExp entity;
  char sig[FRCRYPT_SIG_SIZE];
};

#pragma pack()
#endif

#define FR_AIP_STATS_PK_ENTITY_SIZE	(sizeof(uint32_t) + FRENT_NAME_SIZE)

enum {
	FR_AIP_STATS_PK_RAND		= 0,
	FR_AIP_STATS_PK_PKTSSENT	= FR_AIP_STATS_PK_RAND        + FRCRYPT_RAND_SIZE,
	FR_AIP_STATS_PK_PKTSRECV	= FR_AIP_STATS_PK_PKTSSENT    + sizeof(uint32_t),
	FR_AIP_STATS_PK_ABSTIME		= FR_AIP_STATS_PK_PKTSRECV    + sizeof(uint32_t),
	FR_AIP_STATS_PK_ENTITY		= FR_AIP_STATS_PK_ABSTIME     + sizeof(uint32_t),
	/* Because FrEntIdExp isn't a packed struct, we'll have to decompose it into 
	its constituent members, according to the way it's packed by gcc on Linux. */
	FR_AIP_STATS_PK_ENTITY_TYPE	= FR_AIP_STATS_PK_ENTITY,
	FR_AIP_STATS_PK_ENTITY_NAME	= FR_AIP_STATS_PK_ENTITY_TYPE + sizeof(uint32_t),
	FR_AIP_STATS_PK_SIG			= FR_AIP_STATS_PK_ENTITY_NAME + FRENT_NAME_SIZE,
	FR_AIP_STATS_PK_SIZEOF		= FR_AIP_STATS_PK_SIG         + FRCRYPT_SIG_SIZE
};


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  DLLExport int frPktStatsDataVerify(ZkError err, void *s, FrCryptSig otherPub);
  DLLExport int frPktStatsDataSign(ZkError err, void *s, FrCryptSig myPriv);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	/* !defined(ZK_KERNEL) */

#endif /* FR_STATS_H_ */
