/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkNetinetIn.h"
#if 0
#include "frPktFmt.h"
#endif
#include "zkIntTypes.h"


#define V 0x01020304


static union bo {
  uint32_t i;
  unsigned char a[4];
} bo;


int main(void)
{
  bo.i = V;

  if (bo.a[0] == 1 &&
      bo.a[1] == 2 &&
      bo.a[2] == 3 &&
      bo.a[3] == 4) {
    zkPrintf("Current architecture is big-endian.\n");
  } else if (bo.a[3] == 1 &&
             bo.a[2] == 2 &&
             bo.a[1] == 3 &&
             bo.a[0] == 4) {
    zkPrintf("Current architecture is little-endian.\n");
  } else {
    zkPrintf("Current architecture is neither big- nor little-endian.\n");
  }

  bo.i = htonl(V);
  if (bo.a[0] == 1 &&
      bo.a[1] == 2 &&
      bo.a[2] == 3 &&
      bo.a[3] == 4) {
    zkPrintf("Network byte order is big-endian.\n");
  } else if (bo.a[3] == 1 &&
             bo.a[2] == 2 &&
             bo.a[1] == 3 &&
             bo.a[0] == 4) {
    zkPrintf("Network byte order is little-endian.\n");
  } else {
    zkPrintf("Network byte order is neither big- nor little-endian.\n");
  }
  zkPrintf("end.\n");

  return (EXIT_SUCCESS);
}
