/*
 *  $Id: fr_keystore.h,v 1.7 2001/04/19 20:30:57 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FR_KEYSTORE_H_
#define FR_KEYSTORE_H_


#include "frCrypt.h"
#include "zkError.h"


#ifdef __cplusplus
extern "C" {
#endif /*
 *  __cplusplus
 */

  extern DLLExport int frSecPubKeyNewFromFile(ZkError err, FrCryptPubKey *pk, FrCryptSym key, const char *file);
  extern DLLExport int frSecPubKeyWriteToFile(ZkError err, const char *file, FrCryptSym key, FrCryptPubKey pk);
  extern DLLExport int frSecPubKeyMostRecentInDir(ZkError err, const char *dir, FrCryptSym sym, FrCryptPubKey *pk);
  extern DLLExport int frSecPubKeyAllInDir(ZkError err, const char *dir, FrCryptSym sym, FrCryptPubKey **pk, size_t *nKeys);
  extern DLLExport int frSecCryptNewFromFile(ZkError err, const char *file, FrCryptSym key, FrCryptCrypt *crp);
  extern DLLExport int frSecCryptPrivWriteToFile(ZkError err, const char *file, FrCryptSym key, FrCryptCrypt crp);
  extern DLLExport int frSecSigNewFromFile(ZkError err, const char *file, FrCryptSym key, FrCryptSig *sig);
  extern DLLExport int frSecSigPrivWriteToFile(ZkError err, const char *file, FrCryptSym key, FrCryptSig sig);

  extern DLLExport int frSecPubKeyNewDecryptFromBuf(ZkError err, FrCryptPubKey *pk, FrCryptSym sym, void *buf, size_t bsz);
  extern DLLExport int frSecPubKeyEncryptToBuf(ZkError err, FrCryptPubKey pk, FrCryptSym sym, void **buf, size_t *bsz);

  /*
   *  The following function is _only_ for converting old file formats.
   */
  extern DLLExport int fr_SecPubKeyNewFromFile_v0(ZkError err, FrCryptPubKey *pk, FrCryptSym key, const char *file);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FR_KEYSTORE_H_ */
