/*
 *  $Id: frsec_sig.h,v 1.6 2001/04/19 20:30:57 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FRSEC_SIG_H_
#define FRSEC_SIG_H_


#include "frCrypt.h"
#include "zkError.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern DLLExport int frSecSigGetVersion(ZkError err, void *buf, size_t bsz, unsigned int *vers);
  extern DLLExport int frSecSigGetEntity(ZkError err, void *buf, size_t bsz, FrEntIdExp *ent);
  extern DLLExport int frSecSignData(ZkError err, FrCryptSig sigKey, void *src, size_t ssz, void **dst, size_t *dsz);
  extern DLLExport int frSecSigVerify(ZkError err, FrCryptSig sigKey, void *data, size_t dsz, int *valid);
  extern DLLExport int frSecSigRemove(ZkError err, void *src, size_t ssz, void **dst, size_t *dsz);
  extern DLLExport int frSecSigRemoveInSitu(ZkError err, void *data, size_t *dsz);

  /* for test purposes only, remove in >= v1.2 */

  extern DLLExport int frSecSignData_v2(ZkError err, FrCryptSig sigKey, void *src, size_t ssz, void **dst, size_t *dsz, size_t extLen);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FRSEC_SIG_H_ */
