#ifndef HDR_H_
#define HDR_H_

/*
 *  $Id: hdr.h,v 1.3 2001/04/19 20:31:00 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include "zkIntTypes.h"
#include "fr_gencrypt.h"
#include "fr_mac.h"


#define BUF_HDR_V1_SPEC_SIZE	6

#if 0	/* NOTE: Replacing packed struct with calls to zkPackBuf */
#pragma pack(1)

struct buf_hdr_v1 {
  uint8_t vers;
  uint8_t type;
  char spec[BUF_HDR_V1_SPEC_SIZE]; /* padding to make entire header size a multiple of 8 */
  char iv[FRCRYPT_IVEC_SIZE];

  /*
   *  The symmetric encryption begins with the mac field, so we ensure that
   *  the remainder of the header is a multiple of eight bytes in length.
   *  This allows us to easily decrypt just the header, if necessary.
   */
  
  char mac[FRCRYPT_MAC_SIZE];
  uint32_t dsz; /* actual length of data stored in file */
};

#pragma pack()
#endif

enum {
	BUF_HDR_V1_VERS		= 0,
	BUF_HDR_V1_TYPE		= BUF_HDR_V1_VERS + sizeof(uint8_t),
	BUF_HDR_V1_SPEC		= BUF_HDR_V1_TYPE + sizeof(uint8_t),
	BUF_HDR_V1_IV		= BUF_HDR_V1_SPEC + BUF_HDR_V1_SPEC_SIZE,
	BUF_HDR_V1_MAC		= BUF_HDR_V1_IV   + FRCRYPT_IVEC_SIZE,
	BUF_HDR_V1_DSZ		= BUF_HDR_V1_MAC  + FRCRYPT_MAC_SIZE,
	BUF_HDR_V1_SIZEOF	= BUF_HDR_V1_DSZ  + sizeof(uint32_t)
};


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* HDR_H_ */
