#ifndef HDR_H_
#define HDR_H_

/*
 *  $Id: hdr_v0.h,v 1.2 2001/04/19 20:31:00 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *  
 *  WARNING: this is the first, deprecated version of the encrypted buffer
 *  code.  It is being kept only while conversion to the new format is
 *  necessary.
 */

#include "zkIntTypes.h"
#include "fr_gencrypt.h"


#define BUF_HDR_V0_PAD_SIZE	4

#if 0	/* NOTE: Replacing packed struct with calls to zkPackBuf */
#pragma pack(1)

struct buf_hdr_v0 {
  char iv[FRCRYPT_IVEC_SIZE];
  uint32_t dsz; /* actual length of data stored in file */
  char pad[BUF_HDR_V0_PAD_SIZE];
  /* bug: store hash over data, too. */
};

#pragma pack()
#endif

enum {
	BUF_HDR_V0_IV		= 0,
	BUF_HDR_V0_DSZ		= BUF_HDR_V0_IV + FRCRYPT_IVEC_SIZE,
	BUF_HDR_V0_PAD		= BUF_HDR_V0_DSZ + sizeof(uint32_t),
	BUF_HDR_V0_SIZEOF	= BUF_HDR_V0_PAD + BUF_HDR_V0_PAD_SIZE
};


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* HDR_H_ */
