/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

/* this header file is to provide an interface between different
 * versions of pkcrypt.c only -- it should not be included elsewhere
 */

/* v1 */
DLLExport int fr_SecPubKeySetDecryptLength_v1(ZkError err, size_t newdlen, void *encr, size_t esz);
DLLExport int frSecPubKeyGetCryptKeyVersion_v1(ZkError err, void *encr, size_t esz, unsigned int *vers);
DLLExport int frSecPubKeyEncryptDataKeepSymKey_v1(ZkError err, FrCryptCrypt pubCrypt, FrCryptSymAlg symAlg, void *clear, size_t csz, void **encr, size_t *esz, FrCryptSym *sym);
DLLExport int frSecPubKeyDecryptDataKeepSymKey_v1(ZkError err, FrCryptCrypt privCrypt, void *encr, size_t esz, void **clear, size_t *csz, FrCryptSym *sym);

/* v2 */
DLLExport int fr_SecPubKeySetDecryptLength_v2(ZkError err, size_t newdlen, void *encr, size_t esz);
DLLExport int frSecPubKeyGetCryptKeyVersion_v2(ZkError err, void *encr, size_t esz, unsigned int *vers);
DLLExport int frSecPubKeyEncryptDataKeepSymKey_v2(ZkError err, FrCryptCrypt pubCrypt, FrCryptSymAlg symAlg, void *clear, size_t csz, void **encr, size_t *esz, FrCryptSym *sym);
DLLExport int frSecPubKeyDecryptDataKeepSymKey_v2(ZkError err, FrCryptCrypt privCrypt, void *encr, size_t esz, void **clear, size_t *csz, FrCryptSym *sym);
