/*
 *  $Id: tpfd.c,v 1.4 2001/04/19 20:31:03 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *  
 *  Test sending a passphrase over a file descriptor.
 */


#include <assert.h>
#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkString.h"
#include "zkUnistd.h"
#include "frCrypt.h"
#include "frSec.h"
#include "zkError.h"


int main(void)
{
#if !defined(ZK_CLIENT)

  FrCryptSym sym;
  FrCryptSymAlg alg = FRCRYPT_SYMALG_BLOWFISH;
  ZkError err;
  const char *pass = "0123456789";
  int fd[2];

  assert(zkErrorNew(&err));
  assert(frCryptInit(err, 0));
  assert(pipe(fd) != -1);
  assert(zkWrite(fd[1], pass, strlen(pass)) != -1);
  assert(zkClose(fd[1]) != -1);

  assert(frSecNewSymFromPassPhraseFd(err, &sym, alg, fd[0]));

  assert(zkClose(fd[0]) != -1);
  assert(frCryptSymFree(err, &sym));
  assert(zkErrorFree(&err));

#endif	/* !defined(ZK_CLIENT) */

  return (EXIT_SUCCESS);
}
