/*
 *  $Id: tstr_decr.c,v 1.3 2001/04/19 20:31:03 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *  
 *  For testing frSecStretchedEncryptToFile and frSecStretchedDecryptFromFile.
 *  Mostly a copy of tfile.c which tests frSecEncryptToFile and
 *  frSecDecryptFromFile.
 */  

#include <assert.h>
#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkTime.h"
#include "fr_file.h"
#include "zkShell.h"
#include "zkString.h"


static const char *prog;


static int t(ZkError err, const char *file)
{
  FrCryptSymAlg symalg = FRCRYPT_SYMALG_BLOWFISH;
  const char *pass = "thepass4you";
  char data0[10 * 1024];
  size_t dsz0, dsz1, i;
  void *data1;
  

  dsz0 = sizeof data0;  /* BUG: may neeed to find a better way for the test */


  /* create some data */
  for (i = 0; i < dsz0; i++) {
    data0[i] = 'a' + (i % 26);
  }


  /* decrypt to data1 */
  assert(frSecStretchedDecryptFromFile(err, file, pass, symalg, &data1, &dsz1));

  /* Verify that data0 and data1 have same text */
  assert(memcmp(data1, data0, dsz1) == 0);

  zkFree(data1);

  return 1;
}


static void usage(void)
{
  zkFprintf(stderr, "Usage: %s <temp-file>\n", prog);
  exit(EXIT_FAILURE);
}


int main(int ac, char **av)
{
  ZkError err;

  prog = zkShellGetProgramName(&ac, &av);

  srand(time(0));
  
  if (ac != 2) {
    usage();
  }

  assert(zkErrorNew(&err));
  assert(frCryptInit(err, 0));

  t(err, av[1]);

  assert(zkErrorFree(&err));
  
  return (EXIT_SUCCESS);
}
