/*
 * $Id: frStatBucket.h,v 1.4 2000/11/23 15:13:25 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FRSTATBUCKET_H_
#define FRSTATBUCKET_H_ 

#ifndef FRENT_H_
#include <frEnt.h>
#endif /* FRENT_H_ */

#ifndef FRCRYPT_H_ 
#include <frCrypt.h>
#endif /* FRCRYPT_H_ */

#ifndef FRSEC_H_
#include <frSec.h>
#endif /* FRSEC_H_ */

#ifndef FRKEYQRY_H_
#include <frKeyQry.h>
#endif /* FRKEYQRY_H_ */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct T_FrStatBucket * FrStatBucket;

DLLExport int frStatBucketNew (
  ZkError err ,
  FrStatBucket * sm );

DLLExport int frStatBucketSetHistory (
  ZkError err ,
  FrStatBucket b ,
  size_t h );

DLLExport int frStatBucketHistory (
  ZkError err ,
  FrStatBucket b ,
  size_t * h );

#if 0
DLLExport int frStatBucketSetKeyQueryParameters (
  ZkError err ,
  FrStatBucket b ,
  FrKeyQry kq ,
  FrKeyQryHost kh ,
  unsigned short kqtimeout ,
  int kqretries );
#endif

DLLExport int frStatBucketGetStatUpdByEntity (
  ZkError err ,
  FrStatBucket b ,
  FrEntIdExp * entity ,
  FrStatUpd * fsu ,
  uint32_t * update );

DLLExport int frStatBucketGetStatUpd (
  ZkError err ,
  FrStatBucket b ,
  FrStatUpd * fsu ,
  uint32_t * version );    /* Get the update number (optional, can be NULL) */

DLLExport int frStatBucketGetReset (
  ZkError err ,
  FrStatBucket b );

DLLExport int frStatBucketClearFlags (
  ZkError err ,
  FrStatBucket sm ,
  uint32_t flags );

DLLExport int frStatBucketCheckUpdateBufferSignature (
  ZkError err ,
  FrStatBucket b ,
  void * buf ,
  size_t bsz ,
  FrEntIdExp * entity );

DLLExport int frStatBucketAddUpdateBuffer (
  ZkError ,
  FrStatBucket ,
  void * ,
  size_t * );

DLLExport int frStatBucketAddUpdate (
  ZkError err ,
  FrStatBucket sm ,
  FrStatUpd fsu  );

DLLExport int frStatBucketDump (
  ZkError err ,
  FrStatBucket sm ,
  FILE * f ,
  uint32_t flags );


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FRSTATBUCKET_H_ */
