/*
 * $Id: frStatClient.h,v 1.7 2000/11/23 15:13:25 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FRSTATCLIENT_H_
#define FRSTATCLIENT_H_

#ifndef FRCRYPT_H_
#include <frCrypt.h>
#endif /* FRCRYPT_H_ */

#ifndef FRSTATUPD_H_
#include <frStatUpd.h>
#endif /* FRSTATUPD_H_ */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  typedef struct T_FrStatClient * FrStatClient;

  DLLExport int frStatClientNew (
                                 ZkError err ,
                                 FrStatClient * t );

  DLLExport int frStatClientFree (
                                  ZkError err ,
                                  FrStatClient * t );

  DLLExport int frStatClientSetSignatureKey (
                                             ZkError err ,
                                             FrStatClient t,
                                             FrCryptSig sig );

  DLLExport int frStatClientSetNISSCryptKey (
                                         ZkError err ,
                                         FrStatClient t,
                                         FrCryptPubKey nissPubKey );

  DLLExport int frStatClientSetHostname (
                                         ZkError err ,
                                         FrStatClient t,
                                         const char * host );

  DLLExport int frStatClientSetPort (
                                     ZkError err ,
                                     FrStatClient t,
                                     unsigned short port );

  DLLExport int frStatClientGetSocket (
                                       ZkError err,
                                       FrStatClient t,
                                       int *pSock,
                                       struct sockaddr *pSockAddr,
                                       socklen_t *pAddrSize );
  DLLExport int frStatClientIsServer (
                                      ZkError err,
                                      FrStatClient t,
                                      const char *host,
                                      unsigned short port,
                                      int *same);
  
  DLLExport int frStatClientConnect (
                                     ZkError err ,
                                     FrStatClient t );

  DLLExport int frStatClientDisconnect (
                                        ZkError err ,
                                        FrStatClient t );

  DLLExport int frStatClientSubmitUpdate (
                                          ZkError err ,
                                          FrStatClient t ,
                                          FrStatUpd fsu );


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FRSTATCLIENT_H_ */
