/*
 * $Id: frSerial.h,v 1.7 2000/11/23 15:13:28 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef FRSERIAL_H_
#define FRSERIAL_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * These defines must reflect the comment in the snid.conf.in file with
 * regards to serial number ranges.  These values are inclusive.
 */

#define SERIAL_TYPE_TRIAL_MIN          0
#define SERIAL_TYPE_TRIAL_MAX        499
#define SERIAL_TYPE_STD_MIN          500
#define SERIAL_TYPE_STD_MAX          999
#define SERIAL_TYPE_OLD_MIN         1000
#define SERIAL_TYPE_OLD_MAX         1000
#define SERIAL_TYPE_INTERNAL_MIN    1001
#define SERIAL_TYPE_INTERNAL_MAX    1499
#define SERIAL_TYPE_REPLACEMENT_MIN 1500
#define SERIAL_TYPE_REPLACEMENT_MAX 1999
#define SERIAL_TYPE_MAX             2000


typedef struct T_FrSerialNumber * FrSerialNumber;

DLLExport int frSerialNumberNew (
  ZkError ,               /* Returns the error if one occured */
  FrSerialNumber * );     /* Returns a new serial number */

DLLExport int frSerialNumberFree (
  ZkError ,               /* Returns the error if one occured */
  FrSerialNumber * );     /* Serial number to destroy */

DLLExport int frSerialNumberComputeChecksum (
  ZkError ,               /* Returns the error if one occured */
  FrSerialNumber ,        /* Serial number to compute checksum */
  unsigned short * );     /* Returns the checksum */

DLLExport int frSerialNumberSetChecksum (
  ZkError ,  
  FrSerialNumber ,
  unsigned short );

DLLExport int frSerialNumberVerifyChecksum (
  ZkError ,               /* Returns the error if one occured */
  FrSerialNumber );       /* Serial number to verify */

DLLExport int frSerialNumberGenerate (
  ZkError ,               /* Returns the error if one occured */
  FrSerialNumber );       /* Serial number structure to load up */

DLLExport int frSerialNumberNewFromRandom (
  ZkError ,
  FrSerialNumber * );

DLLExport int frSerialNumberGet (
  ZkError ,
  FrSerialNumber ,
  char * ,                /* Char string to hold the serial number */
  size_t );               /* Size of the character string */

DLLExport int frSerialNumberParse (
  ZkError ,
  FrSerialNumber ,
  char * ,
  size_t );



#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* FRSERIAL_H_ */
