/*
** ZkNetMgmt class C wrapper
**
**
*/

#ifdef __cplusplus

#include "zkNetMgmt.h"

#include "zks.h"
#include "zkserr.h"
#include "zksexception.h"


struct T_zkNetMgmtObj {
    ZkNetMgmt * ptr;
};




/*
**------------------------------------------------------------------------------
**
**------------------------------------------------------------------------------
*/
DLLExport int
zkNetMgmtNew(ZksErr err, ZkNetMgmtObj *obj) {

    DECL_FUNC("zkNetMgmtNew");
    
    try {
        try {

            (*obj) = new struct T_zkNetMgmtObj;

            (*obj)->ptr = new ZkNetMgmt;

        }
        catch( ... ) {
            CZKS::Rethrow(func, "failure");
        }
    }
    catch ( CZKS::Exception &e ) {
        zksErrCtxClone(err, e.zksErr());
        return 0;
    }
    return 1;
}


/*
**------------------------------------------------------------------------------
**
**------------------------------------------------------------------------------
*/
DLLExport int zkNetMgmtFree(ZksErr err, ZkNetMgmtObj obj) {

    DECL_FUNC("zkNetMgmtFree");
    
    try {
        try {

            delete obj->ptr;
            obj->ptr = NULL;

        }
        catch( ... ) {
            CZKS::Rethrow(func, "failure");
        }
    }
    catch ( CZKS::Exception &e ) {
        zksErrCtxClone(err,  e.zksErr());
        return 0;
    }
    return 1;

}


/*
**------------------------------------------------------------------------------
**
**------------------------------------------------------------------------------
*/
DLLExport int zkNetMgmtAddExportInfoStr(ZksErr err, ZkNetMgmtObj obj, char *keyStr, char *infoStr) {

    DECL_FUNC("zkNetMgmtAddExportInfoStr");
    
    try {
        try {

            obj->ptr->AddExportInfo(keyStr, infoStr);

        }
        catch( ... ) {
            CZKS::Rethrow(func, "failure");
        }
    }
    catch ( CZKS::Exception &e ) {
        zksErrCtxClone(err,  e.zksErr());
        return 0;
    }
    return 1;
}


/*
**------------------------------------------------------------------------------
**
**------------------------------------------------------------------------------
*/
DLLExport int zkNetMgmtAddExportInfoDouble(ZksErr err, ZkNetMgmtObj obj, char *keyStr, double infoDouble) {

    DECL_FUNC("zkNetMgmtAddExportInfoDouble");
    
    try {
        try {

            obj->ptr->AddExportInfo(keyStr, infoDouble);

        }
        catch( ... ) {
            CZKS::Rethrow(func, "failure");
        }
    }
    catch ( CZKS::Exception &e ) {
        zksErrCtxClone(err,  e.zksErr());
        return 0;
    }
    return 1;
}


/*
**------------------------------------------------------------------------------
**
**------------------------------------------------------------------------------
*/
DLLExport int zkNetMgmtAddExportInfoInt(ZksErr err, ZkNetMgmtObj obj, char *keyStr, int infoInt) {

    DECL_FUNC("zkNetMgmtAddExportInfoInt");
    
    try {
        try {

            obj->ptr->AddExportInfo(keyStr, infoInt);

        }
        catch( ... ) {
            CZKS::Rethrow(func, "failure");
        }
    }
    catch ( CZKS::Exception &e ) {
        zksErrCtxClone(err,  e.zksErr());
        return 0;
    }
    return 1;
}


/*
**------------------------------------------------------------------------------
**
**------------------------------------------------------------------------------
*/
DLLExport int zkNetMgmtExport(ZksErr err, ZkNetMgmtObj obj) {

    DECL_FUNC("zkNetMgmtExport");
    
    try {
        try {

            obj->ptr->Export();

        }
        catch( ... ) {
            CZKS::Rethrow(func, "failure");
        }
    }
    catch ( CZKS::Exception &e ) {
        zksErrCtxClone(err,  e.zksErr());
        return 0;
    }
    return 1;
}


/*
**------------------------------------------------------------------------------
**
**------------------------------------------------------------------------------
*/
DLLExport int zkNetMgmtNotify(ZksErr err, ZkNetMgmtObj obj,  char *notifyStr) {

    DECL_FUNC("zkNetMgmtNotify");
    
    try {
        try {

            obj->ptr->Notify(notifyStr);

        }
        catch( ... ) {
            CZKS::Rethrow(func, "failure");
        }
    }
    catch ( CZKS::Exception &e ) {
        zksErrCtxClone(err,  e.zksErr());
        return 0;
    }
    return 1;
}


#endif //__cplusplus
