/*
 * $Id: zkNiqsToken.c,v 1.2 2001/04/19 20:32:46 alainc Exp $
 */

static const char * module_id_ = "$Id: zkNiqsToken.c,v 1.2 2001/04/19 20:32:46 alainc Exp $";

#include "zks.h"

#include <zkIntTypes.h>
#include <stdio.h>
#include <stdlib.h>
#ifndef WIN32
#include <unistd.h>
#endif /* WIN32 */
#include <string.h>
#include <zkError.h>
#include <zkNiqs.h>

static const struct T_ZkNiqToken {
  ZkNiqAttr attr; 
  const char * token;
} zkNiqToken[] = {
  { ZKNIQ_ATTR_TOPOLOGY ,    "topology"    },
  { ZKNIQ_ATTR_DESCRIPTION , "description" },
  { ZKNIQ_ATTR_STATUS ,      "status" }
};

#define ZKNIQ_TOKENS (sizeof(zkNiqToken)/sizeof(struct T_ZkNiqToken))

DLLExport int
zkNiqsAttributeToToken (
  ZkError err , 
  ZkNiqAttr attr ,
  const char ** token )
{
  static const char * func = "zkNiqAttributeToToken";
  int return_code = 0;
  uint16_t n = 0;  /* Loop index */

  (void) module_id_;
  zkErrorClear(err);
  if (token && attr) {
    for (n = 0; n < ZKNIQ_TOKENS; n++) {
      if (attr == zkNiqToken[n].attr) {
        return_code = 1;
        *token = zkNiqToken[n].token;
        break;
      }
    }
    if (return_code != 1) {
      zkErrorSet(err,func,ZKERR,ZKMNIQS,ZKENOTFOUND,
                 "Requested attribute does not have a token");
    }
  } else {
    zkErrorSet(err,func,ZKERR,ZKMNIQS,ZKENULLPTR,NULL);
  }
  return return_code;
}

