/*
 * Zkshimlib header
 * $Id: zkshimlib.h,v 1.9 2001/04/19 20:33:17 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 *
 */

#ifndef ZKSHIMLIB_H_
#define ZKSHIMLIB_H_
#include <sys/types.h>
#include <zks.h>
#include <zkIntTypes.h>
#include <zkError.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  
  typedef struct T_ZkShim *ZkShim;


  extern int zkShimNew (ZkError,  ZkShim *);
  extern int zkShimFree (ZkError,  ZkShim *);
  extern int zkShimOpen (ZkError, ZkShim, const char *);
  extern int zkShimClose (ZkError, ZkShim);

  extern int zkShimSetFD (ZkError , ZkShim, int fd);
  extern int zkShimGetFD (ZkError, ZkShim, int *fd);
  // all IP addresses, masks, and ports must be passed in network byte-order
  extern int zkShimRuleSetSrcIP(ZkError, ZkShim, uint32_t ip, uint32_t mask);
  extern int zkShimRuleSetDestIP(ZkError, ZkShim, uint32_t ip, uint32_t mask);
  extern int zkShimRuleSetSrcPort(ZkError, ZkShim, uint16_t port);
  extern int zkShimRuleSetDestPort(ZkError, ZkShim, uint16_t port);
  extern int zkShimRuleSetProto(ZkError, ZkShim, uint8_t proto);
  extern int zkShimRuleApply(ZkError, ZkShim);
  extern int zkShimRuleRemove(ZkError, ZkShim);
  extern int zkShimRuleClear(ZkError, ZkShim);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ZKSHIMLIB_H_ */
