#ifndef MAIPSTAT_H_
#define MAIPSTAT_H_

#ifdef __cplusplus 
extern "C" {
#endif /* __cplusplus */
  
  typedef struct T_FrMaipStatus *FrMaipStatus;

  extern int frMaipStatusFree(ZkError err, 
                              FrMaipStatus *s);

  extern int frMaipStatusNew(ZkError err, 
                             FrMaipStatus *s);

  extern int frMaipStatusInit(ZkError err,
                              FrMaipStatus s,
                              const char *shmFile,
                              const char *mutexFile);

  extern int frMaipStatusSetStatParms(ZkError err, 
                                      FrMaipStatus s,
                                      const char *statServer,
                                      unsigned short statPort, 
                                      size_t history);

  extern int frMaipStatusSetCurrentSigKey(ZkError err, 
                                          FrMaipStatus s, 
                                          FrCryptPubKey sigKey,
                                          const char *version);

  /* Data functions */
  extern int frMaipStatusIncrementConnections(ZkError err, 
                                              FrMaipStatus s);

  extern int frMaipStatusDecrementConnections(ZkError err, 
                                              FrMaipStatus s);

  extern int frMaipStatusGetActive(ZkError err,
                                   FrMaipStatus s, 
                                   uint32_t *active);

  extern int frMaipStatusIncrementActive(ZkError err, 
                                         FrMaipStatus s);

  extern int frMaipStatusDecrementActive(ZkError err, 
                                         FrMaipStatus s);

  /* Collate and send */
  extern int frMaipStatusSendUpdate(ZkError err, 
                                    FrMaipStatus s,
                                    FrCryptPubKey nissKey,
                                    ZkLog log);


  /* Bytes receieved and transmitted */
  extern int frMaipStatusIncrementHeaderRx(ZkError err,
                                           FrMaipStatus s, 
                                           uint32_t sz);

  extern int frMaipStatusIncrementHeaderTx(ZkError err, 
                                           FrMaipStatus s,
                                           uint32_t sz);

  extern int frMaipStatusIncrementMessageRx(ZkError err,
                                            FrMaipStatus s, 
                                            uint32_t sz);

  extern int frMaipStatusIncrementMessageTx(ZkError err,
                                            FrMaipStatus s, 
                                            uint32_t sz);

  extern int frMaipStatusIncrementAlttextRx(ZkError err, 
                                            FrMaipStatus s, 
                                            uint32_t sz);

  extern int frMaipStatusIncrementAlttextTx(ZkError err, 
                                            FrMaipStatus s, 
                                            uint32_t sz);

  extern int frMaipStatusIncrementReplyblockRx(ZkError err,
                                               FrMaipStatus s, 
                                               uint32_t sz);

  extern int frMaipStatusIncrementReplyblockTx(ZkError err, 
                                               FrMaipStatus s, 
                                               uint32_t sz);

  extern int frMaipStatusIncrementRcvd(ZkError err, 
                                       FrMaipStatus s);

  extern int frMaipStatusIncrementSent(ZkError err, 
                                       FrMaipStatus s);

  extern int frMaipStatusIncrementDropped(ZkError err, 
                                          FrMaipStatus s);

  extern int frMaipStatusIncrementQueued(ZkError err, 
                                         FrMaipStatus s);
  extern int frMaipStatusDecrementQueued(ZkError err, 
                                         FrMaipStatus s);

  extern int frMaipStatusSetQueued(ZkError err,
                                   FrMaipStatus s, 
                                   uint32_t n);
#ifdef __cplusplus 
}
#endif /* __cplusplus */
 
#endif /* MAIPSTAT_H_ */

