#ifndef MAIP_STATDB_H_
#define MAIP_STATDB_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

struct T_MAIPStatRec {
  uint16_t limit;
  uint16_t sent;
  time_t   expire;
};

typedef struct T_MAIPStatRec MAIPStatRec;

#define MAIPSTATREC_SZ 8

int MAIPStatRecStore (
  ZkError ,             /* Return the error if any occured */
  FrMaipContext * ,     /* The MAIP context */
  char * ,              /* Name of the nym for which you want mail stats */
  MAIPStatRec * ,       /* The MAIPStatRec record to store in the database */
  int * );              /* Returns 1 if successfully stored */

int MAIPStatRecFetch (
  ZkError ,             /* Return the error if any occured */
  FrMaipContext * ,     /* The MAIP context */
  char * ,              /* Name of the nym for which you want mail stats */
  MAIPStatRec * ,       /* The MAIPStatRec record which will hold result */
  int * );              /* Returns 1 if successfully found */

int MAIPStatRecToBinary (
  ZkError ,            /* Return the error if any occured */
  MAIPStatRec * ,      /* Original structure to convert to a buffer */
  void * ,             /* A pre allocated buffer pointer */
  size_t * );          /* Specifies the size of the buffer, returns used */

int MAIPStatRecFromBinary (
  ZkError ,            /* Return the error if any occured */
  MAIPStatRec *,       /* Pointer to a MAIPStatRec structure to fill */
  const void * ,       /* Raw source data buffer */
  size_t );            /* Number of significant bytes in the buffer */


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* MAIP_STATDB_H_ */
