/*
 * $Id: niqs_qc.h,v 1.5 2000/11/24 15:04:09 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef NIQS_QC_H_
#define NIQS_QC_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct T_FrNiqsQC * FrNiqsQC;

/*
 *
 */

DLLExport int frNiqsQCNew (
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC * qc );

DLLExport int frNiqsQCFree (
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC * qc );
   
DLLExport int frNiqsQCSetName (
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC qc ,
  ZK_IN    const char * name );

DLLExport int frNiqsQCInit (
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC qc );

DLLExport int frNiqsQCTerminate (
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC qc );

DLLExport int frNiqsQCLookup (
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC qc ,
  ZK_IN    const void * qry ,   /* Query buffer */
  ZK_IN    size_t qry_sz ,      /* Query buffer size */
  ZK_OUT   void ** rsp ,        /* Response buffer (NULL if norhing found) */
  ZK_OUT   size_t * rsp_sz ,    /* Size of response buffer (0 is rsp == NULL) */
  ZK_OUT   int * in_cache );    /* Set to non-zero if in cache */

DLLExport int frNiqsQCStore (  
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC qc ,
  ZK_IN    const void * qry ,   /* Query buffer */
  ZK_IN    size_t qry_sz ,      /* Query buffer size */
  ZK_OUT   void * rsp ,         /* Response buffer */
  ZK_OUT   size_t rsp_sz ,      /* Size of response buffer */
  ZK_IN    uint16_t ttl );      /* Record Time To Live */

DLLExport int frNiqsQCCleanup (
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC qc );

DLLExport int frNiqsQCRemove (
  ZK_INOUT ZkError err ,
  ZK_INOUT FrNiqsQC qc ,
  ZK_INOUT const void * qry ,
  ZK_IN    size_t qry_sz ,      /* Query buffer size */
  ZK_OUT   int * found );



#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ! NIQS_QC_H_ */
