/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include <stdio.h>
#include <assert.h>
#include <zkError.h>
#include <zkLog.h>
#include <zkAA.h> 

/* Thomas 2000/03/20 : Program changed but not tested yet due to priority changes...Use with caution */

int main(int argc, char **argv)
{

  ZkError err;
  ZkLog log;
  ZkAA aa;
  char *data;
  int key = 7;
  size_t ds;
  char *p;
  (void) argc; (void) argv;
  
  if (!(   zkErrorNew(&err)
	&& zkErrorLog (err, &log)
	&& zkLogSetStream (log, stdout)
        && zkLogEnable (log))){
    goto abort;
  }

  if (!zkAANew (err, "ndb-test3", &aa)) goto abort;
  if (!zkAAGet (err, aa, &key, 4, (void **) &data, &ds)) goto abort;

  if (data == NULL) {
    fprintf (stderr, "DB is empty\n");
  } else {
    fprintf (stderr, "[%s]\n", data);
  }
  p = strdup ("au");

  if (!zkAAPut (err, aa, &key, 4, (void *) p, 2)) goto abort;

  free (p);

  if (!zkAAGet (err, aa, &key, 4, (void **) &data, &ds)) goto abort;

  if (data == NULL) {
    fprintf (stderr, "DB is empty\n");
  } else {
    fprintf (stderr, "[%s]\n", data);
  }

  key=10;
  p = strdup ("au3");

  if (!zkAAPut (err, aa, &key, 4, (void *) p, 3)) goto abort;
  free(p);

  if (!zkAAGet (err, aa, &key, 4, (void **) &data, &ds)) goto abort;

  if (data == NULL) {
    fprintf (stderr, "DB is empty\n");
  } else {
    fprintf (stderr, "[%s]\n", data);
  }
  key=20;
  p = strdup ("au2");

  if (!zkAAPut (err, aa, &key, 4, (void *) p, 3)) goto abort;
  free(p);

  if (!zkAAGet (err, aa, &key, 4, (void **) &data, &ds)) goto abort;
  if (data == NULL) {
    fprintf (stderr, "DB is empty\n");
  } else {
    fprintf (stderr, "[%s]\n", data);
  }
  /* Usefull stuff ends here */
  key=10;
  if (!zkAADelete (err, aa, &key, 4)) goto abort;
  if (!zkAAGet (err, aa, &key, 4, (void **) &data, &ds)) goto abort;

  if (data == NULL) {
    fprintf (stderr, "DB is empty\n");
  } else {
    fprintf (stderr, "[%s]\n", data);
  }
  
  /* Cleanup upon abort or success */
  goto cleanup;
 abort:
  fprintf (stderr, "Error : Application is terminating unsuccessfully.\n");
 cleanup:
  if (aa && !zkAAFree (err, &aa)){
    fprintf (stderr, "Error : Can not free the persistent associative array.\n");
  }
  
  if (err && !zkErrorFree (&err)){
    fprintf (stderr, "Error : Can not free the Error context.\n");
  }
  return (0);
}

  
