/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include <stdio.h>
#include <assert.h>
#include <zkError.h>
#include <zkLog.h>
#include <zkAA.h> 


int main(int argc, char **argv)
{

  ZkError err;
  ZkLog log;
  ZkAA aa;
  int retcod, found;
  char *data;
  char *key;
  size_t ds, ks;
  (void) argc; (void) argv;

  assert(zkErrorNew(&err));
  assert(zkErrorLog (err, &log));
  assert(zkLogSetStream (log, stdout));
  assert(zkLogEnable (log));

  assert (zkAANew (err, "ndb-test3", &aa));

  /* Useful stuff starts here */

  assert (zkAA_CursorOpen(err, aa));

  while ((retcod = zkAA_CursorGetNext(err, aa, (void **) &key, &ks, (void **) &data,
			       &ds, &found)) && found) {
    printf("%.*s : %.*s\n",
	   (int) ks, key, (int) ds, data);
  }
  if (!retcod) {
    zkAA_CursorAbort(err,aa);
    return 0;
  }

  if (!zkAA_CursorClose(err,aa))
    return 0;
  
  /* Useful stuff ends here */
  assert (zkAAFree (err, &aa));
  assert(zkErrorFree(&err));
  return (1);
}

  
