/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include <stdio.h>
#include <assert.h>
#if 0
/* can't find this file anywhere in the tree */
#include <zk_string.h>
#endif
#include <zkError.h>
#include <zkLog.h>
#include <zkDB.h>
#include <zkDebug.h>


int main(int argc, char **argv)
{

  ZkDB  db = NULL;
  ZkDBT key,data;
  ZkError err;
  ZkLog log;
  char word[256];
  FILE *fp;
  int retcode;
  int cnt = 0;

  (void)argc;

  assert(zkErrorNew(&err));
  assert(zkErrorLog (err, &log));
  assert(zkLogSetStream (log, stdout));
  assert(zkLogEnable (log));
  
  assert(zkDBTNew (err, &key));
  assert(zkDBTNew (err, &data));

  assert(zkDB_Open(err, &db, "ndb-test3"));

  
  zkDebug_va("Load database");
  assert (fp = fopen ("/usr/dict/words", "r"));
  
  while (fscanf (fp, "%s", word) != EOF) {
    if (!(cnt++ % 1000))
      zkDebug_va("%d words loaded", cnt);
    key->data = word;
    key->size = strlen(word)+1;
    if (!zkDBStore (err, db, key, key, &retcode)) {
      if (retcode) {
	fprintf(stderr, "STORE: Key already exists\n");
      } else {
	fprintf(stderr, "ERROR in STORE: not sure what happened\n");
      }
    }
  }
  
  /* Usefull stuff ends here */

  assert(zkDBTFree (err, &key));
  assert(zkDBTFree (err, &data));
  assert(zkDBClose(err, &db));
  assert(zkErrorFree(&err));
  return (0);
}

  
