/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <zkError.h>
#include <zkLog.h>
#include <zkDefs.h>
#include <zkDump.h>
#include <zkDebug.h>
#include <zkDBO.h>
#include <zkDBOTypes.h>

/*
 * Luc Boulianne
 * luc@zks.net
 */

#ifdef ZKMOD
#undef ZKMOD
#endif
#define ZKMOD ZKMDB

int main(int argc, char **argv)
{
  ZkError err;
  ZkLog log;

  char buf1[]="01234567";
  char buf2[]="abcdefghijklmnop";
  char buf3[]="AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPp";

  (void) argc; (void) argv;
  
  assert(zkErrorNew(&err));
  assert(zkErrorLog (err, &log));
  assert(zkLogSetStream (log, stdout));
  assert(zkLogEnable (log));

  zkDebugOn();

  /* Testing underlying conversion routines */
  assert (zkDBOTestBuf(err, buf1, 8));
  assert (zkDBOTestBuf(err, buf2, 16));
  assert (zkDBOTestBuf(err, buf3, 32));

  /* Start fresh */
  /*  
  assert (zkDBODriverFree (err, &dbd));
  assert (zkDBODescFree(err, &dbod1));
  */
  return 1;
}


		     
  
