#! /bin/bash

STATUS_PASS=0
STATUS_FAIL=1
STATUS_UNINITIATED=6

USAGE="zkdb-cleanup.sh <dbname> <access>"

DBNAME=${1:?${USAGE}}
ACCESS=${2:?${USAGE}}

if [ ${ACCESS} != "local" ] ; then
    if [ ${ACCESS} != "remote" ] ; then
        exit $STATUS_UNINITIATED
    fi
fi

echo "1..1"

rm -rf ${DBNAME}*
if [ $? -ne 0 ] ; then
    echo "not ok Cleanup ${ACCESS} zkDB environment ${DBNAME}"
    exit $STATUS_FAIL
fi

if [ ${ACCESS} = "remote" ] ; then
    rm -rf access.conf
    if [ $? -ne 0 ] ; then
        echo "not ok Cleanup ${ACCESS} zkDB environment ${DBNAME}"
        exit $STATUS_FAIL
    fi
fi

rm -rf zkdbsrv-*.log

echo "ok Cleanup ${ACCESS} zkDB environment ${DBNAME}"
exit $STATUS_PASS
