#!/usr/bin/perl -w

use zkdbSystem;

my($db,$basename,$numproc,$numrec,$recsize,$verbosity) = @ARGV;


PROCGEN:
for ($procno = 1; $procno <= $numproc; $procno++) {
  $srcfile = "$basename"."."."$procno";
  $pid = fork();
  if ($pid < 0) {
    die "Not able to load records from $srcfile!\n";
  } elsif ($pid == 0) {
    # Child process
    print STDOUT "Process $$: Loading records from $srcfile\n";
    $startkey = (($procno-1)*$numrec) + 1;
    zkdbSystem::zkdbRegression_dbpopulate($db,$srcfile,$numrec,
                                      $recsize,64,$startkey,$verbosity);
    last PROCGEN;
  } else {
    # Parent process, keep looping
    next PROCGEN;
  }
}

# Wait for child processes if this is the parent process
if ($pid) {
  while (($pid = wait()) != -1) {
    print STDOUT "Process $pid exited: $?\n";
  }
  print STDOUT "Parent exiting\n";
}
