#! /bin/bash

#
# Exit statuses based on IEEE standards

STATUS_PASS=0
STATUS_FAIL=1
STATUS_UNINITIATED=6

OK="ok"
NOK="not ok"

FUNCTION="Kill zkdbsrv"

#
# Error messages

MSG_NOFILE="File does not exist"
USAGE="USAGE: zkdbsrv-kill.sh <pidfile>"

#
# Retrieve parameters

PIDFILE=${1:?${USAGE}}

#
# Check parameters

if [ ! -f ${PIDFILE} ] ; then
    echo "PIDFILE: ${PIDFILE} : ${MSG_NOFILE}"
fi

echo "1..1"
kill -TERM -`cat ${PIDFILE}`
if [ $? -eq 0 ] ; then
    echo "${OK} ${FUNCTION} : ${PIDFILE}"
else
    echo "${NOK} ${FUNCTION} : ${PIDFILE}"
fi

