#! /bin/bash

#
# Exit statuses based on IEEE standards

STATUS_PASS=0
STATUS_FAIL=1
STATUS_UNINITIATED=6

OK="ok"
NOK="not ok"

FUNCTION="Start zkdbsrv"

#
# Error messages

MSG_NOFILE="File does not exist"
USAGE="USAGE: zkdbsrv-start.sh <dbconfig>"

#
# Retrieve parameters

DBCONF=${1:?${USAGE}}

#
# Check parameters

if [ ! -f ${DBCONF} ] ; then
    echo "DBCONF: ${DBCONF} : ${MSG_NOFILE}"
fi

echo "1..1"
${ZK_EXE_DIR}/zkdbsrv --config ${DBCONF}
if [ $? -eq 0 ] ; then
    echo "${OK} ${FUNCTION} : ${DBCONF}"
else
    echo "${NOK} ${FUNCTION} : ${DBCONF}"
fi
