#ifndef NDBUTIL_H_
#define  NDBUTIL_H_ 


#include <zkDB.h>
#include "zks.h"
#include <string.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>

#include "zkAlloc.h"
#include "zkDNS.h"
#include "zkFile.h"
#include "zkLib.h"
#include "zkSignal.h"
#include "zkParms.h"
#include "zkDebug.h"
#include "zkLock.h"

#include "zkCStr.h"


#include <sys/types.h>
#include <stdio.h>
#include <zkConfig.h>
#include <zkIntTypes.h>
#include <zkParms.h>


#include <frFilenames.h>
#include <zkError.h>
#include <zkLog.h>
#include <zkDB.h>
#include <zkDB_priv.h> 

#define ZKDBHOME FREEDOM_DBDIR
#define ZKDBLOCK FREEDOM_LOCKDIR
#define ZKDBLOG  FREEDOM_LOGDIR
 
#define RECOVER_OP 1
#define VERIFY_DIRS  2 
#define REPLICATE_OP 4
#define DEADLOCK_CHECK_OP 8
#define CHECKPOINT_OP 16

#define P_CHECKPOINT "checkpoint"
#define P_REPLICATE  "replicate"
#define P_VERIFY_DIRS  "verifydirs"
#define P_PROMPT       "prompt"

#define P_PARTITIONS "partitions"
struct T_ZkDatabaseCtx {
  char * name;
  char * dbHomeDir;
  char * dbLogDir;
  u_int32_t    min_checkpointtime;
  u_int32_t    min_checkpointsize;
  int    fatalrecovery;
  struct T_ZkDatabaseCtx  * nextDB;
  DB_ENV *dbenv;
  ZkLock  dbFileLock;  
 } ;   

 typedef struct  T_ZkDatabaseCtx   * ZkDatabaseCtx;

  
 struct T_DBUtilCtx {     
   int  prompt;               /*  prompt user for the directory creation*/ 
   ZkConfig config;            /* Configuration object */
   ZkLog log;                  /* Log object */
   char * logfile;
   const char *progname;       /* Program name */
   const char *configfile;     /* Configuration file */
   int debug;                  /* debug or not */
   char * dblist;
   int fork;                   /* fork or not */
   const char *pidfile;        /* PID file */
   ZkDatabaseCtx  dbs;         /* list of the databases wich are have to be proceed */
   ZkDatabaseCtx  curdb;       /* internal list iterator; */
   int operation;              /* recover , checkpoint  or deadlock, verify dir structure */
   
   FILE *fptr;                /* internal file handler */
  };

typedef struct T_DBUtilCtx * ZkDBUtilCtx;


#define NDBUTIL_SESSION  "main"



#endif  /*  NDBUTIL_H_  */


