#ifndef NDBUTIL_H_
#define  NDBUTIL_H_ 


#include <zkDB.h>
#include "zks.h"
#include <string.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>

#include "zkAlloc.h"
#include "zkDNS.h"
#include "zkFile.h"
#include "zkLib.h"
#include "zkSignal.h"
#include "zkParms.h"
#include "zkDebug.h"


#include "zkCStr.h"

#include <sys/types.h>
#include <stdio.h>
#include <zkConfig.h>
#include <zkIntTypes.h>
#include <zkParms.h>

#include <frFilenames.h>

#include <zkError.h>
#include <zkLog.h>
#include <zkDB.h>
#include <zkConfig.h>


#define P_CHECKSONLY "ChecksOnly"

struct T_DBVerifyCtx {
  
  ZkDB  db;
  ZkConfig config;            /* Configuration object */
  ZkLog log;                  /* Log object */
  char * logfile;
  const char *progname;       /* Program name */
  const char *configfile;     /* Configuration file */
  int debug;                  /* debug or not */
  char * dbname;
  int checksonly;             /* do only checking of the data not actial move */
  int helponly;                /* do output of the help information only  */
};

typedef struct T_DBVerifyCtx   * ZkDBVerify;

#define NDBVERIFY_SESSION  "main" /* use main session options */ 



#endif  /*  NDBUTIL_H_  */


