/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

/**************************************************************************

   File:                frNidbRepCollect.h

   Author(s):           Thierry Baron
                        Louis Beaumier

   Created:              1 Oct 1999

   Last Revision:       $Date: 2000/11/24 15:03:08 $

   Description: 

   $Revision: 1.3 $
	
   Copyright (c) 1999 by Zero-Knowledge Systems, Inc
   Please see the copyright notice included in this distribution 
   for full details.

 **************************************************************************/

#ifndef FRNIDBREPCOLLECT_H
#  define FRNIDBREPCOLLECT_H

#include "zks.h"

#include "fr_nidbctx.h"

#include "frNidbReport.h"

/*
** collecting functions
*/
DLLExport int
frNidbRepEntityInfoCollect(
    ZkError           err,
    NidbContext       context,
    const char *      entityType,
    const char *      entityName,
    FrRepEntityInfo * entityInfo
);
DLLExport int
frNidbRepEntityStatCollect(
    ZkError           err,
    NidbContext       context,
    const char *      entityType,
    const char *      entityName,
    FrRepEntityStat * entityStat
);
DLLExport int
frNidbRepFreedomInfoCollect(
    ZkError            err,
    NidbContext        context,
    const char *       entityType,
    const char *       entityName,
    FrRepFreedomInfo * freedomInfo
);
DLLExport int
frNidbRepMaipInfoCollect(
    ZkError         err,
    NidbContext     context,
    const char *    entityType,
    const char *    entityName,
    FrRepMaipInfo * maipInfo
);
DLLExport int
frNidbRepAipInfoCollect(
    ZkError         err,
    NidbContext     context,
    const char *    entityType,
    const char *    entityName,
    FrRepAipInfo *  aipInfo
);
DLLExport int
frNidbRepServopInfoCollect(
    ZkError           err,
    NidbContext       context,
    const char *      entityType,
    const char *      entityName,
    FrRepServopInfo * servopInfo
);
DLLExport int
frNidbRepNetworkInfoCollect(
    ZkError            err,
    NidbContext        context,
    const char *       entityType,
    const char *       entityName,
    FrRepNetworkInfo * networkInfo
);


#endif  /* FRNIDBREPCOLLECT_H */

/***************************************************************************************

   $Log: frNidbRepCollect.h,v $
   Revision 1.3  2000/11/24 15:03:08  marcp
   Merge from scarecrow_dev

   Revision 1.2.32.1  2000/10/11 13:19:50  phil

   License header additions in preparation for the source release.

   Revision 1.2  1999/10/14 20:55:43  louis
   addition of an error tag filed for unsuccessful request
   modification to the function/structure naming

   Revision 1.1  1999/10/08 20:34:44  louis
   addition of the files/functions that were under frreport (which is no longer
   needed)


*/
