#!/bin/sh -f
#
# Script to run from crontab to poll all MAIPs and update the NIQS with the
# results
#
#
# $Id: fr_pollmaips.sh,v 1.2 2000/11/24 15:03:09 marcp Exp $
# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is Freedom code.
# 
# The Initial Developer of the Original Code is Zero-Knowledge Systems,
# Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
# Zero-Knowledge Systems, Inc.  All Rights Reserved.
# 
# Contributor(s):
# Luc Boulianne <luc@zeroknowledge.com>

#
NIDBTOOL=/freedom/bin/nidbtool
#POKEPROG=/freedom/sbin/fr_pokesrv
POKEPROG=/home/philippe/wrk/freedom/libs/frnetinfo/arch/linux-2.2-ix86/fr_pokesrv
TMP=/tmp/pollmaips.$$
TMP2=/tmp/pollmaips-2.$$
RM=/bin/rm
AWK=/bin/awk
debug=0;

trap 'cleanup; exit 2' 1 2 3 13 15
cleanup () {
    $RM -f $TMP $TMP2
}

usage () {
    echo "$0 [--debug]" 1>&2
}


case "$#" in
    "1") 
        if [ $1 = "--debug" ] ; then
           debug=1;
	else 
	    usage;
            exit 2;
	fi
	;;
     "0")
         :
	 ;;
     *)
         usage ;
	 exit 10;
esac

$POKEPROG  --niqs.hostname carrot | perl -e '
print "echo [ Pollmaip.sh ]\n";
while (<>) {
    chomp();
    @line=split(/[ \t]+/, $_);
    if (($line[6] eq "UP")  && ($line[2] eq "maip")){
	printf "entity set maip %s available\n", $line[3] ;
    } elsif ($line[2] eq "maip") {
	printf "entity set maip %s unavailable\n", $line[3] ;
    }
}' > $TMP

if [ $debug = 1 ] ; then 
    cat $TMP 1>&2
    echo "$NIDBTOOL < $TMP"
else 
    $NIDBTOOL < $TMP > $TMP2 2>&1
    cat $TMP2
    echo
fi

cleanup



