#! /bin/sh
#
# Script to run from crontab to poll all MAIPs and update the NIQS with the
# results
#
#
# $Id: fr_pollsrvs.sh,v 1.3 2000/11/24 15:03:09 marcp Exp $
# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is Freedom code.
# 
# The Initial Developer of the Original Code is Zero-Knowledge Systems,
# Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
# Zero-Knowledge Systems, Inc.  All Rights Reserved.
# 
# Contributor(s):
# Luc Boulianne <luc@zeroknowledge.com>

#

FR_NIDBTOOL=${FR_NIDBTOOL:-/freedom/bin/nidbtool}
FR_POLL_LOG=${FR_POLL_LOG:-/freedom/var/log/fr_pollsrv}
FR_POKEPROG=${FR_POKEPROG:-/freedom/sbin/fr_pokesrv}
FR_NIQS=${FR_NIQS:-niqs.freedom.net}

TMP=/tmp/pollsrv.$$
TMP2=/tmp/pollsrv-2.$$
RM=/bin/rm


debug=0;
noaction=0;
export SRV=maip;

trap 'cleanup; exit 2' 1 2 3 13 15
cleanup () {
    $RM -f $TMP $TMP2
}

usage () {
    echo "$0 [--debug] [--service (aip|maip)]" 1>&2
}

while [ $# -ne 0 ] ; do
  case "$1" in
    -d|-debug|--debug) 
        debug=1;
	;;
#    -n|-noaction|--noaction) 
#        noaction=1;
#	;;
    -s|-service|--service) 
	shift;
	if [ $# -lt 1 ] ; then
	    usage;
	fi
	if [ $1 = "aip" ] ; then
	    SRV="aip";
	elif [ $1 = "maip" ] ; then
	    SRV="maip";
	else
	    usage;
	fi
	;;
    *)
	usage ;
	;;
  esac
  shift;
done

export ARCHIVE=/tmp/pollsrv-$SRV.archive

do="";

$FR_POKEPROG  --niqs.hostname $FR_NIQS --type $SRV > $TMP2 ;

perl -e '

my($srv) = $ENV{"SRV"};
my($ARCHIVE) = $ENV{"ARCHIVE"};
my(@line);
my($date) = `date +%Y%m%d-%H%M`;
my($a_flag) = 0;
chomp($date);

print "echo [ PollServer: $srv ]\n";
print "echo [ Date: $date ]\n";

if (open ARCHIVE, $ARCHIVE) {
    $a_flag = 1;
    print "echo [ Archive: yes ]\n";
    while (<ARCHIVE>) {
	chomp();
	if (/^entity/) {
	    @line=split(/ +/, $_);
	    if ($line[4] eq "unavailable") {
		$mark{$line[3]} = 1;
	    }
	}
	if (/^echo entity/) {
	    @line=split(/ +/, $_);
	    if ($line[5] eq "unavailable") {
		$mark{$line[4]} = 1;
	    }
	}
    }
    close ARCHIVE;
} else {
    print "echo [ Archive: $ARCHIVE: $! ]\n";
}

while (<>) {
    chomp();
    @line=split(/[ \t]+/, $_);
    if (($line[6] eq "UP")  && ($line[2] eq "$srv")) {
	if ($mark{$line[3]}) {
	    printf "entity set $srv %s available\n", $line[3] ;
        }
    } elsif ($line[2] eq "$srv") {
	if (! $mark{$line[3]}) {
	    printf "entity set $srv %s unavailable\n", $line[3] ;
	} else { 
	    printf "echo entity set $srv %s unavailable\n", $line[3] ;
        }
    }
}' $TMP2 > $TMP

if [ $debug = 1 ] ; then 
    cat $TMP 1>&2
    echo "$FR_NIDBTOOL < $TMP"
    echo "cat $TMP >> $FR_POLL_LOG"
    cat $TMP > $ARCHIVE
    cat $ARCHIVE
    cat $TMP2
else 
    $do $FR_NIDBTOOL < $TMP > $TMP2 2>&1
    cat $TMP > $ARCHIVE
    $do cat $TMP2 >> $FR_POLL_LOG
fi

cleanup
