#if 0
/*
 *  $Id: nidb_sql_process.c,v 1.5 2000/11/24 15:03:09 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 *  Luc Boulianne <luc@zks.net>

 *  
 *  The Network Information Database Server
 */

#include "zks.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <getopt.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include <zkError.h>
#include <zkLog.h>
#include <zkDB.h> 
#include <zkDebug.h>
#include <zkBase64.h>
#include <zkFile.h>
#include <frSec.h>
#include <frNIDB.h>

#ifdef ZKMOD
# undef ZKMOD
#endif
#define ZKMOD ZKMNIDB
#if 0
int frNIDBAipDataPktStore (FrNIDBContext nidb, FrNIDBAipDataPkt adp)
{

  /*
   * Store the AIP in the aip update database
   * and then the LINK in the link update database
   */
  
  
  if (!nidbPutAipUpdateInDB(nidb, adp->aipinfo)) 
    return 0;
  if (!nidbPutLinkUpdateInDB(nidb, adp->linkinfo)) 
    return 0;

  return 1;
}

int frNIDBAipDataPktLog  (FrNIDBContext nidb, FrNIDBAipDataPkt adp)
{
  char zkdt[ZKDATETIMESTR_SZ];

  if (!zkDateTimeStore (nidb->err, &adp->aipinfo->dategen,
			zkdt, ZKDATETIMESTR_SZ))
    return 0;
  fprintf (nidb->logFP, "%d %d %s ", 
	   adp->aipinfo->aipid,
	   adp->aipinfo->serialnumber,
	   zkdt);

  fprintf (nidb->logFP, "| %d %d %d %d ", 
	   adp->linkinfo->linkid,
	   adp->linkinfo->isUp,
	   adp->linkinfo->pktsSent,
	   adp->linkinfo->pktsRcvd);
  fprintf (nidb->logFP, "\n");
  return 1;
}
#endif
#if 0
/**
 * Process the contents of an AIP buffer
 *
 * Check all signatures- TODO
 * Parse the buffer and load it into the database
 * Clean up all datastructures
 */
int frSQLProcessAipUpdatePktFromFile (FrNIDBContext nidb,
				      MYSQL *mysql,
				      char *pathname)
{
  static const char *funcname = "frNIDBprocessAIPFile";
  
  FrNIDBAipDataPkt adp;

  if (!FrNIDBAipDataPktNew (nidb->err, &adp)) {
    zkErrorSet(nidb->err, funcname, ZKERR, ZKMOD,
	       ZKENOMEM, "Couldn't allocate memory for aip info table");
    return 0;
  }

  
  if (!frNIDBAipDataPktLoad(nidb->err, adp, pathname))
    return 0;
  /*
  if (!frNIDBAipDataPktConsolidate(nidb, adp))
    return 0;
  
  if (!frNIDBAipDataPktDump(nidb->err, adp))
    return 0;

  if (!frNIDBAipDataPktLog(nidb, adp))
    return 0;

  if (!frNIDBAipDataPktStore(nidb, adp))
    return 0;
  */
  
  zkDebug_va("[%d]", adp->aipinfo->aipid);

  if (!FrNIDBAipDataPktFree (nidb->err, &adp)) {
    zkErrorSet(nidb->err, funcname, ZKERR, ZKMOD,
	       ZKENOMEM, "Problem freeing memory");
    return 0;
  }
  return 1;

}
#endif
#endif
