/*
 * $Id: nidbtool.h,v 1.9 2000/11/24 15:03:09 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 */

#ifndef NIDBTOOL_H_
#define NIDBTOOL_H_

#include <zkIntTypes.h>
#include <zkConfig.h>
#include <zkDB.h>
#include <zkParms.h>
#include <frFilenames.h>
#include <fr_nidbctx.h>


/*
 * Configuration file section code
 */

/*
 * Configuration parameter labels
 */

#define FL_DEBUG   0x1          /* Debug mode enabled */
#define FL_XML     0x2          /* XML output formatting */


/*
 * Default context values
 */

#define DEFAULT_FLAGS         0
#define DEFAULT_CONFIG_FILE   NULL
#define DEFAULT_LOG_FILE      FREEDOM_LOGDIR "/nidbtool"
#define DEFAULT_ROOT          "."
#define DEFAULT_PROMPT        "NidbTool-%s.%d> "


struct T_NidbToolContext {
  uint32_t flags;               /* Application behaviour flags */
  ZkError err;                  /* Context error structure */
  ZkLog log;                    /* Context log structure */
  ZkConfig config;              /* Context configuration structure */
  int exit_code;                /* Application exit() code */
  char * prompt;                /* Shell prompt */
  const char * progname;        /* Application program name */
  const char * config_file;     /* Name of the nidbtool config file */
  const char * logfile;         /* Name of the nidbtool log file */

  const char * nissdHost;       /* The name of the NISS host */
  const char * nissdCmdPort;    /* The command port of the NISS */
  int nissdCmdFd;               /* The file descriptor to the NISS */
  
  NidbContext nidb;
};

typedef struct T_NidbToolContext NidbToolContext;


DLLExport int nidbToolContextDump ( ZkError , NidbToolContext * , FILE * );

#endif /* NIDBTOOL_H_ */
