/*
 *  $Id: convert.h,v 1.4 2000/11/24 15:03:11 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 *  Luc Boulianne <luc@zks.net>

 *  
 *  Data conversion routines
 */
#ifndef CONVERT_H
#define CONVERT_H

#include <zks.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <zkIntTypes.h>
#include <zkDateTime.h>
#include <zkError.h>
#include <zkDebug.h>

#ifdef ZKMOD
# undef ZKMOD
#endif
#define ZKMOD ZKMNIDB

#define ZKDATETIMEBIN_SZ ZKDATETIMESTR_SZ 

typedef unsigned char uchar;
extern int zkCvtIntToBin (ZkError,     int ,    uchar *, size_t *);
extern int zkCvtIntFromBin (ZkError,   int *,   uchar *, size_t *);
extern int zkCvtShortToBin (ZkError,   short ,  uchar *, size_t *);
extern int zkCvtShortFromBin (ZkError, short *, uchar *, size_t *);
extern int zkCvtLongToBin (ZkError,    long ,   uchar *, size_t *);
extern int zkCvtLongFromBin (ZkError,  long *,  uchar *, size_t *);
extern int zkCvtCharToBin (ZkError,    char *,  uchar *, size_t );
extern int zkCvtCharFromBin (ZkError,  char *,  uchar *, size_t );
extern int zkCvtStrToBin (ZkError,      char *, uchar *, size_t );
extern int zkCvtStrFromBin (ZkError,    char *, uchar *, size_t );
extern int zkCvtInAddrToBin (ZkError,   struct in_addr *, uchar *, size_t *);
extern int zkCvtInAddrFromBin (ZkError, struct in_addr *, uchar *, size_t *);
extern int zkCvtUInt32ToBin (ZkError,   uint32_t ,  uchar *, size_t *);
extern int zkCvtUInt32FromBin (ZkError, uint32_t *, uchar *, size_t *);
extern int zkCvtUInt16ToBin (ZkError,   uint16_t ,  uchar *, size_t *);
extern int zkCvtUInt16FromBin (ZkError, uint16_t *, uchar *, size_t *);
extern int zkCvtZkDateTimeToBin (ZkError, ZkDateTime *, uchar *, size_t *);
extern int zkCvtZkDateTimeFromBin (ZkError, ZkDateTime *, uchar *, size_t *);
extern int zkCvtBoolToBin (ZkError, int , uchar *, size_t *);
extern int zkCvtBoolFromBin (ZkError, int *, uchar *, size_t *);

#endif
