/*
 * NADB core routines
 * Uses mysql
 *
 * $Id: fr_nadb.c,v 1.4 2000/11/24 15:03:11 marcp Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 * 
 */

static const char * module_id_ =
"$Id: fr_nadb.c,v 1.4 2000/11/24 15:03:11 marcp Exp $";

#include "zks.h"

#include <mysql/mysql.h>
#include <zkIntTypes.h>
#include <string.h>
#include <zkError.h>
#include <zkLog.h>
#include <zkDebug.h>
#include <zkDump.h>
#include <zkDB.h>
#include <zkCStr.h>
#include <zkDBOTypes.h>
#include <frDBOTypes.h>
#include <fr_nidb.h>

#ifdef ZKMOD
# undef ZKMOD
#endif
#define ZKMOD ZKMNIDB

int frNadbArchive (
  ZkError err,
  NidbContext c,
  FrDBOTypeNsdbAip state,
  char *entname,
  int sent,
  int rcvd,
  int *archived)
{
  static const char *funcname = "frNadbArchive";
  char *query = NULL;
  int retcode = 0;
  int sz = 0;
  (void) module_id_;
  
  sz = zkCStrSprintf(&query,
		     "INSERT into aip_archive VALUES ('%s', NULL, %d, %d, %d);",
		     entname, sent, rcvd, state->downtime);
  if (sz <= 0) {
    zkErrorSet(err,funcname,ZKERR,ZKMOD,ZKERROR,"Error generating query");
    return 0;
  }
  if (mysql_query(c->archiveDB, query)) {
    zkLogWrite_va(c->log, "Problem making query");
    goto finish;
  }
  /* bug: check this out */
  retcode = 1;
  *archived = 1;
  
 finish:
  if (query) free(query);
  return retcode;
}
