/* This is a mySQL script to create the initial entity database 
 * $id 
 * Luc Boulianne <luc@zks.net> 
 *
 * run using mysql -vvt < create.sql
 */
use test;
drop table if exists aips;
drop table if exists aipstatus;
drop table if exists linkstatus;

/* 
 * Due to a limitation of mySQL (no subqueries) the 
 * aip entity name does not include the FRENT_TYPE_AIP
 * qualifier at this time
 */
create table aips (
	entity varchar(64) not null primary key
);

create table aipstatus (
	entity varchar(64) not null references aips (entity),
	upflag tinyint unsigned zerofill,
	primary key (entity));

create table linkstatus (
	entity1 varchar(64) not null references aips (entity),
	entity2 varchar(64) not null references aips (entity),
	upflag tinyint unsigned zerofill
);

show columns from aips;
show columns from aipstatus;
show columns from linkstatus;

/* Load the AIP entities */
insert into aips values ('caesar');
insert into aips values ('tyros');
insert into aips values ('jefferson');
insert into aips values ('dogbert');
insert into aips values ('akira');
insert into aips values ('mizu');
insert into aips values ('gehenna');
insert into aips values ('lincoln');

/* Load the aipstatus table from the aips table */
insert into aipstatus (entity)
	select (entity) from aips;

/* Let's see it */
select * from aipstatus;

