/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include <mysql/mysql.h>
#include <stdio.h>
#include <stdlib.h>

MYSQL mysql;
MYSQL_RES *res;
MYSQL_ROW row;

static void exiterr(int exitcode)
{
  fprintf( stderr, "%s\n", mysql_error(&mysql) );
  exit( exitcode );
}

int main(int argc, char *argv[])
{
  uint i = 0;
  
  if (!(mysql_connect(&mysql,"localhost","luc",""))) 
    exiterr(1);

  if (mysql_select_db(&mysql,"test"))
    exiterr(2);

  if (mysql_query(&mysql,"SELECT * FROM aips"))
    exiterr(3);

  if (!(res = mysql_store_result(&mysql)))
    exiterr(4);

  while((row = mysql_fetch_row(res))) {
    for (i=0 ; i < mysql_num_fields(res); i++) 
      printf("%s\n",row[i]);
  }

  mysql_free_result(res);
  mysql_close(&mysql);

  return 0;
}
