#!/bin/sh
#
# $Id: mail-keycache.sh,v 1.4 2000/03/09 04:22:02 gerard Exp $
#
# Adapted the mail-keycache from Gary Reuter <gary@zks.net>
#   by Luc Boulianne <luc@zks.net> to use an arbritary network.
# Network detection by Gerard Cheng <gerard@zks.net>
#
die () {
        exit 2
}

NETWORK=`grep -i "niqs\.hostname" /freedom/etc/freedom.conf | awk -F. '{print $3}'`
case $NETWORK in
  alpha)
    nw_string="Alpha"
    NIQS="niqs.alpha.freedom.net"
    ;;
  rc)
    nw_string="RC-0"
    NIQS="niqs.rc.freedom.net"
    ;;
  freedom)
    nw_string="Freedom"
    NIQS="niqs.freedom.net"
    ;;
  *)
    die
    ;;
esac
#
# Bug: This TO must change to someone more generic
#

TO=marty@zks.net

# create key cache file
/freedom/sbin/fr_makekeycache --logFile /freedom/var/log/makekeycache.log\
        --cacheFile /tmp/${NETWORK}_key.cache

# mail it off
/usr/bin/metasend -b -s "Key.Cache: ${nw_string} Network"  -t $TO \
        -S 409600 -f /tmp/${NETWORK}_key.cache \
        -m 'X-zks/X-key_cache; name="${NETWORK}_key.cache"' \
        -D "Freedom Key Cache for ${nw_string} network"

# create NIQS cache file
/freedom/sbin/fr_getaips --niqs.hostname $NIQS --nodns\
        --save /tmp/niqs.cache >>/dev/null

# mail it off
/usr/bin/metasend -b -s "NIQS.Cache: ${nw_string} Network"  -t $TO \
        -S 409600 -f /tmp/niqs.cache -m 'X-zks/X-NIQS_cache; name="niqs.cache"' \
        -D "Freedom NIQS Cache for ${nw_string} network"

