#include "zkParms.h"
#define DEFAULT_PASSPHRASE_FILE "/dev/fd/0"  

#define VERSION_STR "Zeroknowledge Freedom Network Information Query Service Deamon\n"\
                    "version 1.1.22.1  ("__DATE__", "__TIME__")\n"

#define OPTIONS "\nOPTIONS\n"\
"  Where options can be one or more of the following:\n\n"\
"  --"P_CONFIG" path         \n"\
"      Location of the configuration information.\n"\
"  --"P_DEBUG"  \n" \
"      Enable debugging mode.\n" \
"  --"P_DAEMON" \n"\
"      Forks and creates a background daemon process. \n"\
"  --"P_PIDFILE" PIDfile \n"\
"      File where the parent process PID is written.\n"\
"  --"P_LOGFILE" LogFile  \n"\
"      Log file.\n"\
"  --"P_KEYQRY_HOSTNAME" "P_HOSTNAME"\n"\
"      Key query server hostname.\n "\
"  --"P_KEYQRY_PORT" "P_PORT"\n"\
"      Key query server port.\n"\
"  --"P_KEYQRY_RETRIES" retries\n"\
"      Number of retries to connect to the key query server.\n"\
"  --"P_KEYQRY_TIMEOUT" "P_TIMEOUT"\n"\
"      Time out value for a key lookup.\n"\
"  --"P_PASSPHRASE_FILE" filename\n"\
"      Passphrase filename.\n"\
"  --"P_PASSPHRASE_PROMPT" prompt\n"\
"      Passphrase prompt.\n"\
"  --"P_KEYINFO_DIRECTORY_CRYPT" path \n"\
"      Path to all the server's private cryption keys.\n"\
"  --"P_KEYINFO_DIRECTORY_SIG" path \n"\
"      Path to all the server's private signature keys.\n"\
"  --"P_PORT" "P_PORT"\n"\
"      Port number on which the niqs listens for incoming requests.\n"\
"  --"P_LISTEN_QUEUE_LENGTH" length \n"\
"      Length of the frniqsd daemon listen queue.\n"\
"  --"P_MAX_CONNECTION_TIME" maxtime \n"\
"      Maximum time that a ZKIP server will remain connected to a client.\n"\
"  --"P_PROCESS_LIFE" numberofconnections \n"\
"      Maximum connections the server childs should handle berfore ending.\n"\
"  --"P_CACHE_DATA_VERSION" "P_VERSION"\n"\
"      Cache data version code of the NIQS database.\n"\
"  --"P_NIQS_RESPONSE_CACHE" name \n"\
"      Name of the database where it should keep its cache of signed responses.\n"\
"  --"P_NIQS_RESPONSE_CACHE_TTL" time \n"\
"      Time to live (in seconds) of an entry in the cache.\n"\
"  --"P_NIQS_RESPONSE_LIST_SINCE_0_CACHE_TTL" time \n"\
"      Time to live (in seconds) of a list entry in the cache.\n"\
"  --"P_NIQS_RESPONSE_STATUS_SINCE_0_CACHE_TTL" time \n"\
"      Time to live (in seconds) of a status entry in the cache.\n"\
"  --"P_NIQS_RESPONSE_AVAILABLE_CACHE_TTL" time \n"\
"      Time to live (in seconds) of an available entry in the cache.\n"\
"  --clientinfo  file \n"\
"      File for the client information.\n"\
"  --"P_TOKEN_TYPE_ID" file \n"\
"      File which stores the token type identifier.\n"\
"  --"P_MOTDFILE" file \n"\
"      File which contains the message of the day.\n"\
"  --"P_ACLFILE" file \n"\
"      File which contains the access control list.\n"\
"  --"P_VERBOSE" verbosevalue \n"\
"      Value (0-100) to describe the level of logging.\n"\
"  --"P_MAX_DATA" maximum \n"\
"      Maximum amount of data which can be transfered for a given ZKIP command.\n"\
"  --"P_MAX_CONNECTIONS" maximum \n"\
"      The maximum number of simultaneous connections the server supports.\n"

#define DATABASE_OPTIONS "\nDATABASE OPTIONS\n"\
"  Additionally, there are a number of database-specific options.\n\n"\
"  --"P_NIDB_STATE" configFile \n"\
"      Configuration file for the state database.\n"\
"  --"P_NIDB_TOPO" configFile\n"\
"      Configuration file for the topology database.\n"\
"  --"P_NIDB_ENT" configFile \n"\
"      Configuration file for the entity database.\n"\
"  --"P_NIDB_ENTID" configFile \n"\
"      Configuration file for the entity identity database.\n"\
"  --"P_NIDB_NEIGHBOUR" configFile\n"\
"      Configuration file for the neighbour database.\n"\
"  --"P_NIDB_ARCHIVE" configFile\n"\
"      Configuration file for the archive database.\n"\
"  --"P_NIDB_ENTUPD" configFile \n"\
"      Configuration file for the entity last update database.\n"\
"  --"P_NIDB_HOST" configFile \n"\
"      Configuration file for the host database.\n"\
"  --"P_NIDB_ARCHIVE_SQLHOST" configFile \n"\
"      Configuration file for the host SQL database. \n"\
"  --"P_NIDB_ARCHIVE_SQLUSER" configFile \n"\
"      Configuration file for the user name SQL database.\n"\
"  --"P_NIDB_ARCHIVE_SQLPSWD" configFile \n"\
"      Configuration file for the password SQL database.\n"\
"  --"P_NIDB_ARCHIVE_SQLDB" configFile \n"\
"      Configuration file for the archive SQL database.\n"

#define MESG_HELP VERSION_STR"\nUsage:  %s --options\n"OPTIONS""DATABASE_OPTIONS"\n"

extern int frNiqsEventLoop(ZkError err, FrNiqsCtx *c);

/*
 * Warning this call will be phased out
 */
extern int frNiqsProcessTopology(
  ZkError err ,
  FrNiqsCtx * c,
  const char * attribute_token,
  FrEntIdExp * entity,
  void ** response,
  size_t * rsz,
  int *found);

extern int frNiqsProcessQuery(
  ZkError err ,
  FrNiqsCtx * c,
  uint32_t cmdid,
  const char * attribute_token,
  FrEntIdExp * entity,
  void ** response,
  size_t * resz,
  int *found);

extern int frNiqsProcessList(
  ZkError err,
  FrNiqsCtx * c,
  time_t since,
  uint32_t entity_mask,
  void ** signed_response,
  size_t * sresz,
  int *found);

extern int frNiqsProcessStatus(
  ZkError err,
  FrNiqsCtx * c,
  uint32_t cmdid,
  time_t since,
  uint32_t mask,
  void ** signed_response,
  size_t * sresz,
  int *found);

extern int frNiqsProcessDesc(
  ZkError err,
  FrNiqsCtx * c,
  uint32_t cmdid,
  FrEntIdExp *entity,
  void ** signed_response,
  size_t * sresz,
  int *found);

extern int frNiqsProcessMxQuery( 
  ZkError err,
  FrNiqsCtx * context,
  uint32_t cmd_id,
  const char * attribute,
  time_t since,
  uint16_t encoding,
  uint32_t entity_mask,
  void ** signed_response,
  size_t * signed_response_length,
  int * valid_data);

extern int frNiqsGetCacheDataVersionFromNidb(  /* does not modify the cacheDataVersion in the FrNiqsCtx */
  ZkError err,
  FrNiqsCtx *ctx,
  uint32_t  *cacheDataVersion);

