
#ifndef NSDBCONF_H_
#define  NSDBCONF_H_ 

#include "zks.h"


#include <sys/types.h>
#include <stdio.h>
#include <zkConfig.h>
#include <zkIntTypes.h>
#include <zkParms.h>
#include <frEnt.h>

#include <frFilenames.h>
#include <frStatUpd.h>
#include <frStatClient.h>
#include <frDBOTypes.h>
#include <frStatPkt.h>
#include <frStatBucket.h>
#include "frDBOFuncs.h"
#include <fr_nidbctx.h>

#include <zkError.h>
#include <zkLog.h>
#include <zkDB.h>
#include <zkAA.h>





#ifdef __cplusplus 
extern "C" {
#endif /* __cplusplus */

struct T_frExportCtx {
    ZkConfig config;            /* Configuration object */
    ZkLog log;                  /* Log object */
    const char * logfile;
    const char *progname;       /* Program name */
    const char *configfile;     /* Configuration file */
    int debug;                  /* debug or not */
    const char *sourcefile;     /* Source file */
    const char * aipfile;      /* Destination Files */
    const char * maipfile;
    const char * linkfile;
  
    unsigned char columnDelimiter;
    unsigned char rowDelimiter;
    E_frNsdbObjType  exporttype;    
    
    FILE *sfp;
    FILE *afp;
    FILE *mafp;
    FILE *lfp;

 
  
  };

typedef struct T_frExportCtx * FrExportCtx;

 int nsdbBufferRead(ZkError err, FrExportCtx  ctx);
 int nsdbObjWrite ( ZkError err , FrExportCtx ctx,   FrDBOTypeNsdbObj obj);

#define DEFAULT_COLUMN_DELIMITER  ';'
#define DEFAULT_ROW_DELIMITER  '\n'
#define DEFAULT_EXPORT_TYPE     NsdbAip

  
#define  S_LOG_STAT           "Log"
#define P_SOURCEFILE   "source"
  
#define P_AIPFILE     "aipfile"
#define P_MAIPFILE     "aipfile"
#define P_LINKFILE     "aipfile"  
  
#define P_ROW_DELIMITER     "rowdelimiter"
#define P_COL_DELIMITER  "columndelimiter"  
#define P_EXPORT_TYPE    "exporttype"
  

#endif  /* NSDBCONF_H_ */
