#!/bin/sh
#
# cron job run every day for .dat file generation
#

#
# public settings - can be changed according to installation
#
homepath=/usr/fradmin
inputpath=/freedom/var/log


#
# private settings - must not be changed
#
progname=cron_day
libpath=${homepath}/lib
logfile=${homepath}/var/log/${progname}.log
lockfile=${homepath}/var/run/${progname}.lock


exec >> ${logfile} 2>&1

if ${libpath}/lock.pl ${lockfile}
then

    echo "----------------------------------------"
    date

    #
    # jobs to run
    #

##
## uncomment the following lines for installation on fs2
## Should be run every day just before 00:00:00
##
#    ${libpath}/digestSnSummary.pl

##
## uncomment the following lines for installation on fs3
## Should be run every day just before 00:00:00
##
#    ${libpath}/digestNymSummary.pl


##
## uncomment the following lines for installation on accuracy
##
##
#
#    ${libpath}/loadNymVitalC_daily.pl
#    ${libpath}/RaiseRejectAlert.pl


    rm $lockfile

else
    echo "${progname}: couldn't get lock file ${lockfile}"
fi
