#!/bin/sh
#
# cron job run every hour for .dat file generation
#

#
# public settings - can be changed according to installation
#
homepath=/usr/fradmin
inputpath=/freedom/var/log


#
# private settings - must not be changed
#
progname=cron_hour
libpath=${homepath}/lib
logfile=${homepath}/var/log/${progname}.log
lockfile=${homepath}/var/run/${progname}.lock


exec >> ${logfile} 2>&1

if ${libpath}/lock.pl ${lockfile}
then

    echo "----------------------------------------"
    date

    #
    # jobs to run
    #

#
# uncomment the following lines for installation on fs2 (or faith)
#
#    ${libpath}/digestEntReport.pl --entity aip --output
#    ${libpath}/digestEntReport.pl --entity maip --output
#    ${libpath}/digestEntReport.pl --entity fmg-maip --output
#    ${libpath}/digestServopTrafficSumm.pl
#    ${libpath}/digestLog.pl --snminutes --entity zktsa --in ${inputpath}/zktsa


#
# uncomment the following lines for installation on fs3 (or temperance)
#
#    ${libpath}/digestLog.pl --frnscp --entity frnscpd --in ${inputpath}/frnscpd
#    ${libpath}/digestLog.pl --lodeaudit --entity frloded --in ${inputpath}/frloded.audit
#    ${libpath}/digestLog.pl --nymmailnews --entity fmg-maip   --in ${inputpath}/fmg-maip
#    ${libpath}/digestLog.pl --nymmailnews --entity frpostnews --in ${inputpath}/frpostnews 
#    ${libpath}/digestLog.pl --nymmailactivity --entity fmg      --in ${inputpath}/fmg
#    ${libpath}/digestLog.pl --nymmailactivity --entity fmg-maip --in ${inputpath}/fmg-maip
#    ${libpath}/digestLog.pl --nymnewsactivity --entity frpostnews --in ${inputpath}/frpostnews

#
# uncomment the following lines for installation on accuracy
#
#    ${libpath}/dirsynk.pl --remotehost=fs2.freedom.net --remotepath=/usr/fradmin/var/dat  --localpath=/usr/fradmin/var/dat
#    ${libpath}/dirsynk.pl --remotehost=fs3.freedom.net --remotepath=/usr/fradmin/var/dat  --localpath=/usr/fradmin/var/dat
#    ${libpath}/loadAipActivity.pl
#    ${libpath}/loadFmgMaipActivity.pl
#    ${libpath}/loadMaipActivity.pl
#    ${libpath}/loadNymVitalB.pl --prefix fs3
#    ${libpath}/loadNymVitalC.pl
#    ${libpath}/loadNymVitalD_mail.pl
#    ${libpath}/loadNymVitalD_news.pl
#    ${libpath}/loadAipTraffic.pl
#    ${libpath}/loadSnMinutes.pl
#    ${libpath}/loadSnSummary.pl
#    ${libpath}/loadNymSummary.pl

    rm $lockfile

else
    echo "${progname}: couldn't get lock file ${lockfile}"
fi

