/*
 * The Network Information State Service
 *
 * $Id: fr_niss.h,v 1.9 2000/10/04 12:56:32 marcp Exp $
 * Luc Boulianne <luc@zks.net>
 */

#ifndef FR_NISS_H
#define FR_NISS_H
#include <frStatPkt.h>
#include <frStatUpd.h>
#include "frDBOTypes.h"
#include "frnissd.h"


/**
 * Handle incoming update packets and convert them into DBOs
 * And the archival database
 */
extern int frNissHandleUpdateBuffer (
  ZkError  ,
  FrStatCtx *,
  FrStatBucket ,
  void *,
  size_t );
/**
 * Handle the update packet from an AIP
 */
extern int frNissHandleAip (
  ZkError err,
  FrStatCtx *c,
  FrStatUpd fsu
  );

/**
 * Handle the update packet from a MAIP
 */
extern int frNissHandleMaip (
  ZkError err,
  FrStatCtx *c,
  FrStatUpd fsu
  );

/**
 * handle an update packet from a Link
 */
int frNissHandleLink(
  ZkError     err,
  FrStatCtx * c,
  FrStatUpd   fsu
);

/**
 * handle an update packet from a Wormhole
 */
int frNissHandleWormhole (
  ZkError err,
  FrStatCtx *c,
  FrStatUpd fsu
);

DLLExport int
frNissLookForDownAip(
    ZkError err,
    FrStatCtx * c
);



/**
 * From the Niss database, read, update and store a
 * link status
 */
extern int frNissReadStoreLinkStatus(
  ZkError err,
  FrStatCtx *c,
  FrDBOTypeEntityID aip_eid_dbo,
   FrDBOTypeEntityID remaip_eid_dbo,
  uint32_t p_sent,
  uint32_t p_rcvd,
  time_t last_update_date,
  uint32_t status
  );

extern int frNissEvRecCheckAndStore (
  ZkError err,
  FrStatCtx *ctx,
  FrEntIdent eid,
  FrStatUpdTypes type,
  time_t last_update,
  int *new_entry_flag,		/* This is the first time I've heard from you */
  int *new_update_flag          /* This event is more recent that what I had  */
  );

extern int frNissEventLoop(ZkError err, FrStatCtx *c);
#endif
