#! /bin/bash
# ----------------------------------------------------------------------------
#
# $Id: bounceif.sh,v 1.2 2000/10/04 12:56:36 marcp Exp $
#
# This script performs the necessary MIME manipulations to deliver a pre-
# composed failure (i.e., bounce) message to the sending nym if the test
# given on the command line fails.
#
# ----------------------------------------------------------------------------

if ( reformime -s 1.1 -e | $* )
then

    #
    # The message has passed the "test" ... exit 0 tells qmail-local to
    # move on to the next rule.
    #

    exit 0;
fi

#
# The message failed the "test" ... try to bounce the failure message
# back to the sender.
#

echo "bouncing failure message to sender"

SENDER=`sanitize SENDER`
ACCT="$(frname2account $(cat /freedom/qmail/control/mailroot) $SENDER)"

if [ ! -d $ACCT ]
then

    #
    # The sender doesn't exist!  This is a bad thing!
    #

    echo "sender does not exist so I am dropping the message"
    exit 99
fi

#
# Deliver the failure message
#

seek 0 0 && reformime -s 1.2 -e | mimencode -u | env -u DTLINE -u RPLINE safecat $ACCT/Maildir/tmp $ACCT/Maildir/new && exit 99

#
# If we get here, then the delivery failed.  For now, assume that
# it was a temporary failure (what else can we do?)
#

echo "failed to deliver failure message"

exit 111
