#!/bin/sh
# --------------------------------------------------------------------------
# $Id$
#
# This script provides decrypt and forward services for nym aliases.
#
# For instance, the nym name postmaster@freedom.net may be reserved.  This
# mail allows us to setup a postmaster@freedom.net nym alias to which real
# nyms can send encrypted mail.  Upon receipt by the mail system, the mail
# will be decrypted and forwarded to an internet address via the relay.
#
# To set up an alias for "foo"  do the following steps:
#
# 1.	mkdir /freedom/qmail/alias/foo
# 2.    cp {key for foo} /freedom/qmail/alias/foo/key
# 3.    echo -n {addr for foo} >> /freedom/qmail/alias/foo/addr
# 4.    chmod 640 /freedom/qmail/alias/foo/*
# 5.    chmod 750 /freedom/qmail/alias/foo
# 6.    ln -s /freedom/qmail/delivery/decrypt-and-forward /freedom/qmail/alias/.qmail-foo
#
# --------------------------------------------------------------------------

QMAIL_ROOT="/freedom/qmail"
QMAIL_BIN="${QMAIL_ROOT}/bin"
ALIAS_ROOT="${QMAIL_ROOT}/alias"
FORWARD_RULE="${ALIAS_ROOT}/${LOCAL}"

if [ -d ${FORWARD_ROOT} ]
then
	reformime -s 1.1 -x \
	| mimencode -u \
	| msg-decrypt 3< ${FORWARD_RULE}/key 4< <(reformail -x "X-Freedom-Message-Auth:") \
	| qmail-qmqpc 1< <(printf "F${SENDER}\0T$(cat $FORWARD_RULE)/addr)\0\0") \
	&& exit 99

	echo "Failed delivery to ${LOCAL}"
else

	echo "Alias rule to ${LOCAL} doesn't exist!"
fi

exit 111
