#!/bin/sh
# ---------------------------------------------------------------------------
#
# $Id: qmail-remote-imepb.sh,v 1.2 2000/10/04 12:56:36 marcp Exp $
#
# This script implements the remote delivery pipline of the IMEP backend.
# The qmail-remote which lives in the ??/qmail/bin directory should be
# renamed to qmail-remote.orig and this script should be put in its place.
#
# ---------------------------------------------------------------------------

QMAIL_ROOT=/freedom/qmail
QMAIL_BIN=${QMAIL_ROOT}/bin
QMAIL_CONTROL=${QMAIL_ROOT}/control
REFORM_MAIL=${QMAIL_BIN}/reformail
HOST=${1}
SENDER=${2}
shift
shift

RECIP_REPORT=''
SUCCESS=0

for RECIPIENT
do
    ${QMAIL_BIN}/seek 0 0
    export SENDER RECIPIENT
	    ${REFORM_MAIL} -c | \
	    ${QMAIL_BIN}/qmail-qmqpc 1< <(printf "F$SENDER\0T$RECIPIENT\0\0")
	    QMQPC=$?
	    if [ $(($QMQPC==0)) ]
	    then
		# append another "recipient accepted" indicator
		RECIP_REPORT="${RECIP_REPORT}r"
		SUCCESS=$(($SUCCESS||1))
	    else
		# append a "recipient failed temporarily" indicator
		RECIP_REPORT="${RECIP_REPORT}s"
		SUCCESS=$(($SUCCESS||0))
	    fi
done

# qmail-rspawn wants to know how many recipients succeeded, and whether the
# message was "accepted". we tell it the message was accepted unless _all_ the
# recipients failed, and the recipients we report on a case-by-case basis
# depending on whether we succeeded in forwarding to the relay

if [ $SUCCESS ] 
then
    printf "$RECIP_REPORT\0KMessage(s) forwarded to relay\0"
else
    printf "$RECIP_REPORT\0ZAll forwarding attempts failed\0"
fi

exit 0

