/*
 * $Id: sanitize.c,v 1.2 2000/10/04 12:56:36 marcp Exp $
 *
 * This program takes an environment variable name on the command line and
 * prints to stdout the value of that variable with all characters which
 * are not a legal part of the an account name removed.
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <ctype.h>

int main( int argc, const char * argv[] )
{
    char *value   = NULL;
    char *current = NULL;
    char *last_at = NULL;

    if (argc < 2)
    {
        fprintf(stderr, "usage: %s <ENV_VARIABLE>\n", argv[0]);
        return (1);
    }

    value = getenv(argv[1]);
    if (value == NULL)
    {
        fprintf(stderr, "%s: %s not defined!\n", argv[0], argv[1]);
        return 1;
    }

    for (current = value; *current; ++current)
    {
        if (isalnum(*current))
        {
            *current = (char) tolower(*current);
        }
        else switch (*current)
        {
        case '-':
        case '_':
        case '.':
            break;
            
        case '@':
            last_at = current;
            break;

        default:
            *current = '_';
            break;
        }
    }

    if (last_at != NULL)
    {
        *last_at = '\0';
    }

    printf("%s",value);
    return 0;
}
