#! /usr/bin/perl -w

# $Id: deploy.pl,v 1.15 2000/10/04 12:56:37 marcp Exp $

#
# This is an automated installer for putting up a cacophonix "cluster"
# assuming you have 5 dedicated machines you're allowed to ssh
# into as root 
#

sub pr {
#  print @_, "\n";
  system(@_);
}

sub pr_backtick {
#  print @_, "\n";
  return `@_`;
}

sub dnsip {
  my $name = shift;
  my $ip = `dnsip $name`;
  chop($ip);
  return $ip;
#   my($name) = shift;
#   my($packed_ip);
#   $packed_ip = gethostbyname($name) or die("gethostbyname($name) failed: $!\n");
#   return inet_ntoa($packed_ip);
}

use Socket;
my $kqd_host = 'host1.t12.dev.zks.net';
my $kqd_port = '51109';
my $pkgroot = '/turf/serge/work/zk_v1.2/arch/linux-2.2-ix86/Debug/RPMS/i386';
my @domains = ('t12.dev.zks.net');
my $NYMSRV='oprah';
my $hosts = {
	   'IMEP' => ['kat-moda.dev.zks.net'],
	   'IMEPB' => ['carrot.t10.dev.zks.net'],
	   'NMTA' => ['cabbage.t10.dev.zks.net'],
	   'NMTAB' => ['celery.t10.dev.zks.net'],
	   'POP' => ['avocado.t10.dev.zks.net'],
	   'RELAY' => ['avocado.t10.dev.zks.net'],
	  };

print "Summary of hosts:\n";
my($service);
foreach $service (sort(keys(%{$hosts}))) {
    print "$service: ";
    my($host);
    foreach $host (@{$hosts->{$service}}) {
	print "$host ";
    }
    print "\n";
}
    
print "Getting shared secret from NYMSRV $NYMSRV\n";
my $mailmackey = pr_backtick("ssh root\@$NYMSRV cat /freedom/privkey/NymServer/mailmackey");
print "mailmackey = $mailmackey\n";
my @pkgs = keys(%$hosts);


while ( my ($pkg,$hostnames) = each(%$hosts) ) {
  for my $host (@$hostnames) {
    print "\n" x 3 . "#" x 40 . "\nerasing packages from $host\n" . "#" x 40 . "\n" x 2;
    # erase any pre-existing packages
    pr("ssh root\@$host 'rpm --quiet -e " 
       . join(' ', map {"freedom-qmail-$_ \\\n"} @pkgs)
       . " freedom-qmail 2>&1 | \\\n grep -v \"not installed\" | grep -v \"not empty\""
       . ";\\\n rm -Rf /freedom/qmail;'");
  }
}

while ( my ($pkg,$hostnames) = each(%$hosts) ) {
  for my $host (@$hostnames) {


    print "\n" x 3 . "#" x 40 . "\nsetting up $host as $pkg\n" . "#" x 40 . "\n" x 2;
    
    # ensure DNS understands the picture
    pr("scp -q /etc/resolv.conf root\@$host:/etc/resolv.conf");
    
    # copy fresh versions of the packages
    pr("scp -q $pkgroot/ucspi-tcp-0.88-1.i386.rpm"
       . "\\\n $pkgroot/daemontools-0.70-1.i386.rpm"
       . "\\\n $pkgroot/freedom-qmail-1.00-1.i386.rpm"
       . "\\\n $pkgroot/freedom-qmail-$pkg-1.00-1.i386.rpm\\\n root\@$host:");
        
    # install packages on each box
    pr("ssh root\@$host 'rpm --quiet -i ./ucspi-tcp-0.88-1.i386.rpm;"
       . "\\\n rpm -i ./daemontools-0.70-1.i386.rpm; "
       . "\\\n rpm -i ./freedom-qmail-1.00-1.i386.rpm; "
       . "\\\n rpm -i ./freedom-qmail-$pkg-1.00-1.i386.rpm "
       . "\\\n 2>&1 | grep -v \"already installed\" '");
  }
}

print "\n" x 3 . "#" x 40 . "\nwiring machines together\n" . "#" x 40 . "\n" x 2;

for my $pair (
	      'IMEP', 
	      'NMTA',
	      'RELAY',
	      'IMEPB'
	     ) {

  # setup client/server relationships 
  my ($fel, $bel);
  if ($pair eq 'RELAY') {
    ($fel,$bel)=($hosts->{'NMTAB'}, $hosts->{'RELAY'}); 
  } 
    elsif ($pair eq 'IMEPB') {
    ($fel,$bel)=($hosts->{'IMEPB'}, $hosts->{'RELAY'});
    }
    else {
    ($fel,$bel)=($hosts->{$pair}, $hosts->{$pair . 'B'}); 
  }

  for my $tup ([$fel, 'qmqpservers', $bel], [$bel, 'qmqpclients', $fel]) {
    for my $self (@{$tup->[0]}) {
      my $file = $tup->[1];
      for my $other (@{$tup->[2]}) {
        $ip_address = dnsip($other);
	chop($ip_address);
	print "adding $other ($ip_address) to $file of $self\n";
	pr("ssh root\@$self 'echo $ip_address >>/freedom/qmail/control/$file'");
	print "\n";
      }
    }
  }

  if ($pair eq 'RELAY') { next; }

  # setup recipient domains
  for my $domain (@domains) {
    if ($pair eq 'IMEP') {
      for my $fe (@$fel) {
        print "adding domain $domain to rcpthosts for imep $fe\n";
	pr("ssh root\@$fe 'echo $domain >>/freedom/qmail/control/rcpthosts'");
	print "\n";
      }
    }
    for my $be (@$bel) {
      print "adding domain $domain to locals for backend $be\n";
      pr("ssh root\@$be 'echo $domain >>/freedom/qmail/control/locals'");
      print "\n";
    }
  }
}
 
for my $auth (
	      'IMEPB',
	      'NMTA', 
	      'NMTAB', 
	      'POP'
	     ) {
  my $hostlist = $hosts->{$auth};
  for my $host (@$hostlist) {
    print "setting mailmackey on $host\n";
    pr("ssh root\@$host 'echo -n \"$mailmackey\" >/freedom/qmail/control/mailmackey'");
    print "\n";
  }
}

for my $crypto (
	      'IMEPB',
	      'NMTAB', 
	     ) {
  my $hostlist = $hosts->{$crypto};
  for my $host (@$hostlist) {
    print "setting kqd host for mail delivery on $host\n";
    pr("ssh root\@$host 'echo -n $kqd_host > /freedom/qmail/control/kqd.host;echo -n $kqd_port > /freedom/qmail/control/kqd.port'");
    print "\n";
  }
}

#setup the news domain on relay.
my $hostlist = $hosts->{'RELAY'};
for my $relay_host (@$hostlist) {
  for my $domain (@domains){
    $news_domain = 'news.' . $domain;
    print "setting locals on relay $relay_host to have news domain $news_domain";
    pr("ssh root\@$relay_host 'echo $news_domain >> /freedom/qmail/control/locals'");
  }
}

#start qmail on each machine!
while ( my ($pkg,$hostlist) = each(%$hosts) ) {
  for my $host (@$hostlist) {
    print "staring qmail on $host\n";      
    pr("ssh root\@$host qmail start");
    print "\n";
  }
}
