
#This will generate a file with mail passwords for nyms of the form <basename>N, where N is a numbered index.  This file is then used with a modified version of mstone for mail performance testing for any case where you need to login to more than 1 nym account.  The file will have 1 mail password per line. 
#It is assumed that the nyms in question have already been created on the network.  If you need to create a bunch of nyms, refer to freedom/tools/server-bvt/bin/create_nyms.exp
#The mailmackey for the network in question needs to be in /freedom/qmail/control/mailmackey


mailmackey_file="/freedom/qmail/control/mailmackey"
password_file="passwords.wld"


if [ $# -lt 2 ] ; then

  echo "usage: ./generate_passwd_list.exp <basename> <num_nyms> <start_index>"
  exit

fi
   
basename=$1
num_nyms=$2
start_index=$3


#Check to make sure the mailmackey exists and is the right one

if [ ! -f $mailmackey_file ] ; then
  echo "File $mailmackey_file does not exist.  Cannot generate nym passwords"
  exit
fi

if [ -f $password_file ] ; then
  echo -n "File $password_file already exists.  Do you want to overwrite? (y/n)"
  read choice
  if [ $choice=="y" ] ; then
     \rm $password_file
  else
     exit
  fi
fi

echo -n "Mailmackey to be used to generate mail password: "
cat $mailmackey_file

end_index=`expr $start_index + $num_nyms` 
i=0

while [ $i -le $end_index ] ; do 
  nymname="$basename$i"
  genpasswd $nymname >> $password_file
  i=`expr $i + 1`
done




