#!/usr/bin/perl -w

# $Id$

# Philippe McLean
# 6 October 2000

# Script for generating a set of test nyms for user in the
# UserConfig.pm file in the mail test suite. 

# Required: a machine to run /root/genpasswd with ssh. See below.

use strict;

use Getopt::Long;

sub usage()
{
    die("usage: $0 <genpasswd_server> <base_name> <number_of_nyms>\n");
}

my($genpasswd_server, $base_name, $number_of_nyms);

$genpasswd_server = shift;
$base_name = shift;
$number_of_nyms = shift;

usage() unless defined($genpasswd_server) && defined($base_name) && defined($number_of_nyms);

my($i);

print "\$test_nyms = [\n";
for ($i = 0; $i < $number_of_nyms; ++$i) {
    my($nym_name) = $base_name . $i;
    my($user) = `echo -n \'$nym_name\' | mimencode`;
    chomp($user);
    my($password) = `ssh $genpasswd_server \"/root/genpasswd $nym_name\"`;
    chomp($password);
    
    print "
              {
                  Name => \'$nym_name\',
                  Type => \'\',
                  User => \'$user\',
                  Password => \'$password\',
                  Mail_Size_Limit => 2048,
                  Mail_Send_Limit => 2048,
                  Mail_Volume_Limit => 2048,
              },
";
}
print "
	       ];
";
