#!/usr/bin/perl -w

use strict;

use lib('../lib/perl');
use lib('./lib/perl');

use Mail_Test;
use Getopt::Long;

sub usage()
{
    die("usage: $0 <pop_server> [--port <port_number>] <user> <password>\n");
}


my($port) = 110;
my($result) = GetOptions("port=i" => \$port);

my($host) = shift;
my($user) = shift;
my($password) = shift;

usage() unless defined($host) && defined($user) && defined($password);

## create the factories
my($netuser) = new User::Net();
my($popserv) = new Server::MailServer();
my($popconn) = new Connection::POPX();


## set the supplied username and password
$netuser->name( $user );
$netuser->user( $user );
$netuser->password( $password );

## set the supplied server
$popserv->name( $host );
$popserv->port( $port ) if defined($port);
$netuser->popx_server( $popserv );

## try the pop connection
$popconn->connect( $netuser );
$popconn->quit();


