# $Id: Mail_Test.pm,v 1.3 2000/10/04 12:57:15 marcp Exp $


# all the packages we use for the mail tests...

use strict;

################################################################################

use Message::Base;        # Base class for message classes
use Message::Header;      # Message header base class
use Message::Content;     # Message content (body) base class

use Message::MailMessage; # Internet Mail Message
use Message::NewsMessage; # Internet News Message

################################################################################

use Server::Base;         # Base class for server classes
use Server::MailServer;   # Mail server information class
use Server::NewsServer;   # News server information class
use Server::UserServer;   # User server information class

################################################################################

use Domain::Base;         # Base class for Internet domain names
use Domain::NetUser;      # Network user specific Internet domains
use Domain::NymUser;      # Nym user specific Internet domains

################################################################################

use User::Base;           # Base class for user classes
use User::Net;            # Generic network user class
use User::Nym;            # ZKS Freedom user class

################################################################################

use Connection::Base;     # Base class for network connection classes
use Connection::POPX;     # POP[2,3,Z] protocol encapsulation class
use Connection::SMTP;     # [E]SMTP protocol encapsulation class
use Connection::NNTP;     # Network news protocol encapsulation class

################################################################################

return 1;
