#! /bin/sh -f

#This script will generate 5 sets of 100 test nyms suitable for performance testing of the mail system.  A set of nyms for each message size (1k, 8k, 100k, 1meg) will be generated, as well as an additional set for functions not relevant to mail size.  The purpose of seperate sets of test nyms for each message size is so that when one can easily test pop reads with a given set of nyms and know what size messages will be read.

# ./generate_test_nyms.exp is used to generate each set.  This will create nyms and their pop boxes.  You must be set up to run nymtool and the laip in order to run this script.  To generate the necessary config files for this, run freedom/tools/server-bvt/bin/netgenconfig.sh.  The test nym creation script will also dump out mail password files for each et of nyms, which will be needed in order to run performance tests (using mstone).  Details on running performance tests can be found (insert page here).  It will also dump out a mailcert file for each test set, which provides each nyms mailcert in readable format. 

if [ $# -lt 2 ] ; then
    echo "Usage: $0 <network> <basename> (no_login)"
    echo "If \"no_login\" is specified, will just dump passwd files for already created nyms"
    exit;
fi

network=$1
basename=$2
no_login=$3

num_nyms_per_set=100
basename_1k="$basename"1k
basename_8k="$basename"8k
basename_100k="$basename"100k
basename_1meg="$basename"1meg

./generate_test_nyms.exp $basename $num_nyms_per_set $network $no_login
./generate_test_nyms.exp $basename_1k $num_nyms_per_set $network $no_login
./generate_test_nyms.exp $basename_8k $num_nyms_per_set $network $no_login
./generate_test_nyms.exp $basename_100k $num_nyms_per_set $network $no_login
./generate_test_nyms.exp $basename_1meg $num_nyms_per_set $network $no_login
