#!/bin/sh


#This will substitute numeric paramaters in a given set of test nyms popbox directories to a chosen value.  Good for changing quotas or send limits for a set of test nyms.
#YOU NEED TO BE USER ALIAS IN ORDER TO RUN THIS, AND IT MUST BE RUN FROM ONE OF THE BACK-END MAIL SERVERS (nmtab,imepb or pop server)
#Paramaters you want to change for performance testing nym test sets are .quota, .send-limit and .volume-limit


if [ $# -lt 2 ] ; then

   echo "usage: ./switch_param_to <basename> <num_nyms>"
   exit

fi

basename=$1
num_nyms=$2

new_quota="400000k"
new_send_limit="100000"
new_volume_limit="400000k"

basename1k="$basename"1k
basename8k="$basename"8k
basename100k="$basename"100k
basename1meg="$basename"1meg

for name in $basename $basename1k $basename8k $basename100k $basename1meg ; do
  i=0
  while [ $i -lt $num_nyms ] ; do
    nym_name=$name$i
    echo "$nym_name"
    popbox_directory=$(/freedom/qmail/bin/frname2account /export/popmail/ $nym_name)
    if [ ! -d $popbox_directory ] ; then
      echo "No popbox directory found for nym $nym_name"
      exit
    fi
# .quota
    filename="$popbox_directory/.quota"
    if [ ! -f $filename ] ; then
      echo "File $filename does not exist"
      exit
    fi
    mv $filename $filename.old
    echo "Changing $filename to $new_quota"
    sed -e "s/^.*$/$new_quota/" $filename.old > $filename

# .send-limit
    filename="$popbox_directory/.send-limit"
    if [ ! -f $filename ] ; then
      echo "File $filename does not exist"
      exit
    fi
    mv $filename $filename.old
    echo "Changing $filename to $new_send_limit"
    sed -e "s/^.*$/$new_send_limit/" $filename.old > $filename

# .volume-limit
    filename="$popbox_directory/.volume-limit"
    if [ ! -f $filename ] ; then
      echo "File $filename does not exist"
      exit
    fi
    mv $filename $filename.old
    echo "Changing $filename to $new_volume_limit"
    sed -e "s/^.*$/$new_volume-limit/" $filename.old > $filename

    i=`expr $i + 1`
  done
done

