# $Id: quota.t,v 1.7 2000/10/04 12:57:34 marcp Exp $

#
####################
#

use strict;
use Test;

#use lib('../../lib/perl');
#use lib('../suites/t10');

use Mail_Test;
use Suite_Specific;

use Test::Case;

BEGIN { plan tests => 2 }

#
####################
#

# create user factories and empty users
my($nym_factory) = new Factory::NymFactory();
my($usr_factory) = new Factory::UserFactory();
my($s_user, $r_user);

# create connection factory and empty connections
my($conn_factory) = new Factory::ConnectionFactory();
my($connections) = {};
$connections->{SMTP} = $conn_factory->create_SMTP_connection();
$connections->{POPX} = $conn_factory->create_POPX_connection();


#
####################
#


###############################################################################
#
# Test 1 - NYM to NYM exceeding mail size limit
#
###############################################################################

sub quota_1 {

    print "\n########## NYM TO NYM (EXCEED QUOTA)\n\n";

    $s_user = $nym_factory->create_random_valid_nym();
    $r_user = $nym_factory->create_random_valid_nym();

    # create the list of senders & recipients
    my($s_users) = [ $s_user ];
    my($r_users) = [ $r_user ];

    # execute the test case
    return Test::Case::Run_TCO_Sized_Single_Mail_Message( $connections,
							  $s_user, $r_users, $s_users,
							  $r_user->quota() + int(rand(1000))
							);
}

###############################################################################
#
# Test 2 - NYM to NYM exceeding mail size limit
#
###############################################################################

sub quota_2 {

    print "\n##########  NYM TO NYM (EXCEED QUOTA)\n\n";

    $s_user = $nym_factory->create_random_valid_nym();
    $r_user = $nym_factory->create_random_valid_nym();

    # create the list of senders & recipients
    my($s_users) = [ $s_user ];
    my($r_users) = [ $r_user ];

    # execute the test case
    return Test::Case::Run_TCO_Sized_Single_Mail_Message( $connections,
							  $s_user, $r_users, $s_users,
							  $r_user->quota() + int(rand(1000))
							);

    print "\n########## NYM TO NYM (BELOW QUOTA)\n\n";

    # execute the test case
    return Test::Case::Run_TCO_Sized_Single_Mail_Message( $connections,
							  $s_user, $r_users, $r_users,
							  $r_user->quota() - int(rand(1000))
							);
}

#
####################
#

print "\n";
ok(&quota_1, 'ok');
ok(&quota_2, 'ok');
print "\n";


