
use strict;

use lib('../../lib/perl');
use lib('../suites/t10');

use Mail_Test;
use Net::RMI::Client;
use Getopt::Long;

sub usage()
{
    die("usage: $0 --host <hostname>\n");
}

my($host);
my($result) = GetOptions("host=s" => \$host);

usage() unless defined($host);

# create a new user server
my($server) = new Server::UserServer(Name => $host, Port => 6902);

# Init the client
my(@servers);
push( @servers, "localhost"  );
push( @servers, $server->name() );

my($client) = new Net::RMI::Client(@servers);

# refresh function list
$client->pollAllServers();
print "\n\n";

# grab the password for the NYM
print "Connecting to remote user servers: \n";
my($v_nym) = $client->RM_random_valid_nym(20);
my($b_nym) = $client->RM_random_bogus_nym(20);

# print the parameters
print "\n";
print "Valid NYM:\n";
foreach my $key ( keys %{$v_nym} ) {
  print $key . ": " . $v_nym->{$key} . "\n";
}

print "\n";

print "Bogus NYM:\n";
foreach my $key ( keys %{$b_nym} ) {
  print $key . ": " . $b_nym->{$key} . "\n";
}

print "\n";
