use strict;
use Net::RMI::Server;

my($function) = undef;


##############################
# create the RMI server instance
my($nymserver) = new Net::RMI::Server(Debug => 1) || 
  die "Error: could not create NYM server object\n";
#
#############################

##############################
# generate a random valid nym
#
sub random_valid_nym {
  my($nym_count) = shift || 20;
  my($nym_params) = {};

  # make a random NYM name
  my($nym_number) = int(rand( $nym_count ));
  my($nym_name) = "test_nym_" . $nym_number;

  # build the "genpasswd" command line
  my($genpasswd) = `which genpasswd`;
  chomp($genpasswd);

  # build the base nym parameters  
  $genpasswd .= " " . $nym_name;
  $nym_params->{Name} = $nym_name;
  $nym_params->{Type} = "1";

  # the username should always be encoded for NYM's
  $nym_params->{User} = `echo -n $nym_name | mimencode`;
  chomp($nym_params->{User});

  # generate a pasword valid for this network
  $nym_params->{Password} = `$genpasswd`;
  chomp($nym_params->{Password});

  # generate quota and limit entries
  $nym_params->{Mail_Size_Limit} = 2048;
  $nym_params->{Mail_Send_Limit} = 10;
  $nym_params->{Mail_Volume_Limit} = 2048;

  # return the nym
  return \%{$nym_params};
}
$function = "random_valid_nym";
$nymserver->registerFunction ($function, \&$function, [ "\$" ], "\$");
#
##############################

##############################
# generate a random bogus nym
#
sub random_bogus_nym {
  my($nym_count) = shift;
  my($nym_params) = {};

  # make a random NYM name
  # make a random NYM name
  my($nym_number) = int(rand( $nym_count ));
  my($nym_name) = "bogus_nym_" . $nym_number;

  # build the base nym parameters  
  $nym_params->{Name} = $nym_name;
  $nym_params->{Type} = "1";

  # the username should always be encoded for NYM's
  $nym_params->{User} = `echo $nym_name | mimencode`;
  chomp($nym_params->{User});

  # generate an invalid password for this network
  $nym_params->{Password} = "BOGUSPASSWORD";

  # generate quota and limit entries
  $nym_params->{Mail_Size_Limit} = 2048;
  $nym_params->{Mail_Send_Limit} = 2048;
  $nym_params->{Mail_Volume_Limit} = 2048;

  # return the nym
  return \%{$nym_params};
}
$function = "random_bogus_nym";
$nymserver->registerFunction ($function, \&$function, [ "\$" ], "\$");
#
##############################

##############################
# hello?  anybody there?
#
$nymserver->listen();
