#include <string>
#include <vector>
#include <fstream>

/* this is a simple client for sending ESMTP  mail with AUTH LOGIN style authentication */
   
void response(fstream &in, int code, const char *state) {
  char c;
  int rc;
  in >> rc;
  static char buf[256];
  in.getline(buf,256,'\n');
  if (code != rc) {
    cerr << "server died after " << state << " with: " << endl << rc << buf << endl; 
    exit(1);
  }
}

int main(int argc, char **argv) {
  string rstr;
  string crlf("\r\n");

  fstream netin(6), netout(7);  
  int rc;
  char c;

  if (argc < 4) {
    cerr << "usage: esmtpc  <envelope-to> <envelope-from> <email-body-file> [<base64ed-authuser>] [<base64ed-passwd>] " << endl;
    exit(1);
  }
  

  response(netin,220,"connect");

  if (argc == 6) {
    cerr << "AUTH LOGIN " << argv[4] << endl;
    netout << "AUTH LOGIN " << argv[4] << endl;
    response(netin,334,"AUTH LOGIN"); 
    netout << argv[5] << endl;
    cerr << argv[5] << endl;
    response(netin,235,"password");
  }

  ifstream email(argv[3]);
  if (!email) { cerr << "file " << argv[3] << " cannot be opened for reading" << endl; exit(1); }
  vector <char *> lines;
  char *buf = new char[256];  
  while(email.getline(buf,256,'\n')) {
    lines.push_back(buf);
    buf = new char[256];
  }  
  email.close();
  
  netout << "MAIL FROM:<" << argv[2] << ">" << endl;
  cerr << "MAIL FROM:<" << argv[2] << ">" << endl;
  response(netin,250,"MAIL FROM");
  netout << "RCPT TO:<" << argv[1] << ">" << endl;
  cerr << "RCPT TO:<" << argv[1] << ">" << endl;
  response(netin,250,"RCPT TO");
  netout << "DATA" << endl;
  response(netin,354,"DATA");
  for(vector<char *>::iterator i = lines.begin(); i != lines.end(); ++i)
    netout << *i << crlf;
  netout << crlf << '.' << crlf;
  netout.flush();    
  response(netin,250,"message body"); 
}
