#include <string>
#include <vector>
#include <fstream>

/* this is a simple client for logging in to a POP server */
   
void response(fstream &in, const char *state) {
  static char buf[256];
  memset (buf,0,256);
  in.getline(buf,256,'\n');
  if (buf[0] != '+') {
    cerr << "server died after " << state << " with: " << endl << buf << endl; 
    exit(1);
  }
}

int main(int argc, char **argv) {
  string rstr;
  string crlf("\r\n");

  fstream netin(6), netout(7);  
  int rc;
  char c;

  if (argc < 3) {
    cerr << "usage: popclient  <username> <base64ed-passwd>" << endl;
    exit(1);
  }
  

  response(netin,"connect");
  
  cerr << "USER " << argv[1] << endl;
  netout << "USER " << argv[1] << endl;
  response(netin,"USER");
  cerr << "PASS " << argv[2] << endl;
  netout << "PASS " << argv[2] << endl;
  response(netin,"PASS");
  cerr << "QUIT" << endl;
  netout << "QUIT" << endl;
}
