#!/usr/bin/perl -w

use strict;
use FileHandle;
use CGI;


#################
## Debug Stuff ##
#################

my $DEBUG = 0;
if ($DEBUG gt 0)
  {
    open DEBUGOUT , ">>/tmp/AddRule.log" or die ("can't write to /tmp/AddRule.log");
    DEBUGOUT->autoflush(1);
    print DEBUGOUT "\n--AddRule Starting--\n";
  }

#################
## Error Stuff ##
#################

sub ExitOnError
  {
    print "Content-Type: text/plain\n\n";
    print "ERROR\n";
    print join "\n", @_;
    exit;
  }

####################
## Get the params ##
####################

my $RULEFILE = "./AdBlocker.txt";
my $q = new CGI;

my $dataString = $q->param('data');
$dataString =~ s/\r//g;

if ($DEBUG gt 0) {print DEBUGOUT "Data:\n$dataString\n";}

if (!defined $dataString){ExitOnError("No data, Nothing to do!");}


####################
## Parse the data ##
####################

my @newRules = split "\n", $dataString;

open FIN, "$RULEFILE" or ExitOnError("Could not open $RULEFILE for read");
my @ruleFile = <FIN>;
close FIN;

my $lastLine = @ruleFile[((scalar @ruleFile) - 1)];
if ($DEBUG gt 0) {print DEBUGOUT "LastLine: $lastLine\n";}

my $lastIndex = (split "\t", $lastLine)[0];
if ($DEBUG gt 0) {print DEBUGOUT "LastIndex: \"$lastIndex\"\n";}

###############################
## Add the new lines to file ##
###############################

open FOUT, ">>$RULEFILE" or ExitOnError("Could not open $RULEFILE for append");

my $currentIndex = $lastIndex;

foreach my $lineToAdd (@newRules)
  {
    ++$currentIndex;
    print FOUT "$currentIndex\t$lineToAdd\n";
    if ($DEBUG gt 0) {print DEBUGOUT "Adding Line: \"$currentIndex\t$lineToAdd\"\n";}
  }

close FOUT;

##########################################
## Print out Success if we got this far ##
##########################################

print "Content-Type: text/plain\n\n";

print "SUCCESS\n";



##########
## DONE ##
##########

if ($DEBUG gt 0) {print DEBUGOUT "\n--AddRule Done--\n";}

