#!/usr/bin/perl -w

use strict;
use CGI;
use FileHandle;

require fr_scriptServerLib;

my $DEBUG = 0;
if ($DEBUG eq 1)
  {
    open DEBUGOUT , ">>/tmp/UpdateSince.log";
    DEBUGOUT->autoflush(1);
  }

if ($DEBUG eq 1) {print DEBUGOUT "\n--UpdateSince Starting--\n";}

my $q = new CGI;

my $lastScriptUpdate = $q->param('lastScriptUpdate');
my $lastAdUpdate = $q->param('lastAdUpdate');
my $zipIt = $q->param('zipIt');


if ($DEBUG eq 1) {print DEBUGOUT "Got param lastScriptUpdate = $lastScriptUpdate\n";}
if ($DEBUG eq 1) {print DEBUGOUT "Got param lastAdUpdate = $lastAdUpdate\n";}

my $currentScriptUpdate = fr_getDateString();

if ($DEBUG eq 1) { print DEBUGOUT "Current Update: $currentScriptUpdate\n"; }

###############################################
## Now get the list of files and their dates ##
###############################################

my @scriptListArray = split "\n", `/bin/ls ./scripts/;`;

if ($DEBUG eq 1) { print DEBUGOUT "Script List: \n". join "\n", @scriptListArray; }

my %scriptListHash;

foreach (@scriptListArray)
  {
    my ($dateString, $scriptName) = ($_, $_);
    $dateString =~ s/^.*\.txt\.(\d+)$/$1/;
    $scriptName =~ s/^(.*)\.txt\.\d+$/$1/;
    $scriptListHash{$scriptName}=$dateString;
  }

if ($DEBUG eq 1)
  {
    print DEBUGOUT "\nScript Hash List:\n";
    foreach (keys %scriptListHash)
      {
	print DEBUGOUT "$_ : $scriptListHash{$_}\n";
      }
  }

####################################################
## Now get the list of ad rules and their indices ##
####################################################

open ADBLOCKER, "./AdBlocker.txt";

my %adBlockerHash;

while (<ADBLOCKER>)
  {
    my ($indexString, $ruleString) = ($_, $_);
    $indexString =~ s/^(\d+)\t.*\n$/$1/;
    $ruleString =~ s/^\d+\t(.*)\n$/$1/;
    $adBlockerHash{$indexString}=$ruleString;
  }

close ADBLOCKER;

if ($DEBUG eq 1)
  {
    print DEBUGOUT "\nAd Hash List:\n";
    foreach (keys %adBlockerHash)
      {
	print DEBUGOUT "$_ : $adBlockerHash{$_}\n";
      }
  }

############################################
## Now time to construct the return value ##
############################################

my $returnValue;

if (defined $lastScriptUpdate)
  {
    
    $returnValue .= "---ScriptUpdate---\n\n";
    foreach (keys %scriptListHash)
      {
	if ($scriptListHash{$_} >= $lastScriptUpdate)
	  {
	    $returnValue .=  $_ . "\n\n";
	    open SCRIPTFILE, "./scripts/$_.txt.$scriptListHash{$_}";
	    while (<SCRIPTFILE>)
	      {
		$returnValue .=  $_;
	      }
	    $returnValue .= "\n";
	    close SCRIPTFILE;
	  }
      }

    $returnValue .= "---EndScriptUpdate---\n\n";
  }

my $currentAdUpdate;

sub numerically { $a <=> $b;}
if (defined $lastAdUpdate)
  {

    $returnValue .= "---AdBlockUpdate---\n";
    
    
    foreach (sort numerically keys %adBlockerHash)
      {
	if ($_ > $lastAdUpdate)
	  {
	    $returnValue .= "$adBlockerHash{$_}\n";
	  }
	$currentAdUpdate = $_;
      }

    $returnValue .= "---EndAdBlockerUpdate---\n";

  }

if ($DEBUG eq 1) {print DEBUGOUT "\nReturn String:\n$returnValue";}

####################
## Print the page ##
####################

if (defined  $returnValue)
  {


    ## Compressed?
    ## Not compressed!
    if ((defined $zipIt) and ($zipIt eq "false"))
      {
	print "Content-Type: text/plain\n\n";
	if (defined  $lastScriptUpdate){$returnValue = "thisScriptUpdate=$currentScriptUpdate\n" . $returnValue;}
	if (defined  $lastAdUpdate){$returnValue = "thisAdUpdate=$currentAdUpdate\n" . $returnValue;}
	print $returnValue;
      }
    else
      {
	print "Content-Type: text/compressed\n\n";
	if (defined  $lastScriptUpdate){$returnValue = "thisScriptUpdate=$currentScriptUpdate\n" . $returnValue;}
	if (defined  $lastAdUpdate){$returnValue = "thisAdUpdate=$currentAdUpdate\n" . $returnValue;}
	print `echo \"$returnValue\" | /usr/bin/bzip2 -zc `;
      }


  }

if ($DEBUG eq 1) {print DEBUGOUT "\n--UpdateSince Done--\n";}
