#ifndef TKSRV_DEFAULT_H
# define TKSRV_DEFAULT_H


//
// Application default configuration parameters
//
#define DEFAULT_DEBUG_MODE                           false
#define DEFAULT_VERBOSE_MODE                         false
#define DEFAULT_DAEMON_MODE                          false

#define DEFAULT_SERIAL_DB_FILENAME                   "serial.db"

#define DEFAULT_ENTITY_NAME                          "TokSrv"
#define DEFAULT_ENTITY_TYPE                          "TokSrv"

#define DEFAULT_PASSPHRASE_PROMPT                    ""
#define DEFAULT_PASSPHRASE_FILE                      ""

#define DEFAULT_PRIV_CRYPT_DIR_KEY                   "TokenServer/crypt"
#define DEFAULT_PRIV_SIG_DIR_KEY                     "TokenServer/sig"

#define DEFAULT_PRIV_CRYPT_VERSION_KEY               0
#define DEFAULT_PRIV_SIG_VERSION_KEY                 0


//
// Network default configuration parameters
//
#define DEFAULT_INET_COUNT                           20                       // uint16_t
#define DEFAULT_INET_PORT                            51201                    // uint16_t

#define DEFAULT_LOCAL_SOCKFILE                       "sockfile.sck"           // path

#define DEFAULT_INET_BACKLOG                         (SOMAXCONN)              // int
#define DEFAULT_INET_REUSEADDR_FLAG                  true                     // bool
#define DEFAULT_INET_ADDR_ANY_FLAG                   false                    // bool

#define DEFAULT_LOCAL_BACKLOG                        (SOMAXCONN)              // int
#define DEFAULT_LOCAL_REUSEADDR_FLAG                 true                     // bool

#define DEFAULT_BUFFER_LENGTH                        (64*1024)                // in bytes
#define DEFAULT_RCVBUF_LENGTH                        (DEFAULT_BUFFER_LENGTH)  // in bytes
#define DEFAULT_SNDBUF_LENGTH                        (DEFAULT_BUFFER_LENGTH)  // in bytes

#define DEFAULT_SERVER_INET_RCV_TIMEOUT              30                       // in seconds
#define DEFAULT_SERVER_INET_SND_TIMEOUT              10                       // in seconds

#define DEFAULT_SERVER_LOCAL_RCV_TIMEOUT              5                       // in seconds
#define DEFAULT_SERVER_LOCAL_SND_TIMEOUT              5                       // in seconds

#define DEFAULT_WAIT_FOR_ITERATION_TIMEOUT            1                       // in seconds


#endif /* TKSRV_DEFAULT_H */
