#ifndef TKSRV_ENGINE_H
# define TKSRV_ENGINE_H

# ifdef WIN32
#  pragma warning(disable: 4786)
# endif

# ifdef __cplusplus  

#  include "tksrv.h"
#  include "app.h"
#  include "zkstimeval.h"
#  include "event.h"
#  include "dbo.h"

#  include "zks.h" 
#  include "zkIntTypes.h"
#  include "zkIntTypes.h"

#  include <sys/time.h>
#  include <sys/types.h>
#  include <unistd.h>
#  include <string>


// ////////////////////////////////////////////////////////////////////////////
//
// Connection state machine handler
//
class Engine {
  Engine(const Engine & e);
  Engine & operator=(const Engine & e);
 public:
  Engine(Server * srv):m_srv(srv) {}
  virtual ~Engine() {}

  virtual  Event rcv();
  virtual  Event snd();
  virtual  Event timeout();

  uint16_t rcvCmd() const; // Current received command
  
 protected:
  Server * m_srv;
};


# endif /* __cplusplus */

#endif /* TKSRV_ENGINE_H */
