#define REV_ID "@(#) $Id: main.cpp,v 1.3 2001/04/23 22:41:10 alainc Exp $"
#include "zkrev.h"


#include "tksrv.h"

#include "app.h"

#include "zks.h"
#include "zksexception.h"
#include "zkslogwrap.h"
 
#include <stdlib.h>




// /////////////////////////////////////////////////////////////////////////////
// Main entry point
//
int main(int32_t argc, const char **argv)
{   
  DECL_FUNC("main");

  const char * ctx      = 0;
  int32_t      exitcode = EXIT_FAILURE;
  Application  apps;

  // Shutdown logging
  apps.init_appname(argc, argv);

  // Init logging
  CZKS::Log::init(apps.name());

  // Runtime
  try {
    try {
        ctx = "init term agent";
        CZKS::Log::setTermAgent(new CZKS::Log::TermAgent);

        ctx = "init_cmdline";
        apps.init_cmdline(argc, argv);

        ctx = "init_ini";
        apps.init_ini();

        ctx = "init_logfile";
        apps.init_logfile();

        ctx = "init_debug_status";
        apps.init_debug_status();

        ctx = "init_verbose_status";
        apps.init_verbose_status();

        ctx = "init_passphrase";
        apps.init_passphrase();

        ctx = "init_priv_keys";
        apps.init_priv_keys();

        ctx = "init_deamon_status";
        apps.init_daemon_status();

        ctx = "open databases";
        apps.open_db();

        ctx = "run";
        apps.run();

        ctx = "close database";
        apps.close_db();

        exitcode = EXIT_SUCCESS;

    } catch( ... ) {
      apps.close_db();
      CZKS::Rethrow(func, ctx);
    } 
  } catch( CZKS::Exception & e ) {
    if( e.isErrCode(ZKS_TKSRV_MOD, ZKS_TKSRV_EXIT_ERR) ) {
      exitcode = EXIT_SUCCESS;

    } else if( e.isErrCode(ZKS_TKSRV_MOD, ZKS_TKSRV_ABORT_ERR) ) {  
      exitcode = EXIT_FAILURE;      

    } else {
      CZKS::Log::error(e.zksErr());
    }
  }

  // Shutdown logging
  CZKS::Log::shutdown();
 
  return exitcode;
}

