#ifndef TKSRV_SRVADMIN_H
# define TKSRV_SRVADMIN_H

# ifdef WIN32
#  pragma warning(disable: 4786)
# endif

# ifdef __cplusplus

#  include "tksrv.h"
#  include "engine.h"
#  include "app.h"
#  include "zkstimeval.h"
#  include "event.h"
#  include "dbo.h"

#  include "zks.h"
#  include "zkIntTypes.h"
#  include "zkIntTypes.h"

#  include <sys/time.h>
#  include <sys/types.h>
#  include <unistd.h>
#  include <string>


// /////////////////////////////////////////////////////////////////////////////
//
// Request to put the daemon on hold
//
class ServerAdminHold: public Engine {
  enum State { WAIT_HOLD_REQUEST = 0,   // Wait to receive Serial number
               WAIT_HOLD_STATE,         // Wait for the daemon to be in hold state
               WAIT_SND_ANSWER,         // Wait to send and error
               DONE };
 public:
  ServerAdminHold(Server * srv);
  ~ServerAdminHold();

  Event rcv();
  Event snd();
  Event timeout();

 private:
  State       m_state;
  ZksErrCode  m_errcode;
};



// /////////////////////////////////////////////////////////////////////////////
//
// Request to put the daemon on hold
//
class ServerAdminRelease: public Engine {
  enum State { WAIT_RELEASE_REQUEST = 0,   // Wait to receive Serial number
               WAIT_SND_ANSWER,            // Wait to send and error
               DONE };
 public:
  ServerAdminRelease(Server * srv);
  ~ServerAdminRelease();

  Event rcv();
  Event snd();
  Event timeout();

 private:
  State       m_state;
  ZksErrCode  m_errcode;
};



// /////////////////////////////////////////////////////////////////////////////
//
// Request to put the daemon on hold
//
class ServerAdminStop: public Engine {
  enum State { WAIT_STOP_REQUEST = 0,   // Wait to receive Serial number
               WAIT_STOP_STATE,         // Wait for the daemon to be stop
               WAIT_SND_ANSWER,         // Wait to send and error
               DONE };

 public:
  ServerAdminStop(Server * srv);
  ~ServerAdminStop();

  Event rcv();
  Event snd();
  Event timeout();

 private:
  State       m_state;
  ZksErrCode  m_errcode;
};


# endif /* __cplusplus */

#endif /* TKSRV_SRVADMIN_H */
