#ifndef ZK_AIP_TEST_NYMCLIENT_H_
#define ZK_AIP_TEST_NYMCLIENT_H_

#include "Nym.h"
#include "TokenHandler.h"
#include "frNymClient.h"

class NymBuilder {
 public:
  NymBuilder();
  ~NymBuilder();

  void GetNym(string name,Nym & nym);
  void CreateNym     (Nym & nym, string token);
  void AddTokenToNym (Nym & nym, string token);
  void UpdateNym     (Nym & nym);
  void DisableNym    (Nym & nym);

  void UpdateServerInfo();
  string ToString();

 private:
  
  // Forbidden operators
  NymBuilder(NymBuilder &);
  NymBuilder & operator=(const NymBuilder&);
  void operator&();
  
  unsigned short NymTypeToTokenType(string nymtype);
  
  ZkError err;
  NymServer m_nymsrv;
};

#endif
