#ifndef _ZK_AIP_TEST_MODULE_EXCEPTION_H
#define _ZK_AIP_TEST_MODULE_EXCEPTION_H
/*  Program:         Test module exception.
 *  Author(s):       Troy McLelan
 *  Description:     Yes, that's a good idea.
 *  ToDo:            Lots.
 *  Known Bugs:      None.
 */

#include <map>
#include <string>
#include <errno.h>
#include <exception>
#include <list>
#include "zkError.h"


using namespace std;

namespace {
  string ERRSTR = string("ERROR ");
}
/*
 *
 */
class TestModuleException : public exception {
public:
  TestModuleException() {}
  TestModuleException(string);
  TestModuleException(ZkError, string);
  TestModuleException(int,string);
  virtual ~TestModuleException() {}
  // TestModuleException(const TestModuleException & tme) {errmsg = tme.errmsg}
  void AddScope(string);
  string what();
 protected:
  void SetMessage(string);
private:
  TestModuleException& operator=(const TestModuleException&) {assert(0); return *this;}
  void operator&() {assert(0);}
  string errmsg;
};
/*
 *  This exception represents bad parameters being passed into a method.
 */
class BadParameterException : public TestModuleException {
public:
  BadParameterException(string msg_in) {SetMessage(msg_in);}
  ~BadParameterException() {}
private:
  BadParameterException& operator=(const BadParameterException&) {assert(0); return *this;}
  void operator&() {assert(0);}
};
/*
 *  This exception handles operators that are called when they shouldn't be.
 */
class BadOperatorException : public TestModuleException {
public:
  BadOperatorException(string msg_in) {SetMessage(msg_in);}
  ~BadOperatorException() {}
private:
  BadOperatorException& operator=(const BadOperatorException&) {assert(0); return *this;}
  void operator&() {assert(0);}
};
/*
 *
 */
class EndSession : public TestModuleException {
public:
  EndSession() {}
  ~EndSession() {}
private:
};
/*
 *
 */
#endif

