#include "TestModuleHandler.h"
/*
 *  Base constructor, allocates memory for the default and help modules.  It
 *  doesn't bother with exceptions because if we fail at this point, we're
 *  done anyway.
 */
TestModuleHandler::TestModuleHandler() {

  basemod = new TestModule;
  configmod = new ConfigModule;
  tokmod = new TokenModule;
  netmod = new NetModule;
  nymmod = new NymModule;
  keymod = new KeyModule;
  testmod = new TestingModule;
  clientmod = new ClientModule;
  dhmod = new DHModule;
}
/*
 *  Cleans up all the allocated memory.
 */
TestModuleHandler::~TestModuleHandler() {
  delete basemod;
  delete configmod;
  delete tokmod;
  delete netmod;
  delete nymmod;
  delete keymod;
  delete testmod;
  delete clientmod;
  delete dhmod;
}
/*
 *  Processes all user requests.  When this function returns, the request has
 *  been handled.
 */
void TestModuleHandler::ProcessRequest(UserRequest &request) {

  try {
    basemod->HandleRequest(request);
  }
  catch (TestModuleException &tme) {
    basemod->Deactivate();
    throw;  // Rethrow this exception.
  }
}
