#ifndef _ZK_AIP_USER_REQUEST_H
#define _ZK_AIP_USER_REQUEST_H
/*  Program:         User command packager.
 *  Author(s):       Troy McLelan
 *  Description:     Yes, that's a good idea.
 *  ToDo:            Lots.
 *  Known Bugs:      None.
 */
#include "TestModuleException.h"
#include "ConfigManager.h"
#include <vector>
/*
 *  Packages up a request from the user, indexes the handler, and packages
 *  the response for return to the user.
 */
class UserRequest {
public:
  UserRequest();
  ~UserRequest() {return;}
  void SetCommand(string);
  string GetModuleName() const;
  bool IsCommandEqual(string) const;
  string GetNthToken(unsigned int);
  void SetResponse(string);
  void SetBadCommand(string);
  string GetResponse() const;
private:
  UserRequest(UserRequest &) {throw BadOperatorException("UserRequest copy");}
  UserRequest& operator=(const UserRequest&) {throw BadOperatorException("UserRequest =");}
  void operator&() {throw BadOperatorException("UserRequest &");}
  string modname, usercommand, response;
  vector<string> vs; //holds a vector of string tokens corresponding to the
                     //user command
};
#else
#warning UserRequest.h redefined.
#endif

