#include "UserSession.h"
/*
 *
 */
UserSession::UserSession() {
  welcomemsg = "AIP Test module, you must select a domain, type 'net load <domainname>'\nSelfTests are run on start up, please wait... \n";
  exitmsg = "Shutting down, goodbye\n";

  // Try to load a default config file from the user's home dir
  // Has a silent fail - might want to remove this
  cout<<welcomemsg;
  cout.flush();
  ostringstream oss;
  oss<<"config load "<<getenv("HOME")<<"/.aip-module-conf"<<endl;
  request.SetCommand(oss.str());
  modules.ProcessRequest( request);
}
/*
 *
 */
void UserSession::HandleSession() {
  ostringstream oss;
  oss<<"test self"<<endl;
  request.SetCommand(oss.str());
  modules.ProcessRequest(request);

  for (;;) {
	try {
	  WriteResponse(request);
	  ReadCommand();
	  modules.ProcessRequest(request);
    }
	catch (EndSession & es) {
	  cout<<exitmsg;
	  break;
	}
	catch (TestModuleException & tme) {
	  request.SetResponse(tme.what());
	}
  }
}
/*
 *
 */
void UserSession::ReadCommand() {

  string tempstring;
  getline(cin,tempstring);
  request.SetCommand(tempstring);

}
/*
 *
 */
void UserSession::WriteResponse(UserRequest & request) {
  string tempstring = request.GetResponse()+"\n>> ";
  cout<<tempstring;
}

int main() {
  try {
	UserSession user;
	user.HandleSession();
  }
  catch (TestModuleException &tme) {
	tme.AddScope("main()");
	cerr<<tme.what()<<"\n";
  }
}
