#ifndef _ZK_AIP_USER_SESSION_H
#define _ZK_AIP_USER_SESSION_H
/*  Program:         User session for AIP test module.
 *  Author(s):       Troy McLelan
 *  Description:     A user session wraps the connection and the interface to
 *                   the TestModuleHandler. 
 *  ToDo:            Lots.
 *  Known Bugs:      None.
 */
#include "TestModuleHandler.h"

/*
 *
 */
class UserSession {
public:
  UserSession();
  void HandleSession();
  void ReadCommand();
  void WriteResponse(UserRequest &);
private:
  UserSession(UserSession &) {throw BadOperatorException("UserSession copy");}
  UserSession& operator=(const UserSession&) {throw BadOperatorException("UserSession =");}
  void operator&() {throw BadOperatorException("UserSession &");}
  string welcomemsg, exitmsg, errormsg;
  TestModuleHandler modules;
  UserRequest request;
};
#else
#warning UserSession.h redefined.
#endif
