#!/bin/ksh

FILE=$1
MYSQL=`which mysql`

if [ "$FILE" == "" ]
then
		echo "[ERROR] usage: $0 <sql script>"
		exit 1		
fi

if [ -x "$MYSQL" ]; 
then
	if [ -r "$FILE" ];
	then
		mysql -B < $FILE
		RET=$?
		if [ "$RET" != "0" ];
		then
				echo "[ERROR] mysql failed"
				exit $RET
	  else
				exit 0
		fi
	else
		echo "[ERROR] Can find or read <" $FILE ">"
		exit 1
  fi
else
	echo "[ERROR] Can not find or execute mysql"
	exit 1
fi

