-- Create the freedom's administration database --

DROP	 DATABASE IF EXISTS freedom_admin;
CREATE DATABASE freedom_admin;

-- Use the freedom's administration database as default --

USE freedom_admin;

CREATE TABLE admin_load_state (
  filename      VARCHAR(255)            NOT NULL,
  offset        INTEGER UNSIGNED        NOT NULL,
  UNIQUE (filename)
);

CREATE TABLE nym_transition (
  date          DATETIME                NOT NULL,
  nym           VARCHAR(65)             NOT NULL,
  initiated     VARCHAR(65)             NOT NULL,
  action        VARCHAR(65)             NOT NULL,
  justification VARCHAR(255)            NOT NULL,
  result        VARCHAR(255)            NOT NULL,
  UNIQUE (date,nym)
);

CREATE TABLE nym_activity (
  date          DATETIME                NOT NULL,
  nym           VARCHAR(65)             NOT NULL,
  delta         INTEGER UNSIGNED        NOT NULL,
  mailsent      INTEGER UNSIGNED        NOT NULL,
  mailrecv      INTEGER UNSIGNED        NOT NULL,
  maildisc      INTEGER UNSIGNED        NOT NULL,
  newspost      INTEGER UNSIGNED        NOT NULL,
  newsdisc      INTEGER UNSIGNED        NOT NULL,
  UNIQUE (date,nym)
);

CREATE TABLE nym_activity_event (
  date          DATETIME                NOT NULL,
  nym           VARCHAR(65)             NOT NULL,
  mailsent      INTEGER UNSIGNED        NOT NULL,
  mailrecv      INTEGER UNSIGNED        NOT NULL,
  maildisc      INTEGER UNSIGNED        NOT NULL,
  newspost      INTEGER UNSIGNED        NOT NULL,
  newsdisc      INTEGER UNSIGNED        NOT NULL,
  UNIQUE (date,nym)
);

CREATE TABLE nym_activity_event_tmp (
  date          DATETIME                NOT NULL,
  nym           VARCHAR(65)             NOT NULL,
  mailsent      INTEGER UNSIGNED        NOT NULL,
  mailrecv      INTEGER UNSIGNED        NOT NULL,
  maildisc      INTEGER UNSIGNED        NOT NULL,
  newspost      INTEGER UNSIGNED        NOT NULL,
  newsdisc      INTEGER UNSIGNED        NOT NULL
);

CREATE TABLE mail_activity (
  date          DATETIME                NOT NULL,
  from_user     VARCHAR(65)             NOT NULL,
  to_user       VARCHAR(65)             NOT NULL,
  UNIQUE (date,from_user,to_user)
);

CREATE TABLE mail_activity_tmp (
  date          DATETIME                NOT NULL,
  from_user     VARCHAR(65)             NOT NULL,
  to_user       VARCHAR(65)             NOT NULL
);

CREATE TABLE news_activity (
  date          DATETIME                NOT NULL,
  from_user     VARCHAR(65)             NOT NULL,
  to_newsgroup  VARCHAR(255)            NOT NULL
);

CREATE TABLE aip_activity (
  date          DATETIME                NOT NULL,
  entity        VARCHAR(65)             NOT NULL,
  delta         INTEGER UNSIGNED        NOT NULL,
  uptime        INTEGER UNSIGNED        NOT NULL,
  downtime      INTEGER UNSIGNED        NOT NULL,
  bytesIn       BIGINT                  NOT NULL,
  bytesOut      BIGINT                  NOT NULL,
  bytesDrop     BIGINT                  NOT NULL,
  UNIQUE (date, entity)
);

CREATE TABLE maip_activity (
  date          DATETIME                NOT NULL,
  entity        VARCHAR(65)             NOT NULL,
  delta         INTEGER UNSIGNED        NOT NULL,
  uptime        INTEGER UNSIGNED        NOT NULL,
  downtime      INTEGER UNSIGNED        NOT NULL,
  msgsent       INTEGER UNSIGNED        NOT NULL,
  queuelength   INTEGER UNSIGNED        NOT NULL,
  UNIQUE (date, entity)
);

CREATE TABLE fmg_maip_activity (
  date          DATETIME                NOT NULL,
  entity        VARCHAR(65)             NOT NULL,
  delta         INTEGER UNSIGNED        NOT NULL,
  uptime        INTEGER UNSIGNED        NOT NULL,
  downtime      INTEGER UNSIGNED        NOT NULL,
  msgsent       INTEGER UNSIGNED        NOT NULL,
  queuelength   INTEGER UNSIGNED        NOT NULL,
  UNIQUE (date, entity)
);

CREATE TABLE aip_traffic (
  date          DATETIME                NOT NULL,
  entity        VARCHAR(65)             NOT NULL,
  kbpsIn        BIGINT                  NOT NULL,
  kbpsOut       BIGINT                  NOT NULL,
  UNIQUE (date, entity)
);
