#!/usr/bin/perl
#
# ex: dirdiff.pl -remotehost=akira --remotepath=/tmp --localpath=/tmp
#

use strict;
use Getopt::Long;

select(STDOUT); $| = 1;

my $version = '$Id: dirdiff.pl,v 1.2 2000/06/20 10:47:54 thierry Exp $';
my $revision= '$Revision: 1.2 $';
my $progname= 'dirdiff.pl';

sub ExitOnError {
    print STDERR 
        "***Error $progname $revision\n",
        "***$version\n",
        join("\n", @_),"\n";
    exit 0;
}

##
## argument parsing and checking
##

my $res;
my %optctl  = ();
my %rlist = ();
my %llist = ();

my $SSH = "/usr/local/bin/ssh";
my %Months = (
              "Jan", 1, "Feb", 2, "Mar", 3, "Apr", 4, "May", 5, "Jun", 6,
              "Jul", 7, "Aug", 8, "Sep", 9, "Oct", 10, "Nov", 11, "Dec", 12
             );

my @helpString = 
    (
     "\n\n",
     );

## Get the Options
##
$res = &GetOptions(\%optctl, 
                  "help",
                  "remotehost=s",
                  "remotepath=s",
                  "localpath=s"
                 ) || die "No can do $!";

sub getDirEntries {
  my ($cmd) = @_;
  my (@list);
  my (%list);

  open (SSH, $cmd) || 
        die "Can't get listing with $cmd: $!";

  while (<SSH>) {
    @list = split;
    $list{$list[10]} = $list[9] . "-" . $Months{$list[6]} . "-" . $list[7] 
      . " " . $list[8];
  }
  close (SSH);

  return %list;
}


# Local directories  
%llist = getDirEntries("ls -lAQ --full-time " . $optctl{"localpath"} . "|");
# Remote directories
%rlist = getDirEntries("$SSH ". $optctl{"remotehost"} . 
                " ls -lAQ --full-time " . $optctl{"remotepath"} . "|");


# Cull from the remote list, those files that you
# have locally
my($name);
foreach $name (keys %llist) {
  if (defined($rlist{$name})) {
    if ($rlist{$name} le $llist{$name}) {
      undef $rlist{$name};
    } 
  }
}

# Finally print out the files that are needed.
foreach $name (sort keys %rlist) {
  if (defined($rlist{$name})) {
    #print "$name- $rlist{$name}\n";
    print "$name\n";
  } 
}
