#!/usr/bin/perl -w

use strict;
use English;
use Getopt::Long;

require $ENV{'HOME'} . "/lib/freedomAdminLoadUtils.pl";
require $ENV{'HOME'} . "/lib/freedomAdminLoadDbUtils.pl";

my $APPNAME          = $PROGRAM_NAME;
my $FILENAME_PREEFIX = "nym_transition";
my $TABLE            = "nym_transition";

my $rejectFile = "";

## cannot be accessed because using strict
#cd $PATH; # from /lib/freedomAdminLoadUtils.pl
chdir "$ENV{'HOME'}/var/dat";

#
# argument parsing and checking
#
my $res;
my %optctl = ();

my $helpString = 
    ("Usage $APPNAME\n" .
     "\t--help                : this help\n" .
     "\t--reject   filename   : reject file name".
     "\t--prefix   hostname   : prefix to add to _nym_transition in case of multiple nym servers");

# Get the Options
$res = GetOptions(\%optctl, "help","reject=s","prefix=s") || die "Error in Getopt";

##
## print out the usage string
##
if (defined($optctl{'help'})) {
    print $helpString . "\n";
    exit 0;
}

#
# change the prefix
#
if (defined($optctl{'prefix'})) {
    $FILENAME_PREEFIX = "$optctl{'prefix'}_nym_transition";
}

#
# retrieve the reject filename
#
if (defined($optctl{'reject'})) {
  $rejectFile = $optctl{'reject'}; 
}


#
# Connect to the database
#
ConnectToDatabase() || die "$APPNAME: Can't connect to the database";

LoadFreedomAdmin($APPNAME, $FILENAME_PREEFIX, $TABLE, $rejectFile);

exit 0;
