#!/usr/bin/perl -w

use strict;
use English;
use Getopt::Long;

require $ENV{'HOME'} . "/lib/freedomAdminLoadUtils.pl";
require $ENV{'HOME'} . "/lib/freedomAdminLoadDbUtils.pl";

my $APPNAME          = $PROGRAM_NAME;
my $FILENAME_PREEFIX = "nym_activity";
my $TABLE_TMP        = "nym_activity_event_tmp";
my $TABLE            = "nym_activity_event";

my $rejectFile = "";

#
# argument parsing and checking
#
my $res;
my %optctl = ();

my $helpString = 
    ("Usage $APPNAME\n" .
     "\t--help                : this help\n" .
     "\t--reject   filename   : reject file name");

# Get the Options
$res = GetOptions(\%optctl, "help","reject=s") || die "Error in Getopt";

##
## print out the usage string
##
if (defined($optctl{'help'})) {
    print $helpString . "\n";
    exit 0;
}


#
# retrieve the reject filename
#
if (defined($optctl{'reject'})) {
  $rejectFile = $optctl{'reject'}; 
}

#
# Connect to the database
#
ConnectToDatabase() || die "$APPNAME: Can't connect to the database";

my $sqlerr;

SendSQL("DELETE from $TABLE_TMP");
	
$sqlerr = SqlErrNo();
	
if( defined($sqlerr) && ($sqlerr != 0) ) {
	die "$APPNAME: DELETE failed, " . SqlErrMsg() . ")";
}

LoadFreedomAdmin($APPNAME, $FILENAME_PREEFIX, $TABLE_TMP, $rejectFile);

SendSQL("INSERT $TABLE " .
				"SELECT date, nym, sum(mailsent), sum(mailrecv), sum(maildisc), sum(newspost), sum(newsdisc) " .
				"FROM $TABLE_TMP " .
				"GROUP BY date, nym");

if( defined($sqlerr) && ($sqlerr != 0) ) {
	die "$APPNAME: INSERT failed, " . SqlErrMsg() . ")";
}

SendSQL("DELETE from $TABLE_TMP");

exit 0;
