#!/usr/bin/perl -w

use strict;
use English;
use Getopt::Long;

require $ENV{'HOME'} . "/lib/freedomAdminLoadUtils.pl";
require $ENV{'HOME'} . "/lib/freedomAdminLoadDbUtils.pl";

my $APPNAME          = $PROGRAM_NAME;
my $FILENAME_PREEFIX = "sn_summary";
my $TABLE            = "sn_summary";

my $rejectFile = "";

#
# argument parsing and checking
#
my $res;
my %optctl = ();

my $helpString = 
    ("Usage $APPNAME\n" .
     "\t--help                : this help\n" .
     "\t--reject   filename   : reject file name");

# Get the Options
$res = GetOptions(\%optctl, "help","reject=s") || die "Error in Getopt";

##
## print out the usage string
##
if (defined($optctl{'help'})) {
    print $helpString . "\n";
    exit 0;
}


#
# retrieve the reject filename
#
if (defined($optctl{'reject'})) {
  $rejectFile = $optctl{'reject'}; 
}


#
# Connect to the database
#
ConnectToDatabase() || die "$APPNAME: Can't connect to the database";

LoadFreedomAdmin($APPNAME, $FILENAME_PREEFIX, $TABLE, $rejectFile);

exit 0;
