#!/bin/sh
#
# $Id: partner-central.sh,v 1.1 2000/03/21 19:48:49 thierry Exp $

get_home()
{
  if [ $# -ne 1 ] ; then
    fatal "get_home: bad number of arguments"
  fi
  if p=`grep "^${1}:" /etc/passwd` ; then
    echo $p | awk -F: '{print $6}'
  else
    fatal "get_home: can't find home directory for $1"
  fi
}

home=`get_home fradmin`
dumpd=$home/var/dump
MYSQLDUMP=/usr/local/bin/mysqldump
MYSQL=/usr/local/bin/mysql
SSH=/usr/local/bin/ssh
SCP=/usr/local/bin/scp
RHOST=tosh.freedom.net

if [ ! -d $dumpd ] ; then
	mkdir -p $dumpd
fi

set -x

tag=`date +%Y%m%d-%H%M`

$MYSQLDUMP --all -c --add-drop-table --full --flush-logs --opt -u fradmin \
	freedom_admin aip_activity aip_traffic > ${dumpd}/pc.${tag}.sql

if $SCP -q ${dumpd}/pc.${tag}.sql ${RHOST}:${dumpd} ; then
   if $SSH $RHOST "(cat lib/ddl/admin.ddl;cat ${dumpd}/pc.${tag}.sql) | $MYSQL -u fradmin --password='_oiTr0bY'" ; then
	:
   else
	echo "ERROR: Database load on $RHOST failed"
   fi
else
	echo "ERROR: Database download to $RHOST failed"
fi

	
