#!/usr/bin/perl -w
#
#************************************************************************
#
#   File:		fillStandardReport.pl
#
#   Author(s):		Thierry Baron
#
#   Created:		27 Jan 2000
#
#   Last Revision:	$Date: 2000/03/21 19:48:50 $
#
#   Description:	
#
#   $Revision: 1.1 $
#
#
#   $Id: fillNymsReport.pl,v 1.1 2000/03/21 19:48:50 thierry Exp $	
#
#   Copyright (c) 2000 Zero-Knowledge Systems, Inc
#   Please see the copyright notice included in this distribution 
#   for full details.
#
#***********************************************************************/

use strict;
use Mysql;


my $version = '$Id: fillNymsReport.pl,v 1.1 2000/03/21 19:48:50 thierry Exp $';
my $revision= '$Revision: 1.1 $';
my $progname= 'fillStandardReport.pl';

sub ExitOnError {
    print STDERR 
	"***Error $progname $revision\n",
	"***$version\n",
	join("\n", @_),"\n";
    exit 0;
}

##
##
## $repmon::Month
## $repmon::TotalSent
## $repmon::NymNym
## $repmon::NymInt
## $repmon::IntNym
## $repmon::mailMore20
## $repmon::mailMore10
## $repmon::mailMore5
## $repmon::mailMore1
## $repmon::mailNoPost
## $repmon::newsPosts
## $repmon::nymCount
## $repmon::nymTrial1
## $repmon::nymTrial2
## $repmon::nymPaid30
## $repmon::nymUpgraded
##
my $formToFill="/usr/fradmin/public_html/NymsReport.htm";
my $debug = 0;
my $repmon_Month="";
my $repmon_TotalSent=0;
my $repmon_NymNym=0;
my $repmon_NymInt=0;
my $repmon_IntNym=0;
my $repmon_mailMore20=0;
my $repmon_mailMore10=0;
my $repmon_mailMore5=0;
my $repmon_mailMore1=0;
my $repmon_mailNoPost=0;
my $repmon_newsPosts=0;

my $repmon_nymCount=0;
my $repmon_nymTrial1=0;
my $repmon_nymTrial2=0;
my $repmon_nymPaid30=0;
my $repmon_nymUpgraded=0;

my $repmon_nymTotalCount=0;
my $repmon_nymTotalTrial1=0;
my $repmon_nymTotalTrial2=0;
my $repmon_nymTotalPaid30=0;
my $repmon_nymTotalUpgraded=0;

##
##
##
my $modtime = scalar localtime();
my @stringDate=split(/\s+/,$modtime);
$repmon_Month=$stringDate[1];
if($debug){print "$stringDate[1]\n";}

my @numericalDate = localtime(time);
my $month=$numericalDate[4]+1;

if($debug){print "$month\n";}

#$month=12;
#$repmon_Month='Dec';

##
##
if($debug == 2){
    $repmon_TotalSent=int(rand(178458));
    $repmon_NymNym=int(rand(178458));
    $repmon_NymInt=int(rand(178458));
    $repmon_IntNym=int(rand(178458));
    $repmon_mailMore20=int(rand(178458));
    $repmon_mailMore10=int(rand(178458));
    $repmon_mailMore5=int(rand(178458));
    $repmon_mailMore1=int(rand(178458));
    $repmon_mailNoPost=int(rand(178458));

    $repmon_nymCount=int(rand(178458));
    $repmon_nymTrial1=int(rand(178458));
    $repmon_nymTrial2=int(rand(178458));
    $repmon_nymPaid30=int(rand(178458));
    $repmon_nymUpgraded=int(rand(178458));

    $repmon_nymTotalCount=int(rand(178458));
    $repmon_nymTotalTrial1=int(rand(178458));
    $repmon_nymTotalTrial2=int(rand(178458));
    $repmon_nymTotalPaid30=int(rand(178458));
    $repmon_nymTotalUpgraded=int(rand(178458));
}else{
  my $dbh = Mysql->connect("accuracy","freedom_admin","fradmin","")  || die "Can't connect to database server." ;
  $dbh->selectdb("freedom_admin");

  #################################################################################
  ##
  ## Mail Info
  ## get total mail sent
  my $sth = $dbh->query("select count(1) from mail_activity where month(date)=$month;");
  $repmon_TotalSent=  $sth->fetchrow;
  if($debug){print "<",$repmon_TotalSent,">\n";}

  ## get total mail sent Nym to Nym
  $sth = $dbh->query("select count(1) from mail_activity where month(date)=$month and from_user not like \"%@%\" and to_user not like \"%@%\";");
  $repmon_NymNym=  $sth->fetchrow;
  if($debug){print "<",$repmon_NymNym,">\n";}

  ## get total mail sent Nym to Internet
  $sth = $dbh->query("select count(1) from mail_activity where month(date)=$month and from_user not like \"%@%\" and to_user like \"%@%\";");
  $repmon_NymInt=  $sth->fetchrow;
  if($debug){print "<",$repmon_NymInt,">\n";}

  ## get total mail sent
  $sth = $dbh->query("select count(1) from mail_activity where month(date)=$month and from_user like \"%@%\";");
  $repmon_IntNym=  $sth->fetchrow;
  if($debug){print "<",$repmon_IntNym,">\n";}
  if($debug){print "Total: $repmon_TotalSent ", ($repmon_NymNym + $repmon_NymInt + $repmon_IntNym),"\n";}

  #################################################################################
  ##
  ## Mail Breakdown
  ##
  $sth = $dbh->query("select distinct nym, count(1) from nym_activity where month(date)=$month and mailsent>=20 group by nym;");
  $repmon_mailMore20 = $sth->numrows;
  if($debug){print "<",$repmon_mailMore20,">\n";}

  $sth = $dbh->query("select distinct nym, count(1) from nym_activity where month(date)=$month and mailsent>=10 group by nym;");
  $repmon_mailMore10 = $sth->numrows;
  if($debug){print "<",$repmon_mailMore10,">\n";}

  $sth = $dbh->query("select distinct nym, count(1) from nym_activity where month(date)=$month and mailsent>=5 group by nym;");
  $repmon_mailMore5 = $sth->numrows;
  if($debug){print "<",$repmon_mailMore5,">\n";}

  $sth = $dbh->query("select distinct nym, count(1) from nym_activity where month(date)=$month and mailsent>=1 group by nym;");
  $repmon_mailMore1 = $sth->numrows;
  if($debug){print "<",$repmon_mailMore1,">\n";}

  $sth = $dbh->query("select distinct nym, count(1) from nym_activity where month(date)=$month and mailsent=0 group by nym;");
  $repmon_mailNoPost = $sth->numrows;
  if($debug){print "<",$repmon_mailNoPost,">\n";}

  #################################################################################
  ##
  ## News Info
  ## get total news sent
  $sth = $dbh->query("select count(1) from news_activity where month(date)=$month;");
  $repmon_newsPosts=  $sth->fetchrow;
  if($debug){print "<",$repmon_newsPosts,">\n";}

  #################################################################################
  ##
  ## Nym Activity for the month
  $sth = $dbh->query("select count(1) from nym_transition where action='created' and month(date)=$month;");
  $repmon_nymCount = $sth->fetchrow;
  if($debug){print "<",$repmon_nymCount,">\n";}

  $sth = $dbh->query("select count(1) from nym_transition where action='created'  and justification='Token type 1' and month(date)=$month;");
  $repmon_nymTrial1 = $sth->fetchrow;
  if($debug){print "<",$repmon_nymTrial1,">\n";}

  $sth = $dbh->query("select count(1) from nym_transition where action='created' and justification='Token type 2' and month(date)=$month;");
  $repmon_nymTrial2 = $sth->fetchrow;
  if($debug){print "<",$repmon_nymTrial2,">\n";}

  $sth = $dbh->query("select count(1) from nym_transition where action='created'  and justification='Token type 30' and month(date)=$month;");
  $repmon_nymPaid30 = $sth->fetchrow;
  if($debug){print "<",$repmon_nymPaid30,">\n";}

  $sth = $dbh->query("select count(1) from nym_transition where action='upgraded'  and justification='Token type 30' and month(date)=$month;");
  $repmon_nymUpgraded = $sth->fetchrow;
  if($debug){print "<",$repmon_nymUpgraded,">\n";}


  #################################################################################
  ##
  ## Nym Activity Total
  $sth = $dbh->query("select count(1) from nym_transition where action='created';");
  $repmon_nymTotalCount = $sth->fetchrow;
  if($debug){print "<",$repmon_nymTotalCount,">\n";}

  $sth = $dbh->query("select count(1) from nym_transition where action='created'  and justification='Token type 1';");
  $repmon_nymTotalTrial1 = $sth->fetchrow;
  if($debug){print "<",$repmon_nymTotalTrial1,">\n";}

  $sth = $dbh->query("select count(1) from nym_transition where action='created' and justification='Token type 2';");
  $repmon_nymTotalTrial2 = $sth->fetchrow;
  if($debug){print "<",$repmon_nymTotalTrial2,">\n";}

  $sth = $dbh->query("select count(1) from nym_transition where action='created'  and justification='Token type 30';");
  $repmon_nymTotalPaid30 = $sth->fetchrow;
  if($debug){print "<",$repmon_nymTotalPaid30,">\n";}

  $sth = $dbh->query("select count(1) from nym_transition where action='upgraded'  and justification='Token type 30';");
  $repmon_nymTotalUpgraded = $sth->fetchrow;
  if($debug){print "<",$repmon_nymTotalUpgraded,">\n";}

}


##
##
##
my $tmp=`cat $formToFill`;

$tmp=~ s/\$repmon::Month/$repmon_Month/gi;

$tmp=~ s/\$repmon::TotalSent/$repmon_TotalSent/go;
$tmp=~ s/\$repmon::NymNym/$repmon_NymNym/go;
$tmp=~ s/\$repmon::NymInt/$repmon_NymInt/go;
$tmp=~ s/\$repmon::IntNym/$repmon_IntNym/go;

$tmp=~ s/\$repmon::mailMore20/$repmon_mailMore20/go;
$tmp=~ s/\$repmon::mailMore10/$repmon_mailMore10/go;
$tmp=~ s/\$repmon::mailMore5/$repmon_mailMore5/go;
$tmp=~ s/\$repmon::mailMore1/$repmon_mailMore1/go;
$tmp=~ s/\$repmon::mailNoPost/$repmon_mailNoPost/go;

$tmp=~ s/\$repmon::newsPosts/$repmon_newsPosts/go;

$tmp=~ s/\$repmon::nymCount/$repmon_nymCount/go;
$tmp=~ s/\$repmon::nymTrial1/$repmon_nymTrial1/go;
$tmp=~ s/\$repmon::nymTrial2/$repmon_nymTrial2/go;
$tmp=~ s/\$repmon::nymPaid30/$repmon_nymPaid30/go;
$tmp=~ s/\$repmon::nymUpgraded/$repmon_nymUpgraded/go;

$tmp=~ s/\$repmon::nymTotalCount/$repmon_nymTotalCount/go;
$tmp=~ s/\$repmon::nymTotalTrial1/$repmon_nymTotalTrial1/go;
$tmp=~ s/\$repmon::nymTotalTrial2/$repmon_nymTotalTrial2/go;
$tmp=~ s/\$repmon::nymTotalPaid30/$repmon_nymTotalPaid30/go;
$tmp=~ s/\$repmon::nymTotalUpgraded/$repmon_nymTotalUpgraded/go;

$tmp=~ s/\$repmon::reptime/$modtime/gi;

open(FDOUT,">/home/fradmin/public_html/Nyms$repmon_Month.html") || die "cannot open file /home/fradmin/public_html/Nyms$repmon_Month.html" ;
print FDOUT $tmp;
close(FDOUT);

1;

#   $Log: fillNymsReport.pl,v $
#   Revision 1.1  2000/03/21 19:48:50  thierry
#   fradmin: Repmon utilities added
#
