#!/usr/bin/perl -w
#
#************************************************************************
#
#   File:		fillStandardReport.pl
#
#   Author(s):		Thierry Baron
#
#   Created:		27 Jan 2000
#
#   Last Revision:	$Date: 2000/03/21 19:48:51 $
#
#   Description:	
#
#   $Revision: 1.1 $
#
#
#   $Id: fillRoutesReport.pl,v 1.1 2000/03/21 19:48:51 thierry Exp $	
#
#   Copyright (c) 2000 Zero-Knowledge Systems, Inc
#   Please see the copyright notice included in this distribution 
#   for full details.
#
#***********************************************************************/

use strict;
use Mysql;


my $version = '$Id: fillRoutesReport.pl,v 1.1 2000/03/21 19:48:51 thierry Exp $';
my $revision= '$Revision: 1.1 $';
my $progname= 'fillStandardReport.pl';

sub ExitOnError {
    print STDERR 
	"***Error $progname $revision\n",
	"***$version\n",
	join("\n", @_),"\n";
    exit 0;
}

##
##
##
my $listRoutesCmd = '/usr/fradmin/bin/fr_listroutes';
my $getaips = '/usr/freedom/topotools/bin/fr_getaips';
my $niqsProd = 'niqs.freedom.net';
my $niqsAlpha = 'niqs.alpha.freedom.net';

my($tmp, $tmp0, $tmp1, $tmp2);

my $formToFill="/usr/fradmin/public_html/RouteReport.htm";
my $debug = 0;
my $repmon_Month="";

my $repmon_prod_allAips;
my $repmon_prod_all2Hops;
my $repmon_prod_all2HopsZks;
my $repmon_prod_all3Hops;
my $repmon_prod_all3HopsZks;
my $repmon_prod_allSummary;

my $repmon_prod_upAips;
my $repmon_prod_up2Hops;
my $repmon_prod_up2HopsZks;
my $repmon_prod_up3Hops;
my $repmon_prod_up3HopsZks;
my $repmon_prod_upSummary;

($tmp0, $repmon_prod_allAips, $tmp1, $tmp2) = split(/\s+/, `$getaips --nodns --niqs.hostname $niqsProd | wc`);
($tmp0, $repmon_prod_all2Hops,   $tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --withDead --NHops 2 --niqs.hostname $niqsProd | wc `);
($tmp0, $repmon_prod_all2HopsZks,$tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --withDead --NHops 2 --printEnt --niqs.hostname $niqsProd | grep zks | wc `);
($tmp0, $repmon_prod_all3Hops,   $tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --withDead --NHops 3 --niqs.hostname $niqsProd | wc `);
($tmp0, $repmon_prod_all3HopsZks,$tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --withDead --NHops 3 --printEnt --niqs.hostname $niqsProd | grep zks | wc `);
$repmon_prod_allSummary = int(100 * ($repmon_prod_all2HopsZks + $repmon_prod_all3HopsZks) / ($repmon_prod_all2Hops + $repmon_prod_all3Hops) + .5);

($tmp0, $repmon_prod_upAips,  $tmp1, $tmp2) = split(/\s+/, `$getaips --nodns --long --niqs.hostname $niqsProd | grep unresolved | grep UP | wc`);
($tmp0, $repmon_prod_up2Hops,   $tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --NHops 2 --niqs.hostname $niqsProd | wc `);
($tmp0, $repmon_prod_up2HopsZks,$tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --NHops 2 --printEnt --niqs.hostname $niqsProd | grep zks | wc `);
($tmp0, $repmon_prod_up3Hops,   $tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --NHops 3 --niqs.hostname $niqsProd | wc `);
($tmp0, $repmon_prod_up3HopsZks,$tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --NHops 3 --printEnt --niqs.hostname $niqsProd | grep zks | wc `);
$repmon_prod_upSummary = int(100 * ($repmon_prod_up2HopsZks + $repmon_prod_up3HopsZks) / ($repmon_prod_up2Hops + $repmon_prod_up3Hops) + .5);

#  my $repmon_alpha_allAips;
#  my $repmon_alpha_all2Hops;
#  my $repmon_alpha_all2HopsZks;
#  my $repmon_alpha_all3Hops;
#  my $repmon_alpha_all3HopsZks;
#  my $repmon_alpha_allSummary;

#  my $repmon_alpha_upAips;
#  my $repmon_alpha_up2Hops;
#  my $repmon_alpha_up2HopsZks;
#  my $repmon_alpha_up3Hops;
#  my $repmon_alpha_up3HopsZks;
#  my $repmon_alpha_upSummary;

#  ($tmp0, $repmon_alpha_allAips, $tmp1, $tmp2) = split(/\s+/, `$getaips --nodns --niqs.hostname $niqsAlpha | wc`);
#  ($tmp0, $repmon_alpha_all2Hops,   $tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --withDead --NHops 2 --niqs.hostname $niqsAlpha | wc `);
#  ($tmp0, $repmon_alpha_all2HopsZks,$tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --withDead --NHops 2 --printEnt --niqs.hostname $niqsAlpha | grep zks | wc `);
#  ($tmp0, $repmon_alpha_all3Hops,   $tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --withDead --NHops 3 --niqs.hostname $niqsAlpha | wc `);
#  ($tmp0, $repmon_alpha_all3HopsZks,$tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --withDead --NHops 3 --printEnt --niqs.hostname $niqsAlpha | grep zks | wc `);
#  $repmon_alpha_allSummary = int(100 * ($repmon_alpha_all2HopsZks + $repmon_alpha_all3HopsZks) / ($repmon_alpha_all2Hops + $repmon_alpha_all3Hops) + .5);

#  ($tmp0, $repmon_alpha_upAips,  $tmp1, $tmp2) = split(/\s+/, `$getaips --nodns --long --niqs.hostname $niqsAlpha | grep unresolved | grep UP | wc`);
#  ($tmp0, $repmon_alpha_up2Hops,   $tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --NHops 2 --niqs.hostname $niqsAlpha | wc `);
#  ($tmp0, $repmon_alpha_up2HopsZks,$tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --NHops 2 --printEnt --niqs.hostname $niqsAlpha | grep zks | wc `);
#  ($tmp0, $repmon_alpha_up3Hops,   $tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --NHops 3 --niqs.hostname $niqsAlpha | wc `);
#  ($tmp0, $repmon_alpha_up3HopsZks,$tmp1, $tmp2) = split(/\s+/, `$listRoutesCmd --NHops 3 --printEnt --niqs.hostname $niqsAlpha | grep zks | wc `);
#  $repmon_alpha_upSummary = int(100 * ($repmon_alpha_up2HopsZks + $repmon_alpha_up3HopsZks) / ($repmon_alpha_up2Hops + $repmon_alpha_up3Hops) + .5);

##
##
##
my $modtime = scalar localtime();
my @stringDate=split(/\s+/,$modtime);
$repmon_Month=$stringDate[1];
if($debug){print "$stringDate[1]\n";}

my @numericalDate = localtime(time);
my $month=$numericalDate[4]+1;

if($debug){print "$month\n";}

#$month=12;
#$repmon_Month='Dec';

##
##
##

##
##
##
$tmp=`cat $formToFill`;

$tmp=~ s/\$repmon::Month/$repmon_Month/gi;

$tmp=~ s/\$repmon::prod::allAips/$repmon_prod_allAips/;
$tmp=~ s/\$repmon::prod::all2Hops/$repmon_prod_all2Hops/;
$tmp=~ s/\$repmon::prod::all2HopsZks/$repmon_prod_all2HopsZks/;
$tmp=~ s/\$repmon::prod::all3Hops/$repmon_prod_all3Hops/;
$tmp=~ s/\$repmon::prod::all3HopsZks/$repmon_prod_all3HopsZks/;
$tmp=~ s/\$repmon::prod::allSummary/$repmon_prod_allSummary/;

$tmp=~ s/\$repmon::prod::upAips/$repmon_prod_upAips/;
$tmp=~ s/\$repmon::prod::up2Hops/$repmon_prod_up2Hops/;
$tmp=~ s/\$repmon::prod::up2HopsZks/$repmon_prod_up2HopsZks/;
$tmp=~ s/\$repmon::prod::up3Hops/$repmon_prod_up3Hops/;
$tmp=~ s/\$repmon::prod::up3HopsZks/$repmon_prod_up3HopsZks/;
$tmp=~ s/\$repmon::prod::upSummary/$repmon_prod_upSummary/;

#  $tmp=~ s/\$repmon::alpha::allAips/$repmon_alpha_allAips/;
#  $tmp=~ s/\$repmon::alpha::all2Hops/$repmon_alpha_all2Hops/;
#  $tmp=~ s/\$repmon::alpha::all2HopsZks/$repmon_alpha_all2HopsZks/;
#  $tmp=~ s/\$repmon::alpha::all3Hops/$repmon_alpha_all3Hops/;
#  $tmp=~ s/\$repmon::alpha::all3HopsZks/$repmon_alpha_all3HopsZks/;
#  $tmp=~ s/\$repmon::alpha::allSummary/$repmon_alpha_allSummary/;

#  $tmp=~ s/\$repmon::alpha::upAips/$repmon_alpha_upAips/;
#  $tmp=~ s/\$repmon::alpha::up2Hops/$repmon_alpha_up2Hops/;
#  $tmp=~ s/\$repmon::alpha::up2HopsZks/$repmon_alpha_up2HopsZks/;
#  $tmp=~ s/\$repmon::alpha::up3Hops/$repmon_alpha_up3Hops/;
#  $tmp=~ s/\$repmon::alpha::up3HopsZks/$repmon_alpha_up3HopsZks/;
#  $tmp=~ s/\$repmon::alpha::upSummary/$repmon_alpha_upSummary/;


$tmp=~ s/\$repmon::reptime/$modtime/gi;

open(FDOUT,">/home/fradmin/public_html/Routes$repmon_Month.html") || die "cannot open file /home/fradmin/public_html/newRoutes$repmon_Month.html" ;
print FDOUT $tmp;
close(FDOUT);

1;

#   $Log: fillRoutesReport.pl,v $
#   Revision 1.1  2000/03/21 19:48:51  thierry
#   fradmin: Repmon utilities added
#
