#!/usr/bin/perl -w
#
#************************************************************************
#
#   File:		generateAllAipTraffic.pl
#
#   Author(s):		Thierry Baron
#
#   Created:		27 Jan 2000
#
#   Last Revision:	$Date: 2000/03/21 19:48:51 $
#
#   Description:	
#
#   $Revision: 1.1 $
#
#
#   $Id: generatesAllAipTraffic.pl,v 1.1 2000/03/21 19:48:51 thierry Exp $	
#
#   Copyright (c) 2000 Zero-Knowledge Systems, Inc
#   Please see the copyright notice included in this distribution 
#   for full details.
#
#***********************************************************************/

use strict;
use Mysql;

my $debug = 0;

my $version = '$Id: generatesAllAipTraffic.pl,v 1.1 2000/03/21 19:48:51 thierry Exp $';
my $revision= '$Revision: 1.1 $';
my $progname= 'generateAllAipTraffic.pl';

sub ExitOnError {
    print STDERR 
	"***Error $progname $revision\n",
	"***$version\n",
	join("\n", @_),"\n";
    exit 0;
}

select STDERR;$|=1;
select STDOUT;$|=1;

##
##

my $dbh = Mysql->connect("accuracy","freedom_admin","fradmin","")  || die "Can't connect to database server." ;
$dbh->selectdb("freedom_admin");

#################################################################################
##
## Mail Info
## get total mail sent
my $sth = $dbh->query("select distinct entity from aip_traffic;");
my @res;
if($debug){print "<<", $sth->numrows,">\n";}

my ($ind, $hour, $entity, $meanBytesIn);
my $sth2;
my @cumulBytesIn = ();
my @countEntity  = ();

for($hour=0; $hour<24; $hour++){
    $cumulBytesIn[$hour] = 0;
    $countEntity[$hour]  = 0;
}

for($ind=0; $ind<$sth->numrows; $ind++){
    
    $entity = $sth->fetchrow;
    if($debug){print "$ind: ", $entity,"\n";}
    print $entity, " ";
    for($hour=0; $hour<24; $hour++){
	my($ind2);
#	my $sth2 = $dbh->query("select * from aip_traffic where entity=\"$entity\" and month(date)=2 order by date;");

	my $sth2 = $dbh->query("select sum(bytesIn) / count(1) from aip_activity where entity=\"$entity\" and hour(date)=$hour and month(date)=2;");
	$meanBytesIn = $sth2->fetchrow;

	print $meanBytesIn, " ";
	$cumulBytesIn[$hour] += $meanBytesIn;
	$countEntity[$hour] ++;
    }
    print "\n";
    if($debug){print "\n";}
}

print "Mean ";
for($hour=0; $hour<24; $hour++){
    print $cumulBytesIn[$hour] / $countEntity[$hour], " ";
}
print "\n";

if($debug){print ">\n";}



