# $Id: Freedom.pm,v 1.2 2001/04/19 19:16:02 alainc Exp $

# package for manipulating Freedom servers. Contains information about
# Freedom specific implementations.

use strict;

package Freedom;

# package methods

sub is_mail_2_0_entity {
  my $entity = shift;
  my $freedom_mail_servers = {
                              'imep' => 1,
                              'imepb' => 1,
                              'nmta' => 1,
                              'nmtab' => 1,
                              'pop' => 1,
                              'relay' => 1,
                             };
  return defined($freedom_mail_servers->{$entity});
}

sub get_server_name_by_entity_name {
  my $entity = shift;
  my $freedom_servers = {
                         "aip" => "fraipd",
                         "fmg" => "fmg",
                         "fmgmaip"=> "fmg-maip",
                         "keyqry" => "kqd",
                         "keyupd" => "frkscpd",
                         "maip" => "frmaipd",
                         "niqs" => "frniqsd",
                         "niss" => "frnissd",
                         "nntp" => "nntpserver",
                         "nymsrv" => "frnscpd",
                         "post" => "frpostnews",
                         "replic" => "frreplicd",
                         "toksrv" => "frsnapd",
                         "lode" => "frloded",
                         'imep' => 'qmail',
                         'imepb' => 'qmail',
                         'nmta' => 'qmail',
                         'nmtab' => 'qmail',
                         'pop' => 'qmail',
                         'relay' => 'qmail',
                        };
  return $freedom_servers->{$entity};
}

sub get_mailmackey_path_by_entity {
  my $entity = shift;
  my $locations = {
		   'nymsrv' => '/usr/freedom/privkey/NymServer/mailmackey',
		   'pop' => '/usr/freedom/qmail/control/mailmackey',
		   'nmtab' => '/usr/freedom/qmail/control/mailmackey',
		   'imepb' => '/usr/freedom/qmail/control/mailmackey',
		   'nmta' => '/usr/freedom/qmail/control/mailmackey',
		   # hack --- add entry for mail servers
		   'notfree' => '/usr/freedom/qmail/control/mailmackey',
		   };

  return $locations->{$entity};
}

sub get_privkey_location_by_entity {
  my $privkey_locations = {
			   'aip' => 'AIP',
			   'coreaip' => 'AIP',
			   'fmg' => 'FMG',
			   'keyqry' => 'KeyQryServer',
			   'maip' => 'MAIP',
			   'niqs' => 'NIQSD',
			   'niss' => 'NISSD',
			   'nymsrv' => 'NymServer',
			   'toksrv' => 'TokenServer',
			   # fake entry, isn't a service but it's an entity with a key (I think?)
			   'nidb' => 'NIDB',
			   'KeyUpdServer' => 'KeyUpdServer',
			   'FrMonth' => 'FrMonth',
			  };

  my $entity = shift;
  return $privkey_locations->{$entity};
}

1;
