divert(-1)
#
# Zero Knowledge Systems Inc. 
#
# Master Config file for the Freedom Mail Gateway
#
# Luc Boulianne <luc@zks.net>
# modified: 19991114


divert(0)dnl
VERSIONID(`@(#)ZKS Freedom Mail Gateway (external) - Genesis $Revision: 1.3 $')dnl

dnl
dnl  Set your Operating system type below
dnl
OSTYPE(linux)dnl

#
# Macro defining our domain (for the Genesis template, that is)
#
D{FreedomDomain}@domain_name@
D{FreedomTrialDomain}trial.@domain_name@
#D{FreedomDomain}freedom.net
#D{FreedomTrialDomain}trial.freedom.net

# Users that should not be sent into the FMG
# Nor should they be masqueraded.
FL/etc/sendmail.cL

define(`confDOMAIN_NAME', `$w.$m')dnl
define(`confLOG_LEVEL', `4')dnl

MASQUERADE_AS(@domain_name@)dnl
FEATURE(masquerade_envelope)dnl
FEATURE(relay_entire_domain)dnl

#
# The local mail is redifed to be procmail
#
define(`LOCAL_MAILER_PATH', `/usr/bin/procmail')dnl
define(`LOCAL_MAILER_ARGS', `procmail -Y -a $h -d $u')dnl

#
# Ensure that user freedom is trusted.
#
FEATURE(accept_unresolvable_domains)dnl

MAILER(local)dnl
MAILER(smtp)dnl

Cw localhost @domain_name@
#Cw localhost freedom.net

# User freedom can play with the headers
CTfreedom 
CTroot
CTdaemon


LOCAL_RULE_0
#
# Handle mail 2 news 
#
Rmail2news @ ${FreedomTrialDomain}	$#local $:mail2news
Rmail2news < @ ${FreedomTrialDomain} >	$#local $:mail2news
Rmail2news @ ${FreedomDomain}		$#local $:mail2news
Rmail2news < @ ${FreedomDomain} >	$#local $:mail2news
#
# Special handing of mail to FMG users
#
# Local users $=L are not sent to the Freedom Domain
# These users are located in /etc/sendmail.cL (see FL above)
#
R$=L < @ ${FreedomTrialDomain} . >	$#local $: @ $1	#special local names
R$+ < @ ${FreedomTrialDomain} . >	$#local $:fmg
R$=L < @ ${FreedomDomain} . >		$#local $: @ $1	#special local names
R$+ < @ ${FreedomDomain} . >		$#local $:fmg
