divert(-1)
#
# Zero Knowledge Systems Inc. 
#
# Master Config file for Genesis' Freedom Mail Gateway 
#
# Use for developer workstations
# NOTE: The resulting sendmail.cf needs to be treated by genesis.pl
#
# Luc Boulianne <luc@zks.net>
# $Id: fmg-genesis.mc,v 1.8 2000/05/16 15:35:01 luc Exp $
#


divert(0)dnl
VERSIONID(`@(#)Zero Knowledge Freedom Mail Gateway (internal) - Genesis $Revision: 1.8 $')dnl

dnl
dnl  Set your Operating system type below
dnl
OSTYPE(linux)dnl

#
# Macro defining our domain (for the Genesis template, that is)
#
D{FreedomDomain}@domain_name@
D{FreedomTrialDomain}trial.@domain_name@

# Users that should not be processed via non-local mailers
# Nor should they be masqueraded.
FL/etc/sendmail.cL

define(`confDOMAIN_NAME', `$w.$m')dnl
#
# The local mail is redifed to be procmail
#
define(`LOCAL_MAILER_PATH', `/usr/bin/procmail')dnl
define(`LOCAL_MAILER_ARGS', `procmail -Y -a $h -d $u')dnl
#
# Dev workstation mail needs to be sent to a hub, even if
# the address is local.
#
#efine(`MAIL_HUB', `.zks.net')dnl
#
# All mail destined for the outside world, needs to 
# masquarade behind our domain. Note that the domain
# is zeroknowledge.com
#
MASQUERADE_DOMAIN(zks.net.)dnl
MASQUERADE_DOMAIN(dev.zks.net.)dnl
MASQUERADE_DOMAIN(cia.zks.net.)dnl
MASQUERADE_DOMAIN(zks.net)dnl
MASQUERADE_DOMAIN(dev.zks.net)dnl
MASQUERADE_DOMAIN(cia.zks.net)dnl
MASQUERADE_AS(zeroknowledge.com)dnl
FEATURE(limited_masquerade)dnl
FEATURE(masquerade_envelope)dnl
FEATURE(always_add_domain)dnl
#
# To deal with misconfigure hosts
#
FEATURE(accept_unresolvable_domains)dnl

#
# For local mail delivery - send it to the hub
# Note: DNS entries will likely have to be added
#
#EATURE(nullfreedomclient, mailhost.$m)dnl
#
# Standard mailers
#
MAILER(local)dnl
MAILER(smtp)dnl
define(`LOCAL_RELAY', `mailhost.zks.net')dnl
LOCAL_USER(root fmg mail2news)

### More experimentation
dnl MAILER(freedom)dnl

Cw localhost @domain_name@

# User freedom can play with the headers
CTfreedom 
CTroot
CTluc
CTdaemon

#
# Special rules to handle freedom mail
#
LOCAL_RULE_0
#
# Handle mail 2 news 
#
Rmail2news @ ${FreedomTrialDomain}		$#local $:mail2news
Rmail2news < @ ${FreedomTrialDomain} >		$#local $:mail2news
Rmail2news @ ${FreedomDomain}			$#local $:mail2news
Rmail2news < @ ${FreedomDomain} >		$#local $:mail2news
#
# Special handing of mail to FMG users
#
# Local users $=L are not sent to the Freedom Domain
# These users are located in /etc/sendmail.cL (see FL above)
#
R$=L < @ ${FreedomTrialDomain} . >		$#local $: @ $1	
R$+ < @ ${FreedomTrialDomain} . >		$#local $:fmg
R$=L < @ ${FreedomDomain} . >			$#local $: @ $1
R$+ < @ ${FreedomDomain} . >			$#local $:fmg

# Only include this for a Freedom Null Client
#R$* < @ $* > 		$#nullclient $@ $H $: $1 @ $2
#R$=L @ $M		$#local $: @ $1
#R$=L			$#local $: @ $1
#R| $+			$#local $: | $1
#R$-			$#nullclient $@ $H $: $1 @ $M
#R$+			$#nullclient $@ $H $: $1

LOCAL_RULE_3

R$=E			$@ $1 < @ $j >		leave exposed
R$=L			$@ $1
R$* < @ $=M >		$@ $1 < @ $M >
R$- 			$: $(dequote $1 $) < @ *LOCAL* >	dequote "foo"
R$-			$@ $1 < @ $M >
