#!/bin/sh 
#
# Quick script to install a network
#
usage () {
    echo "$0 [--config configfile] [--dbconfig dbconfigfile] [-hosts list-of-hosts]"
    exit
}

LIST="afs1.syslab.freedom.net \
      afs2.syslab.freedom.net \
      afs3.syslab.freedom.net \
      afs4.syslab.freedom.net \
      jesus.syslab.freedom.net \
      faith.syslab.freedom.net \
      truth.syslab.freedom.net \
      temperance.pray.freedom.net";

clean=""
while  [ $# -gt 0 ] ; do
    case "$1" in
    --config)
	shift; ZKGEN_CONFIG=$1; export  ZKGEN_DBCONFIG
	;;
    --dbconfig)
	shift; ZKGEN_DBCONFIG=$1; export ZKGEN_DBCONFIG
	;;
    --clean)
        clean=$1
	;;
    --hosts)
	shift;
        LIST=$*
	;;
    --help)
        usage
	;;
    *)
	echo "* Error: unknown parameter[$1]"
	usage
	;;
    esac
    shift;
done

if /bin/true ; then   # Lazy way of commenting out parts for testing.
    echo "* Installing freedom on [$LIST]"
    for name in $LIST ; do 
	genesis-bootstrap.sh --dest $name \
	    --network alpha --repository-url http://sysdev.dev.zks.net/genesis-mig/ $clean --ssh-proxy tristan.cia.zks.net
	exit
    done
else
    for name in newattack.syslab.freedom.net ; do 
	genesis-bootstrap.sh --dest $name \
	    --network alpha --ssh-prog ssh1 --scp-prog scp1 --repository-url http://sysdev.dev.zks.net/genesis-mig/ $clean --ssh-proxy tristan.cia.zks.net
    done
	    
fi
