#!/bin/sh 
#
# Quick script to install a network
#
# Luc Boulianne <luc@zks.net>
#
usage () {
    echo "$0 [--install] [--start] [--stop] [--sngen] [--timesync] [--testssh]"
    exit
}


VERSION=1.3
CUR_VERS=`wget -q http://akira.dev.zks.net/genesis/vers.cgi -O -`

#if [ x$CUR_VERS != x$VERSION ] ; then 
#    echo "** ERROR: Script out of date running v$VERSION latest v$CUR_VERS"
#    echo "** Please download the latest \`do_$NETWORK.sh' and \`genesis-bootstrap.sh' scripts"
#    exit
#fi



#LIST="spam1.eg.zks.net spam2.eg.zks.net spam3.eg.zks.net"
LIST="spam2.eg.zks.net spam3.eg.zks.net"
#SOL="fishbowl.dev.zks.net"
SOL=""

NETWORK=spam
DOMAIN=spam.zks.net


clean=""
Install="no";
Start="no";
Status="no";
Stop="no";
TimeSync="no";
SNGen="no";
TestSSH="no";

while [ $# -gt 0 ] ; do
    case "$1" in
    --config)
	shift; ZKGEN_CONFIG=$1; export  ZKGEN_DBCONFIG
	;;
    --dbconfig)
	shift; ZKGEN_DBCONFIG=$1; export ZKGEN_DBCONFIG
	;;
    --clean)
        clean=$1
	;;
    --testssh)
        TestSSH="yes";
	;;
    --timesync)
        TimeSync="yes";
	;;
    --install)
        Install="yes";
	;;
    --start)
	Start="yes";
	;;
    --status)
	Status="yes";
	;;
    --sngen)
	SNGen="yes";
	;;
    --stop)
	Stop="yes";
	;;
    --help)
        usage
	;;
    *)
	echo "* Error: unknown parameter[$1]"
	usage
	;;
    esac
    shift;
done

msg () {

    echo "[***]"
    echo "[***] $*"
    echo "[***]"

}    

frame () {

    printf "+-----[%-17s]------\n" $1
    sed 's/^/| /'
    printf "+------------------------------\n\n" $1

}    


if [ $TestSSH = "yes" ] ; then 
    msg "Testing SSH"
    for name in $SOL ; do 
	printf "%-30s: " $name
	ssh1 -x root@$name "hostname; sleep 1"
    done
    for name in $LIST; do 
	printf "%-30s: " $name
	ssh1 -x root@$name "hostname; sleep 1"
    done
elif [ $TimeSync = "yes" ] ; then 
    msg "Syncing time."
    for name in $SOL ; do 
    	#ssh1 -x -R37:caesar.zks.net:37 root@$name "hostname; rdate -s localhost ; sleep 1"
	/bin/true
    done
    for name in $LIST; do 
	ssh1 -x -R37:caesar.zks.net:37 root@$name "hostname; rdate -s localhost; sleep 5"
    done
elif [ $Install = "yes" ] ; then 
    msg "Proceeding with Installation"

    echo "* Installing freedom on [$SOL]"
    for name in $SOL ; do 
	echo "[***] $name"
	genesis-bootstrap.sh --dest $name \
	    --network $NETWORK --ssh-prog ssh1 --scp-prog scp1 --repository-url http://sysdev.dev.zks.net/genesis-mig/ $clean
    done
    echo "* Installing freedom on [$LIST $MAIL_LIST $CORE_AIP]"
    for name in $LIST; do 
	echo "[***] $name"
	genesis-bootstrap.sh --dest ${name} \
	    --network $NETWORK --ssh-prog ssh1 --scp-prog scp1 --repository-url http://sysdev.dev.zks.net/genesis-mig/ $clean
	sleep 5
    done

elif [ $SNGen = "yes" ] ; then 
    msg "Generating Serial Numbers"
    genesis-sngen.sh --toksrv host1.$NETWORK.zks.net --network $NETWORK \
    	--url http://afs6.freedom.net/update/ --numsets 2  $clean --ssh1

elif [ $Start = "yes" ] ; then 
    msg "Starting Services"
    echo "* Starting freedom on [$LIST]"
    for name in $LIST ; do 
	genesis-bootstrap.sh --dest ${name} \
	    --network $NETWORK --ssh-prog ssh1 --scp-prog scp1 --repository-url http://sysdev.dev.zks.net/genesis-mig/ $clean --start
    done

elif [ $Stop = "yes" ] ; then 
    msg "Stopping Services"
    echo "* SOLARIS SERVERS not affected by this command"

    echo "* Stopping freedom on [$LIST]"
    for name in $LIST; do 
	genesis-bootstrap.sh --dest ${name} \
	    --network $NETWORK --ssh-prog ssh1 --scp-prog scp1 --repository-url http://sysdev.dev.zks.net/genesis-mig/ $clean --stop
    done

elif [ $Status = "yes" ] ; then 
    msg "Getting process status"
    for name in $SOL ; do 
	ssh1 -x root@$name "printf '[%s]\n' `hostname` ; ps -aef | grep $NETWORK | grep -v grep ; sleep 1" | frame $name 2>&1
    done
    for name in $LIST ; do 
	ssh1 -x root@$name "printf '[%s]\n' \`hostname\` ; ps agxfw | grep freedom | egrep -v '(grep|su|agxf)'  ; sleep 1" | frame $name 2>&1
    done

fi

