#!/bin/sh 
#
# $Id: gen-sn.sh,v 1.6 2001/04/23 17:33:27 alainc Exp $
# Luc Boulianne <luc@zks.net>
#
#

usage () {
    echo "Usage: $0: genhome --home homedir --network netname -numsets numserno" 1>&2
    echo "  ex: $0 --home `pwd` --network zeta --numsets 10 " 1>&2
    exit;
}

home="";net="";gensets="";

while  [ $# -gt 0 ] ; do
    case "$1" in
    --home)
	# this is the remote end of the script
	shift; home=$1
	;;
    --network)
	shift; net=$1
	;;
    --numsets)
	shift; gensets=$1;
	;;
    *|--help)
	usage
	exit
	;;
    esac
    shift;
done

SNGEN="$home/frbin/sngen-v1.0h";
DBDIR="$home/var/";
ODIR="$home/var/serno-lists";

activate=`date +%Y%m%d`
_tag=`date +%Y%m%d-%H%M`
tdb=$DBDIR/generated-sernos.db

mkdir -p $ODIR 
mkdir -p $DBDIR

cp /dev/null $tdb

#echo "# Generating serial numbers";
cat <<EOT | while read type snid typeid ntok sets
standard        500   30 5 500
trial             0    1 3 20 
type2           501   31 5 500
type3_create    502   32 3 500
type3_extend    503   33 1 50
1x1_year_repl  1500   30 1 10
5x1_year_repl  1501   30 5 10
3x1_month_repl 1502   50 3 10
1x1_month_repl 1503   50 1 10
1d_trial        399   51 3 20
1d_standard     900   80 5 25
1d_type2        901   81 5 25
1d_type3_create 902   82 3 25
1d_type3_extend 903   83 1 25
1d_1x1_year_repl  1550   80 1 5
1d_5x1_year_repl  1551   80 5 5
1d_3x1_month_repl 1552   99 3 5
1d_1x1_month_repl 1553   99 1 5
EOT
do
    generate=`expr $gensets '*' $sets`
    echo "Generating $gensets * $sets = $generate serial numbers of type $snid" 1>&2
    if [ $generate -gt 25000 ] ; then 
	echo "# too many serial numbers ($generate) requested to be generated." 1>&2 
	exit 2
    fi
    arg="--snlist $tdb --logfile /tmp/s.log \
        --out $ODIR/serno-test-$type-$_tag \
	--activate ${activate}T000000Z \
        --generate $generate \
        --typeid  $typeid \
        --snid  $snid \
        --tokens $ntok"
    if res=`$SNGEN $arg`  ; then
	# Return code is wrong...
	echo "# unable to generate [$type] serial numbers into the token database" 1>&2 
	echo $res
	exit 2
    else
	echo "$ODIR/serno-test-$type-$_tag"
    fi
done

