#!/bin/sh -eu
#
# $Id: genesis-confsub-dbs.sh,v 1.10 2001/04/23 17:33:11 alainc Exp $
#
# fr_confsubst_dbs - Perform configuration substitutions
# for INTERNAL database configurations and database server configuration
#
# Only remote access databases need config at the moment
#
# Copyright (c) 1998-2000, Zero-Knowledge Systems Inc. All Rights Reserved.
#
PATH=/sbin:/usr/sbin:/bin:/usr/bin:/usr/ucb:$PATH
export PATH

if [ $# -eq 2 ]; then
	inputfile=$1
	outputfile=$2
else
	echo 1>&2 "Usage: $0 <inputfile> <outputfile>"
	exit 1
fi
zkfr_root=${zkfr_root:-/freedom}; export zkfr_root;
zkfr_Database_Access=${zkfr_Database_Access:-${zkfr_root}/etc/db/access.conf}; export zkfr_Database_Access;
zkfr_PubkeyDB_Server=${zkfr_PubkeyDB_Server:-pkdb.test.freedom.net:51132}; export zkfr_PubkeyDB_Server;
zkfr_PubkeyDB_ServerPort=${zkfr_PubkeyDB_ServerPort:-51132}; export zkfr_PubkeyDB_ServerPort;
zkfr_PubkeyDB_AuthKey=${zkfr_PubkeyDB_AuthKey:-Az=H.Y33}; export zkfr_PubkeyDB_AuthKey;
zkfr_PubkeyDB_kqd_Server=${zkfr_PubkeyDB_kqd_Server:-pkdb.test.freedom.net:51131}; export zkfr_PubkeyDB_kqd_Server;
zkfr_PubkeyDB_kqd_ServerPort=${zkfr_PubkeyDB_kqd_ServerPort:-51131}; export zkfr_PubkeyDB_kqd_ServerPort;
zkfr_PubkeyDB_kqd_AuthKey=${zkfr_PubkeyDB_kqd_AuthKey:-Az=H.Y33}; export zkfr_PubkeyDB_kqd_AuthKey;
zkfr_PubkeyDB_Nuked_Server=${zkfr_PubkeyDB_Nuked_Server:-kdb.test.freedom.net:51133}; export zkfr_PubkeyDB_Nuked_Server;
zkfr_PubkeyDB_Nuked_ServerPort=${zkfr_PubkeyDB_Nuked_ServerPort:-51133}; export zkfr_PubkeyDB_Nuked_ServerPort;
zkfr_PubkeyDB_Nuked_AuthKey=${zkfr_PubkeyDB_Nuked_AuthKey:-Az=H.Y33}; export zkfr_PubkeyDB_Nuked_AuthKey;
zkfr_NymsDatabase_Server=${zkfr_NymsDatabase_Server:-kdb.test.freedom.net:51134}; export zkfr_NymsDatabase_Server;
zkfr_NymsDatabase_ServerPort=${zkfr_NymsDatabase_ServerPort:-1134}; export zkfr_NymsDatabase_ServerPort;
zkfr_NymsDatabase_AuthKey=${zkfr_NymsDatabase_AuthKey:-Az=H.Y33}; export zkfr_NymsDatabase_AuthKey;
zkfr_NymsDatabase_Nuked_Server=${zkfr_NymsDatabase_Nuked_Server:-kdb.test.freedom.net:51135}; export zkfr_NymsDatabase_Nuked_Server;
zkfr_NymsDatabase_Nuked_ServerPort=${zkfr_NymsDatabase_Nuked_ServerPort:-51135}; export zkfr_NymsDatabase_Nuked_ServerPort;
zkfr_NymsDatabase_Nuked_AuthKey=${zkfr_NymsDatabase_Nuked_AuthKey:-Az=H.Y33}; export zkfr_NymsDatabase_Nuked_AuthKey;
zkfr_SpentTokenDB_Server=${zkfr_SpentTokenDB_Server:-kdb.test.freedom.net:51136}; export zkfr_SpentTokenDB_Server;
zkfr_SpentTokenDB_ServerPort=${zkfr_SpentTokenDB_ServerPort:-51136}; export zkfr_SpentTokenDB_ServerPort;
zkfr_SpentTokenDB_AuthKey=${zkfr_SpentTokenDB_AuthKey:-Az=H.Y33}; export zkfr_SpentTokenDB_AuthKey;
zkfr_NymCache_Server=${zkfr_NymCache_Server:-kdb.test.freedom.net:51137}; export zkfr_NymCache_Server;
zkfr_NymCache_ServerPort=${zkfr_NymCache_ServerPort:-51137}; export zkfr_NymCache_ServerPort;
zkfr_NymCache_AuthKey=${zkfr_NymCache_AuthKey:-Az=H.Y33}; export zkfr_NymCache_AuthKey;
zkfr_MailStatDB_Server=${zkfr_MailStatDB_Server:-kdb.test.freedom.net:51138}; export zkfr_MailStatDB_Server;
zkfr_MailStatDB_ServerPort=${zkfr_MailStatDB_ServerPort:-51138}; export zkfr_MailStatDB_ServerPort;
zkfr_MailStatDB_AuthKey=${zkfr_MailStatDB_AuthKey:-Az=H.Y33}; export zkfr_MailStatDB_AuthKey;
zkfr_NymBlockDB_Server=${zkfr_NymBlockDB_Server:-kdb.test.freedom.net:51139}; export zkfr_NymBlockDB_Server;
zkfr_NymBlockDB_ServerPort=${zkfr_NymBlockDB_ServerPort:-51139}; export zkfr_NymBlockDB_ServerPort;
zkfr_NymBlockDB_AuthKey=${zkfr_NymBlockDB_AuthKey:-Az=H.Y33}; export zkfr_NymBlockDB_AuthKey;

if [ "x$GEN_DEBUG" = "x1" ] ; then

 echo "[debug] zkfr_root=${zkfr_root}" 1>&2
 echo "[debug] zkfr_Database_Access=${zkfr_Database_Access}" 1>&2
 echo "[debug] zkfr_PubkeyDB_Server=${zkfr_PubkeyDB_Server}" 1>&2
 echo "[debug] zkfr_PubkeyDB_ServerPort=${zkfr_PubkeyDB_ServerPort}" 1>&2
 echo "[debug] zkfr_PubkeyDB_AuthKey=${zkfr_PubkeyDB_AuthKey}" 1>&2
 echo "[debug] zkfr_PubkeyDB_kqd_Server=${zkfr_PubkeyDB_kqd_Server}" 1>&2
 echo "[debug] zkfr_PubkeyDB_kqd_ServerPort=${zkfr_PubkeyDB_kqd_ServerPort}" 1>&2
 echo "[debug] zkfr_PubkeyDB_kqd_AuthKey=${zkfr_PubkeyDB_kqd_AuthKey}" 1>&2
 echo "[debug] zkfr_PubkeyDB_Nuked_Server=${zkfr_PubkeyDB_Nuked_Server}" 1>&2
 echo "[debug] zkfr_PubkeyDB_Nuked_ServerPort=${zkfr_PubkeyDB_Nuked_ServerPort}" 1>&2
 echo "[debug] zkfr_PubkeyDB_Nuked_AuthKey=${zkfr_PubkeyDB_Nuked_AuthKey}" 1>&2
 echo "[debug] zkfr_NymsDatabase_Server=${zkfr_NymsDatabase_Server}" 1>&2
 echo "[debug] zkfr_NymsDatabase_ServerPort=${zkfr_NymsDatabase_ServerPort}" 1>&2
 echo "[debug] zkfr_NymsDatabase_AuthKey=${zkfr_NymsDatabase_AuthKey}" 1>&2
 echo "[debug] zkfr_NymsDatabase_Nuked_Server=${zkfr_NymsDatabase_Nuked_Server}" 1>&2
 echo "[debug] zkfr_NymsDatabase_Nuked_ServerPort=${zkfr_NymsDatabase_Nuked_ServerPort}" 1>&2
 echo "[debug] zkfr_NymsDatabase_Nuked_AuthKey=${zkfr_NymsDatabase_Nuked_AuthKey}" 1>&2
 echo "[debug] zkfr_SpentTokenDB_Server=${zkfr_SpentTokenDB_Server}" 1>&2
 echo "[debug] zkfr_SpentTokenDB_ServerPort=${zkfr_SpentTokenDB_ServerPort}" 1>&2
 echo "[debug] zkfr_SpentTokenDB_AuthKey=${zkfr_SpentTokenDB_AuthKey}" 1>&2
 echo "[debug] zkfr_NymCache_Server=${zkfr_NymCache_Server}" 1>&2
 echo "[debug] zkfr_NymCache_ServerPort=${zkfr_NymCache_ServerPort}" 1>&2
 echo "[debug] zkfr_NymCache_AuthKey=${zkfr_NymCache_AuthKey}" 1>&2
 echo "[debug] zkfr_MailStatDB_Server=${zkfr_MailStatDB_Server}" 1>&2
 echo "[debug] zkfr_MailStatDB_ServerPort=${zkfr_MailStatDB_ServerPort}" 1>&2
 echo "[debug] zkfr_MailStatDB_AuthKey=${zkfr_MailStatDB_AuthKey}" 1>&2
 echo "[debug] zkfr_NymBlockDB_Server=${zkfr_NymBlockDB_Server}" 1>&2
 echo "[debug] zkfr_NymBlockDB_ServerPort=${zkfr_NymBlockDB_ServerPort}" 1>&2
 echo "[debug] zkfr_NymBlockDB_AuthKey=${zkfr_NymBlockDB_AuthKey}" 1>&2

 echo "[debug] input=${inputfile}  output=${outputfile}" 1>&2

fi

sed < ${inputfile} > ${outputfile} \
	-e "s;@zkfr_root@;${zkfr_root};"                                      \
	-e "s;@zkfr_Database_Access@;${zkfr_Database_Access};"                \
                                                                              \
	-e "s;@zkfr_PubkeyDB_Server@;${zkfr_PubkeyDB_Server};"                \
	-e "s;@zkfr_PubkeyDB_ServerPort@;${zkfr_PubkeyDB_ServerPort};"        \
	-e "s;@zkfr_PubkeyDB_AuthKey@;${zkfr_PubkeyDB_AuthKey};"              \
                                                                              \
	-e "s;@zkfr_PubkeyDB_kqd_Server@;${zkfr_PubkeyDB_kqd_Server};"                \
	-e "s;@zkfr_PubkeyDB_kqd_ServerPort@;${zkfr_PubkeyDB_kqd_ServerPort};"        \
	-e "s;@zkfr_PubkeyDB_kqd_AuthKey@;${zkfr_PubkeyDB_kqd_AuthKey};"              \
										      \
	-e "s;@zkfr_PubkeyDB_Nuked_Server@;${zkfr_PubkeyDB_Nuked_Server};"          \
	-e "s;@zkfr_PubkeyDB_Nuked_ServerPort@;${zkfr_PubkeyDB_Nuked_ServerPort};"  \
	-e "s;@zkfr_PubkeyDB_Nuked_AuthKey@;${zkfr_PubkeyDB_Nuked_AuthKey};"        \
                                                                              \
	-e "s;@zkfr_NymsDatabase_Server@;${zkfr_NymsDatabase_Server};"            \
	-e "s;@zkfr_NymsDatabase_ServerPort@;${zkfr_NymsDatabase_ServerPort};"    \
	-e "s;@zkfr_NymsDatabase_AuthKey@;${zkfr_NymsDatabase_AuthKey};"          \
                                                                              \
	-e "s;@zkfr_NymsDatabase_Nuked_Server@;${zkfr_NymsDatabase_Nuked_Server};"      \
	-e "s;@zkfr_NymsDatabase_Nuked_ServerPort@;${zkfr_NymsDatabase_Nuked_ServerPort};" \
	-e "s;@zkfr_NymsDatabase_Nuked_AuthKey@;${zkfr_NymsDatabase_Nuked_AuthKey};"    \
                                                                              \
	-e "s;@zkfr_SpentTokenDB_Server@;${zkfr_SpentTokenDB_Server};"            \
	-e "s;@zkfr_SpentTokenDB_ServerPort@;${zkfr_SpentTokenDB_ServerPort};"    \
	-e "s;@zkfr_SpentTokenDB_AuthKey@;${zkfr_SpentTokenDB_AuthKey};"          \
                                                                              \
	-e "s;@zkfr_NymCache_Server@;${zkfr_NymCache_Server};"                \
	-e "s;@zkfr_NymCache_ServerPort@;${zkfr_NymCache_ServerPort};"            \
	-e "s;@zkfr_NymCache_AuthKey@;${zkfr_NymCache_AuthKey};"                  \
                                                                              \
	-e "s;@zkfr_MailStatDB_Server@;${zkfr_MailStatDB_Server};"              \
	-e "s;@zkfr_MailStatDB_ServerPort@;${zkfr_MailStatDB_ServerPort};"        \
	-e "s;@zkfr_MailStatDB_AuthKey@;${zkfr_MailStatDB_AuthKey};"              \
                                                                              \
	-e "s;@zkfr_NymBlockDB_Server@;${zkfr_NymBlockDB_Server};"              \
	-e "s;@zkfr_NymBlockDB_ServerPort@;${zkfr_NymBlockDB_ServerPort};"       \
	-e "s;@zkfr_NymBlockDB_AuthKey@;${zkfr_NymBlockDB_AuthKey};"             \
	-e "s?/freedom/?${zkfr_root}/?"
