#!/bin/bash
#
# Genesis Test Network 
# DB Client Configuration Utility
#
# $Id: genesis-confsub.sh,v 1.15 2001/05/02 19:01:51 francisk Exp $
# Luc Boulianne <luc@zks.net>
# Zero-Knowledge Systems Inc.
#
# $1 - entityname
# $2 - wormhole address (AIP 1.0) |  niqs hostname (AIP 2.0)

#function debug () {
#   #echo "[debug] $*" 1>&2
#}

function advise () {
   echo "[#] $*" 1>&2
}

cd /usr/freedom/etc
mkdir OLD

for file in freedom*.conf.tmpl ; do
  if [ -f $file -a \! -L $file ] ; then
	conf=`echo $file | sed s/.tmpl//`
	/freedom/sbin/fr_confsubst $file $conf $1 $2
	cp $conf /tmp/$file-$$
	if [ -f /freedom/sbin/fr_confsubst_knt ] ; then 
		/freedom/sbin/fr_confsubst_knt /tmp/$file-$$ $conf
		cp $conf /tmp/$file-$$
	fi
	if [ -f /freedom/sbin/fr_confsubst_fmg ] ; then 
		/freedom/sbin/fr_confsubst_fmg /tmp/$file-$$ $conf
		cp $conf /tmp/$file-$$
	fi
	/bin/rm /tmp/$file-$$
	cp $conf OLD/
	# AIP 2.0 Hack:
	# template 'freedom.aip.conf.tmpl' generates 'freedom.aip.conf'
	# but also needs 'freedom.conf'
	if [ "$file" = "freedom.aip.conf.tmpl" ]; then
	    cp -f freedom.conf OLD/
	    /freedom/sbin/fr_confsubst OLD/freedom.conf freedom.conf $1 $2
	fi
  fi
done

cd /usr/freedom/etc/db
mkdir OLD

for file in freedom*.conf.tmpl ; do
  if [ -f $file -a \! -L $file ] ; then
	conf=`echo $file | sed s/.tmpl//`
	/freedom/sbin/fr_confsubst_db $file $conf $1 $2
	cp $conf OLD/
  fi
done

if [ -r /usr/freedom/etc/freedom-nidb.conf ] ; then 
  cacheDataVersion=`date +%Y%m%d`;
  ed /freedom/etc/freedom-nidb.conf <<EOC
1
/^cacheDataVersion/
s/=.*\$/= $cacheDataVersion/p
1
/ StatServer /
/^Port/
s/51113/51123/p
w
w
q
EOC
fi
#
#
if [ "x$ZK_NETWORK" = "x" ] ; then 
   advise "ERROR: \$ZK_NETWORK has not been set"
   exit 2;
fi

cd /usr/freedom/etc ;
echo "[!] Adjusting $ZK_OLDNETWORK to $ZK_NETWORK" 1>&2;

cmd="s/${ZK_OLDNETWORK}/${ZK_NETWORK}/"
#echo "[debug] $cmd" 1>&2;

a=`ls freedom*.conf`

for file in $a ; do
    #echo "[debug] Inspecting $file" 1>&2;
    if [ "x$file" = "xtokentypeid.conf" \
	-o "x$file" = "xclientinfo.conf" \
	-o "x$file" = "xfreedom-access.conf" ] 
    then
	:
	#echo "[debug] NOT Adjusting $file" 1>&2;
    else
	if [ -f $file -a ! -L $file ] ; then
	    #echo "[debug] Adjusting $file" 1>&2;
	    sed "$cmd" $file > /tmp/$$
	    grep $ZK_NETWORK /tmp/$$ 1>&@
	    cp /tmp/$$ $file
	    rm /tmp/$$
        fi
     fi
done

# Bug 5915
if [ -e tokentypeid.conf -a -e tokentypeid.conf.test ] ; then
    cat tokentypeid.conf.test >> tokentypeid.conf
fi
 	     
chown -R freedom /usr/freedom/etc
#grep freedom.net *.conf | grep -v $ZK_NETWORK 1>&2

