#!/bin/sh 
#
# $Id: genesis-rem-sngen.sh,v 1.6 2001/04/23 17:33:11 alainc Exp $
# Luc Boulianne <luc@zks.net>
#
#

if [ $# -lt 3 ] ; then
    echo "Usage: $0: genhome scalperhome testnetname numserno"
    echo "  $0: /home/scalper zeta 2000"
    exit;
fi

home=$1;
net=$2;
gensets=$3;

if [ "x$generate" = "x" ] ; then
    generate=200;
fi

SNGEN="$home/frbin/sngen-v1.0h";
SCALPER="$home/public_html/scalper/scalper-i386.cgi";
ODIR="$home/var/serno-lists";

activate=`date +%Y%m%d`
_tag=`date +%Y%m%d-%H%M`
tdb=/$home/var/db/generated-sernos.db


cp /dev/null $tdb

echo "# Destroying old serial numbers";
#/bin/rm -f $home/db/serialnumberdb/serialnumberdb/*
/bin/rm -f $home/var/db/scalper.$net/*
echo "# Generating serial numbers";
cat <<EOT | while read type snid typeid ntok sets
trial             0    1 3 20 
standard        500   30 5 100
type2           501   31 5 50
type3_create    502   32 5 50
type3_extend    503   33 1 50
1d_trial        399   51 3 10
1d_standard     900   80 5 10
1d_type2        901   81 5 10
1d_type3_create 902   82 5 10
1d_type3_extend 903   83 1 10
EOT
do
    generate=`expr $gensets '*' $sets`
    echo "Generating $gensets * $sets = $generate serial numbers of type $snid"
    if $SNGEN --snlist $tdb --logfile /tmp/s.log \
        --out $ODIR/serno-test-$type-$_tag \
	--activate ${activate}T000000Z \
        --generate $generate \
        --typeid  $typeid \
        --snid  $snid \
        --tokens $ntok ; then
	echo "# unable to generate [$type] serial numbers into the token database"
    else
	if [ ! -d $home/var/db/scalper.${net}-${snid} ] ; then 
	    mkdir -p $home/var/db/scalper.${net}-${snid}
	    chmod -R ugo+rw $home/var/db/scalper.${net}-${snid}
	else
	    echo "# Clearing up the old ${net}-${snid} scalper"
	    /bin/rm -f $home/var/db/scalper.${net}-${snid}/*
	fi
	if $SCALPER  --database scalper.${net}-${snid} --logFile $home/var/log/scalper \
	    --serialNumLoadFile $ODIR/serno-test-$type-$_tag \
	    --databaseHome $home/var/db ; then
	    echo "# Loaded in scalper database"
	    chmod -R ugo+rw $home/var/db/scalper.${net}-${snid}
	    echo "Please load the serial numbers in $ODIR/serno-test-$type-$_tag"
	else 
	    echo "# Problem with $home/var/db/scalper.${net}-${snid} database"
	fi
    fi
 
done

