#!/bin/sh
#
# Luc Boulianne <luc@zks.net>
# Genesis sngen frontend
# $Id: genesis-sngen.sh,v 1.17 2001/04/23 17:33:11 alainc Exp $
#

PATH=/usr/local/bin:/bin/:/usr/bin:/usr/sbin:/usr/ucb; export PATH;
ZK_SSH=ssh2
ZK_SCP=scp2
prog=`basename $0`

usage () {
    echo "$0: [--help] --toksrv tokenserver --network networkname [--ssh1]" 1>&2
    echo "      --url posting-url --numsets sn-num-sets [ --clean ]" 1>&2
    exit 2
}


remote=0;
start="";
while  [ $# -gt 0 ] ; do
    case "$1" in
    --toksrv)
	shift; dest=$1
	;;
    --clean)
	clean=$1
	;;
    --network)
	shift; ZK_NETWORK=$1
	;;
    --ssh1)
	ZK_SSH=ssh1
	ZK_SCP=scp1
	;;
    --ssh2)
	ZK_SSH=ssh2
	ZK_SCP=scp2
	;;
    --url)
        shift; url=$1
        ;;
    --numsets)
        shift; numsets=$1
        ;;
    --help)
	usage
	exit
	;;
    *)
        echo "Unknown argument: $1" 1>&2
	usage
	exit
	;;
    esac
    shift;
done

if [ \
    x$dest = x -o \
    x$ZK_SSH = x -o \
    x$url = x -o \
    x$ZK_NETWORK = x -o \
    x$numsets = x ] ; then
    echo "* Error: --dest, --ssh1/2, --url, --network, or --numsets not set"
    usage
    exit;
fi

if [ x$clean = x ] ; then 
    clean=--keep;
fi

echo "Genesis sngen front-end on-line."
echo " - generating serial numbers for network $ZK_NETWORK"
pwd=`pwd`;
if list=`frbin/gen-sn.sh --home $pwd --network $ZK_NETWORK --numsets $numsets` ; then
    echo " - copying files to remote $dest"
    if $ZK_SCP -q load-sn-toksrv.sh $list root@$dest:/tmp ; then
	list2=`echo $list | tr ' ' '\012' | sed 's?^.*/serno-test-?serno-test-?'`
	$ZK_SSH -x root@$dest \
	    "cd /tmp ; echo "./load-sn-toksrv.sh $clean $list2" > load-sn-fe.sh ; \
	     chmod 700 load-sn-fe.sh ; chown freedom load-sn-fe.sh ; \
	     chmod 755 load-sn-toksrv.sh ; chown freedom load-sn-toksrv.sh ; \
             su -c ./load-sn-fe.sh freedom ; sleep 1"

	$ZK_SSH -x root@$dest \
	    "cd /tmp ; /bin/rm serno-test-* load-sn-fe.sh load-sn-toksrv.sh"

	for n in $list ; do 
	    if frbin/post-sn.pl --network $ZK_NETWORK --url $url $clean < $n ; then 
		:
	    else
		echo "Problem with posting to web server" 1>&2
		exit 2
	    fi
	done
    else
	echo "Problem copying file to tokenserver" 1>&2
    fi
else
   echo "Problem generating serial numbers" 1>&2
fi
