#!/bin/sh 
#
# file:     genesis_database.sh
# author:   Francis Korning
# purpose:  extract a specific database section
# revision  $Revision $

net=$1
conf='dbs-remote.conf'
os=`uname`


usage () {
    echo "$0 <network> [<dbs-config>]"
    echo ""
}


if [ "$#" -lt "1" ]; then
    usage
    exit 1
elif [ "$#" -eq "2" ]; then
    conf=$2
fi


#if [ "x$os" = "xSunOS" ] ; then

    egrep -e "^\[\W*$net general\W*\]" $conf > this-database.conf
    echo "" >> this-datbase.conf

    size=`wc -l $conf | awk '{print $1}'`
    start=`egrep -n -e "^\[\W*$net general\W*\]" $conf \
	| cut -d ':' -f 1`

    if [ ! "x$start" = "x" ]; then
	cut=`echo "$size $start - p" | dc`
	tail -$cut $conf > this-database.trim
    else
	echo "" > this-database.trim
    fi
    

    end=`egrep -n -e "^\[.* general\W*\]" this-database.trim \
	| head -1 | cut -d ':' -f 1`

    if [ ! "x$end" = "x" ]; then
	trim=`echo "$end 1 - p" | dc`
	head -$trim this-database.trim >> this-database.conf
    else
	cat this-database.trim >> this-database.conf
    fi

    \rm -f this-database.trim

#fi
