#!/bin/sh 
#
# file:     genesis_network.sh
# author:   Francis Korning
# purpose:  extract a specific network section
# revision  $Revision $

net=$1
conf='genesis-remote.conf'
os=`uname`


usage () {
    echo "$0 <network> [<genesis-config>]"
    echo ""
}


if [ "$#" -lt "1" ]; then
    usage
    exit 1
elif [ "$#" -eq "2" ]; then
    conf=$2
fi


#if [ "x$os" = "xSunOS" ] ; then

    egrep -e "^\[\W*network $net\W*\]" $conf > this-network.conf
    echo "" >> this-network.conf

    size=`wc -l $conf | awk '{print $1}'`
    start=`egrep -n -e "^\[\W*network $net\W*\]" $conf \
	| cut -d ':' -f 1`

    if [ ! "x$start" = "x" ]; then
	cut=`echo "$size $start - p" | dc`
	tail -$cut $conf > this-network.trim
    else
	echo "" > this-network.trim
    fi
    

    end=`egrep -n -e "^\[\W*network .*\]" this-network.trim \
	| head -1 | cut -d ':' -f 1`

    if [ ! "x$end" = "x" ]; then
	trim=`echo "$end 1 - p" | dc`
	head -$trim this-network.trim >> this-network.conf
    else
	cat this-network.trim >> this-network.conf
    fi

    \rm -f this-network.trim

#fi
