#!/bin/sh
#
# Load Serial Numbers in the token database
# Luc Boulianne <luc@zks.net>
#
#
ZKROOT=/freedom
DB=serialnumberdb

if [ x`whoami` != xfreedom ] ; then
	echo "Please su to 'freedom' to load these serialnumbers"
	exit
fi 

usage () {
	echo "$0 [--keep | --clean] files-to-load"
	echo "  specify --keep to keep the existing serial numbers"
	echo "  specify --clean to clean the existing serial nubmers"
}
if [ $# -lt 2 ] ; then 
	usage
	exit
fi

if [ "$1" = "--keep" ] ; then
	:
elif [ "$1" = "--clean" ]  ; then
	echo "Cleaning old database"
	killall frsnapd
	sleep 2
	find $ZKROOT/db/translog/$DB $ZKROOT/db/$DB -type f -print | xargs -t rm
	printf "*\n* You must manually restart the token server\n*\n"
	# $ZKROOT/etc/rc/S060.frsnapd --passphrase.file $ZKROOT/etc/passprase.file
else 
	echo "You must specify --keep or --clean."
	usage
	exit
fi
shift;
for name in $* ; do 
	if [ -r $name ] ; then 
		echo "bulk add $name"
	fi
done | tee /tmp/sn-hold.$$ | $ZKROOT/bin/zktsa --database $ZKROOT/etc/db/serialnumberdb.local.conf --typeid $ZKROOT/etc/tokentypeid.conf
echo
echo "Serial numbers loaded with " `cat /tmp/sn-hold.$$`
/bin/rm /tmp/sn-hold.$$
