#!/usr/bin/perl -w

# $Id: start_freedom_server.pm,v 1.2 2001/04/19 19:16:32 alainc Exp $

use Freedom;

my $entity = $context->get_entity();
my $server_name = Freedom::get_server_name_by_entity_name($entity);

if (!defined($server_name)) {
  Logger::warning("entity `$entity' has no server");
} else {
  if (Freedom::is_mail_2_0_entity($entity)) {
    Misc::system_to_log_file("qmail start");
    Misc::system_to_log_file("qmail stat");
  } else {    
    Logger::informational("becoming user freedom");
    if (!Misc::become_user('freedom')) {
      Logger::error_and_die("couldn't become user `freedom'");
    }
    Logger::informational("starting $entity");
    
    my $command;
    if ($server_name =~ /kqd/) {
      $command = "/usr/freedom/etc/rc/S*.${server_name}";
    } else {
      $command = "/usr/freedom/etc/rc/S*.${server_name} --passphrase.file /usr/freedom/etc/passphrase.file"
    }
    if ($server_name =~ /niqsd/) {
      # are these bastards already running?
      my $niqs_lines = Misc::list_processes_by_name('frniqsd');
      my $niss_lines = Misc::list_processes_by_name('frnissd');

      if (@{$niqs_lines}) {
	Logger::informational("niqs is already running");
      }
      if (@{$niss_lines}) {
	Logger::informational("niss is already running");
      }

      if (!@{$niqs_lines} and !@{$niss_lines}) {
	Logger::informational("neither niqs nor niss is running, so toasting old db translogs...");
	# they are toast, so toast the translogs
	Misc::system_to_log_file('find /usr/freedom/db/nidb /usr/freedom/db/translog/nidb -type f -a \( -name \'__*\' -o -name \'log.0*\' \) | xargs -t /bin/rm');
      }
    }

    Misc::system_to_log_file($command);
    Logger::informational("sleeping for 5...");
    sleep(5);
    Misc::system_to_log_file("tail /usr/freedom/var/log/${server_name}");
    Logger::informational(" ");
    my $lines = Misc::list_processes_by_name($server_name);
    if (!@{$lines}) {
      Logger::fatal(" $server_name did not start");      
    } else {
      Logger::informational(" $server_name started:");      
      Logger::informational(join("\n", @{$lines}));
    }      
    Logger::informational(" ");
#    Misc::system_to_log_file("ps auxw | grep $server_name");
  }
}
1;
