#!/usr/bin/perl -w

# $Id: stop_freedom_server.pm,v 1.2 2001/04/19 19:16:32 alainc Exp $


use Freedom;

my $entity = $context->get_entity();

my $server_name = Freedom::get_server_name_by_entity_name($entity);

if (!defined($server_name)) {
  Logger::warning("no server for entity `$entity', doing nothing");
} else {
  if (Freedom::is_mail_2_0_entity($entity)) {
    Misc::system_to_log_file("qmail stop");
    Misc::system_to_log_file("qmail stat");
  } else {
    Logger::informational("becoming user freedom");
    if (!Misc::become_user('freedom')) {
      Logger::error_and_die("couldn't become user `freedom'");
    }
    Logger::informational("stopping $entity");
    Misc::system_to_log_file("/usr/freedom/etc/rc/K*.${server_name} --passphrase.file /usr/freedom/etc/passphrase.file");
    sleep(1);
    if ( `ps auxww | grep "$server_name " | grep -v grep` !~ /^\s*$/) {
      Logger::informational("sleeping for 5...");
      sleep(5);
      Misc::system_to_log_file("killall -15 ${server_name}");
      if ($server_name =~ /fraipd/) {
	Misc::system_to_log_file("killall -15 frwhd fridentd");
      }

      if (`ps auxww | grep "$server_name " | grep -v grep` !~ /^\s*$/) {
    
	Logger::informational("sleeping for 5...");
	sleep(5);
	Misc::system_to_log_file("killall -9 ${server_name}");
	if ($server_name =~ /fraipd/) {
	  Misc::system_to_log_file("killall -9 frwhd fridentd");
	}
      }
    }
    Misc::system_to_log_file("tail /usr/freedom/var/log/${server_name}");
    my $lines = Misc::list_processes_by_name($server_name);
    if (@{$lines}) {
      Logger::warning(" $server_name did not stop, examine the following process list:");
      Logger::warning(join("\n", @{$lines}));
    } else {
      Logger::informational(" $server_name stopped");
    }      
    Logger::informational(" ");
  } 
}

1;
