#!/usr/bin/perl -w

# $Id: test_clientinfo.pm,v 1.2 2001/04/19 19:16:53 alainc Exp $

my $network = $context->get_network();
my $network_name = $network->get_name();
my $domain = $network->get_parameters()->{'domain'};

if (!defined($domain)) {
  Logger::fatal("no domain in network description for `$network_name'");
}

my @clients = 
  qw(
freedom-linux-2.0-0
freedom-windows-2.0-0
freedom-linux-2.0-1
freedom-windows-2.0-1
);

my $clientinfo = new IniConf(-file => '/usr/freedom/etc/clientinfo.conf');

print "1.." . @clients . "\n";

my $test = 0;
foreach my $client (@clients) {
  ++$test;
  my $ok = 1;
  my $values = $clientinfo->values("$client");
  if (!defined($values)) {
    $ok = 0;
    Logger::warning("no entry for client `$client'");
  }
  if (!defined($values->{'domain'})) {
    $ok = 0;
    Logger::warning("no domain for client `$client'");
  } else {
    if ($values->{'domain'} ne $domain) {
      $ok = 0;
      Logger::warning("incorrect domain `" . $values->{'domain'} . "' for client `$client'");
    }
  } 

  if ($ok) {
    print "ok $test\n";
  } else {
    print "not ok $test\n";
  }
}

1;
