#ifndef LOAD_H_
#define LOAD_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef PARAMETERS_H_
#include "parameters.h"
#endif /* ! PARAMETERS_H_ */

/*
 *
 */

struct Load_T {
  const char * title;          /* Optional title string for load struct */
  double connections;             /* New connection creation rate (per hour)*/
  double requests;                /* Request rate (per hour)*/
  double data;                    /* Data rate (bytes / hour) */
  enum {
    CloudTraffic ,             /* Traffic through the AIP cloud */
    ClearTraffic ,             /* Freedom traffic in the clear */
    InternetTraffic ,          /* Internet traffic (web pages, etc) */
    None                       /* No traffic */
  } traffic;                   /* Type of traffic */
};

typedef struct Load_T Load;

/*
 *
 */

int load_WH_to_Internet ( FreedomParameters * p , Load * l , Load * b );
int load_WH_to_NISS ( FreedomParameters * p , Load * l , Load * b);
int load_TS_to_AIP ( FreedomParameters * p , Load * l , Load * b );
int load_AIP_to_KQD ( FreedomParameters * p , Load * l , Load * b );
int load_AIP_to_NIQS ( FreedomParameters * p , Load * l , Load * b );
int load_AIP_to_NISS ( FreedomParameters * p , Load * l , Load * b );
int load_NISS_to_AIP ( FreedomParameters * p , Load * l , Load * b );
int load_NISS  ( FreedomParameters * p ,  Load * l ,  Load * b );
int load_MAIP_to_MAIP ( FreedomParameters * p , Load * l , Load * b );
int load_MAIP_to_NISS ( FreedomParameters * p , Load * l , Load * b );
int load_MAIP_to_KQD ( FreedomParameters * p , Load * l , Load * b );
int load_frnetinfo_to_NIQS ( FreedomParameters * p , Load * l , Load * b );
int load_CORE_to_NIQS ( FreedomParameters * p , Load * l , Load * b );
int load_MAIP_to_NIQS ( FreedomParameters * p , Load * l , Load * b );
int load_FMGMAIP_to_MAIP ( FreedomParameters * p , Load * l , Load * b );
int load_FMGMAIP_to_NIQS ( FreedomParameters * p , Load * l , Load * b );
int load_FMGMAIP_to_NISS ( FreedomParameters * p , Load * l , Load * b );
int load_FMGMAIP_to_KQD ( FreedomParameters * p , Load * l , Load * b );
int load_MAIP_to_Internet ( FreedomParameters * p , Load * l , Load * b );
int load_FMGMAIP_to_Internet ( FreedomParameters * p , Load * l , Load * b );
int load_Internet_to_FMG ( FreedomParameters * p , Load * l , Load * b );
int load_frpostnews_to_Internet ( FreedomParameters * p , Load * l , Load * b );
int load_CLIENT_to_AIP ( FreedomParameters * p , Load * l , Load * b );
int load_CLIENT_to_KQD ( FreedomParameters * p , Load * l , Load * b );
int load_CLIENT_to_NIQS ( FreedomParameters * p , Load * l , Load * b );
int load_FMGMAIP_to_NYMSRV ( FreedomParameters * p , Load * l , Load * b );
int load_FMG_to_NYMSRV ( FreedomParameters * p , Load * l , Load * b );
int load_CLIENT_to_NYMSRV ( FreedomParameters * p , Load * l , Load * b );
int load_NYMSRV_to_FMGMAIP ( FreedomParameters * p , Load * l , Load * b );
int load_frpostnews_to_Internet ( FreedomParameters * p , Load * l , Load * b );
int load_KQD  (FreedomParameters * p , Load * l ,  Load * b );
int load_avgMAIP  (FreedomParameters * p , Load * l , Load * b );
  
int load_NYMSRV  (FreedomParameters * p , Load * l , Load * b );
int load_clientNYMSRV (FreedomParameters * p , Load * l , Load * b );
int load_MAIP  (FreedomParameters * p , Load * l , Load * b );
int load_FMGMAIP  (FreedomParameters * p ,Load * l , Load * b );
int load_NIQS ( FreedomParameters * p ,  Load * l , Load * b );
int load_CLIENT_to_FMGMAIP (FreedomParameters * p , Load * l , Load * b );


  


/*
 *
 */

int loadDump ( FILE * stream , Load * l );
int loadDump2 ( FILE * stream , FreedomParameters * p , Load * l );
int loadAdd ( Load * l_total, Load * l );



#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ! LOAD_H_ */
