# $Id: dns_lookup.pm,v 1.2 2001/04/19 19:17:06 alainc Exp $

Logger::informational("DNS lookup:");
Logger::informational(" + validate nameserver entries for entities.");
Morpheus::prompt_user();


use DNS;


# context & environment
defined($context) || Logger::error("context not defined");
my $network = $context->get_network();  # {'zeta'}
my $network_name = $network->get_name();  # 'zeta'
my $network_domain = $network->get_domain();  # 'zeta.feedom.net'

my $host = $context->get_host();  # {'host1'}
my $host_entity = $host->get_name();  # 'host1'}
my $host_name = $host->get_parameters()->{'hostname'};  # 'test001.syslab.freedom.net'
my $dns = $network->get_parameters()->{'dns'};  # 'ns.syslab.freedom.net'
my $dns_path = $network->get_parameters()->{'dns_path'};  # '/var/named/pri/'



sub lookup_entity ($ $ $)
{
  my ($entity, $host, $server) = (@_);
  my ($host_name, $host_ip, $aliases) = ('', '', '', '');

  ($host_name, $host_ip, $aliases) = DNS::nslookup ($host, $server);
  Logger::informational ("\t$host_name $host_ip $aliases\n");
}



# main
#
  my $host_is_aip = defined ($host->get_parameters()->{'aip'});

  # [host-entity]: local lookup
  Logger::informational ("[host-entity] $host_entity: local lookup:\n");
  &lookup_entity ($host_entity, $host_name, '');

  # [host-entity]: remote lookup
  Logger::informational ("[host-entity] $host_entity: remote lookup:\n");
  &lookup_entity ($host_entity, $host_name, $dns);


  # [aip]: wormhole lookup
  if ($host_is_aip)
  {
    my ($wormhole) = $host->get_parameters()->{'worm-hostname'};

    Logger::informational ("[aip] $host_entity: verifying wormhole:\n");
    &lookup_entity ($host_entity, $wormhole, $dns);
  }


  # [niqs]: 'niqs' alias


  # [keyqry]: 'kqd' alias


#
# main


1;
