#!/usr/bin/perl -w

# $Id: insert_pubkey.pl,v 1.1 2001/06/20 23:24:19 colm Exp $

# Must be user freedom to run this script - must be run from KQD
# Will add specified pubkeys in /tmp/upd to pubkeydb
# Assumes keys are already in /tmp/upd and signed by monthly key

use lib './lib';
use lib '../lib';
use lib './lib/IO';
use lib '../lib/IO';
use lib './modules';
use Logger;
use Getopt::Long;
use IniConf;
use Carp;


sub usage()
  {
    die("usage: $0 --type=<ENTITY_TYPE> --name=<ENTITY_NAME>");
  }

my $entity_type = undef;
my $entity_name = undef;

my($result) = GetOptions("type=s" => \$entity_type,
                         "name=s" => \$entity_name);


usage() unless defined($entity_type);
usage() unless defined($entity_name);

my $entity_type_for_key;
# switch coreaip
if ($entity_type eq "coreaip") {
  $entity_type_for_key = "aip";
} else {
  $entity_type_for_key = $entity_type;
}

# files that need to be there   
my($upd_sig_file) = "$entity_type_for_key:$entity_name.sig.upd";
my($hash_sig_file) = "$entity_type_for_key:$entity_name.sig.hash";
my($upd_enc_file) = "$entity_type_for_key:$entity_name.enc.upd";
my($hash_enc_file) = "$entity_type_for_key:$entity_name.enc.hash";
my($upd_dir) = "/tmp/upd/$entity_name";

my @key_files = ();

if ($entity_name eq "ScriptServer") {
  @key_files = ("$upd_sig_file","$hash_sig_file");
} else {
  @key_files = ("$upd_sig_file","$hash_sig_file","$upd_enc_file","$hash_enc_file");
}

# check that all key files are there before proceeding

foreach my $key_file (@key_files) {
  if (!(-f "$upd_dir/$key_file")) {
    Logger::error_and_die("Can not find $key_file .... exiting\n");
  }
}

# add the keys
my $tmp_file = "/tmp/fr_uplocadd_logfile.$$";
print ("Adding pubkeys for $entity_type $entity_name\n");
my ($db_config) = "/usr/freedom/etc/db/pubkeydb-kqd.remote.conf";
my $command = '';
if ($entity_name eq "ScriptServer") {
  $command = "fr_updlocadd --argsInCorrectOrder --pubkeyDbCfgFile $db_config --logFile $tmp_file $upd_dir/$upd_sig_file";
} else {
  $command = "fr_updlocadd --argsInCorrectOrder --replace --pubkeyDbCfgFile $db_config --logFile $tmp_file $upd_dir/$upd_sig_file $upd_dir/$upd_enc_file";
}
#Misc::system_to_log_file("$command"); 	 
system($command);
system("cat $tmp_file");
unlink $tmp_file;





