#!/usr/bin/perl -w

#$Id: privkey_gen.pl,v 1.1 2001/06/20 23:24:19 colm Exp $

# This will generate a privkey for a given entity and entity name.
# insert_pubkey.pl will sign and insert this key into the pubkeydb

use strict;

use lib './lib';
use lib '../lib';
use lib './lib/IO';
use lib '../lib/IO';
use lib './modules';

use Logger;
use Getopt::Long;
use IniConf;
use Carp;
use Morpheus;

sub usage()
  {
    die("usage: $0 --type=<ENTITY_TYPE> --name=<ENTITY_NAME> --privkeydir=<PRIVKEY_DIR>");
  }




my($genkeys_command) = '/usr/freedom/bin/frgenkeys';

#This will need to change
my($passphrase) = "Stop the fucking snow!";

my($entity_type) = undef;
my($entity_name) = undef;
my($privkey_dir) = undef;

my($result) = GetOptions("type=s" => \$entity_type,
                         "name=s" => \$entity_name,
                         "privkeydir=s" => \$privkey_dir);

usage() unless defined($entity_type);
usage() unless defined($entity_name);
usage() unless defined($privkey_dir);


my($vault_dir) = '/usr/freedom/vault';

#make sure directory doesn't exist for key under /freedom/vault
if (-d "$vault_dir/$entity_type:$entity_name") {
  Misc::system_to_log_file("\\rm -rf $vault_dir/$entity_type:$entity_name");
}
#make sure privkeys for entity type don't already exist under privkey dir
if ((-f "$privkey_dir/sig/1")) {
  Morpheus::prompt_continue("Key(s) already exists in $privkey_dir.  They will be overwritten if you continue");
}

#print "Private key directory is $privkey_dir\n";
system("rm -rf $privkey_dir/*");

if (! (-d $vault_dir)) {
  Misc::system_to_log_file("mkdir $vault_dir");
}
Misc::system_to_log_file("chmod 700 $vault_dir");
Misc::system_to_log_file("chown freedom $vault_dir");

#become freedom
if (!Misc::become_user('freedom')) {
  Logger::error_and_die("Could not become user freedom\n");
} 

#make sure has necessary path variables to run frgenkeys
$ENV{'PATH'} .= ':/usr/freedom/bin:/usr/freedom/sbin';
$ENV{'USER'} = 'freedom';
$ENV{'HOME'} = '/usr/freedom';

# hackity hack so that the luser doesn't have to type keys on a keyboard with sticky keys
Misc::system_to_log_file("touch /usr/freedom/var/run/fradmin/.fr_seedinit");

#make sure /freedom/etc/passphrase.info exists - won't for coreaips
my $passphrase_info = '/usr/freedom/etc/passphrase.info';

if (!(-f $passphrase_info)) {
  Misc::system_to_log_file("bin/gen_passwd.exp");
}

#my $frgenkeys;

#($frgenkeys = Expect->spawn($genkeys_command)) || die("Couldn't spawn `$genkeys_command':$!\n");

#sub exp_keyname_prompt
#  {
#    unless ($frgenkeys->expect(5, 'Enter name of key directory (in /usr/freedom/vault): ')) {
#      die("`$genkeys_command': Did not prompt for keyname");
#    }
#  }
#
#sub exp_passphrase_file_prompt
#  {
#    unless ($frgenkeys->expect(5, 'Use existing passinfo file in /freedom/etc/passphrase.info? [y/n] ')) {
#      die("`$genkeys_command': Did not prompt for passhrase file");
#    }
#  }
#
#sub exp_passphrase_prompt
#  {
#    unless ($frgenkeys->expect(5, 'Enter passphrase:')) { 
#      die("`$genkeys_command': Did not prompt for passhrase");
#    }
#  }
#
#sub exp_keyowner_prompt
#  {
#    unless ($frgenkeys->expect(5, 'Enter the name of the key owner (e.g. year:FrYear): ')) { 
#      die("`$genkeys_command': Did not prompt for key owner");
#    }
#  }
#
#sub exp_encryption_key_prompt
#  {
#    unless ($frgenkeys->expect(5, 'Do you want to create an encryption key? [y/n] ')) { 
#      die("`$genkeys_command': Did not ask if wanted encryption key");
#    }
#  }
#
#   
system("keyset-gen/bin/frgenkeypair.exp $entity_type $entity_name /usr/freedom");
#exp_keyname_prompt();
#print $frgenkeys "$entity_type:$entity_name\r";
#exp_passphrase_file_prompt();
#print $frgenkeys "y\r";
#exp_passphrase_prompt();
## *********** WHERE DO WE WANT TO GET PASSPHRASE FROM??
#print $frgenkeys "$passphrase\r";
#exp_keyowner_prompt();
#print $frgenkeys "$entity_type:$entity_name\r";
#exp_encryption_key_prompt();
#if ($entity_name eq "ScriptServer") {
#  print $frgenkeys "n\r";
#} else {
#  print $frgenkeys "y\r";
#}
#sleep 2;

   
#copy the newly generated privkeys to appropriate directories -- be careful about permissions
my($privkeydir_permission) = '700';
my($privkeyfile_permission) = '600';

my($privkey_sig_file) = "$vault_dir/$entity_type:$entity_name/$entity_type:$entity_name.sig.priv";
my($privkey_enc_file) = "$vault_dir/$entity_type:$entity_name/$entity_type:$entity_name.enc.priv";

my($privkey_sig_dir) = "$privkey_dir/sig";
my($privkey_sig_dest_file) = "$privkey_dir/sig/1";
my($privkey_enc_dir) = "$privkey_dir/crypt";
my($privkey_enc_dest_file) = "$privkey_dir/crypt/1";

if (! (-d $privkey_dir)) {
  Misc::system_to_log_file("mkdir $privkey_dir --mode=$privkeydir_permission");
}
if (! (-d $privkey_sig_dir)) {
  Misc::system_to_log_file("mkdir $privkey_sig_dir --mode=$privkeydir_permission");
}
if ($entity_name ne "ScriptServer") {
  if (! (-d $privkey_enc_dir)) {
    Misc::system_to_log_file("mkdir $privkey_enc_dir --mode=$privkeydir_permission");
  }
}


Misc::system_to_log_file("cp $privkey_sig_file $privkey_sig_dest_file");
if ($entity_name ne "ScriptServer") {
  Misc::system_to_log_file("cp $privkey_enc_file $privkey_enc_dest_file");
}

#need to add cleartext passphrase for ScriptServer and move passphrase.info to passhrase.scriptserver.info
# TODO : do we really need a cleartext passphrase here? This seems BAD...
if ($entity_type eq "ScriptServer") {
  my $cleartext_passphrasefile = "/usr/freedom/etc/pass";
  my $scriptserver_passinfo = "/usr/freedom/etc/passphrase.scriptserver.info";
  Misc::system_to_log_file("echo \"$passphrase\" > $cleartext_passphrasefile");
  Misc::system_to_log_file("mv $passphrase_info $scriptserver_passinfo");
}

my $dir = "$vault_dir/${entity_type}:${entity_name}";
chdir($dir) || Logger::error_and_die("Could not chdir $dir: $!\n");

my $tar_ball = "/tmp/pubkeys.${entity_name}.tgz";

Misc::system_to_log_file("rm -f $tar_ball");
if ($entity_name eq "ScriptServer") {
  Misc::system_to_log_file("tar cvfzpsP $tar_ball ${entity_type}:${entity_name}.sig.upd ${entity_type}:${entity_name}.sig.hash");
} else {
  Misc::system_to_log_file("tar cvfzpsP $tar_ball ${entity_type}:${entity_name}.sig.upd ${entity_type}:${entity_name}.sig.hash ${entity_type}:${entity_name}.enc.upd ${entity_type}:${entity_name}.enc.hash");
}

