#!/usr/bin/perl -w

#$Id: gen_default_keypairs.pm,v 1.1 2001/06/20 23:24:24 colm Exp $

# This will generate keypairs for all entities in network description
# It will create 10 additional 'spare' keys for aips, 5 for coreaips, and 2 for each core server (all based on standard naming conventions)
use lib './lib';
use lib './lib/Genesis';
use lib '../lib';
use lib '../lib/Genesis';
use lib '../../lib';
use lib '../../lib/Genesis';

use Misc;
use Logger;

$ENV{'PATH'} .= ':/usr/freedom/bin:/usr/freedom/sbin';
$ENV{'USER'} = 'freedom';
$ENV{'HOME'} = '/usr/freedom';
if (!Misc::become_user('freedom')) {
  Logger::fatal("Could not become user freedom");
}

my $rootdir = "/usr/freedom";

my $num_aip_keys = 50;
for ($i = 1; $i<$num_aip_keys;$i++) {
  my $command = "keyset-gen/bin/frgenkeypair.exp aip host$i $rootdir";
  system $command;
}  
my $num_core_aip_keys = 10;
for ($i = 1; $i<=$num_core_aip_keys;$i++) {
  my $command;
  if ($i<10) {
    $command = "keyset-gen/bin/frgenkeypair.exp aip core-zks-0$i $rootdir";
  } else {
    $command = "keyset-gen/bin/frgenkeypair.exp aip core-zks-$i $rootdir";
  }
  system$command;
}  
my $num_core_keys = 5;
for ($i = 0; $i<$num_core_keys;$i++) {
  my $command;
  if ($i == 0) {
    $command = "keyset-gen/bin/frgenkeypair.exp nymsrv NymServer $rootdir";
  } else {
    $command = "keyset-gen/bin/frgenkeypair.exp nymsrv NymServer$i $rootdir";
  }
  system $command;
}  
for ($i = 0; $i<$num_core_keys;$i++) {
  my $command;
  if ($i == 0) {
    $command = "keyset-gen/bin/frgenkeypair.exp toksrv TokenServer $rootdir";
  } else {
    $command = "keyset-gen/bin/frgenkeypair.exp toksrv TokenServer$i $rootdir";
  }
  system $command;
}  
for ($i = 0; $i<$num_core_keys;$i++) {
  my $command;
  if ($i == 0) {
    $command = "keyset-gen/bin/frgenkeypair.exp keyqry KeyQryServer $rootdir";
  } else {
    $command = "keyset-gen/bin/frgenkeypair.exp keyqry KeyQryServer$i $rootdir";
  }
  system $command;
}  
for ($i = 0; $i<$num_core_keys;$i++) {
  my $command;
  if ($i == 0) {
    $command = "keyset-gen/bin/frgenkeypair.exp niqs NIQS $rootdir";
  } else {
    $command = "keyset-gen/bin/frgenkeypair.exp niqs NIQS$i $rootdir";
  }
  system $command;
}  
for ($i = 0; $i<$num_core_keys;$i++) {
  my $command;
  if ($i == 0) {
    $command = "keyset-gen/bin/frgenkeypair.exp niss NISS $rootdir";
  } else {
    $command = "keyset-gen/bin/frgenkeypair.exp niss NISS$i $rootdir";
  }
  system $command;
}  

exit 0;
