#!/usr/bin/perl -w

#$Id: single_privkey_gen.pm,v 1.1 2001/06/20 23:24:24 colm Exp $

#This script will be used to create a new privkey on a given host

use lib './lib';
use lib '../lib';
use lib './lib/IO';
use lib '../lib/IO';

use Logger;

my $network = $context->get_host()->get_network;
my $morpheus = $context->get_morpheus_configuration();
my $entity = ($context->get_entity());
my $name = $context->get_host()->get_parameters()->{$entity};
my $crypt = $context->get_morpheus()->get_crypt();

my $target_entity = shift;
my $target_entity_name = shift;

if (!(($entity eq $target_entity) && ($name eq $target_entity_name))) {
  Logger::informational("No key to be generated for $entity $name");
  exit;
}
#Key directory names corresponding to entities
my %key_dir_name;
$key_dir_name{aip} = 'AIP';
$key_dir_name{niqs} = 'NIQSD';
$key_dir_name{niss} = 'NISSD';
$key_dir_name{nymsrv} = 'NymServer';
$key_dir_name{toksrv} = 'TokenServer';
$key_dir_name{keyqry} = 'KeyQryServer';
$key_dir_name{nidb} = 'NIDB';

my $entity_for_key;
#Need to have coreaips created as entity aip
if ("$entity" eq "coreaip") {
  $entity_for_key = "aip";
} else {
  $entity_for_key = $entity;
}

my $privkeydir = "/usr/freedom/privkey/$key_dir_name{$entity_for_key}";


my($command) = "keyset-gen/bin/privkey_gen.pl --type=$entity_for_key --name=$name --privkeydir=$privkeydir";

Logger::informational("Genarating private key for $entity $name\n"); 

system($command);

my $tar_ball = "/tmp/pubkeys.${name}.tgz";

  
Logger::informational("copying public keys to the crypt\n"); 

$crypt->move_to_crypt($tar_ball);
1;
