# $Id: copy_user_ssh2_key_on_master.pm,v 1.2 2001/04/19 19:17:11 alainc Exp $

# clear up any old keys that might be kicking around
Misc::system_to_log_file("rm -rf data/tmp/.tmp_ssh2_keys");
Misc::system_to_log_file("mkdir -p data/tmp/.tmp_ssh2_keys");

my ($userfil, $ucfg, @user);

$userfil = "uid.lst";
if (! -f $userfil ) {
    Logger::error_and_die("file $userfil containing list of users doesnt exist");
    }

$ucfg = new IniConf -file => "./uid.lst";
print "@IniConf::errors";
if (defined $ucfg) {
	@user = 
		$ucfg->val("uidlst", "uids");
    }
else {
    Logger::error_and_die("unable to instantiate user id conf file\n @IniConf::errors\n ");
    }

# Copies the user's .ssh2 key to morpheus' data dir so that a later
# script may distribute it.
my $cterr = 0;
my ($home_directory, $user_auth_file, $usr);
my $key_file_name = undef;

foreach $usr (@user) {
$home_directory = "/home/caesar/$usr";

if (!(-d $home_directory)) {
  Logger::informational("error no $home_directory for $usr");
  next;
}
$user_auth_file = "$home_directory/.ssh2/identification";
if (!(-f $user_auth_file)) {
  Logger::informational("no $user_auth_file  for $usr");
  next;
}

open(AUTHORIZATION, $user_auth_file) || die("couldn't open $user_auth_file: $!\n");
while(<AUTHORIZATION>) {
  if (/^\s*(IdKey)\s+(\S+)/) {
    $key_file_name = "$2.pub";
    last;
  }
}
  
if (!defined($key_file_name)) {
  Logger::informational("couldn't find a key in $user_auth_file");
}  
else {
Misc::system_to_log_file(
"cp $home_directory/.ssh2/$key_file_name data/tmp/.tmp_ssh2_keys/$usr.pub");
}
}
