# $Id: copy_user_ssh2_key_to_root_ssh2_authorization.pm,v 1.2 2001/04/19 19:17:11 alainc Exp $
use Cwd;

my ($key_name, $key, $curr_dir);
my $key_dir = "data/tmp/.tmp_ssh2_keys";
# ssh2 info
my $auth_dir = '/root/.ssh2';
my $auth_file = 'authorization';

Logger::error_and_die("morpheus pub keys directory doesnt exist: $key_dir")
	unless  ( -d $key_dir); 
$curr_dir = cwd();
chdir($key_dir);
my @key_list = split " ", `echo *`;
chdir("$curr_dir");

foreach $key_name (@key_list) {
	chomp($key_name);
	(-f "$auth_dir\/$auth_file") || Logger::error_and_die("auth info doesnt exist `$auth_file': `$!'");

# check the auth file for key already installed
	my $key_present = 0;
	open(KEYFILE, "$auth_dir\/$auth_file")
		 || Logger::error_and_die("couldn't open `$auth_file': `$!'");

	while (<KEYFILE>) {
  		if (/\s*Key\s*$key_name/) {
    		$key_present = 1;
    		if (!(-f $key_name) || !(-r $key_name)) {
      			Logger::informational("entry for `$key_name' in authorization file, but key file absent or unreadable");
    		}
                else {
 		   	Logger::informational(
			"$key_name entry in authorization file and key file exists, overwriting it");
		}
    		last;
  		}
	}
	close(KEYFILE);


	if ($key_present) {
  	Logger::informational("key `$key_name' already present, overwriting existing key");  
	} else {
		Logger::informational("adding key `$key_name'");
  		system("echo \"Key $key_name\" >>$auth_dir\/$auth_file ");
	}
  	system("cp -f $key_dir\/$key_name  $auth_dir\/$key_name" );
Logger::error_and_die("couldn't chmod(0644, `$key_name'): `$!'")
  unless   chmod(0644, "$auth_dir/$key_name"); 


} 

