#!/usr/bin/perl -w
#
# Script to show the bytes and packets send/received per second
# on the eth0 interface. Linux Only.
#
# Luc Boulianne <luc@zeroknowledge.com>
# $Id: fr_stat_delta.pl,v 1.3 1999/09/08 20:47:04 nicolas Exp $
#
use strict;
use Time::Local;

# 
# Calculate CTX switching
#
sub calc_ctx_switch {
  my ($ct, $cuse, $cnic, $csys, $cide) = @_;
  my ($div, $div2, $duse, $dsys, $didl, $cs);
  
  $didl = $cide;
  $dsys = $csys;
  $duse = $cuse + $cnic;
  $div  = $duse + $dsys + $didl;
  $div2 = $div / 2;
  $cs = ((($ct * 100) + $div2)/$div);
  return $cs;
}


my($line, @l, $r, $s, $R, $S, $time, $cnt);
my($br, $bs, $bR, $bS);
my($ct, $oct, $cs, $cuse, $cnic, $csys, $cide, $cpu, $ocuse, $ocnic, $ocsys, $ocide, $ocpu);
my($second);

$r = 0;
$s = 0;

$R = 0;
$S = 0;

$br = 0;
$bs = 0;

$bR = 0;
$bS = 0;

$cnt = 0;

$cuse = 0;
$cnic = 0;
$csys = 0;
$cide = 0;
$cpu = 0;

$ocuse = 0;
$ocnic = 0;
$ocsys = 0;
$ocide = 0;
$ocpu = 0;

$ct = 0;
$oct = 0;
$cs = 0;

$second = 0;

select(STDOUT); $| = 1;         # make unbuffered
printf "%9s %7s %7s %4s %4s %4s  %4s %4s %4s \n", "# UTCtime", "BytesIn", "BytesOut", 
        "PkIn", "PkOut", "CS", "UCpu", "SCpu", "ICpu";

while (1) {
    open (DEV,  "/proc/net/dev") || die "Can't open network device: $!";
    open (STAT, "/proc/stat") || die "Can't open statistic device: $!";
    $time = time;

    while (<STAT>) {
        /^cpu/ && do {
          @l = split;
          $cuse = $l[1];
          $cnic = $l[2];
          $csys = $l[3];
          $cide = $l[4];
        };
        /^ctxt/ && do {
          @l = split;
          $ct = $l[1];
        };
    }

    $cs = calc_ctx_switch($ct - $oct, $cuse - $ocuse, $cnic - $ocnic, $csys - $ocsys, $cide - $ocide);

    while (<DEV>) {
        /eth0/ && do {
                s/eth0://;
                @l = split;
                $cnt++;
                
                $r = $l[1] - $R;
                $R = $l[1];
                $s = $l[9] - $S;
                $S = $l[9];

                $br = $l[0] - $bR;
                $bR = $l[0];
                $bs = $l[8] - $bS;
                $bS = $l[8];
                if( $second ) {
                  printf "%9u %7u %7u %4u %4u   %4u %4u %4u %4u\n", 
                          $time, $br, $bs, $r, $s, $cs, $cuse - $ocuse, $csys - $ocsys, $cide - $ocide;
                }
                else {
                  $second = 1;
                }
        }
    }

    $oct = $ct;
    $ocuse = $cuse;
    $ocnic = $cnic; 
    $ocsys = $csys; 
    $ocide = $cide;

    close (DEV);
    close (STAT);
    sleep 1;
}

