#!/usr/bin/perl -w
#AddRule.cgi

use strict;
use FileHandle;
use CGI;

my $passwordtxt = "A@#qt*<5";

#################
## Debug Stuff ##
#################

my $DEBUG = 0;
if ($DEBUG gt 0)
  {
    open DEBUGOUT , ">>/tmp/AddRule.log" or die ("can't write to /tmp/AddRule.log");
    DEBUGOUT->autoflush(1);
    print DEBUGOUT "\n--AddRule Starting--\n";
  }

#################
## Error Stuff ##
#################

sub ExitOnError
  {
    print "Content-Type: text/plain\n\n";
    print "ERROR\n";
    print join "\n", @_;
    exit;
  }

####################
## Get the params ##
####################

my $RULEFILE = "./AdBlocker.txt";
my $q = new CGI;

my $dataString = $q->param('data');
my $password = $q->param('password');

if ($DEBUG gt 0) {print DEBUGOUT "Data:\n$dataString\n";}

if (!defined $dataString){ExitOnError("No data, Nothing to do!");}

if ( (!defined $password) or ($password ne $passwordtxt))
  {
    print "Content-Type: text/plain\n\n";
    print "WRONG_PASSWORD";
    exit;
  }

####################
## Parse the data ##
####################

# clean out carriage returns & http:// strings
$dataString =~ s/\r//gm;
$dataString =~ s/http\%3A\%2F\%2F//gm;
$dataString =~ s/^%2A//mg;

my @newRules = split "\n", $dataString;

open FIN, "$RULEFILE" or ExitOnError("Could not open $RULEFILE for read");
my @ruleFile = <FIN>;
close FIN;

my $lastLine = @ruleFile[((scalar @ruleFile) - 1)];
my $lastIndex = (split "\t", $lastLine)[0];

if ($DEBUG gt 0) {
	print DEBUGOUT "LastLine: $lastLine\n";
	print DEBUGOUT "LastIndex: \"$lastIndex\"\n";
        }

###############################
## Add the new lines to file ##
###############################

open FOUT, ">>$RULEFILE" or ExitOnError("Could not open $RULEFILE for append");

my $currentIndex = $lastIndex;

foreach my $lineToAdd (@newRules)
  {
    ++$currentIndex;
    print FOUT "$currentIndex\t$lineToAdd\n";
    if ($DEBUG gt 0) {print DEBUGOUT "Adding Line: \"$currentIndex\t$lineToAdd\"\n";}
  }

close FOUT;

##########################################
## Print out Success if we got this far ##
##########################################

print "Content-Type: text/plain\n\n";

print "SUCCESS\n";



##########
## DONE ##
##########

if ($DEBUG gt 0) {print DEBUGOUT "\n--AddRule Done--\n";}

