#!/usr/bin/perl -w

use strict;
use FileHandle;
use CGI;

require fr_scriptServerLib;

my $passwordtxt = "A@#qt*<5";

#################
## Debug Stuff ##
#################

my $DEBUG = 1;
if ($DEBUG gt 0)
  {
    open DEBUGOUT , ">>/tmp/AddScript.log" or die ("can't write to /tmp/AddScript.log");
    DEBUGOUT->autoflush(1);
    print DEBUGOUT "\n--AddScript Starting--\n";
  }

#################
## Error Stuff ##
#################

sub ExitOnError
  {
    print "Content-Type: text/plain\n\n";
    print "ERROR\n";
    print join "\n", @_;
    exit;
  }

####################
## Get the params ##
####################

my $currentScriptUpdate = fr_getDateString();

if ($DEBUG gt 0) { print DEBUGOUT "Current Update: $currentScriptUpdate\n"; }

my $q = new CGI;

my $domain = $q->param('domain');
my $dataString = $q->param('data');
my $password = $q->param('password');
my $overwrite = $q->param('overwrite');

$dataString =~ s/\r//g;

if ($DEBUG gt 0) {print DEBUGOUT "Domain: $domain\nData:\n$dataString\nPassword: $password\n";}

if (!defined $domain){ExitOnError("No Domain Specified");}
if (!defined $dataString){ExitOnError("No data, Nothing to do!");}


if ( (!defined $password) or ($password ne $passwordtxt))
  {
    print "Content-Type: text/plain\n\n";
    print "WRONG_PASSWORD";
    exit;
  }

#######################################
## Parse the data and check the file ##
#######################################

my $currentScriptFilename = `/bin/ls ./scripts/$domain.txt.* 2>&1;`;
chomp $currentScriptFilename;
if ($DEBUG gt 0) {print DEBUGOUT "currentScriptFilename: \"$currentScriptFilename\"\n";}


my @scriptLines = split "\n", $dataString;
my @existingLines;
my %rejectLines; # are you a reject (line) ?
my @acceptLines; # we like you guys

my $newScriptFilename = "./scripts/$domain.txt.$currentScriptUpdate";
if ($DEBUG gt 0) {print DEBUGOUT "newScriptFilename: $newScriptFilename\n";}

if ( $currentScriptFilename =~  /^\.\/scripts\/$domain\.txt\.\d*$/ )
  {
    if ($DEBUG gt 0) {print DEBUGOUT "parsing file $currentScriptFilename\n";}

    open FIN , "$currentScriptFilename" or ExitOnError("Could not open $currentScriptFilename");
    while (<FIN>)
      {
	$_ =~ s/\n//g;
	push @existingLines, $_;
      }
    close FIN;


    foreach my $candidateLine (@scriptLines)
      {
	my $match = 0;
	my $doNothing=0;

	LINECOMPARE: foreach my $existingLine (@existingLines)
	  {
	    if ($DEBUG gt 1) 
	      {
		my $tmp1 = (split "\t", $existingLine)[0];
		my $tmp2 = (split "\t", $candidateLine)[0];
		print DEBUGOUT "Comparing: \"$existingLine\" and \"$candidateLine\"\n";
		print DEBUGOUT "---------> \"$tmp1\" and \"$tmp2\"\n";
	      }	    
	    ## compare the first field
	    if( (split "\t", $existingLine)[0] eq (split "\t", $candidateLine)[0] ) 
	      {
		if ("$existingLine" ne "$candidateLine") 
		  {
		    $match = 1;
		    $rejectLines{$candidateLine} = $existingLine;
		    if ($DEBUG gt 0) {print DEBUGOUT "Reject: $candidateLine\n";}
		  }
		else            #simply ignore if the lines are exactly the same
		  {
		    $doNothing=1;
		    if ($DEBUG gt 0) {print DEBUGOUT "Do Nothing: $candidateLine (The line is the same!)\n";}
		  }
		last LINECOMPARE;
	      }
	  }
	if ( (! $match) and (! $doNothing) and ($candidateLine =~ /^.+\t.+$/) ) #ignore lines with the worng format
	  {
	    push @acceptLines, $candidateLine;
	    if ($DEBUG gt 0) {print DEBUGOUT "Accept: $candidateLine\n";}
	  }
      }
    
    `mv $currentScriptFilename $newScriptFilename;`;
    if ($DEBUG gt 0) {print DEBUGOUT "Moving $currentScriptFilename to $newScriptFilename\n";}
      
  }
else  
  {
    @acceptLines = @scriptLines;
    if ($DEBUG gt 0) {print DEBUGOUT "No Match, creating new file $newScriptFilename\n";}
  }

    if ($DEBUG gt 0) {print DEBUGOUT "Accept Lines: ". join "\n", @acceptLines . "\n";}
    if ($DEBUG gt 0) {print DEBUGOUT "Reject Lines: ". join "\n", (keys %rejectLines) . "\n";}


###################################
## Now we can add the Good Lines ##
###################################

if(defined @acceptLines)
  {
    open FOUT, ">>$newScriptFilename";
    foreach my $lineToAdd (@acceptLines)
      {
	#if the second field is ZK%5FErase
	if((split "\t", $lineToAdd)[1] ne "ZK%5FErase") 
	  {
	    print FOUT "$lineToAdd\n";
	  }
	else
	  {
	    if ($DEBUG gt 0) {print DEBUGOUT "Not Adding: $lineToAdd (Can't add a ZK_Erase line!)\n";}
	  }
      }
    close FOUT;
  }

#################################################
## Change the lines if an overwrite variable was supplied ##
#################################################

if (defined $overwrite and defined %rejectLines)
  {
    if ($DEBUG gt 0) {print DEBUGOUT "The overwrite is indicated\n";}
    open FIN, "$newScriptFilename" or ExitOnError("Could not open $newScriptFilename for read");
    my @scriptContents = <FIN>;
    close FIN;
    if ($DEBUG gt 0) {print DEBUGOUT "The script has length: ". scalar(@scriptContents)."\n";}
    
    foreach my $lineToReplace (keys %rejectLines)
      {
	my $i = 0;
	REPLACE_LOOP: while ($i < scalar(@scriptContents))
	  {
	    if ($DEBUG gt 1) 
	      {
		print DEBUGOUT "$i: Comparing \"".
		  (split "\t", $scriptContents[$i])[0]."\" with \"".
		    (split "\t", $rejectLines{$lineToReplace})[0]."\"\n";
	      }
	    if ((split "\t", $scriptContents[$i])[0] eq (split "\t", $rejectLines{$lineToReplace})[0])
	      {
		if ((split "\t", $lineToReplace)[1] =~ /ZK%5FErase/)
		  {
		    if ($DEBUG gt 0) {print DEBUGOUT "Deleting \"$scriptContents[$i]\"\n";}
		    $scriptContents[$i] = "";
		  }
		else
		  {
		    if ($DEBUG gt 0) {print DEBUGOUT "Replacing \"$scriptContents[$i]\" with \"$lineToReplace\"\n";}
		    $scriptContents[$i] = $lineToReplace."\n";
		  }
		delete $rejectLines{$lineToReplace};
		last REPLACE_LOOP;
	      }
	    ++$i;
	  }
      }
    if ($DEBUG gt 0) {print DEBUGOUT "Writing new script to $newScriptFilename\n";}
    open FOUT, ">$newScriptFilename" or ExitOnError("Could not open $newScriptFilename for write");
    print FOUT @scriptContents;
    close FOUT;

  }




####################################
## Print out the conflicting Lines##
####################################

print "Content-Type: text/plain\n\n";
if(scalar keys %rejectLines > 0)
  {
    foreach my $lineConflict (keys %rejectLines)
      {
	print "CONFLICT:\"$lineConflict\":\"$rejectLines{$lineConflict}\"\n";
      }

  }
else
  {
    print "SUCCESS\n";
  }


##########
## DONE ##
##########

if ($DEBUG gt 0) {print DEBUGOUT "--AddScript Done--\n";}

