#!/usr/bin/perl -w
#RemoveRule.cgi

use strict;
use FileHandle;
use CGI;

my $RULEFILE = "./AdBlocker.txt";
my $TEMPFILE = "/tmp/removerule.tmp";
my $passwordtxt = "A@#qt*<5";

#################
## Debug Stuff ##
#################

my $DEBUG = 0;
if ($DEBUG gt 0)
  {
    open DEBUGOUT , ">>/tmp/RemoveRule.log" or die ("can't write to /tmp/RemoveRule.log");
    DEBUGOUT->autoflush(1);
    print DEBUGOUT "\n--RemoveRule Starting--\n";
  }

#################
## Error Stuff ##
#################

sub ExitOnError
  {
    print "Content-Type: text/plain\n\n";
    print "ERROR\n";
    print join "\n", @_;
    exit;
  }

#################
## Print PWord ##
## Prompt      ##
#################

sub PrintPasswordPrompt
{
	print "Content-Type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Remove Ad Blocker Rule</TITLE></HEAD><BODY>";
	if(defined $_[0]) { print "$_[0]\n"; }
	print "<b>Enter Password to Continue:</b>";
	print "<FORM METHOD=\"POST\" action=\"RemoveRule.cgi\">";
	print "<input name=\"password\">";
	print "<input type=\"SUBMIT\" value=\"Continue\">";
	print "</FORM></BODY></HTML>";
	exit;
}

############################
## Print List of Ad Rules ##
############################

sub PrintOneItem
{
        my($ruleNum, $ruleName, $rulePattern) = @_;

	print "<tr><td><input type=checkbox name=to_delete value=$ruleNum></td><td>$ruleNum</td><td>$ruleName</td><td>$rulePattern</td></tr>";
}

sub PrintList
{
        open(FIN, $RULEFILE) || die "Could not open $RULEFILE";
	
	print "Content-Type: text/html\n\n";
	print "<HTML><HEAD><TITLE>Remove Ad Blocker Rule</TITLE></HEAD><BODY>";
	if(defined $_[0]) { print "$_[0]\n"; }
	print "<FORM METHOD=POST action=\"RemoveRule.cgi\">";
	print "<INPUT TYPE=hidden name=password value=\"$passwordtxt\">";
	print "<table cellspacing=0 cellpadding=4 width=100%>";
	print "<tr><td><b>Delete</b></td><td><B>ID</b></td><td><b>Friendly Name</b></td><td><b>Pattern</b></td></tr>";
	my $nextLine;
	while($nextLine = <FIN>)
	{
	     if($nextLine =~ m/^(\d+)\s+(\S+)/)
	     {
	          my $ruleID = $1;
		  my $ruleStr = $2;

		  my $decodedStr = CGI::unescape($ruleStr);
		  my ($type, $name, $pattern);

		  if($decodedStr =~ m/^(.)(.+)<(.+)/)
	          {
		       $type = $1;
		       $name = $2;
		       $pattern = $3;
		  }
		  elsif($decodedStr =~ m/^(.)(.+)/)
		  {
		       $type = $1;
		       $pattern = $2;		       
		  }
		  else {die "Didn't recognize the rule string $nextLine"}; #oh shit..
		  
		  if($type eq "@")
		  {
		       $name = "<i>" . $name . "<i>";
		  }

		  if($type ne "!")
		  {
		       PrintOneItem($ruleID, $name, $pattern);
		  }
	     }
	}

	print "</table><INPUT type=submit value=\"Delete Selected Items\"></form></body></html>";

	close(FIN);
}

#######################
## Remove some rules ##
#######################

sub RemoveRules
{
        my @indices = @_;
	my $index;
	my %deleteHash;
	foreach $index (@indices)
	{
	     $deleteHash{$index} = "delete";
	}
        open FIN, "$RULEFILE" or ExitOnError("Could not open $RULEFILE for read");
	my @ruleFile = <FIN>;
	close FIN;

	open FOUT, ">$TEMPFILE" or ExitOnError("Could not open $TEMPFILE for writing");
	my $line;
	my $highestIndex = 0;
	my @removeCommands;

	foreach $line (@ruleFile)
	{
	     chomp $line;
	     my $thisIndex = (split "\t", $line)[0];
	     if($deleteHash{$thisIndex} eq "delete")
	     {
	          $line = CGI::unescape($line);
	          $line =~ m/^\d+\s+[^<]*<*([^<]+)\Z/;
		  my $pattern = $1;
		  push @removeCommands, CGI::escape("!$pattern");
	     }
	     else
	     {
	          print FOUT "$line\n";
	     }
	     $highestIndex = $thisIndex;
	}
	foreach $line (@removeCommands)
	{
	     $highestIndex++;
	     print FOUT "$highestIndex\t$line\n";
	}
	close FOUT;
	`mv -f $TEMPFILE $RULEFILE`;
	PrintList("<b>DeletionSuccessful</b>");
	exit;
}

####################
## Get the params ##
####################

my $q = new CGI;

my @removeIndices = $q->param('to_delete');
my $password = $q->param('password');

if ( !defined $password )  { PrintPasswordPrompt(); }
elsif ( $password ne $passwordtxt ) { PrintPasswordPrompt( "Password Incorrect." );  }
elsif (!defined @removeIndices){PrintList();}
else { RemoveRules(@removeIndices);}
