#!/usr/bin/perl
# scp-update.pl
# Oct 12, 2000
#
# used to move in the updated scripts directory that was
# transfered from scriptupdate.<gamma.>freedom.net
# it is executed by an ssh command run by a cron job on 
# scriptupdate:/turf/scp-scripts.sh
#

chdir "/usr/freedom/scriptserver";
print "running scp-update.pl";

my $transfn = "./scp-scripts.tgz";
my $olddir = "./scripto/";
my $newdir = "./scripts/";
my $LOK_EXCL  = 2;
my $LOK_NBLK  = 4;
my $LOK_UNDO  = 8; 
my $lokfile = "./.lock";

# tar file must be there 
die "error file doesnt exist $transfn" unless -e $transfn;

# no update on going so shared lock on the lock file.
die "error unable to open $lokfile" unless open LOKFILE,  $lokfile;
 
# blocking lock so will wait until all shared locks are removed
die "error unable to lock $lokfile" unless flock LOKFILE, $LOK_EXCL ;

# backup scripts directory
# rename fails if olddir exists

`rm -rf $olddir`;

die "error unable to backup $newdir" unless rename $newdir, $olddir;

# untar updated directory
`/bin/tar -xzf $transfn`;

# release the lock 
flock LOKFILE, $LOK_UNDO;
close LOKFILE;

# remove the tar file
unlink $transfn;

