# Rudimentary error handling definitions

#$Id: error.tcl,v 1.3 2001/04/19 19:18:00 alainc Exp $

set ERR(FATAL)     "fatal"
set ERR(NODB)      "nodb"
set ERR(TIMEOUT)   "timeout"
set ERR(NOT_FOUND) "not_found"

set err_Debug 0

proc err_Init {debug} {
   global err_Debug
   set err_Debug $debug
}

proc err {log func msg} {
   upvar $log logf
   global err_Debug
   puts $logf "ERROR : $func : $msg"
   if {$err_Debug} { send_error "ERROR : $func : $msg\n" }
}
