#$Id: keyqry.tcl,v 1.4 2001/04/19 19:18:00 alainc Exp $

source $env(ZK_FRTOOLBOX_ROOT)/tools/server-bvt/inc/defs.tcl
source $TESTLIB_RT/inc/netinfo.tcl

#############################################################################
#                                                                           #
#  FUNCTIONS THAT WORK THROUGH TKQ                                          #
#                                                                           #
#############################################################################

proc keyqry_CheckKey {type name kqd_index key_status entityInfo} {

    global ports entity_type keyInfo
    upvar $key_status k_status
    upvar $entityInfo eInfo
    set old_timeout timeout
    set timeout 30

    # save current process if there is one
    if [info exists spawn_id] {	set oldspawnid spawn_id }

    for {set type_index 0} {$type_index<$keyInfo(type,num)} {incr type_index +1} {
      for {set version_index 0} {$version_index<$keyInfo(version,num)} {incr version_index +1} {
        spawn /bin/sh -c "tkq $eInfo(keyqry,$kqd_index,ipaddr) $ports(keyqry) $type $name $keyInfo(type,$type_index) $keyInfo(version,$version_index)"

            expect {
                 timeout {set current_key_status timeout
                          return 1}
                 "tkq: valid"  {set current_key_status valid}
                 "tkq: invalid"  {set current_key_status invalid}
                 "tkq: Key not found"  {set current_key_status notfound}
                 "frKeyQryRecvKey: ERROR" {set current_key_status spurious
                                           return 1}
            }
            wait
            close
            set k_status($keyInfo(type,$type_index),$keyInfo(version,$version_index)) $current_key_status
      }
    }

    # restore the old process if there was one
    if [info exists oldspawnid] { set spawn_id $oldspawnid }
    set timeout old_timeout
 
    return 0
}

#############################################################################
#                                                                           #
#  FUNCTIONS THAT WORK THROUGH LODE CLIENT                                  #
#                                                                           #
#############################################################################

# ---------
# DeleteKey
# ---------
# erase all trace of nym key with frlodec

proc keyqry_DeleteKey {nymname entityInfo} {
    upvar $entityInfo info
    global ports frlodec env

    spawn /bin/sh -c "frlodec --hostname $info(keyqry,0,ipaddr) --user $frlodec(user) --passphrase $frlodec(passphrase) --reason $frlodec(reason) --service keydb --operation \"delete $nymname\""
    wait
    close
}

# ---------
# RestoreKey
# ---------
# restore nym key with frlodec
proc keyqry_RestoreKey {nymname entityInfo} {
    upvar $entityInfo info
    global ports frlodec env

    spawn /bin/sh -c "frlodec --hostname $info(keyqry,0,ipaddr) --user $frlodec(user) --passphrase $frlodec(passphrase) --reason $frlodec(reason) --service keydb --operation \"restore $nymname\""
    wait
    close
}

