if [ $# -lt 2 ] ; then
    echo "Usage: $0 <network> <network_domain (i.e. gamma.freedom.net)> [rootdir]"
    echo ""
fi

# ** Do we want to clean out old netconf.tcl just to be safe?


# parse arguments
network=$1
network_domain=$2
homeDir=$HOME
if [ $# -ge 3 ] ; then
    homeDir=$3
fi

# global constants
pphrs="11111111"

# location of support files, should change as per user
#scriptDir=../lib
scriptDir="./network-sanity/lib"

if [ ! -d $homeDir/.freedom ] ; then
        mkdir -p $homeDir/.freedom
fi
if [ ! -d $homeDir/.freedom/$network ] ; then
        mkdir -p $homeDir/.freedom/$network
fi
if [ ! -d $homeDir/.freedom/$network/keys ] ; then
        mkdir -p $homeDir/.freedom/$network/keys
fi

#setup the new passphrase.info file
if [ ! -f $homeDir/.freedom/$network/passphrase.info ] ; then
    $scriptDir/fr_passchg.exp $homeDir/.freedom/$network/passphrase.info $pphrs
fi

#setup the new passphrase.file file
if [ ! -f $homeDir/.freedom/$network/passphrase.file ] ; then
    echo -n "$pphrs" > "$homeDir/.freedom/$network/passphrase.file"
fi

# generate config file for network
$scriptDir/ns-config-file-gen.exp $network $network_domain $homeDir

