#$Id: ns-keyqry.tcl,v 1.2 2001/04/19 19:18:16 alainc Exp $

source $env(NETSANITY_ROOT)/inc/ns-defs.tcl
source $env(NETSANITY_ROOT)/inc/ns-netinfo.tcl

#############################################################################
#                                                                           #
#  FUNCTIONS THAT WORK THROUGH TKQ                                          #
#                                                                           #
#############################################################################

proc keyqry_CheckKey {type name kqd_index key_status entityInfo} {

    global ports entity_type keyInfo
    upvar $key_status k_status
    upvar $entityInfo eInfo
    set old_timeout timeout
    set timeout 30

    Vputs 1 "Querying for keys for $type $name at KQD $eInfo(keyqry,$kqd_index,name)"
    for {set type_index 0} {$type_index<$keyInfo(type,num)} {incr type_index +1} {
      for {set version_index 0} {$version_index<$keyInfo(version,num)} {incr version_index +1} {
        spawn /bin/sh -c "tkq $eInfo(keyqry,$kqd_index,ipaddr) $ports(keyqry) $type $name $keyInfo(type,$type_index) $keyInfo(version,$version_index)"

            expect {
                 timeout {error "Timeout querying for key $type $name at KQD $eInfo(keyqry,$kqd_index,ipaddr)"}
                 "tkq: valid"  {set current_key_status valid}
                 "tkq: invalid"  {set current_key_status invalid}
                 "tkq: Key not found"  {set current_key_status notfound}
                 "frKeyQryRecvKey: ERROR" {error "Spurious response from KQS $eInfo(keyqry,$kqd_index,ipaddr) qhen querying for key for $type $name"}
                                           
            }
            wait
            close
            set k_status($keyInfo(type,$type_index),$keyInfo(version,$version_index)) $current_key_status
      }
    }

    set timeout old_timeout
 
    return 0
}

#############################################################################
#                                                                           #
#  FUNCTIONS THAT WORK THROUGH LODE CLIENT                                  #
#                                                                           #
#############################################################################

# ---------
# DeleteKey
# ---------
# erase all trace of nym key with frlodec

proc keyqry_DeleteKey {nymname entityInfo} {
    upvar $entityInfo info
    global ports frlodec env

    Vputs 1 "Deleting key for nym $nymname at lode server $info(keyqry,0,ipaddr)"
    spawn /bin/sh -c "frlodec --hostname $info(keyqry,0,ipaddr) --user $frlodec(user) --passphrase $frlodec(passphrase) --reason $frlodec(reason) --service keydb --operation \"delete $nymname\""
    wait
    close
}

# ---------
# RestoreKey
# ---------
# restore nym key with frlodec
proc keyqry_RestoreKey {nymname entityInfo} {
    upvar $entityInfo info
    global ports frlodec env

    Vputs 1 "Restoring key for nym $nymname at lode server $info(keyqry,0,ipaddr)"
    spawn /bin/sh -c "frlodec --hostname $info(keyqry,0,ipaddr) --user $frlodec(user) --passphrase $frlodec(passphrase) --reason $frlodec(reason) --service keydb --operation \"restore $nymname\""
    wait
    close
}

