#!/usr/bin/perl -w

#$Id: check_services.pm,v 1.2 2001/04/19 19:18:27 alainc Exp $

#This script will perform a sanity check on all entities private keys in a given network description

use lib './lib';
use lib '../lib';
use lib '../../lib';


use Logger;

my $network = $context->get_host()->get_network;
my $morpheus = $context->get_morpheus_configuration();
my $name = $context->get_host()->get_parameters()->{$entity};
my $host = $context->get_host();
my $hostname = $host->get_hostname();



my @possible_entities = ("aip","niqs","niss","nymsrv","toksrv","keyqry");

#Key directory names corresponding to entities
my %grep_string;
$grep_string{aip} = 'fr\\\aipd';
$grep_string{niqs} = 'frniq\\\sd';
$grep_string{niss} = 'frnis\\\sd';
$grep_string{nymsrv} = 'frnsc\\\pd';
$grep_string{toksrv} = 'frsnap\\\d';
$grep_string{keyqry} = 'k\\\qd';

sub check_service {
  my $serv_string = shift;
  my $command = ("ps auxww | egrep " . $serv_string);
  my $rc = system($command);
  return $rc;
}
  

foreach my $entity (@possible_entities) {
    if (!$host->has_entity("$entity")) {
#      Logger::informational("not a $entity");
    } else {
      Logger::informational("Checking that $entity is running on $hostname");
      if (!(check_service $grep_string{$entity})) {
        Logger::informational("$entity is running");
      } else {
        Logger::error("$entity is not running on $hostname");
        exit 1; 
      }
    }
}


exit 0;
