#!/usr/bin/perl -w

#$Id: ns-setup.pm,v 1.2 2001/04/19 19:18:27 alainc Exp $

#This script does the following:
# create the necessary links to run all network sanity tests
# create link to genesis-remote.conf
# ensure necessary binaries exist and are defined in path
# ensure that laip can be run???? (zkshim)

# Assumes that ZK_ROOT env variable is set


# create link to network sanity directory
Misc::system_to_log_file("ln -s $ENV{'ZK_ROOT'}/freedom/tools/server-bvt/network-sanity $ENV{'ZK_ROOT'}/tools/morpheus");

# create link to genesis-remote.conf
Misc::system_to_log_file("ln -s $ENV{'ZK_ROOT'}/freedom/tools/genesis/prog/genesis-remote.conf $ENV{'ZK_ROOT'}/tools/morpheus");

# check that necessary binaries are there

my @binary_list = ("laip","nymtool","niqs_test","fr_listroutes","frpasschg","tkq");

foreach my $binary (@binary_list) {
  if (Misc::system_to_log_file("which $binary")) {
    Logger::error("Can not find $binary -- ensure that it exists in path");
    exit 1
  }
}

exit 0


