#!/usr/bin/perl -w

#$Id: privkey_sanity.pm,v 1.2 2001/04/19 19:18:27 alainc Exp $

#This script will perform a sanity check on all entities private keys in a given network description

use lib './lib';
use lib '../lib';
use lib '../../lib';


use Logger;

my $network = $context->get_host()->get_network;
my $morpheus = $context->get_morpheus_configuration();
my $name = $context->get_host()->get_parameters()->{$entity};
my $host = $context->get_host();



#Get KQD hostname
my $kqds;
$kqds = $network->get_entities('keyqry');

my $kqd_hostname = $kqds->[0]->get_hostname();

my($privkey_dir_root) = "/usr/freedom/privkey";

#BECOME FREEDOM
#become freedom

if (!Misc::become_user('freedom')) {
  Logger::error_and_die("Could not become user freedom\n");
}

#make sure has necessary path variables to run frgenkeys
$ENV{'PATH'} .= ':/usr/freedom/bin:/usr/freedom/sbin';
$ENV{'USER'} = 'freedom';
$ENV{'HOME'} = '/usr/freedom';

# Generate a list of privkey dirs to check
my @possible_entities = ("aip","niqs","niss","nymsrv","toksrv","keyqry");

#Key directory names corresponding to entities
my %key_dir_name;
$key_dir_name{aip} = 'AIP';
$key_dir_name{coreaip} = 'AIP';
$key_dir_name{niqs} = 'NIQSD';
$key_dir_name{niss} = 'NISSD';
$key_dir_name{nymsrv} = 'NymServer';
$key_dir_name{toksrv} = 'TokenServer';
$key_dir_name{keyqry} = 'KeyQryServer';
$key_dir_name{nidb} = 'NIDB';

my $privkey_dir;

sub run_check_keys {
  my $dir = shift;
  my $kqd = shift;
  my $tmp_file = "/tmp/check_priv_keys.log.$$";
  system("rm -f $tmp_file");
#  my $rc = (Misc::system_to_log_file("../bin/check_priv_keys.exp $dir $kqd $tmp_file"))/256;
#  my $rc = (Misc::system_to_log_file("./network-sanity/bin/check_priv_keys.exp $dir $kqd $tmp_file"))/256;
  my $rc = (system("./network-sanity/bin/check_priv_keys.exp $dir $kqd $tmp_file"))/256;
  unlink($tmp_file);
  return $rc;
}
  

my $test_result = 0;
foreach my $entity (@possible_entities) {
    if (!$host->has_entity("$entity")) {
#      Logger::informational("not a $entity");
    } else {
      Logger::informational(" ");
      Logger::informational("CHECKING $name $entity="
			    . $host->get_parameters()->{$entity}
			   );
      $privkey_dir = $key_dir_name{$entity};
# check that privkeys are there
      if (!(-f "$privkey_dir_root/$privkey_dir/crypt/1")) {
         Logger::error("Private key for $entity is missing in $privkey_dir_root/$privkey_dir/crypt/1\n");
         $test_result = 1;
      } else {
	if (run_check_keys("$privkey_dir_root/$privkey_dir/crypt", $kqd_hostname)) {
          Logger::error("Private key check for $entity key $privkey_dir_root/$privkey_dir/crypt/1 failed");
          $test_result = 1;
        }
      }
      if (!(-f "$privkey_dir_root/$privkey_dir/sig/1")) {
         Logger::error("Private key for $entity is missing in $privkey_dir_root/$privkey_dir/sig/1\n");
         $test_result = 1;
      } else {
	if (run_check_keys("$privkey_dir_root/$privkey_dir/sig", $kqd_hostname)) {
          Logger::error("Private key check for $entity key $privkey_dir_root/$privkey_dir/sig/1 failed");
          $test_result = 1;
        }
      }
    }
}

Logger::informational(" Done checking keys");

exit $test_result;
