# $Id: rpm_sanity_check.pm,v 1.2 2001/04/19 19:18:27 alainc Exp $

#!/usr/bin/perl -w


use lib './lib';
use lib '../lib';
use lib './lib/IO';
use lib '../lib/IO';

use Logger;

#Checks that approriate rpms are installed on a given machine

my $entity = $context->get_entity();
my $genesis = $context->get_genesis_configuration();
my $network = $context->get_host()->get_network();
my $host = $context->get_host();
my $rpms = $network->get_rpms();


#RPMS THAT SHOULD BE INSTALLED ON EACH ENTITY TYPE

my @rpm_list;

#all hosts should have either base qmail package (mail hosts) or base freedom package (all others)
if (!$context->get_host()->has_entity('notfree')) {
  push @rpm_list, "base"; 
} else {
  push @rpm_list, "qmail"; 
}

#check what other entities associated with rpms are on the machine 
my @possible_entities = ("keyqry","nymsrv","niqs","toksrv","fmg","imep","imepb","pop","nmta","nmtab","relay");

my $check;

foreach my $check_entity (@possible_entities) {
  if ($host->has_entity("$check_entity")) {
# coreaip
    if ($check_entity eq "coreaip") {
       push(@rpm_list,"coreaip");
# knt package should be on nymsrv, toksrv, kqd, niqs
    } elsif ($check_entity =~ "nymsrv|toksrv|keyqry|niqs") {
       push(@rpm_list,"knt");
# fmg package only on fmg
    } elsif ($check_entity eq "fmg") {
       push(@rpm_list,"fmg");
# MAIL RPMS
    } elsif ($check_entity eq "imep") {
       push(@rpm_list,"qmail-IMEP");
    } elsif ($check_entity eq "imepb") {
       push(@rpm_list,"qmail-IMEPB");
    } elsif ($check_entity eq "nmta") {
       push(@rpm_list,"qmail-NMTA");
    } elsif ($check_entity eq "nmtab") {
       push(@rpm_list,"qmail-NMTAB");
    } elsif ($check_entity eq "pop") {
       push(@rpm_list,"qmail-POP");
    } elsif ($check_entity eq "relay") {
       push(@rpm_list,"qmail-RELAY");
    }
  }
}


my $rpm;
my $rpm_name;
my $errmsg;
my $rc = 0;

foreach $rpm (@rpm_list) {
  my $rpm_name = $rpms->get_parameters()->{lc($rpm)}; 
  if (!defined($rpm_name)) {
    Logger::fatal("no rpm $rpm_name");
  }    
# need to trim '.i386.rpm' extension - this is a hack
  if ($rpm_name =~ /(.*)\.i386\.rpm/) {
    $rpm_name = $1;
  }
#  if (Misc::system_to_log_file("rpm -q $rpm_name")) {
  if (system("rpm -q $rpm_name")) {
     Logger::error("rpm $rpm_name is not installed\n");
     $rc = 1;
  } else {
     Logger::informational("rpm $rpm_name is installed");
  }
}


if (!$rc) {
  Logger::informational("All rpms are installed");
}

return $rc;
