#!/usr/bin/perl -w
#
#************************************************************************
#
#   File:		getLinkCountPerEntity.pl
#
#   Author(s):		Thierry Baron
#
#   Created:		21 Feb 2000
#
#   Last Revision:	$Date: 2000/03/21 19:50:58 $
#
#   Description:	
#
#   $Revision: 1.1 $
#
#
#   $Id: getLinkCountPerEntity.pl,v 1.1 2000/03/21 19:50:58 thierry Exp $	
#
#   Copyright (c) 2000 Zero-Knowledge Systems, Inc
#   Please see the copyright notice included in this distribution 
#   for full details.
#
#***********************************************************************/

use strict;
use Getopt::Long;
use FileHandle;

require 'getEntityMapping.pl';

##
## Global Variables
##
my $version = '$Id: getLinkCountPerEntity.pl,v 1.1 2000/03/21 19:50:58 thierry Exp $';
my $revision= '$Revision: 1.1 $';
my $progname= 'getLinkCountPerEntity.pl';
my $DEFAULT_TOPOLOGY_REPORT = "/turf/thierry/test/tmp/TopoPerAip";
my $DEFAULT_NIQS_HOSTNAME   = "niqs.freedom.net";
my $DEFAULT_NIQS_PORT       = "51107";

##
## autoflush mode
##
STDERR->autoflush(1);
STDOUT->autoflush(1);


##
##
sub getNumberOfLinkPerEntity {
  my($niqsHostname, $niqsPort) = @_;

  my %entityHash = ();
  getAipsMapping(\%entityHash, $niqsHostname, $niqsPort, "entityip");
  my @tmpRes = `fr_listroutes --niqs.hostname $niqsHostname --niqs.port $niqsPort --withDead --printEnt --NHops 2`;

  my($count, $entity);
  my(%entityLinkCount)=();
  foreach $entity (keys %entityHash){
    $count = scalar grep (/2\s+$entity/, @tmpRes);
#    printf("%16s: %4d\n", $entity, $count);
    $entityLinkCount{$entity} = $count;
  }
  return (%entityLinkCount);
}

##
## if program is not run as sub programm do the job
## and print out the information
##
if($0 =~ /$progname/){
  my %result = getNumberOfLinkPerEntity ("niqs.freedom.net",51107);
  my $key;
  foreach $key (sort keys %result){
    printf("%16s: %4d\n", $key, $result{$key});
  }
}

##
##
##

1;

#   $Log: getLinkCountPerEntity.pl,v $
#   Revision 1.1  2000/03/21 19:50:58  thierry
#   add tools for topology: get number of link for an aip and get entity mapping
#
