#ifndef HEADERS_H_
#define HEADERS_H_

/*
 * This file is used to provide the same header structs across different
 * platforms.  Everyone seems to have their own special flavour for 
 * structs which represent various standard types of headers.
 */


/*
 * This ethernet header is based on the structure define in <linux/if_ether.h>
 */

#ifndef USE_SOCKPACKET
#define ETH_ALEN   6   /* Octets in one ethernet address */

struct ethhdr
{
        unsigned char   h_dest[ETH_ALEN];       /* destination eth addr */
        unsigned char   h_source[ETH_ALEN];     /* source ether addr    */
        unsigned short  h_proto;                /* packet type ID field */
};

/*
 * This macro is used to return the length of a unix domain socket
 */

#ifndef SUN_LEN
#define SUN_LEN(ptr) ((size_t) (((struct sockaddr_un *) 0)->sun_path)         \
                      + strlen ((ptr)->sun_path))
#endif /* SUN_LEN */
#endif /* USE_SOCKPACKET */
#endif /* HEADERS_H_ */
