#include "zks.h"

#warning "Dont't use this code! It has security bugs and will be removed before the next release (bug 4392)."

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#ifndef WIN32
#include <unistd.h>
#endif /* WIN32 */
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <zkIntTypes.h>
#include <zkError.h>
#include <zkHash.h>
#include "ident.h"

#define CMD_SZ 128

/**
 *  Open a connection to the zkidentd server command socket
 */

int
frIdentOpen (
  ZkError err ,
  char * identd ,
  int * sdptr ,
  int timeout )
{
  const char * func = "frIdentOpen";
  struct sockaddr_un identd_addr;
  int sd  = 0;
  int syserr = 0;

  (void)func;

  zkErrorClear(err);

  identd_addr.sun_family = AF_UNIX;
  strncpy(identd_addr.sun_path,identd,64);

  *sdptr = -1;
  if ((sd = socket(AF_UNIX,SOCK_DGRAM,0)) < 0) {
    zkErrorSystemSet(err,"frIdentOpen",ZKERR,ZKMWORMHOLE,"socket failed");
    return 0;
  }
  while (timeout > 0) {
    if (connect(sd,(struct sockaddr *) &identd_addr,sizeof(identd_addr)) != 0) {
      if( !syserr ) {
        syserr = errno;
      }
      sleep(1);
      timeout -= 1;
    } else {
      *sdptr = sd;
      return 1;
    }
  }
  zkErrorSet_va(err,"frIdentOpen",ZKERR,ZKMWORMHOLE,ZKESOCKET,
             "Unable to get connection to zkidentd server (errno=%d)", syserr);
  close(sd);
  return 0;
}
  
int
frIdentAdd (
  ZkError err ,
  int sd ,
  uint16_t src ,
  uint16_t dst ,
  uint32_t aci ,
  char * name )
{
  const char * func = "frIdentAdd";
  char cmd[CMD_SZ]; 
  int bytes = 0;
  int size = 0;

  (void)func;

  if (name) {
    size = 11 + strlen(name);
    cmd[0] = size / 0x100;
    cmd[1] = size % 0x100;
    cmd[2] = 1;
    cmd[3] = src / 0x100;
    cmd[4] = src % 0x100;
    cmd[5] = dst / 0x100;
    cmd[6] = dst % 0x100;
    cmd[7] = (aci & 0xFF000000) >> 24;
    cmd[8] = (aci & 0xFF0000) >> 16;
    cmd[9] =  (aci & 0xFF00) >> 8;
    cmd[10] =  aci & 0xFF;
    memcpy(&(cmd[11]),name,strlen(name));
    bytes = send(sd,cmd,size,0);
    if (bytes < size) {
      zkErrorSystemSet(err,"frIdentAdd",ZKERR,ZKMWORMHOLE,
                       "failed to send zkidentd update command for aci/port map");
      return 0;
    }
    return 1;
  }
  zkErrorSet(err,"frIdentAdd",ZKERR,ZKMWORMHOLE,ZKENULLPTR,NULL);
  return 0;
}

int
frIdentDel (
  ZkError err ,
  int sd ,
  uint32_t aci  )
{
  const char * func = "frIdentDel";
  char cmd[CMD_SZ];
  int bytes = 0;
  int size = 0;

  (void)func;
  
  size = 7;    
  cmd[0] = size / 0x100;
  cmd[1] = size % 0x100;
  cmd[2] = 3;
  cmd[3] = (aci & 0xFF000000) >> 24;
  cmd[4] = (aci & 0xFF0000) >> 16;
  cmd[5] =  (aci & 0xFF00) >> 8;
  cmd[6] =  aci & 0xFF;

  bytes = send(sd,cmd,size,0);
  if (bytes < size) {
    zkErrorSystemSet(err,"frIdentDel",ZKERR,ZKMWORMHOLE,
                     "failed to send zkidentd delete command for nym");
    return 0;
  }
  return 1;
}

  
