#include "zks.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <zkError.h>
#include <zkLog.h>
#include <zkPacket.h>
#include "acimap.h"
#include "worm.h"

int
main (
  int argc ,
  char ** argv )
{  
  FrAciMap acimap;
  ZkError err = NULL;
  ZkLog log = NULL;
  char line[128];
  FILE * f = stdin;
  char * tok = NULL;
  char * tok1 = NULL;
  char * tok2 = NULL;
  int newmap = 0;
  FrAci aci;
  uint16_t port;
  uint16_t port2;
  uint32_t src_addr;

  zkErrorNew(&err);
  zkErrorLog(err,&log);
  zkLogSetStream(log,stderr);
  zkLogEnable(log);

  memset(&acimap,0,sizeof(FrAciMap));

  (void)argc;

  if (!frAciMapInit(err, 
                    log,
                    &acimap, 
                    atoi(argv[1]), 
                    atoi(argv[2]), 
                    atoi(argv[3]),
                    atoi(argv[4]),
                    atoi(argv[5]),
                    NULL)) {
    printf("frAciMapInit:  failed!\n");
  }
  
  while (!feof(f)) {
    fgets(line,128,f);
    if (line[0] == 0) continue;
    tok = strtok(line,"\t ");
    if (tok == NULL) continue;
    if (strcmp(tok,"send") == 0) {
      tok1 = strtok(NULL,"\t ");
      if (tok1 == NULL) continue;
      tok2 = strtok(NULL,"\t ");
      if (tok2 == NULL) continue;
      aci = (FrAci) atoi(tok1);
      port = (uint16_t) atoi(tok2);
      port2 = 0;
      if (!frAciMapGetSourcePort(err,&acimap, ZK_IPPROTO_TCP,aci,0,port,&port2,&newmap)) {
        printf("frAciMapGetSourcePort:  failed!\n");
      } else {
        printf("Outgoing (aci %d port %d) port is %d\n",aci,port,port2);
      }
    } else if (strcmp(tok,"recv") == 0) {
      tok1 = strtok(NULL,"\t ");
      if (tok1 == NULL) continue;
      port2 = (uint16_t) atoi(tok1);
      if (!frAciMapGetDestPortAndAci(err,&acimap,port2,&port,&aci,&src_addr)) {
        printf("frAciMapGetDestPortAndAci:  failed!\n");
      } else {
        printf("Incoming (%d) goes to ACI %d port %d\n",port2,aci,port);
      } 
    } else if (strcmp(tok,"del") == 0) {
      tok1 = strtok(NULL,"\t ");
      if (tok1 == NULL) continue;
      aci = (FrAci) atoi(tok1);
      if (!frAciMapDeleteAci(err,&acimap,aci)) {
        printf("frAciMapDeleteAci:  failed!\n");
      } else {
        printf("ACI %d deleted\n",aci);
      }
    } else {
      printf("Unknown command\n");
    }
  }
  exit(0);
  return 0; /* to shut up insure */
}
