#ifndef ARPFNC_H_
#define ARPFNC_H_

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if_arp.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * ARP flags consist of the following possible values:
 *   ATF_COM            Completed entry (ha valid)
 *   ATF_PERM           Permanent entry 
 *   ATF_PUBL           Publish entry
 *   ATF_USETRAILERS    Has requested trailers
 *   ATF_NETMASK        Want to use a netmask (only for proxy entries)
 *   ATF_DONTPUB        Don't answer this addresses
 *   ATF_MAGIC          Automatically added entry 
 * These flags can be ORed together
 */

int arpSet (
  struct sockaddr * ,                 /* Protocol (IP) address */
  struct sockaddr * ,                 /* Hardware (Ethernet) address */
  int );                              /* ARP flags */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ARPFNC_H_ */
