#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <zkIntTypes.h>
#include <zkError.h>
#include <zkLog.h>
#include "ether.h"

int
main (
  int argc ,
  char ** argv )
{
  struct sockaddr address;
  ZkError err = NULL;
  ZkLog log = NULL;
  int i = 0; /* Loop index */

  if (argc != 2) {
    fprintf(stderr,"usage:  %s device\n\n",argv[0]);
    exit(EXIT_FAILURE);
  }

  /*
   * Enable auto logging 
   */

  zkErrorNew(&err);
  zkErrorLog(err,&log);
  zkLogSetStream(log,stdout);
  zkLogEnable(log);

  if (!zkEtherGetAddress(err,argv[1],&address)) {
    printf("zkEtherGetAddress:  failed\n");
  } else {
    printf("Device: %s\nFamily: 0x%X\nAddress: %02X",argv[1],
           address.sa_family,(unsigned char) address.sa_data[0]);
    for (i = 1; i < 6; i++) {
      printf(":%02X",(unsigned char) address.sa_data[i]);
    }
    printf("\n\n");
  }

  zkErrorFree(&err);
  exit(EXIT_SUCCESS);
  return 0; /* to shut up insure */
}
