#include "zks.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <zkError.h>
#include "support.h"

DLLExport int
LoadTextFile (
  ZkError err,
  char * filename ,
  char ** buffer ,
  int * size )
{
  FILE * f = NULL;
  struct stat sbuf;

  zkErrorClear(err);
  if ((filename == NULL) || (buffer == NULL) || (size == NULL)) {
    zkErrorSet(err,"LoadTextFile",ZKERR,0,ZKENULLPTR,NULL);
    return 0;
  }
  if (stat(filename,&sbuf) != 0) {
    zkErrorSet(err,"LoadTextFile",ZKERR,0,ZKEFILEOPEN,NULL);
    return 0;
  }
  *buffer = (char *) malloc(sbuf.st_size + 1);
  if (*buffer == NULL) {
    zkErrorSet(err,"LoadTextFile",ZKERR,0,ZKENOMEM,NULL);
    return 0;
  }
  f = fopen(filename,"rb");
#warning clean this up
  if (f == NULL) {  
    zkErrorSet(err,"LoadTextFile",ZKERR,0,ZKEFILEOPEN,filename);
    return 0;
  }
  *size = fread(*buffer,1,sbuf.st_size,f);
  fclose(f);
  (*buffer)[sbuf.st_size] = (char) 0;
  return 1;
}

  
