#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>

#define BUFFER_SZ 256
#define LINE_SZ 256
#define MESG_SZ 256

int
main (
  int argc ,
  char ** argv )
{
  char * progname = NULL; /* name of the test program */
  int uds = 0; /* Unix domain socket to talk to identd */
  unsigned short server,client; /* ports */
  struct sockaddr_un addr; /* Address of the identd */
  char mesg[MESG_SZ]; /* For sending commands to identd */
  char line[LINE_SZ]; /* for reading commands */
  int size = 0; /* Size of the message */
  char * tok = NULL; /* Parse token */
  FILE * f = stdin; /* Input stream */
  int bytes = 0; /* Bytes written to ident server socket */
  unsigned long aci = 0;


  if ((progname = strrchr(argv[0],'/')) == NULL) {
    progname = argv[0];
  }

  if (argc != 2) {
    fprintf(stderr,"usage:  %s identuds\n\n",progname);
    exit(EXIT_FAILURE);
  }

  addr.sun_family = AF_UNIX;
  strcpy(addr.sun_path,argv[1]); /* bug: audit */

  if ((uds = socket(AF_UNIX,SOCK_DGRAM,0)) < 0) {
    perror("socket");
    exit(EXIT_FAILURE);
  }
/* 
  if (connect(uds,(struct sockaddr *) &addr, SUN_LEN(&addr)) != 0) {
    perror("connect");
    exit(EXIT_FAILURE);
  }
   
*/
  while (!feof(f)) {
    line[0] = (char) 0;
    fgets(line,LINE_SZ,f);
    if (line[0] == (char) 0) {
      continue;
    }
    tok = strtok(line," \t\n\r");
    if (tok == NULL) { 
      continue;
    } else if (strcmp(tok,"add") == 0) {
      if ((tok = strtok(NULL," \t\n\r")) == NULL) {       
        fprintf(stdout,"Missing server port\n");
        continue;
      }
      server = (unsigned short) atoi(tok);
      if ((tok = strtok(NULL," \t\n\r")) == NULL) {       
        fprintf(stdout,"Missing client port\n");
        continue;
      }
      client = (unsigned short) atoi(tok);
      if ((tok = strtok(NULL," \t\n\r")) == NULL) {       
        fprintf(stdout,"Missing ACI\n");
        continue;
      }
      aci = atoi(tok);
      if ((tok = strtok(NULL," \t\n\r")) == NULL) {       
        fprintf(stdout,"Missing nym\n");
        continue;
      }
      size = 11 + strlen(tok);
      mesg[0] = size / 0x100;
      mesg[1] = size % 0x100;
      mesg[2] = 1;
      mesg[3] = server / 0x100;
      mesg[4] = server % 0x100;
      mesg[5] = client / 0x100;
      mesg[6] = client % 0x100;
      mesg[7] = (aci & 0xFF000000) >> 24;
      mesg[8] = (aci & 0xFF0000) >> 16;
      mesg[9] =  (aci & 0xFF00) >> 8;
      mesg[10] =  aci & 0xFF;
      memcpy(&(mesg[11]),tok,strlen(tok));
    } else if (strcmp(tok,"del") == 0) {
      if ((tok = strtok(NULL," \t\n\r")) == NULL) {       
        fprintf(stdout,"Missing nym\n");
        continue;
      }
      size = 3 + strlen(tok);
      mesg[0] = size / 0x100;
      mesg[1] = size % 0x100;
      mesg[2] = 2;
      memcpy(&(mesg[3]),tok,strlen(tok));
    } else if (strcmp(tok,"acidel") == 0) {
      if ((tok = strtok(NULL," \t\n\r")) == NULL) {       
        fprintf(stdout,"Missing aci\n");
        continue;
      }
      aci = atoi(tok);
      size = 7 ;
      mesg[0] = size / 0x100;
      mesg[1] = size % 0x100;
      mesg[2] = 3;
      mesg[3] = (aci & 0xFF000000) >> 24;
      mesg[4] = (aci & 0xFF0000) >> 16;
      mesg[5] =  (aci & 0xFF00) >> 8;
      mesg[6] =  aci & 0xFF;
    } else if (strcmp(tok,"quit") == 0) {
      exit(EXIT_SUCCESS);
    } else {
      fprintf(stdout,"Valid commands are add, del, and quit\n");
      continue;
    }
/*
    size = write(uds,mesg,size);
 */
    if ((bytes = sendto(uds,mesg,size,0,&addr,sizeof(addr))) < 0) {
      perror("sendto");
    }


    fprintf(stdout,"Wrote %d bytes\n",bytes);
  }
  return 0;
}
  
