#ifndef KSCP_H_
#define KSCP_H_

#define VERSION_KSCP_STR "Zero-Knowledge Systems Key Server V1.0 ("__DATE__")"

#if 0
/*
 * This spits out the server's public key, you'd probably shouldnt trust it
 * to verify the signature of other data that comes from this server (let's
 * be realistic here ;-) but it's good for debugging
 */
int zkKeyCommandShowPubKey (
  ZkError ,
  ZkipSession ,
  void * );
#endif

int zkKeyCommandCreate (
  ZkError ,
  ZkipSession ,
  void * );

int zkKeyCommandUpdate (
  ZkError ,
  ZkipSession ,
  void * );

int zkKeyCommandRemove (
  ZkError ,             /* Return the error if one occured */
  ZkipSession ,         /* Handles the current connection */
  void * );             /* Extra data passed  by server */


/*
 * This is the command callback which implements the KSCP "query" command
 */

#if 0
int zkKeyCommandQuery (
  ZkError ,
  ZkipSession ,
  void * );

int zkKeyCommandAuthenticate (
  ZkError ,
  ZkipSession ,
  void * );
#endif

#endif /* KSCP_H_ */
