
#include <sys/types.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/strsubr.h>
#include <sys/socket.h>
#include <sys/sockio.h>
#include <sys/dlpi.h>
#include <sys/kstat.h>
#include <sys/kmem.h>
#include <sys/ethernet.h>
#include <sys/tihdr.h>
#include <sys/stat.h>
#include <sys/modctl.h>
#include <sys/errno.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <net/route.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>

#undef IPOPT_EOL
#undef IPOPT_NOP
#undef IPOPT_LSRR
#undef IPOPT_RR
#undef IPOPT_SSRR
#include <inet/common.h>
#include <inet/ip.h>
#include <inet/tcp.h>

#include <netinet/ip_mroute.h>

#include <sys/proc.h>
#include <sys/file.h>
#include <sys/socketvar.h>
#include <sys/kmem_impl.h>

#include <stddef.h>

/* These two must be last in the system include sequence */
#include <sys/ddi.h>
#include <sys/sunddi.h>

#if !defined(__inline__) && !defined(__GNUC__)
#pragma "warning: turning off __inline__ for this compiler"
#define __inline__
#endif

#ifndef msgblen
#define msgblen(bp) ((bp)->b_wptr - (bp)->b_rptr)
#endif

typedef struct ip iphdr_t;
#define ip_saddr ip_src.s_addr
#define ip_daddr ip_dst.s_addr

#if ZK_SOLARIS < 57
typedef unsigned long   t_uscalar_t;
#endif

#if defined(_LP64) || defined(_I32LPx)
#define INADDRLFMT	""
#else
#define INADDRLFMT	"l"
#endif

#define KRWLOCK_T	krwlock_t
#define KRWLOCK_DECL(rwl) KRWLOCK_T rwl

#define INIT_LOCK(plck, str)	rw_init (plck, str, RW_DRIVER, NULL)
#define DESTROY_LOCK(plck)	rw_destroy (plck)

#define READ_LOCK(x)		rw_enter(x, RW_READER)
#define WRITE_LOCK(x,f)		rw_enter(x, RW_WRITER)
#define READ_UNLOCK(x)		rw_exit(x)
#define WRITE_UNLOCK(x,f)	rw_exit(x)

#define ZKMB_T			mblk_t

#if ZK_SOLARIS >= 57
#define ZKTIMER_T		timeout_id_t
#define ZKTIMERFUNCARG_T	void *
#define ZK_TIME_CURRENT()	ddi_get_time()
#else
#define ZKTIMER_T		int
#define ZKTIMERFUNCARG_T	caddr_t
static __inline__ unsigned long ZK_TIME_CURRENT() {
	uint32_t timestamp;

	(void) drv_getparm(TIME, &timestamp);
	return (unsigned long)timestamp;
}
#endif
#define ZK_SET_TIMER(t, o, f, a) *t = timeout(f, a, (o) * drv_usectohz(1000000))
#define ZK_CANCEL_TIMER(t)      if(*t != 0) { untimeout(*t); *t = 0; }


#define KMALLOC(s)	kmem_alloc(s, KM_NOSLEEP)
#define KMFREE(p)	kmem_free(p, sizeof(*(p)))

/**************************************************************************/
/* The following is borrowed from <linux/list.h>                          */

struct list_head {
	struct list_head *next, *prev;
};

#define LIST_HEAD(name) \
	struct list_head name = { &name, &name }

#define INIT_LIST_HEAD(ptr) do { \
	(ptr)->next = (ptr); (ptr)->prev = (ptr); \
} while (0)

/*
 * Insert a new entry between two known consecutive entries. 
 *
 * This is only for internal list manipulation where we know
 * the prev/next entries already!
 */
static __inline__ void __list_add(struct list_head * new,
	struct list_head * prev,
	struct list_head * next)
{
	next->prev = new;
	new->next = next;
	new->prev = prev;
	prev->next = new;
}

/*
 * Insert a new entry after the specified head..
 */
static __inline__ void list_add(struct list_head *new, struct list_head *head)
{
	__list_add(new, head, head->next);
}

/*
 * Delete a list entry by making the prev/next entries
 * point to each other.
 *
 * This is only for internal list manipulation where we know
 * the prev/next entries already!
 */
static __inline__ void __list_del(struct list_head * prev,
				  struct list_head * next)
{
	next->prev = prev;
	prev->next = next;
}

static __inline__ void list_del(struct list_head *entry)
{
	__list_del(entry->prev, entry->next);
}

static __inline__ int list_empty(struct list_head *head)
{
	return head->next == head;
}

#define list_entry(ptr, type, member) \
	((type *)((char *)(ptr)-(ptrdiff_t)(&((type *)0)->member)))


/**************************************************************************/


typedef struct ZkShimNetIf {
	struct ZkShimNetIf *zif_nextp;
	ill_t	*zif_ill;
	void	*zif_iptr;
	void	*zif_optr;
	queue_t *zif_qout;
	struct	qinit	*zif_wqinfo;
	struct	qinit	zif_wqinit;
#ifdef ZKSHIM_WEDGEIN
	queue_t *zif_qin;
	struct	qinit	*zif_rqinfo;
	struct	qinit	zif_rqinit;
#endif
	char	zif_name[8];
	int	zif_hl;
} ZkShimNetIf;

#define zkShimCloneMb(mp) mp /* no need to clone under SunOS */

