
#define ZKSHIM_CACHE_INTERVAL	30		/* 30 seconds */
#define ZKSHIM_CACHE_TIMEOUT	120		/* 2 minutes */

typedef struct ZkShimCacheKey {
	uint8_t zck_ip_tos;
	uint8_t zck_ip_p;
	uint32_t zck_ip_src;
	uint32_t zck_ip_dst;
	uint16_t zck_sport;
	uint16_t zck_dport;
} ZkShimCacheKey;

#define ZK_KEYS_EQUAL(k1, k2) (((k1)->zck_ip_tos == (k2)->zck_ip_tos) && \
							((k1)->zck_ip_p == (k2)->zck_ip_p) && \
							((k1)->zck_ip_src == (k2)->zck_ip_src) && \
							((k1)->zck_ip_dst == (k2)->zck_ip_dst) && \
							((k1)->zck_sport == (k2)->zck_sport) && \
							((k1)->zck_dport == (k2)->zck_dport))

typedef struct ZkShimCacheEntry {
	struct list_head zce_list;
	ZkShimCacheKey zce_cachekey;
	ZkShimRuleEntry *zce_ruleentry;
	unsigned long zce_time;
} ZkShimCacheEntry;

void
zkShimCacheInit(void);

void
zkShimCacheCleanup(void);

void
zkShimCachePurge(void);

ZkShimRuleEntry *
zkShimCacheLookup(ZkShimCacheKey *zck);

void
zkShimCacheUpdate(ZkShimCacheKey *zck, ZkShimRuleEntry *zre);

