/*******************************************************************************
; zkshim driver
; Written by Marc Boucher <marc@mbsi.ca>
*******************************************************************************/

#if defined(DEBUG) && !defined(ZKSHIM_DEBUG)
#define ZKSHIM_DEBUG
#endif
#if defined(ZKSHIM_DEBUG) && !defined(DEBUG)
#define DEBUG 1
#endif

#include <zkshim_os.h>
#include <zkshim.h>

#define ZKSHIM_MODINFO	"ZKS SHIM Driver v"ZKSHIM_VERSION" pl"ZKSHIM_PATCHLEV

typedef struct ZkShimUnit {
	struct ZkShimUnit *zun_nextp;
	int zun_minordev;
#ifdef ZK_SOLARIS
	queue_t *zun_rdqueue;
	cred_t zun_cred;
#endif /* ZK_SOLARIS */
#ifdef ZK_LINUX
	struct file *zun_file;
	struct wait_queue *zun_waitq;
	struct fasync_struct *zun_fasync;
	struct sk_buff_head zun_readq;
#endif /* ZK_LINUX */
	struct ZkShimRuleEntry *zun_rules;
} ZkShimUnit;

#include "zkshim_util.h"
#include "zkshim_rules.h"
#include "zkshim_cache.h"
#include "zkshim_frag.h"

extern KRWLOCK_T zkShimLock; /* Lock protecting all global data */
extern ZkShimUnit	*zkShimUnitList; /* List of open units */

#define ZK_IS_UDPTCP(p)	((p == IPPROTO_TCP) || (p == IPPROTO_UDP))

