
#ifdef ZKSHIM_DEBUG
extern int zkshim_debug;

#ifdef __GNUC__
#define ZKDBG(l, fmt, args...) { if(zkshim_debug >= l) zkDebugOut (l, __FUNCTION__": " fmt "\n", ##args); };
#else
void
zkDebugOut_va(int level, char *fmt, __va_list ap);

static char *ZKDBG_file;
static int ZKDBG_line;
static void
ZKDBG_func(int level, char *fmt, ...)
{
	__va_list ap;
	char buf[150];

	va_start(ap, fmt);
	if(zkshim_debug >= level) {
		sprintf(buf, "%s(line %d): %s\n", ZKDBG_file, ZKDBG_line, fmt);
		zkDebugOut_va(level, buf, ap);
	}
	va_end(ap);
}
#define ZKDBG ZKDBG_file = __FILE__; ZKDBG_line = __LINE__; ZKDBG_func
#endif /* __GNUC__ */

#ifdef ZK_LINUX
#define zkDebugOut(lev, fmt, arg...) { if(lev >= 2) \
										printk(KERN_DEBUG fmt,##arg); \
									   else \
										printk(KERN_NOTICE fmt,##arg); \
									 }
#endif /* ZK_LINUX */

#ifdef ZK_SOLARIS
void
zkDebugOut(int level, char *fmt, ...);

char *
zkDebugOutQueue(struct queue *q, char *buf);

char *
zkDebugOutMblk(mblk_t *mp, char *buf);

const char *
zkDebugMsgType(unsigned char type);
#endif /* ZK_SOLARIS */

const char *
zkDebugIoctlType(int type);

#else
#ifdef __GNUC__
#define ZKDBG(x...)
#else
#define ZKDBG(x)
#endif /* __GNUC__ */
#endif /* ZKSHIM_DEBUG */

