/*
 * $Id: help.c,v 1.4 1999/03/31 22:39:11 bill Exp $
 */

#include "zks.h"

#include <zkIntTypes.h>
#include <stdio.h>
#include <stdlib.h>
#ifndef WIN32
#include <unistd.h>
#endif /* !WIN32 */
#include <string.h>
#include <zkError.h>
#include <zkLog.h>
#include <zkConfig.h>
#include <zkFile.h>
#include <zkBase64.h>
#include <ZKIP.h>
#include <zkipEngine.h>
#include <zkipSession.h>
#include <zkipClient.h>
#include "zkxfer.h"
#include "upload.h"
#include "xferClient.h"
#include <netdb.h>

int
zkXFERUsage (
  ZKXFERContext * context ,
  FILE * stream )
{
  if (context) {
    if (stream == NULL) {
      stream = stderr;
    }
    fprintf(stream,"%s\n\n",VERSION_XFER_STR);
    fprintf(stream,
"usage:  %s option1 option2 ...\n\n"
"The following options are available in either client or server mode.\n"
"By default, the application runs as a client.  You must specify the\n"
"--servermode command line switch if you wish to run as a server.\n\n"
"  --debug                     Turn on debugging output\n"
"  --config filename           Specify the configuration file\n"
"  --help                      Display this help screen\n"
"  --version                   Display the version number of this application\n"
"  --overwrite                 Allow XFER to overwrite files\n"
"  --permissions perm          Octal file create permissions (see chmod(2))\n"
"  [ --verbose level ]         Specify a verbose logging level from 0 to 100\n"
"  [ --logfile filename ]      Specify a logging file\n"
"  [ --servermode ]            Run the application as a server\n"
"\nThe following command line switches are available in client mode.\n\n"
"  --server hostname           Specify a remote XFER server hostname\n"
"  --port port                 Specify the remote XFER server port\n"
"  --local filename            Local file/pathname to send\n"
"  [ --delete ]                Remove files which were succesfully transfered\n"
"  [ --remote filename ]       Filename on remote XFER server\n"
"                              (If this option is not specified, the local\n"
"                              filename is used.  This option has not effect\n"
"                              when transfering a directory)\n"
"  --command cmd               The specific client command, which must be one\n"
"                              of the following:\n"            
"                              directory     Displays files on the server\n"
"                              upload        To upload a file\n"
"                              download      To download a file\n"
"  [ --timeout seconds ]       Specify a connection timeout in seconds\n"
"\nThe following command line switches are available in server mode\n\n"
"  --inbox directory           Directory used to store incoming files\n"
"  [ --outbox directory ]      Directory used to store outgoing files\n"
"  [ --port port ]             Server listening port\n"
"  [ --pidfile filename ]      Specify a file to store the server PID\n"
"  [ --name servername ]       Specify an optional server name\n"
"  [ --maxdata bytes ]         Specify a maximum amount of data per transfer\n"
"  [ --maxconnections number ] The maximum number of concurrent connections\n"
"  [ --dontfork ]              Dont return to the shell prompt on launch\n"
"  [ --name ]                  A unique server name (for logging purposes)\n\n"
"Options in [ square ] brackets are optional.  If you specify a configuration\n"
"file and command line parameters, the command line parameters will take\n"
"precedence.\n\n",context->progname);
    return 1;
  }
  return 0;
}



