/*
 *  $Id: zkTypes.h,v 1.10 2001/04/19 17:34:58 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *  
 *  zkTypes.h
 */ 
#ifndef _ZKTYPES_H
#define _ZKTYPES_H


#if defined(__MWERKS__) || defined(_MSC_VER)
#	pragma once
#endif

#include "zkIntTypes.h"			/* uint8_t, etc. */

/* For some reason, someone decided that INADDR_NONE should be accessible 
 * from just about everywhere.  Unfortunately, INADDR_NONE isn't standard 
 * (AFAIK, it's only defined under Linux and Windows).  So we need to 
 * #include the proper header on the platforms where it's defined, and 
 * define it ourselves on the other platforms.
 */
#if defined(ZK_LINUX)
# include <netinet/in.h>
#elif defined(WIN32)
# include <winsock2.h>
#elif defined(__APPLE__)
# include <netinet/in.h>
#else
# define INADDR_NONE 0xfffffff
#endif


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

    typedef struct stdHdr {
        uint8_t zkVers;         /* Version */
        uint8_t zkType;         /* Type of pkt */
        uint32_t zkLen;         /* Length of pkt */
    } ZkStdHdr;                 /* StdHdr */


/*
** boolean type 
*/
typedef uint32_t                ZkBool;



#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _ZKTYPES_H */
