/* redefine PR error codes (-5000 increasing towards 0) */

#define ZKPR_OUT_OF_MEMORY_ERROR           PR_OUT_OF_MEMORY_ERROR 
#define ZKPR_BAD_DESCRIPTOR_ERROR          PR_BAD_DESCRIPTOR_ERROR      
#define ZKPR_WOULD_BLOCK_ERROR             PR_WOULD_BLOCK_ERROR         
#define ZKPR_ACCESS_FAULT_ERROR            PR_ACCESS_FAULT_ERROR         
#define ZKPR_INVALID_METHOD_ERROR          PR_INVALID_METHOD_ERROR      
#define ZKPR_ILLEGAL_ACCESS_ERROR          PR_ILLEGAL_ACCESS_ERROR       
#define ZKPR_UNKNOWN_ERROR                 PR_UNKNOWN_ERROR              
#define ZKPR_PENDING_INTERRUPT_ERROR       PR_PENDING_INTERRUPT_ERROR      
#define ZKPR_NOT_IMPLEMENTED_ERROR         PR_NOT_IMPLEMENTED_ERROR          
#define ZKPR_IO_ERROR                      PR_IO_ERROR                   
#define ZKPR_IO_TIMEOUT_ERROR              PR_IO_TIMEOUT_ERROR             
#define ZKPR_IO_PENDING_ERROR              PR_IO_PENDING_ERROR            
#define ZKPR_DIRECTORY_OPEN_ERROR          PR_DIRECTORY_OPEN_ERROR           
#define ZKPR_INVALID_ARGUMENT_ERROR        PR_INVALID_ARGUMENT_ERROR     
#define ZKPR_ADDRESS_NOT_AVAILABLE_ERROR   PR_ADDRESS_NOT_AVAILABLE_ERROR      
#define ZKPR_ADDRESS_NOT_SUPPORTED_ERROR   PR_ADDRESS_NOT_SUPPORTED_ERROR      
#define ZKPR_IS_CONNECTED_ERROR            PR_IS_CONNECTED_ERROR            
#define ZKPR_BAD_ADDRESS_ERROR             PR_BAD_ADDRESS_ERROR            
#define ZKPR_ADDRESS_IN_USE_ERROR          PR_ADDRESS_IN_USE_ERROR          
#define ZKPR_CONNECT_REFUSED_ERROR         PR_CONNECT_REFUSED_ERROR          
#define ZKPR_NETWORK_UNREACHABLE_ERROR     PR_NETWORK_UNREACHABLE_ERROR       
#define ZKPR_CONNECT_TIMEOUT_ERROR         PR_CONNECT_TIMEOUT_ERROR         
#define ZKPR_NOT_CONNECTED_ERROR           PR_NOT_CONNECTED_ERROR           
#define ZKPR_LOAD_LIBRARY_ERROR            PR_LOAD_LIBRARY_ERROR              
#define ZKPR_UNLOAD_LIBRARY_ERROR          PR_UNLOAD_LIBRARY_ERROR          
#define ZKPR_FIND_SYMBOL_ERROR             PR_FIND_SYMBOL_ERROR          
#define ZKPR_INSUFFICIENT_RESOURCES_ERROR  PR_INSUFFICIENT_RESOURCES_ERROR     
#define ZKPR_DIRECTORY_LOOKUP_ERROR        PR_DIRECTORY_LOOKUP_ERROR          
#define ZKPR_TPD_RANGE_ERROR               PR_TPD_RANGE_ERROR               
#define ZKPR_PROC_DESC_TABLE_FULL_ERROR    PR_PROC_DESC_TABLE_FULL_ERROR      
#define ZKPR_SYS_DESC_TABLE_FULL_ERROR     PR_SYS_DESC_TABLE_FULL_ERROR        
#define ZKPR_NOT_SOCKET_ERROR              PR_NOT_SOCKET_ERROR             
#define ZKPR_NOT_TCP_SOCKET_ERROR          PR_NOT_TCP_SOCKET_ERROR             
#define ZKPR_SOCKET_ADDRESS_IS_BOUND_ERROR PR_SOCKET_ADDRESS_IS_BOUND_ERROR
#define ZKPR_NO_ACCESS_RIGHTS_ERROR        PR_NO_ACCESS_RIGHTS_ERROR         
#define ZKPR_OPERATION_NOT_SUPPORTED_ERROR PR_OPERATION_NOT_SUPPORTED_ERROR
#define ZKPR_PROTOCOL_NOT_SUPPORTED_ERROR  PR_PROTOCOL_NOT_SUPPORTED_ERROR 
#define ZKPR_REMOTE_FILE_ERROR             PR_REMOTE_FILE_ERROR             
#define ZKPR_BUFFER_OVERFLOW_ERROR         PR_BUFFER_OVERFLOW_ERROR        
#define ZKPR_CONNECT_RESET_ERROR           PR_CONNECT_RESET_ERROR         
#define ZKPR_RANGE_ERROR                   PR_RANGE_ERROR                 
#define ZKPR_DEADLOCK_ERROR                PR_DEADLOCK_ERROR                 
#define ZKPR_FILE_IS_LOCKED_ERROR          PR_FILE_IS_LOCKED_ERROR         
#define ZKPR_FILE_TOO_BIG_ERROR            PR_FILE_TOO_BIG_ERROR               
#define ZKPR_NO_DEVICE_SPACE_ERROR         PR_NO_DEVICE_SPACE_ERROR          
#define ZKPR_PIPE_ERROR                    PR_PIPE_ERROR                  
#define ZKPR_NO_SEEK_DEVICE_ERROR          PR_NO_SEEK_DEVICE_ERROR         
#define ZKPR_IS_DIRECTORY_ERROR            PR_IS_DIRECTORY_ERROR          
#define ZKPR_LOOP_ERROR                    PR_LOOP_ERROR                  
#define ZKPR_NAME_TOO_LONG_ERROR           PR_NAME_TOO_LONG_ERROR         
#define ZKPR_FILE_NOT_FOUND_ERROR          PR_FILE_NOT_FOUND_ERROR          
#define ZKPR_NOT_DIRECTORY_ERROR           PR_NOT_DIRECTORY_ERROR            
#define ZKPR_READ_ONLY_FILESYSTEM_ERROR    PR_READ_ONLY_FILESYSTEM_ERROR      
#define ZKPR_DIRECTORY_NOT_EMPTY_ERROR     PR_DIRECTORY_NOT_EMPTY_ERROR       
#define ZKPR_FILESYSTEM_MOUNTED_ERROR      PR_FILESYSTEM_MOUNTED_ERROR        
#define ZKPR_NOT_SAME_DEVICE_ERROR         PR_NOT_SAME_DEVICE_ERROR          
#define ZKPR_DIRECTORY_CORRUPTED_ERROR     PR_DIRECTORY_CORRUPTED_ERROR       
#define ZKPR_FILE_EXISTS_ERROR             PR_FILE_EXISTS_ERROR               
#define ZKPR_MAX_DIRECTORY_ENTRIES_ERROR   PR_MAX_DIRECTORY_ENTRIES_ERROR     
#define ZKPR_INVALID_DEVICE_STATE_ERROR    PR_INVALID_DEVICE_STATE_ERROR     
#define ZKPR_DEVICE_IS_LOCKED_ERROR        PR_DEVICE_IS_LOCKED_ERROR          
#define ZKPR_NO_MORE_FILES_ERROR           PR_NO_MORE_FILES_ERROR              
#define ZKPR_END_OF_FILE_ERROR             PR_END_OF_FILE_ERROR            
#define ZKPR_FILE_SEEK_ERROR               PR_FILE_SEEK_ERROR                 
#define ZKPR_FILE_IS_BUSY_ERROR            PR_FILE_IS_BUSY_ERROR           
#define ZKPR_RESERVED_ERROR_5935           PR_RESERVED_ERROR_5935         
#define ZKPR_IN_PROGRESS_ERROR             PR_IN_PROGRESS_ERROR             
#define ZKPR_ALREADY_INITIATED_ERROR       PR_ALREADY_INITIATED_ERROR       
#define ZKPR_GROUP_EMPTY_ERROR             PR_GROUP_EMPTY_ERROR              
#define ZKPR_INVALID_STATE_ERROR           PR_INVALID_STATE_ERROR         
#define ZKPR_NETWORK_DOWN_ERROR            PR_NETWORK_DOWN_ERROR            
#define ZKPR_SOCKET_SHUTDOWN_ERROR         PR_SOCKET_SHUTDOWN_ERROR          
#define ZKPR_CONNECT_ABORTED_ERROR         PR_CONNECT_ABORTED_ERROR          
#define ZKPR_HOST_UNREACHABLE_ERROR        PR_HOST_UNREACHABLE_ERROR          
#define ZKPR_MAX_ERROR                     PR_MAX_ERROR                

/* error codes generated by czk classes (-6001 and decreasing) */

#define ZKPR_ErrorAddFD           (-6001L)
#define ZKPR_ErrorRemoveFD        (-6002L)
#define ZKPR_ErrorGetEventFD      (-6003L)
#define ZKPR_ErrorPeekNextTimeout (-6004L)
#define ZKPR_ErrorLockOpen        (-6005L)
#define ZKPR_ErrorTCPSocketOpen   (-6006L)
#define ZKPR_ErrorUDPSocketOpen   (-6007L)
#define ZKPR_ErrorSocketAccept    (-6008L)
#define ZKPR_ErrorConditionOpen   (-6009L)
