#ifndef _czkDirectory

#define _czkDirectory

#include "czknspr.h"

// Wrapper class for NSPR's directory i/o routines
//
class czkDirectory {

 private:

   ZKPRDir* dir;

 public:

   // constructor
   czkDirectory();
   
   // destructor
   virtual ~czkDirectory();

   // make a new directory
   int32_t mkDir(char*,      // full path name of directory to create 
                 int32_t);   // access mode - see PR_MkDir

   // remove an exsting directory
   int32_t rmDir(char*); // full path name of directory to remove 

   // open a directory for read access
   int32_t open(const char *); // full path name of directory to read

   // close the directory opened for reading
   int32_t close();          

   // read an entry from the opened directory
   int32_t read( ZKPRDirEntry**,     // returns directory entry read 
                 ZKPRDirFlags flag); // read option flag - see PR_ReadDir
};

#endif


