#ifndef _czkIntervalTime
#define _czkIntervalTime

#include <stdlib.h>
#include <cctype>
#include "czknspr.h"

#define CZKNSPR_TIMER_HARDLIMIT  ( ((uint32_t)-1) / PR_INTERVAL_MAX / 2)

// Wrapper class for NSPR's time interval routines
//
class czkIntervalTime {

 private:

 public:

   // constructor
   czkIntervalTime() {};

   // destructor
   virtual ~czkIntervalTime() {};

   // return interval time in seconds
   ZKPRIntervalTime getSeconds(int32_t sec ) 
      { return PR_SecondsToInterval( sec); } ;

   // return interval time in milleseconds
   ZKPRIntervalTime getMilliseconds(int32_t millisec ) 
      { return PR_MillisecondsToInterval( millisec); } ;

   // return interval time in microseconds
   ZKPRIntervalTime getMicroseconds(int32_t microsec ) 
      { return PR_MicrosecondsToInterval( microsec); } ;

   // return current interval time count
   ZKPRIntervalTime getIntervalNow() 
     { return PR_IntervalNow(); };
};

#endif


