#ifndef _czkSockAcceptor
#define _czkSockAcceptor

#include "nspr.h"
#include "prpriv.h"
 
#include <stdlib.h>
#include <string.h>

#include "czknspr.h"

#include "czkSocket.h"

// Class to handle incoming socket connections
//
// Methods:
//
//      open() - open a TCP socket
//
// Notes:
//
// the following sequence is required:
//
// czkSockAcceptor sock;
// czkSocket* csock;
//
// sock.open();
// sock.bind( addr);
// sock.listen( backlog);
// sock.accept(&csock, &addrfrom, timeout)
// 
class czkSockAcceptor : public czkSocket {

private:

public:

  czkSockAcceptor() {};
 
  virtual ~czkSockAcceptor() {};
 
  int32_t open() { return openTCPSocket(); }

  // connect not allowed
  int32_t connect( ZKPRNetAddr addr, ZKPRIntervalTime timeout) 
     { assert(0); assert(&addr); assert(timeout); };

  // send not allowed
  int32_t send( char* buf, int32_t buflen, int32_t flags, 
                ZKPRIntervalTime timeout)
    { assert(0); assert(buf); assert(buflen); assert(flags); 
      assert(timeout); };

  // recv not allowed
  int32_t recv( char* buf, int32_t buflen, int32_t flags, 
                ZKPRIntervalTime timeout)
    { assert(0); assert(buf); assert(buflen); assert(flags); 
      assert(timeout); };

  // sendto not allowed
  int32_t sendto( char* buf, int32_t buflen, int32_t flags, 
                  const ZKPRNetAddr* addr, ZKPRIntervalTime timeout)
    { assert(0); assert(buf); assert(buflen); assert(flags); 
      assert(addr); assert(timeout); };

  // recvfrom not allowed
  int32_t recvfrom( char* buf, int32_t buflen, int32_t flags,  
                    ZKPRNetAddr* addr, ZKPRIntervalTime timeout)
    { assert(0); assert(buf); assert(buflen); assert(flags); 
      assert(addr); assert(timeout); };
};

#endif 

