#ifndef _czkSockCoDgram

#define _czkSockCoDgram

#include "nspr.h"
#include "prpriv.h"

#include <stdlib.h>
#include <string.h>

#include "czknspr.h"

#include "czkSocket.h"

// Class to open a connected UDP socket
//
// Methods:
//
//      open() - open a UDP socket
//
// Notes:
//
// the following sequence is required:
//
// czkSockCoDgram sock;
//
// sock.open();
// sock.bind( addr);
//
class czkSockCoDgram : public czkSocket {

private:

public:

  czkSockCoDgram() {};

  virtual ~czkSockCoDgram() {};

  int32_t open() { return openUDPSocket(); };

  // assert not allowed
  int32_t listen(int32_t backlog) { assert(0); assert(backlog); };

  // accept not allowed
  int32_t accept( czkSocket** newSocket, ZKPRNetAddr* addrfrom, 
                  ZKPRIntervalTime timeout)
    { assert(0); assert(newSocket); assert(addrfrom); assert(timeout); };


};

#endif
