#ifndef _czkSockConnector

#define _czkSockConnector

#include "nspr.h"
#include "prpriv.h"

#include <stdlib.h>
#include <string.h>

#include "czknspr.h"

#include "czkSocket.h"

// Class to initiate socket connections
//
// Methods:
//
//      open() - open a TCP socket
//
// Notes:
//
// the following sequence is required:
//
// czkSockConnector sock;
//
// sock.open();
// sock.connect( addr, timeout);
// 
class czkSockConnector: public czkSocket {

private:

public:  

  czkSockConnector() { };
  virtual ~czkSockConnector() { };
  int32_t open() { return openTCPSocket(); };

  // bind not allowed
  int32_t bind(ZKPRNetAddr addr) { assert(0); assert(&addr); };

  // listen not allowed
  int32_t listen(int32_t backlog) { assert(0); assert(backlog); };

  // accept not allowed
  int32_t accept( czkSocket** newSocket, ZKPRNetAddr* addrfrom, 
                  ZKPRIntervalTime timeout)
    { assert(0); assert(newSocket); assert(addrfrom); assert(timeout); };

};

#endif

