#ifndef _czkSockDgram

#define _czkSockDgram

#include "nspr.h"
#include "prpriv.h"

#include <stdlib.h>
#include <string.h>

#include "czknspr.h"

#include "czkSocket.h"

// Class to create an unconnected UDP socket
//
// Methods:
//
//      open() - open a UDP socket
//
// Notes:
//
// the following sequence is required:
//
// czkSockDgram sock;
//
// sock.open();
// 
class czkSockDgram : public czkSocket {

private:

public:

  czkSockDgram() { };

  virtual ~czkSockDgram() { };

  int32_t open() { return openUDPSocket(); };

  // listen not allowed
  int32_t listen(int32_t backlog) { assert(0); assert(backlog); };

  // connect not allowed
  int32_t connect( ZKPRNetAddr addr, ZKPRIntervalTime timeout) 
     { assert(0); assert(&addr); assert(timeout); };

  // accept not allowed
  int32_t accept( czkSocket** newSocket, ZKPRNetAddr* addrfrom, 
                  ZKPRIntervalTime timeout)
    { assert(0); assert(newSocket); assert(addrfrom); assert(timeout); };

  // send not allowed
  int32_t send( char* buf, int32_t buflen, int32_t flags, 
                ZKPRIntervalTime timeout)
    { assert(0); assert(buf); assert(buflen); assert(flags); 
      assert(timeout); };

  // recv not allowed
  int32_t recv( char* buf, int32_t buflen, int32_t flags, 
                ZKPRIntervalTime timeout)
    { assert(0); assert(buf); assert(buflen); assert(flags); 
      assert(timeout); };

};

#endif
