#ifndef _czkSockNativeTCP

#define _czkSockNativeTCP

#include "nspr.h"
#include "prpriv.h"

#include <stdlib.h>
#include <unistd.h>	// for close()
#include <string.h>
#include <sys/socket.h>
#include <sys/un.h>

#include "czknspr.h"

#include "czkSocket.h"

// Class to wrap a "native" file descriptor into the coreloop framework
//
// Methods:
//
//      open(fd) - creates a ZKPRFileDesc* and stuffs fd into it.
//
// Notes:
//
// the following sequence is required:
//
// czkSockNativeTCP sock;
//
// do something to create fd
//
// sock.open(fd);
// 
class czkSockNativeTCP : public czkSocket {

private:

public:

  czkSockNativeTCP() { };

  virtual ~czkSockNativeTCP() { };

  int32_t open(int32_t fd) 
  { 

     int32_t ret = openTCPSocket();
     if (ret == ZKPR_SUCCESS) {
        ZKPRFileDesc* temp = getHandle();
        ::close(PR_FileDesc2NativeHandle(temp));
        PR_ChangeFileDescNativeHandle(temp, fd);
     }
     return ret;
           
  };

};

#endif
