#ifndef _czkSockNativeUDP

#define _czkSockNativeUDP

#include "nspr.h"
#include "prpriv.h"

#include <stdlib.h>
#include <unistd.h>      // for close()
#include <string.h>

#include "czknspr.h"

#include "czkSocket.h"

// Class to wrap a "native UDP-type" file descriptor into the 
// NSPR world & czkCoreLoop framework
//
// Methods:
//
//      open(fd) - creates a ZKPRFileDesc* and stuffs fd into it.
//
// Notes:
//
// the following sequence is required:
//
// czkSockNativeUDP sock;
//
// do something to create fd
//
// sock.open(fd);
// 
class czkSockNativeUDP : public czkSocket {

private:

public:

  czkSockNativeUDP() { };

  virtual ~czkSockNativeUDP() { };

  int32_t open(int32_t fd) 
  { 

     int32_t ret = openUDPSocket();
     if (ret == ZKPR_SUCCESS) {
        ZKPRFileDesc* temp = getHandle();
        ::close(PR_FileDesc2NativeHandle(temp));
        PR_ChangeFileDescNativeHandle(temp, fd);
     }
     return ret;
           
  };

};

#endif
