#ifndef _czkSystemInfo

#define _czkSystemInfo

#include "czknspr.h"

// Wrapper class for NSPR's system information routines
//
class czkSystemInfo {

 private:
  
 public:

   // constructor
   czkSystemInfo();

   // destructor
   virtual ~czkSystemInfo();

   // return host name
   int32_t getHostname(char*, int32_t);

   // return system name
   int32_t getSysname(char*, int32_t);

   // return release name
   int32_t getRelease(char*, int32_t);

   // return architectur
   int32_t getArchitecture(char*, int32_t);

   // return page size
   int32_t getPageSize();

   // return page shift
   int32_t getPageShift();

   // return the contents of an environment variable
   const char* getEnvVariable(char*);
};

#endif


