#ifndef _czkThread

#define _czkThread

#include "assert.h"

#include "czknspr.h"

// Wrapper class for spawning a thread:
//
// Constructor:  czkThread()
//
// Methods:
//
//      spawn - spawn a thread
//
//      join  - wait for specified thread to complete

class czkThread {

public:

  // spawn : return value is handle to newly created thread
  ZKPRThread* spawn( 
       void (*func)(void *arg),//entry point of thread - this routine
                               //must have one argument (void*)
       void* clientData,       //data passed to thread
       ZKPRThreadScope scope,  //ZKPR_LOCAL_THREAD or ZKPR_GLOBAL_THREAD
       ZKPRThreadState state,  //ZKPR_JOINABLE_THREAD or ZKPR_UNJOINABLE_THREAD
       PRThreadPriority priority, // 0 - 3 (LOW to HIGH)
       uint32_t stackSize);      // size of stack (0 is default)
           
  // join : return value is status code
  int32_t join( 
	   ZKPRThread* h);            // handle to thread to wait for.

};

#endif
  
