#ifndef _czkThreadTrack

#define _czkThreadTrack

#include "cAipComponent.h"

// class to track if a thread is alive
//
// an object of this class can be instantiated when the thread starts
// and will set the threadAlive data element of the component object
//
// when the thread exits, the destructor of this object will set
// the threadAlive data element to false.
//
// thus, querying the isThreadALive() method of the component object
// will return if the thread is alive or not 

class czkThreadTrack {

private:
  cAipComponent* pComponent;

public:

  czkThreadTrack( cAipComponent* component) 
     { pComponent = component; pComponent->setThreadAlive(true); };

  virtual ~czkThreadTrack() { pComponent->setThreadAlive(false); };

};

#endif
