#include "czkDirectory.h"

// constructor
czkDirectory::czkDirectory()
{
  dir = NULL;
}

// destructor
czkDirectory::~czkDirectory()
{
}

// open the specified directory
int32_t czkDirectory::open(const char *name)
{
  dir = PR_OpenDir( name);
  return dir ? ZKPR_SUCCESS : PR_GetError();
}

// close an open directory
int32_t czkDirectory::close()
{
  assert(dir);
  PRStatus status = PR_CloseDir(dir);
  return PRtoZKStatus( status);
}

// make a new directory
int32_t czkDirectory::mkDir(char *name, int32_t mode)
{
  ZKPRStatus status = PR_MkDir(name, mode);
  return PRtoZKStatus(status);
}

// remove (delete) an existing directory
int32_t czkDirectory::rmDir(char *name)
{
  ZKPRStatus status = PR_RmDir(name);
  return PRtoZKStatus(status);
}

// read an entry from an open directory
int32_t czkDirectory::read( ZKPRDirEntry** entry, ZKPRDirFlags flag)
{
  assert(dir);
  assert(entry);
  *entry = PR_ReadDir( dir, flag);
  return *entry ? ZKPR_SUCCESS : PR_GetError();
}



