#include "czkFile.h"

czkFile::czkFile()
{
  fd = NULL;
}

czkFile::~czkFile()
{
}

int32_t czkFile::open(const char *name, int32_t flags, int32_t mode)
{
  fd = PR_Open( name, flags, mode);
  return fd ? ZKPR_SUCCESS : PR_GetError();
}

int32_t czkFile::close()
{
  assert(fd);
  ZKPRStatus status = PR_Close(fd);
  fd = NULL;
  return PRtoZKStatus(status);
}

int32_t czkFile::deleteFile(char *name)
{
  ZKPRStatus status = PR_Delete(name);
  return PRtoZKStatus(status);
}

int32_t czkFile::renameFile(char *name, char* name2)
{
  ZKPRStatus status = PR_Rename(name, name2);
  return PRtoZKStatus(status);
}

int32_t czkFile::getFileInfo(ZKPRFileInfo* info)
{
  assert(fd);
  assert(info); 
  ZKPRStatus status = PR_GetOpenFileInfo( fd, info);
  return PRtoZKStatus(status);
}

int32_t czkFile::getFileInfo(ZKPRFileInfo* info, ZKPRFileDesc* fdin)
{
  assert(fdin);
  assert(info);
  ZKPRStatus status = PR_GetOpenFileInfo( fdin, info);
  return PRtoZKStatus(status);
}

int32_t czkFile::getFileInfo(ZKPRFileInfo* info, char* name)
{
  assert(info);
  ZKPRStatus status = PR_GetFileInfo( name, info);
  return PRtoZKStatus(status);
}

int32_t czkFile::getFileAccess(char* name, ZKPRAccessHow how)
{
  return PR_Access( name, how);
}

int32_t czkFile::read( char* buf, int32_t n)
{
  assert(fd);
  int32_t nr = PR_Read( fd, buf, n);
  return PRtoZKStatus(nr);
}

int32_t czkFile::write( char* buf, int32_t n)
{
  assert(fd);
  int32_t nw = PR_Write( fd, buf, n);
  return PRtoZKStatus(nw);
}

int32_t czkFile::getAvailable()
{
  assert(fd);
  int32_t av = PR_Available( fd);
  return PRtoZKStatus(av);

}

int32_t czkFile::sync()
{
  assert(fd);
  ZKPRStatus status = PR_Sync(fd);
  return PRtoZKStatus(status);
}


