#include "czkLock.h"

czkLock::czkLock()
{
  lockid = NULL;
}

czkLock::~czkLock()
{
}

int32_t czkLock::open()
{
  int32_t rc;

  assert(lockid == NULL);
  lockid = PR_NewLock();
  if (!lockid) {
    rc = ZKPR_ErrorLockOpen;
  }
  else {
    rc = ZKPR_SUCCESS;
  }
  return rc;
}

void czkLock::close()
{
  assert(lockid);
  PR_DestroyLock( lockid);
  lockid = NULL;
}  

void czkLock::acquire()
{
  assert(lockid);
  PR_Lock( lockid);
}

int32_t czkLock::release()
{
  assert(lockid);
  ZKPRStatus status = PR_Unlock( lockid);
  return PRtoZKStatus(status);
}

ZKPRLock* czkLock::getLockid()
{
  assert(lockid);
  return lockid;
}


