#include "czkSystemInfo.h"

// constructor
czkSystemInfo::czkSystemInfo()
{
}

// destructor
czkSystemInfo::~czkSystemInfo()
{
}

// return hostname
int32_t czkSystemInfo::getHostname(char *buf, int32_t buflen)
{  
  assert(buf);
  ZKPRStatus status = PR_GetSystemInfo( ZKPR_SI_HOSTNAME, buf, buflen); 
  return PRtoZKStatus(status); 
}

// return sysname
int32_t czkSystemInfo::getSysname(char *buf, int32_t buflen)
{  
  assert(buf);
  ZKPRStatus status = PR_GetSystemInfo( ZKPR_SI_SYSNAME, buf, buflen); 
  return PRtoZKStatus(status); 
}

// return release 
int32_t czkSystemInfo::getRelease(char *buf, int32_t buflen)
{  
  assert(buf);
  ZKPRStatus status = PR_GetSystemInfo( ZKPR_SI_RELEASE, buf, buflen); 
  return PRtoZKStatus(status); 
}

// return architecture
int32_t czkSystemInfo::getArchitecture(char *buf, int32_t buflen)
{  
  assert(buf);
  ZKPRStatus status = PR_GetSystemInfo( ZKPR_SI_ARCHITECTURE, buf, buflen); 
  return PRtoZKStatus(status); 
}

// return page size
int32_t czkSystemInfo::getPageSize()
{  
  return PR_GetPageSize(); 
}

// return page shift
int32_t czkSystemInfo::getPageShift()
{  
  return PR_GetPageShift(); 
}

// return value of env variable
const char* czkSystemInfo::getEnvVariable( char* var)
{
  return PR_GetEnv( var);
}
