/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef ZKALLOC_H_
#define ZKALLOC_H_

#include "zkStdlib.h"
#include "zkError.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern DLLExport int zkMemAlloc(ZkError err, void **mem, size_t msz);
  extern DLLExport int zkMemCalloc(ZkError err, void **mem, size_t nmemb, size_t msz);
  extern DLLExport int zkMemAppend(ZkError err, void **dst, size_t *dsz, const void *app, size_t asz);
  extern DLLExport int zkMemDup(ZkError err, void **dst, const void *src, size_t n);
#if !defined(ZK_KERNEL)
  extern DLLExport int zkMemRealloc(ZkError err, void **p, size_t n);
#endif
  extern DLLExport int zkMemRealloc_s(ZkError err, void **p, size_t oldsize, size_t newsize);
  extern DLLExport int zkMemFree(ZkError err, void **mem);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ZKALLOC_H_ */
