/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef _ZKBASE64_H
#define _ZKBASE64_H

#include "zks.h"

#ifndef _ZKERROR_H
#include "zkError.h"
#endif /* _ZKERROR_H */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

# define zkBinarySizeToBase64Size(n)    ((((n)+2)*4)/3)

DLLExport int zkConvertToBase64 (
  ZkError ,                  		/* Returns the error */
  const unsigned char * ,               /* Source text to convert to base64 */
  unsigned char * ,                     /* Pre-allocate base64 dest buffer */
  size_t );                             /* Number of bytes to convert */

DLLExport int zkConvertFromBase64 (
  ZkError ,                             /* Returns the error */
  const unsigned char * ,               /* Source base64 text buffer */
  unsigned char * ,                     /* Pre-allocated raw dest buffer */
  size_t * );                           /* Returns size of the raw text */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _ZKBASE64_H */
