/*
 *	zkCtype.h	(c) 2000 Zero-Knowledge Systems, Inc.
 *	
 *	$Id: zkCtype.h,v 1.2 2001/04/19 17:26:48 alainc Exp $
 *	
 *	Wrapper for <ctype.h>
 *	
 *	This file defines at least the following symbols:
 *
 *	Functions:
 *		int isalnum(int c);
 *		int isalpha(int c);
 *		int iscntrl(int c);
 *		int isdigit(int c);
 *		int isgraph(int c);
 *		int islower(int c);
 *		int isprint(int c);
 *		int ispunct(int c);
 *		int isspace(int c);
 *		int isupper(int c);
 *		int isxdigit(int c);
 *		int tolower(int c);
 *		int toupper(int c); 
 *	
 */

#ifndef ZKCTYPE_H_
#define ZKCTYPE_H_

#if defined(__MWERKS__) || defined(_MSC_VER)
#	pragma once
#endif


/* Merely include the Standard C version of the ctype header.  Makes 
it look like this header isn't very useful, but this will change once 
we move some libraries into kernel-space. */

#if !defined(ZK_KERNEL)
#	include <ctype.h>
#else
#	include "zkKrtCtype.h"
#endif


#endif	/* ZKCTYPE_H_ */
