/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef ZKDNS_H_
#define ZKDNS_H_

#include "zks.h"
#include "zkIntTypes.h"
#include "zkError.h"
#include "zkNetdb.h"

#if !defined(ZK_KERNEL)

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

DLLExport int zkGetHostByName (
  ZkError ,            /* Returns the error if any occured */
  const char * ,       /* NUL terminated host name to lookup */
  struct hostent ** ); /* Returns a pointer to a static hostent struct */ 

DLLExport int zkGetHostByAddr (
  ZkError ,            /* Returns the error if any occured */
  const char * ,       /* Address to lookup */
  int ,                /* Length (in bytes) of the address */
  int ,                /* Address type (usually AF_INET) */
  struct hostent ** ); /* Returns a pointer to a static hostent struct */ 

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	/* !defined(ZK_KERNEL) */

#endif /* ZKDNS_H_ */
