/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef ZKDIR_H_
#define ZKDIR_H_

#include "zks.h"
#include "zkIntTypes.h"
#include "zkTypes.h"
#include "zkError.h"
#include "zkList.h"


#if !defined(ZK_KERNEL)

typedef struct zk_dir *ZkDir;


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern DLLExport int zkDirNew(ZkError err, ZkDir *dir);
  extern DLLExport int zkDirFree(ZkError err, ZkDir *dir);
  extern DLLExport int zkDirOpen(ZkError err, ZkDir dir, const char *path);
  extern DLLExport int zkDirClose(ZkError err, ZkDir dir);
  extern DLLExport int zkDirNext(ZkError err, ZkDir dir);
  extern DLLExport int zkDirGetFileName(ZkError err, ZkDir dir, const char **name);
  extern DLLExport int zkDirListEntries(ZkError err, const char * dirName, ZkList *listP);
  extern DLLExport int zkDirListEntriesFree(ZkError err, ZkList *listP);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	/* !defined(ZK_KERNEL) */

#endif /* ZKDIR_H_ */
