/*
 * zkLib.h
 * $Id: zkLib.h,v 1.4 2001/04/19 17:26:48 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 */
#ifndef _ZKLIB_H
#define _ZKLIB_H

#include "zkStdlib.h"
#include "zkError.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


extern const char *zkLibGetBuildRelease(ZkError err);

#if defined(macintosh)
	
	/* CFM init & term procs suitable for applications such as testbeds */
	pascal short			ZksAppInit(const struct CFragSystem7InitBlock *initBlock);
	pascal void				ZksAppTerm(void);
	
	/* CFM init & term procs suitable for shared libraries */
	pascal short			ZksLibInit(const struct CFragSystem7InitBlock *initBlock);
	pascal void				ZksLibTerm(void);
	
	/* returns the shared library's FSSpec */
	const struct FSSpec*	ZksLibGetSpec(void);
	
#endif	/* defined(macintosh) */


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
