/*
 * zkMemPool.h
 * $Id: zkMemPool.h,v 1.3 2001/04/19 17:26:48 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):
 * Luc Boulianne <luc@zks.net>

 */
#ifndef _ZKMEMPOOL_H
#define _ZKMEMPOOL_H

#include "zkStdlib.h"
#include "zkError.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  typedef struct T_ZkMemPool *ZkMemPool;
  
#define ZKMEMPOOL_ENTRIES 128
  
  DLLExport extern int zkMemPoolNew(ZkError, ZkMemPool *);
  DLLExport extern int zkMemPoolRegister(ZkError, ZkMemPool, void *, size_t);
  DLLExport extern int zkMemPoolFree(ZkError, ZkMemPool *);
  DLLExport extern int zkMemPoolStrndup (ZkError, ZkMemPool, const char *, size_t, char **);
  
#ifndef NDEBUG
  DLLExport extern int zkMemPoolTest (ZkError);
#endif
  
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
