/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef ZKNET_H_
#define ZKNET_H_



#include "zkSysTypes.h" /* fd_set */
#include "zkSysSelect.h"
#include "zkSysTime.h"
#include "zkUnistd.h"

#include "zkError.h"
#include "zks.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  extern DLLExport struct timeval zkTvAdd(struct timeval a, struct timeval b);
  extern DLLExport struct timeval zkTvSubtract(struct timeval a, struct timeval b);
  extern DLLExport struct timeval zkTvDivide(struct timeval a, double b);
  extern DLLExport int            zkTvCompare(struct timeval a, struct timeval b);

#if !defined(ZK_KERNEL)

  extern DLLExport int zkSelectUpdateTimeout(ZkError err, int n, fd_set  *readfds,  
                                             fd_set  *writefds, fd_set *exceptfds, 
                                             struct timeval *timeout);
  extern DLLExport int zkNetPortFromService(ZkError err, unsigned short *port, const char *service, const char *proto);

#endif	/* !defined(ZK_KERNEL) */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ZKNET_H_ */
