/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

/* 
 * zkQueue.h
 */ 
#ifndef _ZKQUEUE_H
#define _ZKQUEUE_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
    typedef struct T_ZkQueue *ZkQueue;

    typedef int (*ZkQueueDumpCallback)(ZkError, void *);
    
    DLLExport int zkQueueNew(ZkError,     /* zkError structure */
                   ZkQueue *,   /* Queue */
                   int);        /* Maximum number of elements */

    DLLExport void **zkQueueDequeue(ZkError, /* zkError structure */
                         ZkQueue); /* Queue */
                                /* Element in Queue  */

    DLLExport int zkQueueEnqueue(ZkError, /* zkError structure */
                       ZkQueue, /* Queue */
                       void **); /* Element in Queue  */

    DLLExport int zkQueueFree(ZkError,    /* zkError structure */
                    ZkQueue *); /* Queue */

    int zkQueueIsEmpty(ZkError, /* zkError structure */
                       ZkQueue); /* Queue */

    DLLExport int zkQueueCapacity(ZkError, /* zkError structure */
                        ZkQueue, /* Queue */
                        unsigned int *); /* Return value, capacity */
    
#if !defined(ZK_KERNEL)

    int zkQueueDump(ZkError,    /* zkError structure */
                    ZkQueue,    /* Queue */
                    ZkQueueDumpCallback); /* Callback function */

#endif	/* !defined(ZK_KERNEL) */

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _ZKQUEUE_H */
