/*
 *	zkStdlib.h		(c) 2000 Zero-Knowledge Systems, Inc.
 *	
 *	$Id: zkStdlib.h,v 1.3 2001/04/19 17:26:49 alainc Exp $
 *	
 *	Wrapper for <stdlib.h>
 *	
 *	In addition to the symbols defined in <stdlib.h> by the C standard, this 
 *	file defines at least the following symbols:
 *
 *	Functions:
 *		void*	zkCalloc(size_t nmemb, size_t size);
 *		void	zkFree(void* ptr);
 *		void*	zkMalloc(size_t size);
 *		void*	zkRealloc(void* ptr, size_t size);
 */

#ifndef ZKSTDLIB_H_
#define ZKSTDLIB_H_

#if defined(__MWERKS__) || defined(_MSC_VER)
#	pragma once
#endif

#ifndef ZKS_H_
#	include "zks.h"
#endif

#if !defined(ZK_KERNEL)
	/* standard headers */
#	include <stdlib.h>
#else
#	include "zkKrtStdlib.h"
#endif

#ifdef __cplusplus 
	extern "C" {
#endif


/* Wrapper Function Declarations */

DLLExport void*	zkCalloc(size_t nmemb, size_t size);
DLLExport void	zkFree(void* ptr);
DLLExport void*	zkMalloc(size_t size);
DLLExport int	zkRand_r(unsigned int* seed);
#if !defined(ZK_KERNEL)
DLLExport void*	zkRealloc(void* ptr, size_t newsize);
#endif	/* !defined(ZK_KERNEL) */
DLLExport void*	zkRealloc_s(void* ptr, size_t oldsize, size_t newsize);


#ifdef __cplusplus 
	}
#endif

#endif /* ZKSTDLIB_H_ */
