/*
 *  $Id: zknbo.h,v 1.4 2001/04/19 17:26:49 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef ZKNBO_H_
#define ZKNBO_H_

#include "zks.h"
#include "zkIntTypes.h"


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

  /*
   *  64 bit types.
   */

  extern DLLExport void zkNboFromHostUint64(char nbo[8], uint64_t n);
  extern DLLExport uint64_t zkNboToHostUint64(const char nbo[8]);
  extern DLLExport void zkNboFromHostInt64(char nbo[8], int64_t n);
  extern DLLExport int64_t zkNboToHostInt64(const char nbo[8]);
  
  /*
   *  32 bit types.
   */

  extern DLLExport void zkNboFromHostUint32(char nbo[4], uint32_t n);
  extern DLLExport uint32_t zkNboToHostUint32(const char nbo[4]);
  extern DLLExport void zkNboFromHostInt32(char nbo[4], int32_t n);
  extern DLLExport int32_t zkNboToHostInt32(const char nbo[4]);
  
  /*
   *  16 bit types.
   */

  extern DLLExport void zkNboFromHostUint16(char nbo[2], uint16_t n);
  extern DLLExport uint16_t zkNboToHostUint16(const char nbo[2]);
  extern DLLExport void zkNboFromHostInt16(char nbo[2], int16_t n);
  extern DLLExport int16_t zkNboToHostInt16(const char nbo[2]);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ZKNBO_H_ */
