/* 
 * $Id: zksmodule.h,v 1.2 2001/04/19 17:26:49 alainc Exp $
 */
#ifndef ZKS_MODULE_H
# define ZKS_MODULE_H

# include "zks.h"
# include "zkIntTypes.h"
# include "zkIntLimits.h"
# include "zkTypes.h"
# include "zkDefs.h"



/*
 * Error hadling and ModuleId section 
 */
# define ZKS_MODULE_MOD                   "ZksModule"

/*
** Unknown module definition
*/
# define ZKS_GENERIC_UNKNOWN_MOD          "ZKS_GENERIC_UNKNOWN_MODULE"

/*
** Generic test module definition
*/
# define ZKS_GENERIC_TEST_MOD             "ZKS_GENERIC_TEST_MODULE"

/*
** Limits
*/
# define ZKS_MODULE_NAME_MAX              (63)


/*
** NONE Values
*/
# define ZKS_MODULE_ID_NONE               ((uint16_t)     0x0000U)
# define ZKS_MODULE_NAME_NONE             ((const char *) NULL)


/*
** Base Module Id
*/
# define ZKS_MODULE_ID_BASE               ((uint16_t)     0x1000U)


/*
** Unknown module constants
*/
# define ZKS_MODULE_ID_UNKNOWN            (ZKS_MODULE_ID_BASE)
# define ZKS_MODULE_NAME_UNKNOWN          (ZKS_GENERIC_UNKNOWN_MOD)



# ifdef __cplusplus
extern "C" {
# endif

  /* =========================================================================  
  ** ZkModule API
  */

  void         zksModuleHandlerInit      (void);

  uint16_t     zksModuleId               (const char *   modName);

  const char * zksModuleName             (uint16_t       modId);


# ifdef __cplusplus
}
# endif /* __cplusplus */

#endif /* ZKS_MODULE_H */
