/* 
 * $Id: zkspid.h,v 1.2 2001/04/19 17:26:49 alainc Exp $
 */
#ifndef ZKS_PID_H
# define ZKS_PID_H

# include "zks.h"

#if !defined(ZK_KERNEL)

# include "zkIntTypes.h"
# include "zkIntLimits.h"
# include "zkTypes.h"
# include "zkDefs.h"


/*
 * Error hadling and ModuleId section 
 */
# define ZKS_PID_MOD                        "ZksPid"



/*
 * Generic base type definition
 */
typedef uint64_t                            ZksProcessId;
typedef uint64_t                            ZksThreadId;


/*
** S_ZksPid stucture.
*/
typedef struct S_ZksPid {
  ZksProcessId pId;   /* Process Id */
  ZksThreadId  tId;   /* Thread Id */
} T_ZksPid;




# ifdef __cplusplus
extern "C" {
# endif

  ZkBool zksPidInit                         (T_ZksPid       * pid);

  ZkBool zksPidEqual                        (const T_ZksPid * pidA, 
                                             const T_ZksPid * pidB, 
                                             ZkBool         * equalP);

  ZkBool zksPidAssign                       (T_ZksPid       * dstPid, 
                                             const T_ZksPid * srcPid);

  ZkBool zksPidAsString                     (const T_ZksPid * dstPid,
                                             char           * buffer,
                                             uint32_t         buffersz);

# ifdef __cplusplus
}
# endif

#endif /*  !defined(ZK_KERNEL) */

#endif /*  ZKS_PID_H */
