/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef ZKSTATS_H_
# define ZKSTATS_H_


# include "zkStdio.h"
# include "zkStdlib.h"
# include <stdarg.h>
# include "zkError.h"

# ifdef __cplusplus
extern "C" {
# endif /* __cplusplus */


/*
** define the list of possible attributs
*/
# define MSG_RECEIVED                  "MSG_RECEIVED"
# define MSG_SENT                      "MSG_SENT"
# define MSG_DROP                      "MSG_DROP"
# define MSG_QUEUED                    "MSG_QUEUED"

# define PACKET_RECEIVED               "PACKET_RECEIVED"
# define PACKET_SENT                   "PACKET_SENT"
# define PACKET_DROP                   "PACKET_DROP"
# define PACKET_QUEUED                 "PACKET_QUEUED"

# define BYTES_RECEIVED                "BYTES_RECEIVED"
# define BYTES_SENT                    "BYTES_SENT"
# define BYTES_DROP                    "BYTES_DROP"
# define BYTES_QUEUED                  "BYTES_QUEUED"



  DLLExport int zkStatsVDumpToLog
  (
   ZK_INOUT ZkError     err,
   ZK_IN    ZkLog       log,           /* Log object to dump into */
   ZK_IN    const char *label,         /* Label to be use for the stats line representation (optional) */
   ZK_IN    const char *attrib[],      /* List of attributs to be dump */
   ZK_IN    va_list     vargs          /* Variable list of value UINT64_T associate with each attributs to be dump */
   );


  DLLExport int zkStatsDumpToLog_va
  (
   ZK_INOUT ZkError     err,
   ZK_IN    ZkLog       log,           /* Log object to dump into */
   ZK_IN    const char *label,         /* Label to be use for the stats line representation (optional) */
   ZK_IN    const char *attrib[],      /* List of attributs to be dump */
   ...                                 /* Variable list of value UINT64_T associate with each attributs to be dump */
   );

# ifdef __cplusplus
}
# endif /* __cplusplus */


#endif /* ZKSTATS_H_ */
