/*
 * $Id: zkclientconsole.c,v 1.2 2001/04/19 17:26:52 alainc Exp $
 */

static const char * module_id_ = "$Id: zkclientconsole.c,v 1.2 2001/04/19 17:26:52 alainc Exp $";
/*
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */


#include "zks.h"
#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkUnistd.h"
#include "zkString.h"
#include "zkError.h"
#include "zkclientconsole.h"

#if !defined(ZK_KERNEL)

/*
 *
 */

DLLExport int
zkClientConsoleFprintf (
  ZK_INOUT ZkError err ,
  ZK_IN    const char * prefix ,
  ZK_IN    ZkClientConsoleMessage  msg,
  ZK_IN    ConsSeverity lvl ,
  ZK_IN    const char * action ,
  ZK_IN    const char * msg_short ,
  ZK_IN    const char * msg_long ,
  ZK_IN    void * extra )
{
  static const char * func = "zkClientConsolePrint";
  FILE * stream = (FILE *) extra;
  int ret = 1;

  (void) module_id_; /* Get rid of compile warning */

  /* These are the parameters I will not be using for this callback 
   * implementation 
   */

  (void) msg;
  (void) lvl;
  (void) msg_long;

  if (!prefix) {
    zkErrorSet(err,func,ZKERR,ZKMCLIENTCONSOLE,ZKENULLPTR,
               "No prefix specified");
    ret = 0;
  } else if (!msg_short) {
    zkErrorSet(err,func,ZKERR,ZKMCLIENTCONSOLE,ZKENULLPTR,
               "No short message specified");
    ret = 0;
  } else if (!stream) {
    zkErrorSet(err,func,ZKERR,ZKMCLIENTCONSOLE,ZKENULLPTR,
               "No stream specified");
    ret = 0;
  } else {
    zkFprintf(stream,"%s: %s %s\n",prefix,action?action:" ",msg_short);
  }

  return ret;
}

#endif	/* !defined(ZK_KERNEL) */
