/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include "zks.h"
#include "zkStdio.h"
#include "zkDebug.h"

#if defined(ZK_KERNEL)
#	include "zkKrtDebug.h"
#endif

#if defined(WIN32) || defined(macintosh) || defined(__APPLE__)

DLLExport void ClientTrace(const char fnc[], const char detail[])
{
#if !defined(NDEBUG)
	
# if defined(ZK_KERNEL)
    
    zkKrtDebugPrint("%s: %s\n", fnc, detail);

# elif defined(WIN32)

	zkDebugPrint("ClientTrace() function [%s], message [%s]\n", fnc, strlen(detail)?detail:"no detail");

# elif defined(macintosh)
    
	zkDebugPrint("%s: %s\n", fnc, detail);
	
# endif
    
#endif	/* NDEBUG */
	
    /* silence compiler */
    (void) fnc;
    (void) detail;
}

#endif	/* defined(WIN32) || defined(macintosh) || defined(__APPLE__) */
