/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include "zks.h"

#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkTime.h"
#include "zkUnistd.h"
#include "zkString.h"
#include "zkError.h"
#include "zkLog.h"
#include "zkDateTime.h"


#define S_SZ 20

int
main (
  int argc ,
  char ** argv )
{
  ZkDateTime dt;
  ZkDateTime dt2;
  ZkError err = NULL;
  ZkLog log = NULL;
  char s[S_SZ + 1];
  int n = 1850;
  int result = 0;

  (void) argc;
  (void) argv;
  
  zkErrorNew(&err);
  zkErrorLog(err,&log);
  zkLogSetStream(log,stderr);
  zkLogEnable(log);

  zkDateTimeSetCurrent(err,&dt,ZKTIME_FL_UTC);
  zkDateTimeStore(err,&dt,s,S_SZ);
  zkPrintf("Current time is %s\n",s);
  for (n = 1850; n < 2600; n++) if (zkIsLeapYear(n)) zkPrintf("%d  ",n);
  zkPrintf("\n");
  zkSleep(5);
  zkDateTimeSetCurrent(err,&dt2,ZKTIME_FL_UTC);
  zkDateTimeCompare(err,&dt,&dt2,&result);
  zkPrintf("result:  %d\n",result);
  zkDateTimeCompare(err,&dt2,&dt2,&result);
  zkPrintf("result:  %d\n",result);
  zkDateTimeCompare(err,&dt2,&dt,&result);
  zkPrintf("result:  %d\n",result);
  
  return (EXIT_SUCCESS);
}
  

