/*
 *  $Id: tcode.c,v 1.3 2001/04/19 17:26:56 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *  
 *  Test routines that produce C Code.
 */

#include <assert.h>
#include "zkStdlib.h"
#include "zkStdio.h"
#include "zkString.h"
#include "zkCode.h"


int main(void)
{
  ZkError err;
  char c[] = {
    0x00, 0x01, 0x02, 0x03, 0x04, 0x05,
    0x06, 0x07, 0x08, 0x09, 0x0A, 0x0B
  };
  char *s;
  size_t i, ssz;

  assert(zkErrorNew(&err));
  for (i = sizeof c - 3; i <= sizeof c; i++) {
    assert(zkCodeUCharArrayFromData(err, c, i, &s, &ssz));
    zkPrintf("String (%lu) is %s\n", (unsigned long)ssz, s);
    zkFree(s);
  }
  assert(zkErrorFree(&err));
  
  return (EXIT_SUCCESS);
}
