/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include "zkStdio.h"
#include <assert.h>
#include "zkUnistd.h"
#include "zkStdlib.h"
#include "zkSecure.h"

int main(void)
{
#if defined(ZK_LINUX) || defined(ZK_SOLARIS)
  ZkError err;

  zkErrorNew(&err);
  assert(zkSecureSetSafe(err));
  assert(zkSecureSetParanoid(err));
  assert(!zkSecureRunAsRoot());
  assert(zkSecureSetUmask(err, ZKSECURE_PARANOID));
  assert(!zkSecureCheckFile(err, "/tmp", ZKSECURE_PARANOID));
  assert(!zkSecureCheckFile(err, "tmp/test1", ZKSECURE_PARANOID));
  assert(zkSecureCheckFile(err, "/tmp/test2", ZKSECURE_PARANOID));
  assert(!zkSecureCheckDir(err, "/tmp/test1", ZKSECURE_PARANOID));
  assert(!zkSecureCheckDir(err, "/tmp/testdir1", ZKSECURE_PARANOID));
  assert(zkSecureCheckDir(err, "/tmp/testdir2", ZKSECURE_PARANOID));

  zkErrorFree(&err);
#endif /* ZK_LINUX || ZK_SOLARIS */

  return (EXIT_SUCCESS);
}
