/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

/*
 *  Copy stdin to a file in small, randomly sized chunks.
 */

#include <assert.h>
#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkTime.h"
#include "zkShell.h"


int main(int ac, char **av)
{
  FILE *fp;
  char d[25];
  const char* progname;
  
  progname = zkShellGetProgramName(&ac, &av);
  
  srand(time(0) + 12345);
  
  assert(ac == 2);
  assert(fp = zkFopen(av[1], "wb"));
  (void)setbuf(fp, 0);
  while (1) {
    size_t n = 1 + (rand() % sizeof d), nn;
    if ((nn = zkFread(d, 1, n, stdin)) == 0) break;
    assert(zkFwrite(d, 1, nn, fp) == nn);
  }
  assert(feof(stdin));
  (void)zkFclose(fp);

  return (EXIT_SUCCESS);
}
