/* **************************************************************************
** $Id: zkIpTable.h,v 1.4 2001/04/19 17:26:06 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

** Copyright (C) 2000 Zero-Knowledge Systems Inc.  All rights reserved.
** --------------------------------------------------------------------------
**
** This file contains declarations for manipulating an IP table.
**
** **************************************************************************
*/

#ifndef ZKIPTABLE_H_
#define ZKIPTABLE_H_

#include <sys/socket.h>
#include <zks.h>
#include <zkIntTypes.h>
#include <zkError.h>

#define ZKIPTABLE_GROW_SIZE 20
#define MAX_LINE_SIZE       300


extern int zkLoadIpTableFromFile(ZK_OUT ZkError       err, 
                                 ZK_IN  const char*   filename,
                                 ZK_IN  const char*** ipTable, 
                                 ZK_OUT uint16_t*     size);

extern int zkHostInTable(ZK_OUT ZkError      err, 
                         ZK_IN  const char** ipTable, 
                         ZK_IN  uint16_t     size,
                         ZK_IN  const char*  addrPath, 
                         ZK_OUT int*         found);
#endif
