/*
 * $Id: zkHTTPField.h,v 1.5 2001/04/19 17:03:33 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */


#ifndef ZKHTTPFIELD_H_
#define ZKHTTPFIELD_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef ZKHTTPFIELD_T
#define ZKHTTPFIELD_T
typedef struct T_ZkEmailField * ZkHTTPField;
#endif /* ZKHTTPFIELD_T */


DLLExport int zkHTTPFieldNew (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField * );

DLLExport int zkHTTPFieldFree (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField * );

DLLExport int zkHTTPFieldGetParameter (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  const unsigned char * ,
  const unsigned char ** );

DLLExport int zkHTTPFieldLink (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  ZkHTTPField * );

DLLExport int zkHTTPFieldSetLink (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  ZkHTTPField );

DLLExport int zkHTTPFieldDelete (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField * );

DLLExport int zkHTTPFieldForceValue (
  ZkError ,
  ZkHTTPField ,
  enum ZkMIMEFieldId ,
  const char * ,
  size_t );


DLLExport int zkHTTPFieldStrip (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField * ,
  uint32_t );                      /* Strip control flags, see zkMIME.h */

DLLExport int zkHTTPFieldSetName (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  const unsigned char * );

DLLExport int zkHTTPFieldName (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  const unsigned char ** );

DLLExport int zkHTTPFieldSetValue (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  const unsigned char * );

DLLExport int zkHTTPFieldValue (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  const unsigned char ** );

DLLExport int zkHTTPFieldId (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  enum ZkMIMEFieldId * );

DLLExport int zkHTTPFieldSetId (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  enum ZkMIMEFieldId );

DLLExport int zkHTTPFieldAddParameter (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  const unsigned char * ,
  const unsigned char * );

DLLExport int zkHTTPFieldParse (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  const unsigned char * );

DLLExport int zkHTTPFieldDump (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  ZkEmailDumpCallback ,
  void * );

DLLExport int zkHTTPFieldDup (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  ZkHTTPField * );

DLLExport int zkHTTPFieldIdFlags (
  ZkError ,                        /* Returns the error if any occured */
  ZkHTTPField ,
  uint32_t * );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ZKHTTPFIELD_H_ */
