/*
 * $Id: zkEmailParse.h,v 1.5 2001/04/19 17:03:34 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#ifndef ZKEMAILPARSE_H_
#define ZKEMAILPARSE_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define CHAR_CR             0x0D        /* Carriage Return (ASCII 13) */
#define CHAR_LF             0x0A        /* Line Feed (ASCII 10) */
#define CHAR_NUL            0x00        /* NUL string terminator (ASCII 0) */
#define CHAR_SPACE          0x20        /* Blank space (ASCII 32) */
#define CHAR_HTAB           0x09        /* Horizontal Tab (ASCII 9) */
#define CHAR_DQUOTE         0x22        /* Double Quote (ASCII 34) */
#define CHAR_SOLIDUS        0x5C        /* Back Slash (ASCII 92) */
#define CHAR_ZERO           0x30        /* Decimal Zero (ASCII 48) */
#define CHAR_PERIOD         0x2E        /* Period (ASCII 46) */
#define CHAR_COLON          0x3A        /* Colon (ASCII 58) */
#define CHAR_OPENPAREN      0x28        /* Open parenthesis (ASCII 40) */ 
#define CHAR_CLOSEPAREN     0x29        /* Close parenthesis (ASCII 41) */
#define CHAR_EQUALS         0x3D        /* Equals sign (ASCII 61) */
#define CHAR_GT             0x3E        /* Greater than Sign (ASCII 62) */
#define CHAR_LT             0x3C        /* Less Than Sign (ASCII 60) */
#define CHAR_SEMICOLON      0x3B        /* Semicolon (ASCII 59) */

unsigned char * trimWhiteSpace( unsigned char * );
unsigned char * unfoldLine ( unsigned char * , uint32_t );
unsigned char * stripDoubleQuotes ( unsigned char * );
unsigned char * trimDoubleQuotes (unsigned  char * );
unsigned char * startOfNextLine ( unsigned char *  );
unsigned char * startOfNextFoldedLine ( unsigned char * );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* ZKEMAILPARSE_H_ */
