/*
 * $Id: zkUDP.c,v 1.10 2001/04/19 15:54:12 alainc Exp $
 */

static const char * module_id_ = "$Id: zkUDP.c,v 1.10 2001/04/19 15:54:12 alainc Exp $";
/*
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */


#include "zks.h"

#include "zkStdio.h"
#include "zkStdlib.h"
#include "zkArpaInet.h"
#include "zkNetinetIn.h" /* htons(), ntohs(), ... */
#include "zkPacket.h"



#if !defined(ZK_KERNEL)

DLLExport int
zkUDPHeaderDump (
  void * udph ,
  FILE * stream )
{
  zkFprintf(stream,"UDP Packet Header Pointer %p\n", (void *)udph);
  if (udph == NULL) {
    return 0;
  }
  zkFprintf(stream,"  Source port             %d\n",zkUDPHeaderGetSrcPort(udph));
  zkFprintf(stream,"  Destination Port        %d\n",zkUDPHeaderGetDstPort(udph));
  zkFprintf(stream,"  Length                  %d\n",zkUDPHeaderGetUdpLength(udph));
  zkFprintf(stream,"  Header Checksum         %d\n",zkUDPHeaderGetUdpCheckSum(udph));
  return 1;
}

#endif	/* !defined(ZK_KERNEL) */

#if defined(ZK_KERNEL_MAC_OS8) && defined(_DEBUG)

int zkUDPHeaderDump ( void * udph  )
{
  dprintf("UDP Packet Header Pointer %p\n", (void *)udph);
  if (udph == NULL) {
    return 0;
  }
  dprintf("  Source port             %d\n",zkUDPHeaderGetSrcPort(udph));
  dprintf("  Destination Port        %d\n",zkUDPHeaderGetDstPort(udph));
  dprintf("  Length                  %d\n",zkUDPHeaderGetUdpLength(udph));
  dprintf("  Header Checksum         %d\n",zkUDPHeaderGetUdpCheckSum(udph));
  return 1;
}

#endif	/* defined(ZK_KERNEL_MAC_OS8) && defined(_DEBUG) */

DLLExport uint16_t
zkUDPHeaderSourcePort (
  void * udph ,
  uint16_t * port ) 
{
  (void) module_id_; /* Get rid of compile time warning */
  *port = zkUDPHeaderGetSrcPort(udph);
  return *port ;
}

DLLExport uint16_t
zkUDPHeaderDestinationPort (
  void * udph ,
  uint16_t * port )
{
  *port = zkUDPHeaderGetDstPort(udph);
  return *port;
}

DLLExport int
zkUDPHeaderSetSourcePort (
  void * udph ,
  uint16_t port )
{  
  zkUDPHeaderSetSrcPort(udph, port);
  return 1;
}

DLLExport int
zkUDPHeaderSetDestinationPort (
  void * udph ,
  uint16_t port )
{
  zkUDPHeaderSetDstPort(udph, port);
  return 1;
}

