
/* $Id: monitorp.h,v 1.2 2001/04/19 16:49:22 alainc Exp $ */
/*
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */


#include "monitor.h"

typedef struct {
  char comment;
  int port;               /* Port to listen on */
  int nbTests;            /* Number of tests each slave will run */
  int s;                  /* main socket */
  int slaves;             /* Number of slave */
  T_MonitorSlave *slave;  /* Slave info */
} T_Monitor;


/* prototypes */

DLLExport int zkperfClient_MonitorReport(ZkError err, T_Monitor *m,
                                         const char *name, 
                                         ZkPerfClientReport report );


DLLExport int zkperfClient_MonitorReportConcurrent( ZkError err, T_Monitor *m,
                                                    FILE *fp, int header);

DLLExport int zkperfClient_MonitorReportTask( ZkError err, T_Monitor *m,
                                              FILE *fp, int header);

DLLExport int zkperfClient_MonitorReportAvg( ZkError err, T_Monitor *m,
                                             FILE *fp, int header);

DLLExport int zkperfClient_MonitorReportRun( ZkError err, T_Monitor *m,
                                             FILE *fp, int header);
