
/* $Id: monitor.h,v 1.2 2001/04/19 16:49:22 alainc Exp $ */
/*
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */


typedef struct {
  char *name;
  double r,u,s;
} T_MonitorTimer;

typedef struct {
  
  struct timeval startTime;
  struct timeval endTime;
  struct timeval elapsedTime;
  T_MonitorTimer *timer;
  int num;
  
} T_MonitorInfo;

typedef struct {
  int fd;               /* Slave communication channel */
  int iterations;
  int concurrents;      /* Number of concurrents */
  T_MonitorInfo *info;  /* Concurrent Info */
  
} T_MonitorSlave;




/* Prototypes */

int zkperfClient_MonitorWrite( ZkError err, ZkPerfClient c);
int zkperfClient_MonitorRead( ZkError err, T_MonitorSlave *ms );

int zkperfClient_MonitorSynch( ZkError err, ZkPerfClient c);


