/*
** **************************************************************************
** $Id: zkPlugin.h,v 1.3 2001/04/19 15:44:41 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

**
** Copyright (C) 1999 Zero-Knowledge Systems Inc.  All Rights Reserved
** **************************************************************************
*/

# ifndef ZKPLUGIN_H_
# define ZKPLUGIN_H_

# ifndef ZKPLUGINIMPL_H_
# include "zkPluginImpl.h"
# endif

# ifdef __cplusplus
extern "C" {
# endif


DLLExport int
zkPluginLoad(
    ZkError                    err,
    const char *               plugin_file,
    ZkPluginInfo *             plugin_info_ptr,
    const char *               plugin_conf);

DLLExport int
zkPluginUnload(
    ZkError                    err,
    ZkPluginInfo *             plugin_info_ptr );

DLLExport int
zkPluginGetName(
    ZkError                    err,
    ZkPluginInfo               plugin_info,
    const char **              name );

DLLExport int
zkPluginGetVersion(
    ZkError                    err,
    ZkPluginInfo               plugin_info,
    uint32_t *                 version );

DLLExport int
zkPluginGetApiVersion(
    ZkError                    err,
    ZkPluginInfo               plugin_info,
    uint32_t *                 api_version );

DLLExport int
zkPluginMemFree(
    ZkError                    err,
    ZkPluginInfo               plugin_info,
    void **                    mem_to_free );

# define zkPluginCommand zkPluginCommand_1

DLLExport int
zkPluginCommand_1(
    ZkError                    err,
    ZkPluginInfo               plugin_info,
    const char *               argv[],
    size_t                     argc,
    const void *               in_data,
    size_t                     in_data_size,
    void **                    out_data,
    size_t *                   out_data_size );

# ifdef __cplusplus
}
# endif

# endif /* ZKPLUGIN_H_ */
