/*
 *  $Id: rntest.c,v 1.3 2001/04/19 16:48:45 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 */

#include "zkStdlib.h"
#include "zkSysTime.h"
#include "zkUnistd.h"
#include <assert.h>
#include "zks.h"
#include "zkrand.h"


int main(int argc, char **argv)
{
  uint32_t n, min, max, t;
  ZkError err;
  struct timeval tv;
  
  assert(zkErrorNew(&err));
  zkRand_Init(0, 0);
  zkRand_Debug();
  
  if (argc == 1) {
    zkGettimeofday(&tv, NULL);
    srand( tv.tv_usec ^ tv.tv_sec );
    min = 0;
    max = rand();
    t = rand();
    if (t & 0x1) { max *= 2; t = rand() & 0x1; max |= t; }
  }
  if (argc > 1) {
    min = 0;
    max = strtoul( argv[1], NULL, 10 );
  }
  if (argc > 2) {
    min = max;
    max = strtoul( argv[2], NULL, 10 );
  }

  /*  fprintf(stderr, "range = (0..%lu)\n", max); */

  if (!zkRandGetUInt32InRange(err, min, max, &n)) { fprintf(stderr,"error"); }
  printf("range (%lu..%lu) = %lu\n", (unsigned long) min, (unsigned long) max, (unsigned long) n);
  
  return(0);
}
