/*
 *  $Id: trandom.c,v 1.3 2001/04/19 16:48:45 alainc Exp $
 * 
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Freedom code.
 * 
 * The Initial Developer of the Original Code is Zero-Knowledge Systems,
 * Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
 * Zero-Knowledge Systems, Inc.  All Rights Reserved.
 * 
 * Contributor(s):

 *  
 *  Test the random data routines.
 */

#include "zks.h"

#include <assert.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include "zkrand.h"
#include "zkError.h"

static char seedfile[] = "seedfile";

static sig_atomic_t done = 0;


static void dosig(int sig)
{
  (void)sig;
  done = 1;
}


int main(void)
{
  ZkError err;
  char buf[2048];
  size_t bsz;

  srand(time(0));

  assert(zkErrorNew(&err));
  signal(SIGINT, dosig);

  while ( ! done) {
    int e, bits, max;
    
    bsz = 1 + rand() % sizeof buf;
    assert(zkRand_Init(0,seedfile));
    assert(zkRandGetData(err, buf, bsz));

#if 1
    sleep(1);
#endif

    zkRandEntropyGetCount(0, &e, 0, 0, &bits, &max);
    fprintf(stderr, "%d %d/%d\n", e, bits, max);
  }

  assert(zkErrorFree(&err));

  exit(EXIT_SUCCESS);
}
