/* 
 * $Id: zkslogagent.h,v 1.2 2001/04/19 14:44:17 alainc Exp $
 */
#ifndef ZKS_LOGAGENT_H
# define  ZKS_LOGAGENT_H

# include <zks.h>
# include <zkIntTypes.h>
# include <zkIntLimits.h>
# include <zkTypes.h>
# include <zkDefs.h>

# include "zksmodule.h"
# include "zkserr.h"
# include "zkslogmng.h"


/*
 * Error hadling and ModuleId section 
 */
# define ZKS_LOGAGENT_MOD                    "ZksLogAgent"

# define ZKS_LOGAGENT_BADPTR_ERR             ((uint16_t) 0x0001U)
# define ZKS_LOGAGENT_ALLOC_ERR              ((uint16_t) 0x0002U)
# define ZKS_LOGAGENT_LOGMNG_ERR             ((uint16_t) 0x0004U)


/*
 * File permision
 */
typedef uint32_t ZksLogAgentFilePerm;

# define ZKS_LOGAGENT_FILEPERM_NONE          ((ZksLogAgentFilePerm) 0x00000000UL)
# define ZKS_LOGAGENT_FILEPERM_USER_READ     ((ZksLogAgentFilePerm) 0x00000001UL)
# define ZKS_LOGAGENT_FILEPERM_USER_WRITE    ((ZksLogAgentFilePerm) 0x00000002UL)
# define ZKS_LOGAGENT_FILEPERM_GROUP_READ    ((ZksLogAgentFilePerm) 0x00000004UL)
# define ZKS_LOGAGENT_FILEPERM_GROUP_WRITE   ((ZksLogAgentFilePerm) 0x00000008UL)
# define ZKS_LOGAGENT_FILEPERM_OTHER_READ    ((ZksLogAgentFilePerm) 0x00000010UL)
# define ZKS_LOGAGENT_FILEPERM_OTHER_WRITE   ((ZksLogAgentFilePerm) 0x00000020UL)


# ifdef __cplusplus
extern "C" {
# endif


  /* =========================================================================  
  ** Term zksLogAgent API
  */

  ZkBool zksLogAgentTermNew                  (ZksErr        err,
                                              ZksLogAgent * agentP);

  ZkBool zksLogAgentTermFree                 (ZksErr        err,
                                              ZksLogAgent * agentP);



  /* =========================================================================  
  ** Nul zksLogAgent API (use to strip out logging message for a given module)
  */

  ZkBool zksLogAgentNulNew                  (ZksErr        err,
                                             ZksLogAgent * agentP);

  ZkBool zksLogAgentNulFree                 (ZksErr        err,
                                             ZksLogAgent * agentP);



  /* =========================================================================  
  ** File zksLogAgent API
  */


  ZkBool zksLogAgentFileNew                  (ZksErr              err,
                                              ZksLogAgent       * agentP, 
                                              const char        * filename,
                                              ZksLogAgentFilePerm perm);

  ZkBool zksLogAgentFileFree                 (ZksErr              err,
                                              ZksLogAgent       * agentP);


  ZkBool zksLogAgentFileReset                (ZksErr              err,
                                              ZksLogAgent         agent);


# ifdef __cplusplus
}
# endif


#endif /* ZKS_LOGAGENT_H */
