/* 
 * $Id: log.c,v 1.2 2001/04/19 14:44:26 alainc Exp $
 */
#include <stdio.h>


#include <zks.h>
#include "zkserr.h"
#include "zksmodule.h"
#include "zkslog.h"
#include "zkslogagent.h"



 
int main(int argc, const char * argv[])
{                             
  ZksErr       err       = NULL;
  ZksLogAgent  fileAgent = NULL;

  (void)argc;

  fprintf(stdout, "==============================================\n");
  fprintf(stdout, "Test logging\n\n");
 
  if( !zksLogInit(argv[0]) ||
      !zksLogTermInit()  ) {
    return 1;

  } else  if( !zksErrNew(&err) ) {
    return 1;

  } else if( !zksLogAgentFileNew(err, 
                                 &fileAgent, 
                                 "./test.log",
                                 ZKS_LOGAGENT_FILEPERM_USER_WRITE |
                                 ZKS_LOGAGENT_FILEPERM_USER_READ  |
                                 ZKS_LOGAGENT_FILEPERM_GROUP_READ |
                                 ZKS_LOGAGENT_FILEPERM_OTHER_WRITE) ) {
    return 1;

  } else if( !zksLogSpecificAdd(ZKS_GENERIC_TEST_MOD, fileAgent) ) {
    return 1;
  }
  
  ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, ZKS_GENERIC_UNKNOWN_MOD, "Should see this line into the terminal: log line %d", 1);

  zksErrSetEx(err, 12, ZKS_GENERIC_TEST_MOD, 0x0001, "My function", "Test message %d", 1);
  zksErrPush(err, "My function5", "Test message %d", 5);
  zksErrPush(err, "My function6", "Test message %d", 6);

  zksLogError(err);

  zksLogTermDisable();
  
  ZKS_LOGDEBUG_1(ZKS_LOG_ANY_MASK, ZKS_GENERIC_TEST_MOD, "Should see this line into the log file: log line %d", 2);

  zksErrFree(&err);

  if( !zksLogAgentFileFree(err, &fileAgent) ) {
    return 1;
  }

  if( !zksLogShutdown() ) {
    return 1;
  }

  fprintf(stdout, "==============================================\n");
  fprintf(stdout, "Test completed succefully\n\n");
  return 0;
}

                        
