/* 
 * $Id: module.c,v 1.2 2001/04/19 14:44:26 alainc Exp $
 */
#include <stdio.h>

#include <zks.h>
#include "zksmodule.h"



static void error(const char * mesg)
{
  fprintf(stderr, mesg);
  exit(1);
}

 
int main(void)
{                             
  uint16_t    id;
  uint16_t    revId;
  const char *modName;

  zksModuleHandlerInit();

  /* Test Reverse lookup
   */
  fprintf(stdout, "==============================================\n");
  fprintf(stdout, "Test reverse lookup\n\n");

  for( id=0; id<(uint16_t)-1; id++ ) {    
    if( (revId = zksModuleId(modName = zksModuleName(id))) != id ) {
      if( revId != ZKS_MODULE_ID_UNKNOWN ) {
        fprintf(stderr, "Id=0x%x, Module=%-*s,Reverse Id=0x%x\n", id, 32, modName, revId);
        error("Reverse lookup failed");
      }
    } else {
      fprintf(stdout, "Id=0x%x, Module=%-*s,Reverse Id=0x%x\n", id, 32, modName, revId);
    }
  }

  /* Test invalid module name
   */
  fprintf(stdout, "==============================================\n");
  fprintf(stdout, "Test invalid module name lookup\n\n");

  if( strncmp(zksModuleName(ZKS_MODULE_ID_UNKNOWN), ZKS_MODULE_NAME_UNKNOWN, ZKS_MODULE_NAME_MAX) ) {
    error("zksModuleName failed, shouldn't have found an invalid module");
  }

  /* Test invalid module id
   */
  fprintf(stdout, "==============================================\n");
  fprintf(stdout, "Test invalid module id lookup\n\n");

  if( zksModuleId("wimziuewnzsdji") != ZKS_MODULE_ID_UNKNOWN ) {
    error("zksModuleId failed, shouldn't have found an invalid module");
  }

  fprintf(stdout, "==============================================\n");
  fprintf(stdout, "Test completed succefully\n\n");

  return 0;
}

