#include <fstream>
#include <iostream>
#include "zksini.h"

//
//
//
int main()
{
  CZKS::Ini     config;
  std::ifstream file("./test_ini.ini");  

  file >> config;

  CZKS::Ini::const_iterator          iit;
  CZKS::Ini::Section::const_iterator sit;

  std::cout << std::endl << "=======================" << std::endl;
  std::cout << "test iterator" << std::endl << std::endl;

  for( iit = config.begin(); iit != config.end(); iit++ ) {
    std::cout << "[" << iit->first << "]" << std::endl;
    for( sit = iit->second.begin(); sit != iit->second.end(); sit++ ) {
      std::cout << sit->first << "=" << "\"" << sit->second << "\"" <<std::endl;
    }
  }

  std::cout << std::endl << "=======================" << std::endl;
  std::cout << "test direct access" << std::endl << std::endl;

  for( iit = config.begin(); iit != config.end(); iit++ ) {
    std::cout << "[" << iit->first << "]" << std::endl;
    for( sit = iit->second.begin(); sit != iit->second.end(); sit++ ) {
      std::cout << sit->first << "=" << "\"" << config[iit->first][sit->first] << "\"" << std::endl;
    }
  }


  std::cout << std::endl << "=======================" << std::endl;
  std::cout << "test conversion" << std::endl << std::endl;

  bool bval;
  double dval;

  config.set("sect 1", "key4", 34);

  config.at("sect 1", "key4", bval, false);
  std::cout << (bval ? "true" : "false") << std::endl;

  config.at("sect 1", "key56", bval, false);
  std::cout << (bval ? "true" : "false") << std::endl;

  config.at("sect x", "key3", dval, 12.54543);
  std::cout << dval << std::endl;

  config.at("sect 1", "key3", dval, 12.54543);
  std::cout << dval << std::endl;

  CZKS::Ini::Group                 group = config.getGroup("sect");
  CZKS::Ini::Group::const_iterator git;

  std::cout << std::endl << "=======================" << std::endl;
  std::cout << "test group" << std::endl << std::endl;

  std::cout << std::endl << "# Group: " << "sect" << std::endl;    

  for( git = group.begin(); git != group.end(); git++ ) {
    const CZKS::Ini::Section & sec = config[git->second];

    std::cout << std::endl << "# Member: " << git->first 
              << std::endl 
              << "[" << git->second << "]" << std::endl;    

    for( sit = sec.begin(); sit != sec.end(); sit++ ) {
      std::cout << sit->first << "=" << "\"" << sit->second << "\"" <<std::endl;
    }
  }
  
  return 0;
}

