#include <fstream>
#include <iostream>
#include "zkspath.h"
#include "zkslogwrap.h"
#include <stdio.h>

#define INIT_OUTPUT "./output-logwrap.log"
#define ROTATE_OUTPUT "./output-logwrap.log.1"

//
//
//
int main(int argc, const char ** argv)
{
  CZKS::Log::init(CZKS::Path(argv[0]).basename());

  CZKS::Log::setTermAgent(new CZKS::Log::TermAgent);

  CZKS::Log::FileAgent file(INIT_OUTPUT);
  CZKS::Log::FileAgent file2("./output-logwrap-specific.log");

  CZKS::Log::addAgent(&file);

  CZKS::Log::debug(CZKS::Log::LOCAL, ZKS_GENERIC_TEST_MOD, "Test default debug logging vith ANY mask");
  CZKS::Log::setDebugMask(CZKS::Log::LOCAL);
  CZKS::Log::debug(CZKS::Log::LOCAL, ZKS_GENERIC_TEST_MOD, "Test default debug logging vith LOCAL mask");

  ::rename(INIT_OUTPUT, ROTATE_OUTPUT);
  file.reset();

  CZKS::Log::setDebugMask(CZKS::Log::NONE);
  CZKS::Log::setDebugMask(CZKS::Log::NONE);
  CZKS::Log::debug(CZKS::Log::LOCAL, ZKS_GENERIC_TEST_MOD, "Test default debug logging vith NONE mask");

  CZKS::Log::addAgent(ZKS_GENERIC_TEST_MOD, &file2);
  CZKS::Log::setDebugMask(ZKS_GENERIC_TEST_MOD, CZKS::Log::NONE);
  CZKS::Log::debug(CZKS::Log::LOCAL, ZKS_GENERIC_TEST_MOD, "Test specific debug logging vith NONE mask");
  CZKS::Log::setDebugMask(ZKS_GENERIC_TEST_MOD, CZKS::Log::LOCAL);
  CZKS::Log::debug(CZKS::Log::LOCAL, ZKS_GENERIC_TEST_MOD, "Test specific debug logging vith LOCAL mask");
  CZKS::Log::setDebugMask(ZKS_GENERIC_TEST_MOD, CZKS::Log::ANY);
  CZKS::Log::debug(CZKS::Log::LOCAL, ZKS_GENERIC_TEST_MOD, "Test specific debug logging vith ANY mask");
  CZKS::Log::clearAgent(ZKS_GENERIC_TEST_MOD);

  CZKS::Log::mesg(ZKS_GENERIC_TEST_MOD, "Test message logging");

  CZKS::Log::shutdown();
  return 0;
}

