#include <iostream>
#include "zkssmartptr.h"

class Test {
  int m_v;
public:
  Test(int v):m_v(v)
  {
    std::cout << "Construct" << m_v << std::endl;
  }
  ~Test()
  {
    std::cout << "Destroy" << m_v << std::endl;
  }

  void call(void)
  {
    std::cout << "Call " << m_v << std::endl;
  }
};



int main() 
{
  std::cout << "Create test 1" << std::endl;
  CZKS::SmartPtr<Test> o1 = new Test(1);
  std::cout << "Done" << std::endl;

  std::cout << "Create test 2" << std::endl;
  CZKS::SmartPtr<Test> o2 = new Test(2);
  std::cout << "Done" << std::endl;


  std::cout << "Call serie 1" << std::endl;
  o1->call();
  (*o2).call();   
  std::cout << "Done" << std::endl;
  
  std::cout << "Assign" << std::endl;
  o1  = o2;
  std::cout << "Done" << std::endl;

  std::cout << "Call serie 2" << std::endl; 
  o1->call();
  (*o2).call();
  std::cout << "Done" << std::endl;

  std::cout << "Copy Cxtr" << std::endl;
  CZKS::SmartPtr<Test> o3(o2);

  std::cout << "Call serie 3" << std::endl; 
  o1->call();
  (*o2).call();
  o3->call();
  std::cout << "Done" << std::endl;

  std::cout << "Copy Cxtr 2" << std::endl;
  CZKS::SmartPtr<Test> o4(new Test(4));

  std::cout << "Call serie 4" << std::endl; 
  o1->call();
  (*o2).call();
  o3->call();
  o4->call();
  std::cout << "Done" << std::endl;

  std::cout << "Base type 1" << std::endl;
  CZKS::SmartPtr<int> i1(new int(11));
  CZKS::SmartPtr<int> i2(new int(12));
  i1 = i2;
  i2 = new int(4);
  i1 = new int(5);
  return 0;
}
