#!/usr/bin/perl -w

use strict;
use IPC::Open2;
use IO::Handle;
use CGI;

my $datadir = '/home/httpd/chainsaw-data';
my $gpgbin = '/usr/bin/gpg';
my $adambin = './pgpdsa';
my $adamargs = "-s $datadir/ca-private-key.pgp - -";

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time());
$year += 1900;
$mon++;

STDOUT->autoflush();

my $q = new CGI;
$q->use_named_parameters(1);
my $key = $q->param('pubkey');

my $text;
$text .= "Type: " . $q->param('nodetype') . "\n";
$text .= "Status: paid\n";
$text .= sprintf("Creation date: %04d-%02d-%02d %02d:%02d:%02d\n",
                 $year, $mon, $mday, $hour, $min, $sec);
$text .= "Comment: All your traffic are belong to us.\n";

my ($newkey, $l);
if (defined($key)) {
    $key =~ s/\x0d//g; # I love the web!

    # Dearmor the key, since that's what chainsaw will expect to be signed
    if (!open2(*Reader, *Writer, "$gpgbin --dearmor")) {
        print "Content-type: text/plain\n\n";
        print "Cannot execute $gpgbin: $!\n";
        exit(1);
    }
    Writer->autoflush();

    print Writer $key;
    close(Writer);
    $newkey = "-----BEGIN PGP PUBLIC KEY BLOCK-----\n";
    while (defined($l = <Reader>)) {
        $newkey .= $l;
    }
    close(Reader);
    $newkey .= "-----END PGP PUBLIC KEY BLOCK-----\n";
}

if (!open2(*Reader, *Writer, "$adambin $adamargs")) {
    print "Content-type: text/plain\n\n";
    print "Cannot execute $gpgbin: $!\n";
    exit(1);
}
Writer->autoflush();

print Writer $text;
print Writer $newkey;
close(Writer);

my $sign;
while (defined($l = <Reader>)) {
    $sign .= $l;
}
close(Reader);

# uuencode this shit.  What a disaster this file is.  I hate myself.

# I'm wasting away my one and only youth, working through the night,
# to the pink light of dawn, under these goddamn halogen lights that
# never turn off; these lights that are totally useless, that seem to
# exist only to burn money.  These lights shine on empty hallways or
# directly into my eyes, making me strain to make out the characters on
# my monitor, characters that make up this software that they'll
# probably never even use.  Can this possibly be worth it?

# I remember now that Jamie wrote something like this, when he was busy
# destroying his wrists and his health, just to ship Netscape on Unix.

# Well.  It seems to have worked out OK for him.

if (!open2(*Reader, *Writer, "/usr/bin/uuencode -")) {
    print "Content-type: text/plain\n\n";
    print "Cannot execute $gpgbin: $!\n";
    exit(1);
}
Writer->autoflush();

my $crap;
$crap = ("-----BEGIN CHAINSAW CERTIFICATE-----\n" .
         $text . $newkey .
         "-----BEGIN PGP SIGNATURE-----\n" .
         $sign .
         "-----END PGP SIGNATURE-----\n" .
         "-----END CHAINSAW CERTIFICATE-----\n");

syswrite(Writer, $crap);
close(Writer);

my $uue;
while (defined($l = <Reader>)) {
    $uue .= $l;
}
close(Reader);

#------------------------------------------------------------------------------
    print "Content-type: text/html\n\n";

    print '<html><head><title>Chainsaw Network Access Certificate</title><style
TYPE="text/css">
<!--
BODY { color: black;
       background: white;
       font-family: sans-serif; }
TABLE.pretty { background: #FFA;
               border: solid black; }
TD { white-space: nowrap; }
TH { white-space: nowrap; }
-->
</style>
</head>
<body>';

    if (defined($key)) {
        print "This is your uuencoded Chainsaw network access certificate.<br><br>";

        print '<table class="pretty"><tr><td><pre>';
        print $q->escapeHTML($uue);

        print "</pre></td></tr></table><br><br>";

        print 'uudecode by pasting it into something like:<br><br>';

        print '<table class="pretty"><tr><td><pre>';
        print "[csaw\@myhost scripts]\$ uudecode > chainsaw_certificate";
        print "</pre></td></tr></table><br><br>";

        print '<tt>chainsaw_certificate</tt> is your proper Chainsaw '
          . 'network access certificate.  Enjoy!';
    } else {
        print "<h1>Chainsaw Network Access Certificate Generator</h1>";
        print "Paste your GPG public key below and press submit.  You can "
          . "generate this cetificate by doing something like:<br><br>";

        print '<table class="pretty"><tr><td><pre>';
        print "[csaw\@myhost scripts]\$ gpg --export -a -o - myuser";
        print "</pre></td></tr></table><br><br>";

        print $q->startform();
        print '<table width=1%>';
        print '<tr><th>GPG Public Key:</th><th>Certificate Type:</th></tr>';
        print '<tr><td>';
        print $q->textarea(name => 'pubkey');
        print '</td><td>';
        print $q->radio_group(name => 'nodetype',
                              values => ['Client', 'Node'],
                              default => 'Client',
                              linebreak => 1);
        print '</td></tr></table><br>';
        print $q->submit(name => 'submit', value => 'submit');
        print $q->endform();                    
    }

    print "</body></html>";

exit(0);
