#!/usr/bin/perl

use strict;

my $nodes;
my $edges;

my ($l, $state);
my $p = 0;
while (defined($l = <>)) {
    if ($l =~ /^(.*) (.*)$/) {
        $nodes->{$1} = $p++;
        $nodes->{$2} = $p++;

        $edges->{$1}->{$2} = 1;
    } else {
        print STDERR "Crap sticks!\n";
    }
}

print
'graph: {
title:"chainsaw topology"
xmax: 700 ymax: 700 x: 30 y: 30 
arrow_mode: free
layoutalgorithm: maxdepthslow
finetuning: yes
';

foreach $l (sort(keys(%{$nodes}))) {
    print "node: { title: \"$nodes->{$l}\" label: \"$l\" shape: ellipse }\n";
}

foreach $l (sort(keys(%{$edges}))) {
    my $s = $nodes->{$l};
    my $k;
    foreach $k (sort(keys(%{$edges->{$l}}))) {
        my $t = $nodes->{$k};
        print("edge: { sourcename: \"$s\" targetname: \"$t\"" .
              " class: 1 arrowsize: 0 }\n");
    }
}

print "}\n";
