#ifndef __CF_H__
#define __CF_H__

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <glib.h>

#include "socketin.h" /* for ip_pool */

#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)

struct our_config {
    unsigned int debug_level;

    struct sockaddr_in local_addr;
    char *man_socket_path;
    GList *neighbour;
    int lsa_duration;
    int lsa_expiration;
    int file_refresh_duration;
    int lsa_retry_duration;
    int lsa_retry_maximum;
    int lsa_retransmit_throttle;
    int lsa_auth_type;
    char *topology_file, *topology_file_tmp, *lsa_sequence_file;
    char *log_file, *log_fd;
    struct ip_pool ip_pool;
    char *module_dir;

    char *gpg_certificate; /* used for both GPG and AGP auth */

    char *agp_ca_public_key;
    char *agp_public_key;
    char *agp_private_key;

    char *ssh_identity;
    char *ssh_auth_keys;

    int neg_rekey_duration;
    int nymip_port;

    int link_idle_probe_delay;
    int link_idle_probe_interval;
    int link_idle_timeout;
    int link_rekey_interval;
    int retransmit_interval;
};

struct our_config *cf;

extern int load_config(struct our_config *cf, char *filename);

#endif
