/* -*- Mode: c; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * 
 * The Chainsaw anonymous IP network daemon
 *
 * Copyright (c) 2001 Zero-Knowledge Systems, Inc.
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <zlib.h>

#include "munge.h"

/*
 * munging, gzip style.  
 */

static void *gzip_init(unsigned char *data, size_t len)
{
    /*
     * we could use the data to set a different 
     * compression level..
     */
    return (void *)1;
}
static size_t gzip_in(unsigned char *in, unsigned char *out, size_t len, 
                    void *state)
{
    uLongf destlen;
    compress2( out, &destlen, in, len, 3);
            
    return destlen;
}
static size_t gzip_out(unsigned char *in, unsigned char *out, size_t len, 
                    void *state)
{
    uLongf destlen;
    uncompress( out, &destlen, in, len);

    return destlen;
}
static void gzip_destroy(void *state)
{
    return;
}
struct munger m_gzip = {
    init:       gzip_init,
    in:         gzip_in,
    out:        gzip_out,
    destroy:    gzip_destroy
};
