#ifndef __MAN_PACKET_H__
#define __MAN_PACKET_H__

enum {
    MP_SHMFILL,
    MP_BUILDROUTE,
    MP_BUILDLINK,
    MP_DESTROYROUTE,
    MP_DESTROYLINK,
    MP_SHUTDOWN,
};

#define MP_SHM_MIN 0

enum {
    MP_SHM_LINK = MP_SHM_MIN,
    MP_SHM_CIRCUIT,
    MP_SHM_MAX,
};

struct management_packet {
    int type;
    int status;

    union {

        struct mp_link {
            guint32 remote_addr;
        } link;

        struct mp_buildroute {
            int num_hops;
            guint32 hops[3];
        } build;

        struct mp_destroyroute {
            guint32 remote_addr;
            guint32 remote_id;
        } destroy;

        struct mp_shmfill {
            int type;
            int id;
        } fill;

    } u;
};

struct link_stat {
    struct sockaddr_in remote_sin;
};

#define ENDPOINT_STRLEN 16

struct circ_stat {
    guint32 local_id, remote_id;
    struct sockaddr_in remote_sin;
    char endpoint_string[ENDPOINT_STRLEN];
};
#endif
