#ifndef __MUNGE_H__
#define __MUNGE_H__

#define M_MIN 0

enum {
    M_NULL = M_MIN,
    M_XOR,
    M_GZIP,

    M_MAX
};

struct munger {
    void * (*init)(unsigned char *data, size_t len);
    size_t (*in)(unsigned char *in, unsigned char *out, size_t len, 
                 void *state);
    size_t (*out)(unsigned char *in, unsigned char *out, size_t len, 
                  void *state);
    void (*destroy)(void *state);

    void *state;
};

extern struct munger * munger_new(int munger_type, void *data, size_t len);
extern int munger_destroy(struct munger *m);

#endif
