/* -*- Mode: c; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * 
 * The Chainsaw anonymous IP network daemon
 *
 * Copyright (c) 2001 Zero-Knowledge Systems, Inc.
 */

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

#include "log.h"

/*
 * For now we just read directly from /dev/random on
 * platforms that support it.  We'd like to support
 * arbitrary random number generators, so that people
 * can throw in things like yarrow or hardware specific
 * rngs, but its not clear its worth the effort.  
 */

static int random_fd = -1;

void get_random_bytes(unsigned char *ptr, size_t len)
{
    int num;

    /*
     * as far as I can tell, a normal blocking read
     * on /dev/random can only return temp errors..
     */
    while(len) {
        num = read(random_fd, ptr, len);
        if(num > 0)
            len -= num;
    }
}

int random_init(void)
{
    if ((random_fd = open("/dev/urandom", O_RDONLY)) < 0) {
        LOG("couldn't open /dev/urandom: %d\n", errno);
        return -1;
    }

    return 0;
}
