#ifndef __SOCKETIN_H__
#define __SOCKETIN_H__

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <glib.h>

struct ip_pool {
    struct in_addr start;
    int size;
};

/*
 * a local udp socket that we send
 * and receive traffic on.  its also
 * a convenient place to store stuff that
 * is associated with a 'server', which 
 * is really a network endpoint.
 */
struct sock_endpoint {
    int fd;
    struct sockaddr_in sin;
    struct instance *inst;
    GHashTable *cloud_links;
    GHashTable *client_links;
    struct topo_control *top;
    struct in_addr ip_start;
    int ip_pool_size;
    int *ip_pool;
    struct digest_instance *dig;
};

extern int socketin_init(struct sock_endpoint *sock);

#endif
