#ifndef __TOPO_H__
#define __TOPO_H__

#include <glib.h>

#include <openssl/bn.h>

#include "auth.h"
#include "cf.h"
#include "links.h"
#include "socketin.h"

/*
 * controls how we flood
 * our topology, records state, 
 * etc
 */
struct topo_control {
    guint lsa_id;
    guint refresh_id;
    struct sock_endpoint *sock;
    int refresh_file:1;
    char *path, *path_tmp;
    struct auth_instance *ainst;
    GTree *lsa_tree;
    BIGNUM *lsa_seq;
    int seq_file;
};

struct nlsahdr {
    guint8      seq[16];
    guint32     addr;
    guint16     payload_len;
    guint16     auth_id;
    guint8      numneighbors;
    guint8      __reserved;
} __attribute__ ((packed));

extern void topo_incoming(struct link *link, struct our_packet *op,
                          guint8 link_nh);
extern int topo_init(struct sock_endpoint *sock, struct our_config *cf);
void topo_shutdown(struct sock_endpoint *sock);
extern void topo_notify_link_up(struct sock_endpoint *sock, struct link *link);
extern void topo_notify_link_down(struct sock_endpoint *sock,
                                  struct link *link);

#endif /*__TOPO_H__*/
