#!/usr/bin/perl -w

#
# $Id: runUnitTestScripts.pl,v 1.2 2000/11/23 19:40:56 marcp Exp $
# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is Freedom code.
# 
# The Initial Developer of the Original Code is Zero-Knowledge Systems,
# Inc.  Portions created by Zero-Knowledge are Copyright (C) 2000
# Zero-Knowledge Systems, Inc.  All Rights Reserved.
# 
# Contributor(s):
# Philippe McLean <philippem@zks.net>

#
#

# Run unit tests passed on command line using Test::Harness.

use strict;
use Getopt::Long;
use Test::Harness;

# hack to work around broken WCOREDUMP...
sub Test::Harness::WCOREDUMP {
    my($ret) = shift;
    return $ret & 0200;
}

# 
my($verbose) = 0;
my(@unit_test_scripts) = ();

# Grab options.
my($result) = GetOptions("verbose!" => \$verbose);

$Test::Harness::verbose = $verbose = 0;

# Grab the rest of the arguments (test scripts to run)...

my($test_script);

foreach $test_script (@ARGV) {
    push (@unit_test_scripts, $test_script);
}

# Establish environment.

# Run the scripts.
if (@unit_test_scripts) {
    runtests(@unit_test_scripts);
}

