#!/usr/bin/perl 

#
# $Id: zkUnitTest_Cleanup.pl,v 1.2 2001/04/19 14:12:20 alainc Exp $

# Clean up temp files left behind by unit tests
#

use strict;
use File::Basename;
use Cwd;

sub removeTempPerlWrapper($) {
  my($cmdline) = shift;
  my(@cmdargv) = split / /,$cmdline;
  my($cmdname) = shift(@cmdargv);

  my($pwrapfn) = join('',$cmdname,@cmdargv,'.temp');
  system(rm,$pwrapfn);
}

my($infile) = shift;

usage() unless defined $infile;
die("couldn't find test suite `$infile': $!\n") unless -e $infile;
my($fh) = open(TESTS,"<" . $infile);

# Clean Up Perl Wrappers

while(<TESTS>)
  {
    if (($_ !~ /^\#/) && ($_ !~ /^[\n\t \r]/))
        {
         chomp($_);
         removeTempPerlWrapper($_);
        }
  }
