#!/usr/bin/perl 

#
# $Id: zkUnitTest_Run.pl,v 1.2 2001/04/19 14:12:20 alainc Exp $

# Harness to execute test scripts and generate test results.
#
# usage: run-test.pl <test_list>
#
# <test_list> should be a file containing a flat list of test programs to run

use strict;
use Getopt::Long;
use Test::Harness;

use File::Basename;
use Cwd;

# hack to work around broken WCOREDUMP...
sub Test::Harness::WCOREDUMP {
    my($ret) = shift;
    return $ret & 0200;
}


sub usage()
{
    die("usage: $0 <test_list>\n");
}


sub getTempPerlWrapperName($) {
  my($cmdline) = shift;
  my(@cmdargv) = split / /,$cmdline;
  my($cmdname) = shift(@cmdargv);

  my($pwrapfn) = join('',$cmdname,@cmdargv,'.temp');
  return $pwrapfn;
}
                            

# Grab options...
my($verbose) = 0;
my($result) = GetOptions("verbose!" => \$verbose);
$Test::Harness::verbose = $verbose;

# Open the list of test execs...
my($infile) = shift;
usage() unless defined $infile;
die("couldn't find test suite `$infile': $!\n") unless -e $infile;
my($fh) = open(TESTS,"<" . $infile);

# construct list of test scripts
my(@test_scripts) = ();
my($seperator) = '/';

while(<TESTS>)
  {
    if (($_ !~ /^\#/) && ($_ !~ /^[\n\t \r]/))
        {
         chomp($_);
         my($pwfile) = getTempPerlWrapperName($_);
         push @test_scripts, $pwfile;
        }
  }

# set test harness switches
my($cwd) = &cwd();
$Test::Harness::switches .= " -I$cwd ";

runtests(@test_scripts);
