#!/usr/bin/perl 

#
# $Id: zkUnitTest_Setup.pl,v 1.2 2001/04/19 14:12:20 alainc Exp $

# Set up required to run unit tests
#

use strict;
use File::Basename;
use Cwd;

sub generateTempPerlWrapper($) {
  my($cmdline) = shift;
  my(@cmdargv) = split / /,$cmdline;
  my($cmdname) = shift(@cmdargv);
  my($exepath) = join('/',$ENV{ZK_ROOT},'arch',$ENV{ZK_ARCH},
                      $ENV{ZK_CONFIG},'bin');
  my($cmdpath);

  if (! -e $cmdname) {
     $cmdpath = join('/',$exepath,$cmdname);
    (-e $cmdpath) || die "Test executable does not exist";
  } else { $cmdpath = join('/',cwd(),$cmdname); }

  my($pwrapfn) = join('',$cmdname,@cmdargv,'.temp');
  my($pwrapfh) = open(WRAPPER,">" . $pwrapfn);
  my($perlbin) = `which perl`; # path to perl command
  
  # contents of perl file

  print WRAPPER '#!' . $perlbin                                          ."\n";
  print WRAPPER 'my(@outtoks) = '."`",join(' ',$cmdpath,@cmdargv),"`;"   ."\n";
  print WRAPPER 'foreach $tok (@outtoks) {'                              ."\n";
  print WRAPPER '   print $tok;'                                         ."\n";
  print WRAPPER '}'                                                      ."\n";
  
  close WRAPPER;
}

my($infile) = shift;

usage() unless defined $infile;
die("couldn't find test suite `$infile': $!\n") unless -e $infile;
my($fh) = open(TESTS,"<" . $infile);

# Generate Perl Wrappers

while(<TESTS>)
  {
    if (($_ !~ /^\#/) && ($_ !~ /^[\n\t \r]/))
        {
         chomp($_);
         generateTempPerlWrapper($_);
        }
  }
