// =============================================================================
//	ADBUtils.h								 (c)2000 Zero-Knowledge Systems Inc.
// =============================================================================
//

#ifndef ADBUtils_H_
#define ADBUtils_H_

#if defined(__MWERKS__)
#	pragma once
#endif

// system headers
#include <DeskBus.h>

#pragma options align=power

#ifdef __cplusplus
	extern "C" {
#endif


// =============================================================================
//	ADB Defines

// default addresses
#define kADBDongleAddr		1
#define kADBKeyboardAddr	2
#define kADBMouseAddr		3
#define kADBTabletAddr		4
#define kADBModemAddr		5
#define kADBReservedAddr	6
#define kADBMiscAddr		7

// handler IDs
#define kADBClassicAppleMouseDevType		1
#define kADBExtendedAppleMouseDevType		4
#define kADBExtendedAppleKeyboardDevType	2

// ADB commands
#define ADBCmdAddr(cmd)				(((cmd) >> 4) & 0x0F)
#define ADBCmdReg(cmd)				((cmd) & 0x03)
#define ADBCmdIsTalk(cmd)			(((cmd) & 0x0C) == 0x0C)
#define ADBCmdIsListen(cmd)			(((cmd) & 0x0C) == 0x08)
#define ADBCmdIsFlush(cmd)			(((cmd) & 0x0F) == 0x01)
#define ADBCmdIsReset(cmd)			(((cmd) & 0x0F) == 0x00)
#define ADBCmdIsTalkReg0(cmd)		(((cmd) & 0x0F) == 0x0C)
#define ADBMakeTalkCmd(adr, reg)	(((adr) << 4) | (reg) | 0x0C)


// =============================================================================
//	ADBInit hooks

typedef struct ADBInitHook	ADBInitHook;

OSStatus	InstallADBInitHook(
				SInt32			inGlobals, 
				ADBInitHook**	outHook);
void		ActivateADBInitHook(
				ADBInitHook*	inHook, 
				ADBInitUPP		inUPP);
void		DeactivateADBInitHook(
				ADBInitHook*	inHook, 
				ADBInitUPP*		outUPP);

// =============================================================================
//	ADBServiceRoutine hooks

typedef struct ADBServiceHook	ADBServiceHook;
typedef struct ADBServiceData	ADBServiceData;

OSStatus	InstallADBServiceHook(
				ADBAddress				inAddr, 
				const ADBDataBlock*		inData, 
				SInt32					inGlobals, 
				ADBServiceHook**		ioHook, 
				ADBServiceData**		outData);
void		UninstallADBServiceHook(
				ADBAddress				inAddr, 
				ADBServiceHook**		ioHook, 
				ADBServiceData*			inData, 
				Boolean					inReinit, 
				ADBServiceRoutineUPP*	outUPP);
void		ActivateADBServiceHook(
				ADBServiceHook*			inHook, 
				ADBServiceData*			inData, 
				ADBServiceRoutineUPP	inUPP, 
				SInt32					inArg);
void		DeactivateADBServiceHook(
				ADBServiceHook*			inHook, 
				ADBServiceData*			inData, 
				ADBServiceRoutineUPP*	outUPP);

// =============================================================================
//	Other

OSStatus	SendADBCommand(
				StringPtr				buff, 
				SInt16					cmd);


#ifdef __cplusplus
	}
#endif

#pragma options align=reset

#endif	/* ADBUtils_H_ */
