/* ===========================================================================
 * AliasUtils.h				 (c) 1999 Paul Lalonde enrg.  All rights reserved.
 * ===========================================================================
 *	
 *	Redistribution and use in source and binary forms, with or without 
 *	modification, are permitted provided that redistributions of source code 
 *	retain the above copyright notice and the following disclaimer.
 *	
 *	THIS SOFTWARE IS PROVIDED BY PAUL LALONDE ENRG. ``AS IS'' AND ANY EXPRESS 
 *	OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 *	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
 *	DISCLAIMED.  IN NO EVENT SHALL PAUL LALONDE ENRG. BE LIABLE FOR ANY 
 *	DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 *	DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS 
 *	OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 *	HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 *	STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
 *	ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _H_AliasUtils
#define _H_AliasUtils

/* system headers */
#include <Aliases.h>

#if PRAGMA_ONCE
#pragma once
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT
#pragma import on
#endif


OSErr	YarrowIsFileAliasFile(
			const FSSpec*	inFromFile, 
			Boolean*		outIsAliasFile, 
			Boolean*		outIsFolder);

OSErr	YarrowResolveHandleAlias(
			const FSSpec*	inFromFile, 
			AliasHandle		inAlias, 
			Boolean			inMountRemoteVols, 
			Boolean			inResolveAliasChains, 
			FSSpec*			outTargetFile, 
			Boolean*		outChanged, 
			Boolean*		outIsFolder);

OSErr	YarrowResolveFileAlias(
			FSSpec*			ioFile, 
			Boolean			inMountRemoteVols, 
			Boolean			inResolveAliasChains, 
			Boolean*		outIsFolder, 
			Boolean*		outWasAliased);

OSErr	YarrowResolveAliasFileMountOption(
			FSSpec*			ioFile, 
			Boolean			inResolveAliasChains, 
			Boolean*		outIsFolder, 
			Boolean*		outWasAliased, 
			Boolean			inMountRemoteVols);


#ifdef PRAGMA_IMPORT_OFF
#pragma import off
#elif PRAGMA_IMPORT
#pragma import reset
#endif

#ifdef __cplusplus
}
#endif

#endif	/* _H_AliasUtils */
