/* =============================================================================
 *	YarrowDriverVers.h						 (c)2000 Zero-Knowledge Systems Inc.
 * =============================================================================
 *	
 *	Contains the definition for the various components of the 
 *	Yarrow driver's version number.
 */

#ifndef YarrowDriverVers_H_
#define YarrowDriverVers_H_

#ifdef Rez
#	include "MacTypes.r"
#else
#	include <MacTypes.h>
#endif

#pragma options align=power

#ifdef __cplusplus
	extern "C" {
#endif


#define kYarrowDriverName				"\p.Yarrow"
#define kYarrowDriverRegEntry			"ZKS,Yarrow"


/* Don't change these ... */
#ifdef Rez
#	define kYarrowDriverDevStage		development
#	define kYarrowDriverAlphaStage		alpha
#	define kYarrowDriverBetaStage		beta
#	define kYarrowDriverFinalStage		final
#else
#	define kYarrowDriverDevStage		developStage
#	define kYarrowDriverAlphaStage		alphaStage
#	define kYarrowDriverBetaStage		betaStage
#	define kYarrowDriverFinalStage		finalStage
#endif
#define kYarrowDriverMinorAndBugfixVers	((kYarrowDriverMinorVers << 4) | kYarrowDriverBugfixVers)


/* These should be changed to reflect the current release number 
of the driver. */
#define kYarrowDriverMajorVers		1
#define kYarrowDriverMinorVers		1
#define kYarrowDriverBugfixVers		0
#define kYarrowDriverStage			kYarrowDriverDevStage
#define kYarrowDriverNonFinalRelase	7
#define kYarrowDriverRegion			verUS
#define kYarrowDriverVersString		"1.1d7"


#ifdef __cplusplus
	}
#endif

#pragma options align=reset

#endif	/* YarrowDriverVers_H_ */
