/* =============================================================================
 *	YarrowGestalt.h							 (c)2000 Zero-Knowledge Systems Inc.
 * =============================================================================
 *	
 *	Defines the structure that is returned by Yarrow's Gestalt selector.  This 
 *	structure is used both by the INIT and by the driver to talk to the entropy 
 *	hooks.
 */

#ifndef YarrowGestalt_H_
#define YarrowGestalt_H_

#if defined(__MWERKS__)
#	pragma once
#endif

/* system headers */
#include <DeskBus.h>
#include <OSUtils.h>

#pragma options align=power

#ifdef __cplusplus
	extern "C" {
#endif


/* Yarrow signature -- also our Gestalt selector */
#define kYarrowSig	'Yaro'

/* Values for 'flags' field of YarrowGestalt struct. */
#define kYarrowFlagINIT		0x0001	/* Gestalt was installed from INIT	*/

typedef struct YarrowGestalt {
	OSType			sig;		/* our signature -- kYarrowSig		*/
	UInt32			size;		/* sizeof(YarrowGestalt)			*/
	NumVersion		vers;		/* version of loaded extension		*/
	void*			reserved;
	UInt16			numSources;	/* number of entropy sources		*/
	QHdr			srcQueue;	/* queue of entropy sources			*/
	Str31			prefsName;	/* name of preferences file			*/
	UInt32			flags;		/* flags							*/
} YarrowGestalt;


#ifdef __cplusplus
	}
#endif

#pragma options align=reset

#endif	/* YarrowGestalt_H_ */
