/* =============================================================================
 *	YarrowInstall.h							 (c)2000 Zero-Knowledge Systems Inc.
 * =============================================================================
 *	
 *	Defines the structure that is returned by Yarrow's Gestalt selector.  This 
 *	structure is used both by the INIT and by the driver to talk to the entropy 
 *	hooks.
 */

#ifndef YarrowInstall_H_
#define YarrowInstall_H_

#if defined(__MWERKS__)
#	pragma once
#endif

/* system headers */
#include <Files.h>

#pragma options align=power

#ifdef __cplusplus
	extern "C" {
#endif


typedef union YarrowInstallerArgs	YarrowInstallerArgs;

/* Installer Entry Point */

typedef pascal OSStatus	(*YarrowInstallerProcPtr)(SInt32 selector, YarrowInstallerArgs* args);
typedef STACK_UPP_TYPE(YarrowInstallerProcPtr) YarrowInstallerUPP;

enum {
	uppYarrowInstallerProcInfo = kPascalStackBased
		| RESULT_SIZE(SIZE_CODE(sizeof(OSStatus)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(SInt32)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof(YarrowInstallerArgs*)))
};

#define NewYarrowInstallerUPP(proc)		\
			(YarrowInstallerUPP) NewRoutineDescriptor((ProcPtr)(proc), uppYarrowInstallerProcInfo, GetCurrentArchitecture())
#define DisposeYarrowInstallerUPP(upp)	\
			DisposeRoutineDescriptor(upp)
#define InvokeYarrowInstallerUPP(selector, args, upp)	\
			CALL_TWO_PARAMETER_UPP((upp), uppYarrowInstallerProcInfo, (SInt32) (selector), (args))

/* Selectors */

enum {
	kYarrowInstallerIsInstalled = 1,
	kYarrowInstallerInstall,
	kYarrowInstallerUninstall
};

union YarrowInstallerArgs {
	/* kYarrowInstallerIsInstalled			*/
	struct {
		UInt16		result;						/* => */
	} isinstalled;
	/* kYarrowInstallerInstall				*/
	struct {
		SInt16		resfile;					/* => */
		FSSpec		spec;						/* => */
		void*		reserved;					/* => */
	} install;
	/* kYarrowInstallerUninstall			*/
	/*	- no args							*/
};


#ifdef __cplusplus
	}
#endif

#pragma options align=reset

#endif	/* YarrowInstall_H_ */
