/* =============================================================================
 *	YarrowInstall.r							 (c)2000 Zero-Knowledge Systems Inc.
 * =============================================================================
 *	
 *	This Rez source file constructs our INIT, which is actually a 
 *	safe, fat code resource.  "MixedMode.r" contains the template 
 *	for this kind of resource, defined as a resource of type 'sdes'.
 */

/* system headers  */
#include "MixedMode.r"


type 'Inst' as 'sdes';


#ifndef NDEBUG
#	define INSTALL_68K		"Install.68k.dbg.rsrc"
#	define INSTALL_PPC		"Install.ppc.dbg.shlb"
#else
#	define INSTALL_68K		"Install.68k.rsrc"
#	define INSTALL_PPC		"Install.ppc.shlb"
#endif

#define kYarrowInstallId	1000

#define uppYarrowInstallerProcInfo	\
	kPascalStackBased	\
		| (kFourByteCode << kResultSizePhase)	\
		| (kFourByteCode << (kStackParameterPhase + (0 * kStackParameterWidth)))	\
		| (kFourByteCode << (kStackParameterPhase + (1 * kStackParameterWidth)))

resource 'Inst' (kYarrowInstallId, "Installer", protected)
{
	// 68K ProcInfo
	uppYarrowInstallerProcInfo,
	// PowerPC ProcInfo
	uppYarrowInstallerProcInfo,
	// Specify file name, type and ID of resource containing 68k code
	$$Resource(INSTALL_68K, 'Inst', kYarrowInstallId),
	// Specify file containing PPC code in PEF format
	$$Read(INSTALL_PPC)
};
