#ifndef YLOCK_H
#define YLOCK_H

#include "yarrow.h"

#ifdef USE_LIBZKTHREAD

int LOCK(void);
int UNLOCK(void);
int LOCK_INIT(void);
int LOCK_FINAL(void);

#else

# if defined( macintosh ) && YARROW_DRIVER
#  define LOCK() (YARROW_OK)
#  define UNLOCK() (YARROW_OK)
# else
#  include "openssl/crypto.h"
#  define LOCK() (CRYPTO_w_lock(CRYPTO_LOCK_RAND), YARROW_OK)
#  define UNLOCK() (CRYPTO_w_unlock(CRYPTO_LOCK_RAND), YARROW_OK)
# endif
#define LOCK_INIT() (YARROW_OK)
#define LOCK_FINAL() (YARROW_OK)
#endif /* USE_LIBZKTHREAD */

#endif /* YLOCK_H */
