/* locking with zkthread */


#include "yarrow.h"
#include "ylock.h"

#ifdef USE_LIBZKTHREAD

#include "zkThread.h"

static ZkMutex mutex;
static int initialized = 0;

int LOCK_INIT(void)
{
  if (!initialized) {
    if (zkMutexNew(NULL, &mutex))
      initialized = 1;
    else
      return (YARROW_LOCKING);
  }
  return YARROW_OK;
}

int LOCK_FINAL(void)
{
	if (initialized) {
		if (zkMutexFree(0, &mutex))
			return YARROW_OK;
	}
	return YARROW_LOCKING;
}

int LOCK(void)
{
  if (!initialized)
	return (YARROW_LOCKING);

  if (!zkMutexLock(NULL, mutex))
    return (YARROW_LOCKING);

  return (YARROW_OK);
}

int UNLOCK(void)
{
  return (zkMutexUnlock(NULL, mutex) ? YARROW_OK : YARROW_LOCKING);
}

#endif /* USE_LIBZKTHREAD */
