#include "ystate.h"
#include <stdio.h>
#if !defined(macintosh)
# include <sys/types.h>
# include <sys/stat.h>
# include <fcntl.h>
#endif

#ifdef YARROW_SAVE_STATE

#if defined(macintosh) && YARROW_DRIVER

/* Mac OS -- driver environment */

#  include "YarrowDriverCore.h"

void STATE_Save(const char *filename, const struct Yarrow_STATE* state)
{
# pragma unused(filename)
  
  PerformStateWrite(state);
}

int STATE_Load(const char *filename, struct Yarrow_STATE* state)
{
# pragma unused(filename)
  
  return (PerformStateRead(state) ? YARROW_OK : YARROW_STATE_ERROR);
}

#else

/* Other platforms */

void STATE_Save(const char *filename, const struct Yarrow_STATE* state)
{
  FILE* fp = NULL;
#if !defined(WIN32) && !defined(macintosh)
  int fd = open(filename, O_CREAT | O_RDWR, 0600);
  if (fd != -1)
    fp = fdopen(fd, "wb");
#endif
  if (!fp)
    fp = fopen(filename,"wb");
  if (!fp)
    return;
#if !defined(WIN32) && !defined(macintosh)
  chmod(filename, 0600);
#endif

  fwrite(state, sizeof(*state), 1, fp);
  fclose(fp);
}

int STATE_Load(const char *filename, struct Yarrow_STATE* state)
{
  FILE* fp;
  int ret = YARROW_STATE_ERROR;

  fp = fopen(filename, "rb");
  if (!fp)
    return YARROW_STATE_ERROR;
  ret = fread(state, sizeof(*state), 1, fp);
  fclose(fp);
  return (ret == 1 ? YARROW_OK : YARROW_STATE_ERROR);
}

#endif    /* platform */
#endif    /* YARROW_SAVE_STATE */
